/* SystemGroup.c generated by valac 0.38.10, the Vala compiler
 * generated from SystemGroup.vala, do not modify */

/*
 * SystemGroup.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_SYSTEM_GROUP (system_group_get_type ())
#define SYSTEM_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_GROUP, SystemGroup))
#define SYSTEM_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYSTEM_GROUP, SystemGroupClass))
#define IS_SYSTEM_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_GROUP))
#define IS_SYSTEM_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYSTEM_GROUP))
#define SYSTEM_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYSTEM_GROUP, SystemGroupClass))

typedef struct _SystemGroup SystemGroup;
typedef struct _SystemGroupClass SystemGroupClass;
typedef struct _SystemGroupPrivate SystemGroupPrivate;
enum  {
	SYSTEM_GROUP_0_PROPERTY,
	SYSTEM_GROUP_IS_INSTALLED_PROPERTY,
	SYSTEM_GROUP_IS_SYSTEM_PROPERTY,
	SYSTEM_GROUP_NUM_PROPERTIES
};
static GParamSpec* system_group_properties[SYSTEM_GROUP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SystemGroup {
	GObject parent_instance;
	SystemGroupPrivate * priv;
	gchar* name;
	gchar* password;
	gint gid;
	gchar* user_names;
	gchar* shadow_line;
	gchar* password_hash;
	gchar* admin_list;
	gchar* member_list;
	gboolean is_selected;
	GeeArrayList* users;
};

struct _SystemGroupClass {
	GObjectClass parent_class;
};


static gpointer system_group_parent_class = NULL;
extern GeeHashMap* system_group_all_groups;
GeeHashMap* system_group_all_groups = NULL;

GType system_group_get_type (void) G_GNUC_CONST;
SystemGroup* system_group_new (const gchar* name);
SystemGroup* system_group_construct (GType object_type, const gchar* name);
void system_group_query_groups (gboolean no_passwords);
GeeHashMap* system_group_read_groups_from_file (const gchar* group_file, const gchar* gshadow_file, const gchar* password);
gchar* tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file, const gchar* password);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static SystemGroup* system_group_parse_line_group (const gchar* line);
static SystemGroup* system_group_parse_line_gshadow (const gchar* line, GeeHashMap* list);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
gint system_group_add_group (const gchar* group_name, gboolean system_account);
gint tee_jee_process_helper_exec_sync (const gchar* cmd, gchar* * std_out, gchar* * std_err);
gint system_group_add (SystemGroup* self);
gboolean system_group_get_is_system (SystemGroup* self);
gint system_group_add_user_to_group (const gchar* user_name, const gchar* group_name);
void tee_jee_logging_log_debug (const gchar* message);
gint system_group_add_to_group (SystemGroup* self, const gchar* user_name);
gboolean system_group_update_group_file (SystemGroup* self);
gchar* system_group_get_group_line (SystemGroup* self);
gboolean tee_jee_file_system_file_write (const gchar* file_path, const gchar* contents);
void tee_jee_logging_log_msg (const gchar* message, gboolean highlight);
gboolean system_group_update_gshadow_file (SystemGroup* self);
gchar* system_group_get_gshadow_line (SystemGroup* self);
GeeArrayList* system_group_get_all_groups_sorted (void);
static gint _system_group_all_groups_sorted___lambda17_ (SystemGroup* a, SystemGroup* b);
static gint __system_group_all_groups_sorted___lambda17__gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self);
gboolean system_group_get_is_installed (SystemGroup* self);
static void system_group_finalize (GObject * obj);
static void _vala_system_group_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


SystemGroup* system_group_construct (GType object_type, const gchar* name) {
	SystemGroup * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GeeArrayList* _tmp2_;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self = (SystemGroup*) g_object_new (object_type, NULL);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = name;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->name);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->name = _tmp1_;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_object_unref0 (self->users);
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->users = _tmp2_;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return self;
#line 138 "SystemGroup.c"
}


SystemGroup* system_group_new (const gchar* name) {
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return system_group_construct (TYPE_SYSTEM_GROUP, name);
#line 145 "SystemGroup.c"
}


void system_group_query_groups (gboolean no_passwords) {
	gboolean _tmp0_;
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = no_passwords;
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp0_) {
#line 155 "SystemGroup.c"
		GeeHashMap* _tmp1_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp1_ = system_group_read_groups_from_file ("/etc/group", "", "");
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (system_group_all_groups);
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		system_group_all_groups = _tmp1_;
#line 163 "SystemGroup.c"
	} else {
		GeeHashMap* _tmp2_;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp2_ = system_group_read_groups_from_file ("/etc/group", "/etc/gshadow", "");
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (system_group_all_groups);
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		system_group_all_groups = _tmp2_;
#line 172 "SystemGroup.c"
	}
}


GeeHashMap* system_group_read_groups_from_file (const gchar* group_file, const gchar* gshadow_file, const gchar* password) {
	GeeHashMap* result = NULL;
	GeeHashMap* list = NULL;
	GeeHashMap* _tmp0_;
	gchar* txt = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	const gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	gboolean _tmp33_;
	const gchar* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	const gchar* _tmp42_;
	gchar** _tmp43_;
	gchar** _tmp44_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (group_file != NULL, NULL);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (gshadow_file != NULL, NULL);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_SYSTEM_GROUP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	list = _tmp0_;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = g_strdup ("");
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp1_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = group_file;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_str_has_suffix (_tmp2_, ".tar.gpg");
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp3_) {
#line 223 "SystemGroup.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp4_ = group_file;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp5_ = password;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp6_ = tee_jee_file_system_file_decrypt_untar_read (_tmp4_, _tmp5_);
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		txt = _tmp6_;
#line 237 "SystemGroup.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp7_ = group_file;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp8_ = tee_jee_file_system_file_read (_tmp7_);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		txt = _tmp8_;
#line 249 "SystemGroup.c"
	}
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp9_ = txt;
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp10_ = strlen (_tmp9_);
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp11_ = _tmp10_;
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp11_ == 0) {
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = list;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 265 "SystemGroup.c"
	}
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp12_ = txt;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, "\n", 0);
#line 271 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = _tmp14_;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp13_);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp13_); line_it = line_it + 1) {
#line 283 "SystemGroup.c"
			gchar* _tmp15_;
			gchar* line = NULL;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp15_ = g_strdup (line_collection[line_it]);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			line = _tmp15_;
#line 290 "SystemGroup.c"
			{
				gboolean _tmp16_ = FALSE;
				const gchar* _tmp17_;
				SystemGroup* group = NULL;
				const gchar* _tmp21_;
				SystemGroup* _tmp22_;
				SystemGroup* _tmp23_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp17_ = line;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp17_ == NULL) {
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp16_ = TRUE;
#line 304 "SystemGroup.c"
				} else {
					const gchar* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp18_ = line;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp19_ = strlen (_tmp18_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp20_ = _tmp19_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp16_ = _tmp20_ == 0;
#line 317 "SystemGroup.c"
				}
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp16_) {
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (line);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					continue;
#line 325 "SystemGroup.c"
				}
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp21_ = line;
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp22_ = system_group_parse_line_group (_tmp21_);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				group = _tmp22_;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp23_ = group;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp23_ != NULL) {
#line 337 "SystemGroup.c"
					GeeHashMap* _tmp24_;
					SystemGroup* _tmp25_;
					const gchar* _tmp26_;
					SystemGroup* _tmp27_;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp24_ = list;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp25_ = group;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp26_ = _tmp25_->name;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp27_ = group;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, _tmp26_, _tmp27_);
#line 352 "SystemGroup.c"
				}
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_object_unref0 (group);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (line);
#line 358 "SystemGroup.c"
			}
		}
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 363 "SystemGroup.c"
	}
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp28_ = gshadow_file;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp29_ = strlen (_tmp28_);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp30_ = _tmp29_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp30_ == 0) {
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = list;
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 379 "SystemGroup.c"
	}
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp31_ = g_strdup ("");
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp31_;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp32_ = gshadow_file;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp33_ = g_str_has_suffix (_tmp32_, ".tar.gpg");
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp33_) {
#line 393 "SystemGroup.c"
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp34_ = gshadow_file;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp35_ = password;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp36_ = tee_jee_file_system_file_decrypt_untar_read (_tmp34_, _tmp35_);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		txt = _tmp36_;
#line 407 "SystemGroup.c"
	} else {
		const gchar* _tmp37_;
		gchar* _tmp38_;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp37_ = gshadow_file;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp38_ = tee_jee_file_system_file_read (_tmp37_);
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		txt = _tmp38_;
#line 419 "SystemGroup.c"
	}
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp39_ = txt;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp40_ = strlen (_tmp39_);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp41_ = _tmp40_;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp41_ == 0) {
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = list;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 435 "SystemGroup.c"
	}
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp42_ = txt;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp44_ = _tmp43_ = g_strsplit (_tmp42_, "\n", 0);
#line 441 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = _tmp44_;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp43_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp43_); line_it = line_it + 1) {
#line 453 "SystemGroup.c"
			gchar* _tmp45_;
			gchar* line = NULL;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp45_ = g_strdup (line_collection[line_it]);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			line = _tmp45_;
#line 460 "SystemGroup.c"
			{
				gboolean _tmp46_ = FALSE;
				const gchar* _tmp47_;
				const gchar* _tmp51_;
				GeeHashMap* _tmp52_;
				SystemGroup* _tmp53_;
				SystemGroup* _tmp54_;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp47_ = line;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp47_ == NULL) {
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp46_ = TRUE;
#line 474 "SystemGroup.c"
				} else {
					const gchar* _tmp48_;
					gint _tmp49_;
					gint _tmp50_;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp48_ = line;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp49_ = strlen (_tmp48_);
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp50_ = _tmp49_;
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp46_ = _tmp50_ == 0;
#line 487 "SystemGroup.c"
				}
#line 126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp46_) {
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (line);
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					continue;
#line 495 "SystemGroup.c"
				}
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp51_ = line;
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp52_ = list;
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp53_ = system_group_parse_line_gshadow (_tmp51_, _tmp52_);
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp54_ = _tmp53_;
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_object_unref0 (_tmp54_);
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (line);
#line 509 "SystemGroup.c"
			}
		}
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 514 "SystemGroup.c"
	}
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = list;
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 522 "SystemGroup.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 545 "SystemGroup.c"
}


static SystemGroup* system_group_parse_line_group (const gchar* line) {
	SystemGroup* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	SystemGroup* group = NULL;
	gchar** fields = NULL;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = line;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp1_ == NULL) {
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp0_ = TRUE;
#line 570 "SystemGroup.c"
	} else {
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp2_ = line;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp3_ = strlen (_tmp2_);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp4_ = _tmp3_;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp0_ = _tmp4_ == 0;
#line 583 "SystemGroup.c"
	}
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp0_) {
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = NULL;
#line 138 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 591 "SystemGroup.c"
	}
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	group = NULL;
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp5_ = line;
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ":", 0);
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	fields = _tmp7_;
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	fields_length1 = _vala_array_length (_tmp6_);
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_fields_size_ = fields_length1;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8_ = fields;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8__length1 = fields_length1;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp8__length1 == 4) {
#line 611 "SystemGroup.c"
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		SystemGroup* _tmp13_;
		SystemGroup* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		SystemGroup* _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gint _tmp23_;
		SystemGroup* _tmp24_;
		gchar** _tmp25_;
		gint _tmp25__length1;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		SystemGroup* _tmp28_;
		const gchar* _tmp29_;
		gchar** _tmp30_;
		gchar** _tmp31_;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp9_ = fields;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp9__length1 = fields_length1;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp10_ = _tmp9_[0];
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp11_ = string_strip (_tmp10_);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp12_ = _tmp11_;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp13_ = system_group_new (_tmp12_);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (group);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		group = _tmp13_;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp12_);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp14_ = group;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp15_ = fields;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp15__length1 = fields_length1;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp16_ = _tmp15_[1];
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp17_ = string_strip (_tmp16_);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp14_->password);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp14_->password = _tmp17_;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp18_ = group;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp19_ = fields;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp19__length1 = fields_length1;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp20_ = _tmp19_[2];
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp21_ = string_strip (_tmp20_);
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp22_ = _tmp21_;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp23_ = atoi (_tmp22_);
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp18_->gid = _tmp23_;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp22_);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp24_ = group;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp25_ = fields;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp25__length1 = fields_length1;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp26_ = _tmp25_[3];
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp27_ = string_strip (_tmp26_);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp24_->user_names);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp24_->user_names = _tmp27_;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp28_ = group;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp29_ = _tmp28_->user_names;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp31_ = _tmp30_ = g_strsplit (_tmp29_, ",", 0);
#line 709 "SystemGroup.c"
		{
			gchar** user_name_collection = NULL;
			gint user_name_collection_length1 = 0;
			gint _user_name_collection_size_ = 0;
			gint user_name_it = 0;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			user_name_collection = _tmp31_;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			user_name_collection_length1 = _vala_array_length (_tmp30_);
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			for (user_name_it = 0; user_name_it < _vala_array_length (_tmp30_); user_name_it = user_name_it + 1) {
#line 721 "SystemGroup.c"
				gchar* _tmp32_;
				gchar* user_name = NULL;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp32_ = g_strdup (user_name_collection[user_name_it]);
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				user_name = _tmp32_;
#line 728 "SystemGroup.c"
				{
					SystemGroup* _tmp33_;
					GeeArrayList* _tmp34_;
					const gchar* _tmp35_;
#line 152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp33_ = group;
#line 152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp34_ = _tmp33_->users;
#line 152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp35_ = user_name;
#line 152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (user_name);
#line 743 "SystemGroup.c"
				}
			}
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			user_name_collection = (_vala_array_free (user_name_collection, user_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 748 "SystemGroup.c"
		}
	} else {
		gchar** _tmp36_;
		gint _tmp36__length1;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp36_ = fields;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp36__length1 = fields_length1;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp37_ = g_strdup_printf (": %d", _tmp36__length1);
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp38_ = _tmp37_;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp39_ = g_strconcat ("'group' file contains a record with non-standard fields", _tmp38_, NULL);
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp40_ = _tmp39_;
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp40_, FALSE, FALSE);
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp40_);
#line 156 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp38_);
#line 157 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = NULL;
#line 157 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 157 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (group);
#line 157 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 783 "SystemGroup.c"
	}
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = group;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 791 "SystemGroup.c"
}


static SystemGroup* system_group_parse_line_gshadow (const gchar* line, GeeHashMap* list) {
	SystemGroup* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	SystemGroup* group = NULL;
	gchar** fields = NULL;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = line;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp1_ == NULL) {
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp0_ = TRUE;
#line 818 "SystemGroup.c"
	} else {
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp2_ = line;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp3_ = strlen (_tmp2_);
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp4_ = _tmp3_;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp0_ = _tmp4_ == 0;
#line 831 "SystemGroup.c"
	}
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp0_) {
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = NULL;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 839 "SystemGroup.c"
	}
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	group = NULL;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp5_ = line;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ":", 0);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	fields = _tmp7_;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	fields_length1 = _vala_array_length (_tmp6_);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_fields_size_ = fields_length1;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8_ = fields;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8__length1 = fields_length1;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp8__length1 == 4) {
#line 859 "SystemGroup.c"
		gchar* group_name = NULL;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		GeeHashMap* _tmp12_;
		const gchar* _tmp13_;
		gboolean _tmp14_;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp9_ = fields;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp9__length1 = fields_length1;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp10_ = _tmp9_[0];
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp11_ = string_strip (_tmp10_);
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		group_name = _tmp11_;
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp12_ = list;
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp13_ = group_name;
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp14_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp12_, _tmp13_);
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		if (_tmp14_) {
#line 886 "SystemGroup.c"
			GeeHashMap* _tmp15_;
			const gchar* _tmp16_;
			gpointer _tmp17_;
			SystemGroup* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			SystemGroup* _tmp21_;
			gchar** _tmp22_;
			gint _tmp22__length1;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			SystemGroup* _tmp25_;
			gchar** _tmp26_;
			gint _tmp26__length1;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			SystemGroup* _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			const gchar* _tmp31_;
			gchar* _tmp32_;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp15_ = list;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp16_ = group_name;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_object_unref0 (group);
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			group = (SystemGroup*) _tmp17_;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp18_ = group;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp19_ = line;
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (_tmp18_->shadow_line);
#line 178 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp18_->shadow_line = _tmp20_;
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp21_ = group;
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp22_ = fields;
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp22__length1 = fields_length1;
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp23_ = _tmp22_[1];
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp24_ = string_strip (_tmp23_);
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (_tmp21_->password_hash);
#line 179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp21_->password_hash = _tmp24_;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp25_ = group;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp26_ = fields;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp26__length1 = fields_length1;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp27_ = _tmp26_[2];
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp28_ = string_strip (_tmp27_);
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (_tmp25_->admin_list);
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp25_->admin_list = _tmp28_;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp29_ = group;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp30_ = fields;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp30__length1 = fields_length1;
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp31_ = _tmp30_[3];
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp32_ = string_strip (_tmp31_);
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (_tmp29_->member_list);
#line 181 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp29_->member_list = _tmp32_;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			result = group;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (group_name);
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			return result;
#line 978 "SystemGroup.c"
		} else {
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp33_ = group_name;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp34_ = g_strdup_printf (": %s", _tmp33_);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp35_ = _tmp34_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp36_ = g_strconcat ("group in file 'gshadow' does not exist in file 'group'", _tmp35_, NULL);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp37_ = _tmp36_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			tee_jee_logging_log_error (_tmp37_, FALSE, FALSE);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (_tmp37_);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (_tmp35_);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			result = NULL;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_free0 (group_name);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_object_unref0 (group);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			return result;
#line 1011 "SystemGroup.c"
		}
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (group_name);
#line 1015 "SystemGroup.c"
	} else {
		gchar** _tmp38_;
		gint _tmp38__length1;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp38_ = fields;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp38__length1 = fields_length1;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp39_ = g_strdup_printf (": %d", _tmp38__length1);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp40_ = _tmp39_;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp41_ = g_strconcat ("'gshadow' file contains a record with non-standard fields", _tmp40_, NULL);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp42_ = _tmp41_;
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp42_, FALSE, FALSE);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp42_);
#line 190 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_free0 (_tmp40_);
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		result = NULL;
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (group);
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		return result;
#line 1049 "SystemGroup.c"
	}
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_object_unref0 (group);
#line 1055 "SystemGroup.c"
}


gint system_group_add_group (const gchar* group_name, gboolean system_account) {
	gint result = 0;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* cmd = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
	gint _tmp8_;
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (group_name != NULL, 0);
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = system_account;
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp1_) {
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp0_ = " --system";
#line 1082 "SystemGroup.c"
	} else {
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp0_ = "";
#line 1086 "SystemGroup.c"
	}
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = group_name;
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_strdup_printf ("groupadd%s %s", _tmp0_, _tmp2_);
#line 197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	cmd = _tmp3_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = cmd;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync (_tmp4_, &_tmp5_, &_tmp6_);
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	std_out = _tmp5_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	std_err = _tmp6_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	status = _tmp7_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8_ = status;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp8_ != 0) {
#line 1112 "SystemGroup.c"
		const gchar* _tmp9_;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp9_ = std_err;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp9_, FALSE, FALSE);
#line 1118 "SystemGroup.c"
	} else {
	}
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = status;
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (cmd);
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1131 "SystemGroup.c"
}


gint system_group_add (SystemGroup* self) {
	gint result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_;
#line 208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = self->name;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = system_group_get_is_system (self);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = _tmp1_;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = system_group_add_group (_tmp0_, _tmp2_);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = _tmp3_;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1155 "SystemGroup.c"
}


gint system_group_add_user_to_group (const gchar* user_name, const gchar* group_name) {
	gint result = 0;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
	gint _tmp8_;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (user_name != NULL, 0);
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (group_name != NULL, 0);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = user_name;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = group_name;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = g_strdup_printf ("adduser %s %s", _tmp0_, _tmp1_);
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	cmd = _tmp2_;
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = cmd;
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = cmd;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync (_tmp4_, &_tmp5_, &_tmp6_);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	std_out = _tmp5_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	std_err = _tmp6_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	status = _tmp7_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8_ = status;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	if (_tmp8_ != 0) {
#line 1208 "SystemGroup.c"
		const gchar* _tmp9_;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp9_ = std_err;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp9_, FALSE, FALSE);
#line 1214 "SystemGroup.c"
	} else {
	}
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = status;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (cmd);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1227 "SystemGroup.c"
}


gint system_group_add_to_group (SystemGroup* self, const gchar* user_name) {
	gint result = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (user_name != NULL, 0);
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = user_name;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = self->name;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = system_group_add_user_to_group (_tmp0_, _tmp1_);
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = _tmp2_;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1250 "SystemGroup.c"
}


gboolean system_group_update_group_file (SystemGroup* self) {
	gboolean result = FALSE;
	gchar* file_path = NULL;
	gchar* _tmp0_;
	gchar* txt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* txt_new = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("/etc/group");
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	file_path = _tmp0_;
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = file_path;
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = tee_jee_file_system_file_read (_tmp1_);
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp2_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_strdup ("");
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt_new = _tmp3_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = txt;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 1293 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = _tmp6_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp5_); line_it = line_it + 1) {
#line 1305 "SystemGroup.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			line = _tmp7_;
#line 1312 "SystemGroup.c"
			{
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gboolean _tmp13_;
				gchar** parts = NULL;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gchar** _tmp16_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp8_ = line;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp10_ = _tmp9_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp11_ = strlen (_tmp10_);
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp12_ = _tmp11_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp13_ = _tmp12_ == 0;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (_tmp10_);
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp13_) {
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (line);
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					continue;
#line 1355 "SystemGroup.c"
				}
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp14_ = line;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ":", 0);
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				parts = _tmp16_;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				parts_length1 = _vala_array_length (_tmp15_);
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_parts_size_ = parts_length1;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp17_ = parts;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp17__length1 = parts_length1;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp17__length1 != 4) {
#line 1373 "SystemGroup.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp18_ = parts;
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp18__length1 = parts_length1;
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp19_ = g_strdup_printf (": %d", _tmp18__length1);
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp20_ = _tmp19_;
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp21_ = g_strconcat ("'group' file contains a record with non-standard fields", _tmp20_, NULL);
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp22_ = _tmp21_;
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp22_);
#line 249 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp20_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					result = FALSE;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (line);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (file_path);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					return result;
#line 1414 "SystemGroup.c"
				}
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp23_ = parts;
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp23__length1 = parts_length1;
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp24_ = _tmp23_[0];
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp25_ = string_strip (_tmp24_);
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp26_ = _tmp25_;
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp27_ = self->name;
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (_tmp26_);
#line 253 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp28_) {
#line 1434 "SystemGroup.c"
					const gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp29_ = txt_new;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp30_ = system_group_get_group_line (self);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp31_ = _tmp30_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp33_ = _tmp32_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					txt_new = _tmp34_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp33_);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp31_);
#line 1461 "SystemGroup.c"
				} else {
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp35_ = txt_new;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp36_ = line;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp37_ = g_strconcat (_tmp36_, "\n", NULL);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp38_ = _tmp37_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					txt_new = _tmp39_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp38_);
#line 1484 "SystemGroup.c"
				}
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (line);
#line 1490 "SystemGroup.c"
			}
		}
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1495 "SystemGroup.c"
	}
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp40_ = file_path;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp41_ = txt_new;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	tee_jee_file_system_file_write (_tmp40_, _tmp41_);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp42_ = self->name;
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp43_ = g_strdup_printf (": %s", _tmp42_);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp44_ = _tmp43_;
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp45_ = g_strconcat ("Updated group settings in /etc/group", _tmp44_, NULL);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp46_ = _tmp45_;
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	tee_jee_logging_log_msg (_tmp46_, FALSE);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp46_);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp44_);
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = TRUE;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt_new);
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (file_path);
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1529 "SystemGroup.c"
}


gchar* system_group_get_group_line (SystemGroup* self) {
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
#line 268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("");
#line 269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp0_;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = txt;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = self->name;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_strdup_printf ("%s", _tmp2_);
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp5_;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp4_);
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp6_ = txt;
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp7_ = self->password;
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8_ = g_strdup_printf (":%s", _tmp7_);
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp9_ = _tmp8_;
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp10_;
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp9_);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp11_ = txt;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp12_ = self->gid;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp13_ = g_strdup_printf (":%d", _tmp12_);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp14_ = _tmp13_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp15_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp14_);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp16_ = txt;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp17_ = self->user_names;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp18_ = g_strdup_printf (":%s", _tmp17_);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp19_ = _tmp18_;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp20_;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp19_);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = txt;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1631 "SystemGroup.c"
}


gboolean system_group_update_gshadow_file (SystemGroup* self) {
	gboolean result = FALSE;
	gchar* file_path = NULL;
	gchar* _tmp0_;
	gchar* txt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* txt_new = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("/etc/gshadow");
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	file_path = _tmp0_;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = file_path;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = tee_jee_file_system_file_read (_tmp1_);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp2_;
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_strdup ("");
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt_new = _tmp3_;
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = txt;
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 1674 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = _tmp6_;
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp5_); line_it = line_it + 1) {
#line 1686 "SystemGroup.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			line = _tmp7_;
#line 1693 "SystemGroup.c"
			{
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gboolean _tmp13_;
				gchar** parts = NULL;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gchar** _tmp16_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_;
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp8_ = line;
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp10_ = _tmp9_;
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp11_ = strlen (_tmp10_);
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp12_ = _tmp11_;
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp13_ = _tmp12_ == 0;
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (_tmp10_);
#line 283 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp13_) {
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (line);
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					continue;
#line 1736 "SystemGroup.c"
				}
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp14_ = line;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ":", 0);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				parts = _tmp16_;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				parts_length1 = _vala_array_length (_tmp15_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_parts_size_ = parts_length1;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp17_ = parts;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp17__length1 = parts_length1;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp17__length1 != 4) {
#line 1754 "SystemGroup.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp18_ = parts;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp18__length1 = parts_length1;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp19_ = g_strdup_printf (": %d", _tmp18__length1);
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp20_ = _tmp19_;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp21_ = g_strconcat ("'gshadow' file contains a record with non-standard fields", _tmp20_, NULL);
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp22_ = _tmp21_;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp22_);
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp20_);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					result = FALSE;
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (line);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (file_path);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					return result;
#line 1795 "SystemGroup.c"
				}
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp23_ = parts;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp23__length1 = parts_length1;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp24_ = _tmp23_[0];
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp25_ = string_strip (_tmp24_);
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp26_ = _tmp25_;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp27_ = self->name;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (_tmp26_);
#line 294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				if (_tmp28_) {
#line 1815 "SystemGroup.c"
					const gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp29_ = txt_new;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp30_ = system_group_get_gshadow_line (self);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp31_ = _tmp30_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp33_ = _tmp32_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					txt_new = _tmp34_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp33_);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp31_);
#line 1842 "SystemGroup.c"
				} else {
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp35_ = txt_new;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp36_ = line;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp37_ = g_strconcat (_tmp36_, "\n", NULL);
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp38_ = _tmp37_;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					txt_new = _tmp39_;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
					_g_free0 (_tmp38_);
#line 1865 "SystemGroup.c"
				}
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				_g_free0 (line);
#line 1871 "SystemGroup.c"
			}
		}
#line 282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1876 "SystemGroup.c"
	}
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp40_ = file_path;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp41_ = txt_new;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	tee_jee_file_system_file_write (_tmp40_, _tmp41_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp42_ = self->name;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp43_ = g_strdup_printf (": %s", _tmp42_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp44_ = _tmp43_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp45_ = g_strconcat ("Updated group settings in /etc/gshadow", _tmp44_, NULL);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp46_ = _tmp45_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	tee_jee_logging_log_msg (_tmp46_, FALSE);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp46_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp44_);
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = TRUE;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt_new);
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (file_path);
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 1910 "SystemGroup.c"
}


gchar* system_group_get_gshadow_line (SystemGroup* self) {
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("");
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp0_;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = txt;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = self->name;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_strdup_printf ("%s", _tmp2_);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp5_;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp4_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp6_ = txt;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp7_ = self->password_hash;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp8_ = g_strdup_printf (":%s", _tmp7_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp9_ = _tmp8_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp10_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp9_);
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp11_ = txt;
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp12_ = self->admin_list;
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp13_ = g_strdup_printf (":%s", _tmp12_);
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp14_ = _tmp13_;
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp15_;
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp14_);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp16_ = txt;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp17_ = self->member_list;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp18_ = g_strdup_printf (":%s", _tmp17_);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp19_ = _tmp18_;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	txt = _tmp20_;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (_tmp19_);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = txt;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 2012 "SystemGroup.c"
}


static gint _system_group_all_groups_sorted___lambda17_ (SystemGroup* a, SystemGroup* b) {
	gint result = 0;
	GCompareFunc _tmp0_;
	SystemGroup* _tmp1_;
	const gchar* _tmp2_;
	SystemGroup* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = g_strcmp0;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = a;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = _tmp1_->name;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = b;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_->name;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = _tmp5_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 2044 "SystemGroup.c"
}


static gint __system_group_all_groups_sorted___lambda17__gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gint result;
	result = _system_group_all_groups_sorted___lambda17_ ((SystemGroup*) a, (SystemGroup*) b);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 2053 "SystemGroup.c"
}


GeeArrayList* system_group_get_all_groups_sorted (void) {
	GeeArrayList* result;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp13_;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = gee_array_list_new (TYPE_SYSTEM_GROUP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	list = _tmp0_;
#line 2066 "SystemGroup.c"
	{
		GeeIterator* _group_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp1_ = system_group_all_groups;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp3_ = _tmp2_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp4_ = _tmp3_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_tmp6_ = _tmp5_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (_tmp4_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_group_it = _tmp6_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		while (TRUE) {
#line 2093 "SystemGroup.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_;
			SystemGroup* group = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			GeeArrayList* _tmp11_;
			SystemGroup* _tmp12_;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp7_ = _group_it;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			if (!_tmp8_) {
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
				break;
#line 2109 "SystemGroup.c"
			}
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp9_ = _group_it;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			group = (SystemGroup*) _tmp10_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp11_ = list;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_tmp12_ = group;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
			_g_object_unref0 (group);
#line 2125 "SystemGroup.c"
		}
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		_g_object_unref0 (_group_it);
#line 2129 "SystemGroup.c"
	}
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp13_ = list;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	gee_list_sort ((GeeList*) _tmp13_, __system_group_all_groups_sorted___lambda17__gcompare_data_func, NULL, NULL);
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = list;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 2139 "SystemGroup.c"
}


gboolean system_group_get_is_installed (SystemGroup* self) {
	gboolean result;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = system_group_all_groups;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = self->name;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = _tmp2_;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 2160 "SystemGroup.c"
}


gboolean system_group_get_is_system (SystemGroup* self) {
	gboolean result;
	gint _tmp0_;
#line 231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = self->gid;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	result = _tmp0_ < 1000;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	return result;
#line 2175 "SystemGroup.c"
}


static void system_group_class_init (SystemGroupClass * klass) {
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	system_group_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_system_group_get_property;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	G_OBJECT_CLASS (klass)->finalize = system_group_finalize;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_GROUP_IS_INSTALLED_PROPERTY, system_group_properties[SYSTEM_GROUP_IS_INSTALLED_PROPERTY] = g_param_spec_boolean ("is-installed", "is-installed", "is-installed", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_GROUP_IS_SYSTEM_PROPERTY, system_group_properties[SYSTEM_GROUP_IS_SYSTEM_PROPERTY] = g_param_spec_boolean ("is-system", "is-system", "is-system", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 2190 "SystemGroup.c"
}


static void system_group_instance_init (SystemGroup * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("");
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->name = _tmp0_;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp1_ = g_strdup ("");
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->password = _tmp1_;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->gid = -1;
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp2_ = g_strdup ("");
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->user_names = _tmp2_;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp3_ = g_strdup ("");
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->shadow_line = _tmp3_;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp4_ = g_strdup ("");
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->password_hash = _tmp4_;
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp5_ = g_strdup ("");
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->admin_list = _tmp5_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_tmp6_ = g_strdup ("");
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->member_list = _tmp6_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self->is_selected = FALSE;
#line 2234 "SystemGroup.c"
}


static void system_group_finalize (GObject * obj) {
	SystemGroup * self;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SYSTEM_GROUP, SystemGroup);
#line 31 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->name);
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->password);
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->user_names);
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->shadow_line);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->password_hash);
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->admin_list);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_free0 (self->member_list);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	_g_object_unref0 (self->users);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	G_OBJECT_CLASS (system_group_parent_class)->finalize (obj);
#line 2260 "SystemGroup.c"
}


GType system_group_get_type (void) {
	static volatile gsize system_group_type_id__volatile = 0;
	if (g_once_init_enter (&system_group_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SystemGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) system_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SystemGroup), 0, (GInstanceInitFunc) system_group_instance_init, NULL };
		GType system_group_type_id;
		system_group_type_id = g_type_register_static (G_TYPE_OBJECT, "SystemGroup", &g_define_type_info, 0);
		g_once_init_leave (&system_group_type_id__volatile, system_group_type_id);
	}
	return system_group_type_id__volatile;
}


static void _vala_system_group_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SystemGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SYSTEM_GROUP, SystemGroup);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		case SYSTEM_GROUP_IS_INSTALLED_PROPERTY:
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		g_value_set_boolean (value, system_group_get_is_installed (self));
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		break;
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		case SYSTEM_GROUP_IS_SYSTEM_PROPERTY:
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		g_value_set_boolean (value, system_group_get_is_system (self));
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		break;
#line 2293 "SystemGroup.c"
		default:
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/timeshift-18.4/src/Utility/SystemGroup.vala"
		break;
#line 2299 "SystemGroup.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



