/* CryptTabEntry.c generated by valac 0.38.10, the Vala compiler
 * generated from CryptTabEntry.vala, do not modify */

/*
 * CryptTabEntry.vala
 *
 * Copyright 2016 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_CRYPT_TAB_ENTRY (crypt_tab_entry_get_type ())
#define CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntry))
#define CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))
#define IS_CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CRYPT_TAB_ENTRY))
#define IS_CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CRYPT_TAB_ENTRY))
#define CRYPT_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))

typedef struct _CryptTabEntry CryptTabEntry;
typedef struct _CryptTabEntryClass CryptTabEntryClass;
typedef struct _CryptTabEntryPrivate CryptTabEntryPrivate;
enum  {
	CRYPT_TAB_ENTRY_0_PROPERTY,
	CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY,
	CRYPT_TAB_ENTRY_NUM_PROPERTIES
};
static GParamSpec* crypt_tab_entry_properties[CRYPT_TAB_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CryptTabEntry {
	GObject parent_instance;
	CryptTabEntryPrivate * priv;
	gboolean is_comment;
	gboolean is_empty_line;
	gchar* mapped_name;
	gchar* device_string;
	gchar* keyfile;
	gchar* options;
	gchar* line;
};

struct _CryptTabEntryClass {
	GObjectClass parent_class;
};


static gpointer crypt_tab_entry_parent_class = NULL;

GType crypt_tab_entry_get_type (void) G_GNUC_CONST;
GeeArrayList* crypt_tab_entry_read_file (const gchar* file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
CryptTabEntry* crypt_tab_entry_new (void);
CryptTabEntry* crypt_tab_entry_construct (GType object_type);
gchar* crypt_tab_entry_write_file (GeeArrayList* entries, const gchar* file_path, gboolean keep_comments_and_empty_lines);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path, const gchar* contents);
void crypt_tab_entry_append_option (CryptTabEntry* self, const gchar* option);
void crypt_tab_entry_remove_option (CryptTabEntry* self, const gchar* option);
CryptTabEntry* crypt_tab_entry_find_entry_by_uuid (GeeArrayList* entries, const gchar* uuid);
gchar* crypt_tab_entry_get_device_uuid (CryptTabEntry* self);
void crypt_tab_entry_set_device_uuid (CryptTabEntry* self, const gchar* value);
static void crypt_tab_entry_finalize (GObject * obj);
static void _vala_crypt_tab_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_crypt_tab_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 116 "CryptTabEntry.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 135 "CryptTabEntry.c"
	} else {
		const gchar* _tmp2_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 142 "CryptTabEntry.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 148 "CryptTabEntry.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 158 "CryptTabEntry.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 162 "CryptTabEntry.c"
		gchar* _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 170 "CryptTabEntry.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 202 "CryptTabEntry.c"
				goto __catch40_g_regex_error;
			}
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 211 "CryptTabEntry.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 227 "CryptTabEntry.c"
				goto __catch40_g_regex_error;
			}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 238 "CryptTabEntry.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 252 "CryptTabEntry.c"
	}
	goto __finally40;
	__catch40_g_regex_error:
	{
		GError* e = NULL;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1423 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 266 "CryptTabEntry.c"
	}
	__finally40:
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return NULL;
#line 277 "CryptTabEntry.c"
	}
}


GeeArrayList* crypt_tab_entry_read_file (const gchar* file_path) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	gchar* text = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** lines = NULL;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = gee_array_list_new (TYPE_CRYPT_TAB_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	list = _tmp0_;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp1_ = file_path;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp2_ = tee_jee_file_system_file_exists (_tmp1_);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (!_tmp2_) {
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		result = list;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		return result;
#line 315 "CryptTabEntry.c"
	}
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp3_ = file_path;
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp4_ = tee_jee_file_system_file_read (_tmp3_);
#line 63 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	text = _tmp4_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp5_ = text;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	lines = _tmp7_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	lines_length1 = _vala_array_length (_tmp6_);
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_lines_size_ = lines_length1;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp8_ = lines;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp8__length1 = lines_length1;
#line 337 "CryptTabEntry.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		line_collection = _tmp8_;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		line_collection_length1 = _tmp8__length1;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		for (line_it = 0; line_it < _tmp8__length1; line_it = line_it + 1) {
#line 349 "CryptTabEntry.c"
			gchar* _tmp9_;
			gchar* line = NULL;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp9_ = g_strdup (line_collection[line_it]);
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			line = _tmp9_;
#line 356 "CryptTabEntry.c"
			{
				CryptTabEntry* entry = NULL;
				CryptTabEntry* _tmp10_;
				GeeArrayList* _tmp11_;
				CryptTabEntry* _tmp12_;
				CryptTabEntry* _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gboolean _tmp17_;
				CryptTabEntry* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				CryptTabEntry* _tmp24_;
				gboolean _tmp25_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp10_ = crypt_tab_entry_new ();
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				entry = _tmp10_;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp11_ = list;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp12_ = entry;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp13_ = entry;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp14_ = line;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp15_ = string_strip (_tmp14_);
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp16_ = _tmp15_;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp17_ = g_str_has_prefix (_tmp16_, "#");
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp13_->is_comment = _tmp17_;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_free0 (_tmp16_);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp18_ = entry;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp19_ = line;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp20_ = string_strip (_tmp19_);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp21_ = _tmp20_;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp22_ = strlen (_tmp21_);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp23_ = _tmp22_;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp18_->is_empty_line = _tmp23_ == 0;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_free0 (_tmp21_);
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp24_ = entry;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp25_ = _tmp24_->is_comment;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				if (_tmp25_) {
#line 421 "CryptTabEntry.c"
					CryptTabEntry* _tmp26_;
					const gchar* _tmp27_;
					gchar* _tmp28_;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp26_ = entry;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp27_ = line;
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp28_ = g_strdup (_tmp27_);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_g_free0 (_tmp26_->line);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp26_->line = _tmp28_;
#line 435 "CryptTabEntry.c"
				} else {
					CryptTabEntry* _tmp29_;
					gboolean _tmp30_;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp29_ = entry;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp30_ = _tmp29_->is_empty_line;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					if (_tmp30_) {
#line 445 "CryptTabEntry.c"
						CryptTabEntry* _tmp31_;
						gchar* _tmp32_;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp31_ = entry;
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp32_ = g_strdup ("");
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_g_free0 (_tmp31_->line);
#line 76 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp31_->line = _tmp32_;
#line 456 "CryptTabEntry.c"
					} else {
						CryptTabEntry* _tmp33_;
						const gchar* _tmp34_;
						gchar* _tmp35_;
						gchar** parts = NULL;
						const gchar* _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						gchar** _tmp39_;
						gchar** _tmp40_;
						gchar** _tmp41_;
						gint _tmp41__length1;
						gint parts_length1;
						gint _parts_size_;
						gint part_num = 0;
						gchar** _tmp42_;
						gint _tmp42__length1;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp33_ = entry;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp34_ = line;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp35_ = g_strdup (_tmp34_);
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_g_free0 (_tmp33_->line);
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp33_->line = _tmp35_;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp36_ = line;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp37_ = string_replace (_tmp36_, "\t", " ");
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp38_ = _tmp37_;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp40_ = _tmp39_ = g_strsplit (_tmp38_, " ", 0);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp41_ = _tmp40_;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp41__length1 = _vala_array_length (_tmp39_);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_g_free0 (_tmp38_);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						parts = _tmp41_;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						parts_length1 = _tmp41__length1;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_parts_size_ = parts_length1;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						part_num = -1;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp42_ = parts;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						_tmp42__length1 = parts_length1;
#line 510 "CryptTabEntry.c"
						{
							gchar** part_collection = NULL;
							gint part_collection_length1 = 0;
							gint _part_collection_size_ = 0;
							gint part_it = 0;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
							part_collection = _tmp42_;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
							part_collection_length1 = _tmp42__length1;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
							for (part_it = 0; part_it < _tmp42__length1; part_it = part_it + 1) {
#line 522 "CryptTabEntry.c"
								gchar* _tmp43_;
								gchar* part = NULL;
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
								_tmp43_ = g_strdup (part_collection[part_it]);
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
								part = _tmp43_;
#line 529 "CryptTabEntry.c"
								{
									const gchar* _tmp44_;
									gchar* _tmp45_;
									gchar* _tmp46_;
									gint _tmp47_;
									gint _tmp48_;
									gboolean _tmp49_;
									gint _tmp50_;
									gint _tmp51_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp44_ = part;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp45_ = string_strip (_tmp44_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp46_ = _tmp45_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp47_ = strlen (_tmp46_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp48_ = _tmp47_;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp49_ = _tmp48_ == 0;
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_g_free0 (_tmp46_);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									if (_tmp49_) {
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										_g_free0 (part);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										continue;
#line 559 "CryptTabEntry.c"
									}
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp50_ = part_num;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									part_num = _tmp50_ + 1;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_tmp51_ = part_num;
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									switch (_tmp51_) {
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										case 0:
#line 571 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp52_;
											const gchar* _tmp53_;
											gchar* _tmp54_;
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp52_ = entry;
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp53_ = part;
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp54_ = string_strip (_tmp53_);
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp52_->mapped_name);
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp52_->mapped_name = _tmp54_;
#line 88 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											break;
#line 588 "CryptTabEntry.c"
										}
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										case 1:
#line 592 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp55_;
											const gchar* _tmp56_;
											gchar* _tmp57_;
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp55_ = entry;
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp56_ = part;
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp57_ = string_strip (_tmp56_);
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp55_->device_string);
#line 90 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp55_->device_string = _tmp57_;
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											break;
#line 609 "CryptTabEntry.c"
										}
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										case 2:
#line 613 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp58_;
											const gchar* _tmp59_;
											gchar* _tmp60_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp58_ = entry;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp59_ = part;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp60_ = string_strip (_tmp59_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp58_->keyfile);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp58_->keyfile = _tmp60_;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											break;
#line 630 "CryptTabEntry.c"
										}
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										case 3:
#line 634 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp61_;
											const gchar* _tmp62_;
											gchar* _tmp63_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp61_ = entry;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp62_ = part;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp63_ = string_strip (_tmp62_);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_g_free0 (_tmp61_->options);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											_tmp61_->options = _tmp63_;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
											break;
#line 651 "CryptTabEntry.c"
										}
										default:
#line 85 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
										break;
#line 656 "CryptTabEntry.c"
									}
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
									_g_free0 (part);
#line 660 "CryptTabEntry.c"
								}
							}
						}
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 666 "CryptTabEntry.c"
					}
				}
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_object_unref0 (entry);
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_free0 (line);
#line 673 "CryptTabEntry.c"
			}
		}
	}
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	result = list;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (text);
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	return result;
#line 685 "CryptTabEntry.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 692 "CryptTabEntry.c"
}


gchar* crypt_tab_entry_write_file (GeeArrayList* entries, const gchar* file_path, gboolean keep_comments_and_empty_lines) {
	gchar* result = NULL;
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp36_;
	gboolean _tmp37_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	text = _tmp0_;
#line 712 "CryptTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _entry_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _entry_index = 0;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp1_ = entries;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_entry_list = _tmp2_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp3_ = _entry_list;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp5_ = _tmp4_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_entry_size = _tmp5_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_entry_index = -1;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		while (TRUE) {
#line 740 "CryptTabEntry.c"
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			CryptTabEntry* entry = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gboolean _tmp12_ = FALSE;
			CryptTabEntry* _tmp13_;
			gboolean _tmp14_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp6_ = _entry_index;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_entry_index = _tmp6_ + 1;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp7_ = _entry_index;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp8_ = _entry_size;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				break;
#line 763 "CryptTabEntry.c"
			}
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp9_ = _entry_list;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp10_ = _entry_index;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			entry = (CryptTabEntry*) _tmp11_;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp13_ = entry;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp14_ = _tmp13_->is_comment;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			if (_tmp14_) {
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp12_ = TRUE;
#line 781 "CryptTabEntry.c"
			} else {
				CryptTabEntry* _tmp15_;
				gboolean _tmp16_;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp15_ = entry;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp16_ = _tmp15_->is_empty_line;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp12_ = _tmp16_;
#line 791 "CryptTabEntry.c"
			}
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			if (_tmp12_) {
#line 795 "CryptTabEntry.c"
				gboolean _tmp17_;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp17_ = keep_comments_and_empty_lines;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				if (_tmp17_) {
#line 801 "CryptTabEntry.c"
					const gchar* _tmp18_;
					CryptTabEntry* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp18_ = text;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp19_ = entry;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp20_ = _tmp19_->line;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp21_ = g_strdup_printf ("%s\n", _tmp20_);
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp22_ = _tmp21_;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_tmp23_ = g_strconcat (_tmp18_, _tmp22_, NULL);
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_g_free0 (text);
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					text = _tmp23_;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
					_g_free0 (_tmp22_);
#line 826 "CryptTabEntry.c"
				}
			} else {
				const gchar* _tmp24_;
				CryptTabEntry* _tmp25_;
				const gchar* _tmp26_;
				CryptTabEntry* _tmp27_;
				const gchar* _tmp28_;
				CryptTabEntry* _tmp29_;
				const gchar* _tmp30_;
				CryptTabEntry* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp24_ = text;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp25_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp26_ = _tmp25_->mapped_name;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp27_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp28_ = _tmp27_->device_string;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp29_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp30_ = _tmp29_->keyfile;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp31_ = entry;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp32_ = _tmp31_->options;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp33_ = g_strdup_printf ("%s\t%s\t%s\t%s\n", _tmp26_, _tmp28_, _tmp30_, _tmp32_);
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp34_ = _tmp33_;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_tmp35_ = g_strconcat (_tmp24_, _tmp34_, NULL);
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_free0 (text);
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				text = _tmp35_;
#line 118 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_free0 (_tmp34_);
#line 871 "CryptTabEntry.c"
			}
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_g_object_unref0 (entry);
#line 875 "CryptTabEntry.c"
		}
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_object_unref0 (_entry_list);
#line 879 "CryptTabEntry.c"
	}
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp36_ = file_path;
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp37_ = tee_jee_file_system_file_exists (_tmp36_);
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (_tmp37_) {
#line 887 "CryptTabEntry.c"
		const gchar* _tmp38_;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp38_ = file_path;
#line 125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		tee_jee_file_system_file_delete (_tmp38_);
#line 893 "CryptTabEntry.c"
	}
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp39_ = file_path;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp40_ = text;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	tee_jee_file_system_file_write (_tmp39_, _tmp40_);
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	result = text;
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	return result;
#line 905 "CryptTabEntry.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 925 "CryptTabEntry.c"
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_;
	glong _tmp16_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	gchar* _tmp21_;
#line 1363 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1365 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1365 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 958 "CryptTabEntry.c"
		glong _tmp3_;
		glong _tmp4_;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 967 "CryptTabEntry.c"
	}
#line 1368 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1368 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 973 "CryptTabEntry.c"
		glong _tmp6_;
		glong _tmp7_;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 982 "CryptTabEntry.c"
	}
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 988 "CryptTabEntry.c"
		glong _tmp10_;
		glong _tmp11_;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 997 "CryptTabEntry.c"
	} else {
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 1001 "CryptTabEntry.c"
	}
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp8_, NULL);
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp13_ = end;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp13_ >= ((glong) 0)) {
#line 1009 "CryptTabEntry.c"
		glong _tmp14_;
		glong _tmp15_;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = end;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = _tmp14_ <= _tmp15_;
#line 1018 "CryptTabEntry.c"
	} else {
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = FALSE;
#line 1022 "CryptTabEntry.c"
	}
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp16_ = start;
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp17_ = end;
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp21_;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 1044 "CryptTabEntry.c"
}


void crypt_tab_entry_append_option (CryptTabEntry* self, const gchar* option) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp8_;
	gboolean _tmp9_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = self->options;
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp1_ = option;
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp2_ = string_contains (_tmp0_, _tmp1_);
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (!_tmp2_) {
#line 1068 "CryptTabEntry.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp3_ = self->options;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp4_ = option;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp5_ = g_strdup_printf (",%s", _tmp4_);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp6_ = _tmp5_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp7_ = g_strconcat (_tmp3_, _tmp6_, NULL);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		self->options = _tmp7_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (_tmp6_);
#line 1090 "CryptTabEntry.c"
	}
#line 139 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp8_ = self->options;
#line 139 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp9_ = g_str_has_prefix (_tmp8_, ",");
#line 139 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (_tmp9_) {
#line 1098 "CryptTabEntry.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp10_ = self->options;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp11_ = self->options;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp12_ = strlen (_tmp11_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp13_ = _tmp12_;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp14_ = string_slice (_tmp10_, (glong) 1, (glong) _tmp13_);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		self->options = _tmp14_;
#line 1118 "CryptTabEntry.c"
	}
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp15_ = self->options;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp16_ = string_strip (_tmp15_);
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->options = _tmp16_;
#line 1128 "CryptTabEntry.c"
}


void crypt_tab_entry_remove_option (CryptTabEntry* self, const gchar* option) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp12_;
	gboolean _tmp13_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = self->options;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp1_ = option;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp2_ = string_replace (_tmp0_, _tmp1_, "");
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp3_ = _tmp2_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->options = _tmp4_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (_tmp3_);
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp5_ = self->options;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp6_ = g_str_has_prefix (_tmp5_, ",");
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (_tmp6_) {
#line 1170 "CryptTabEntry.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp7_ = self->options;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp8_ = self->options;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp9_ = strlen (_tmp8_);
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp10_ = _tmp9_;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp11_ = string_slice (_tmp7_, (glong) 1, (glong) _tmp10_);
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		self->options = _tmp11_;
#line 1190 "CryptTabEntry.c"
	}
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp12_ = self->options;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp13_ = g_str_has_suffix (_tmp12_, ",");
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (_tmp13_) {
#line 1198 "CryptTabEntry.c"
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp14_ = self->options;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp15_ = self->options;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp16_ = strlen (_tmp15_);
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp17_ = _tmp16_;
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp18_ = string_slice (_tmp14_, (glong) 0, (glong) (_tmp17_ - 1));
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		self->options = _tmp18_;
#line 1218 "CryptTabEntry.c"
	}
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp19_ = self->options;
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp20_ = string_strip (_tmp19_);
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->options = _tmp20_;
#line 1228 "CryptTabEntry.c"
}


CryptTabEntry* crypt_tab_entry_find_entry_by_uuid (GeeArrayList* entries, const gchar* uuid) {
	CryptTabEntry* result = NULL;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1238 "CryptTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _entry_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp0_ = entries;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_entry_list = _tmp1_;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp2_ = _entry_list;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp4_ = _tmp3_;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_entry_size = _tmp4_;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_entry_index = -1;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		while (TRUE) {
#line 1266 "CryptTabEntry.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			CryptTabEntry* entry = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			CryptTabEntry* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			const gchar* _tmp15_;
			gboolean _tmp16_;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp5_ = _entry_index;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_entry_index = _tmp5_ + 1;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp6_ = _entry_index;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp7_ = _entry_size;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				break;
#line 1292 "CryptTabEntry.c"
			}
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp8_ = _entry_list;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp9_ = _entry_index;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			entry = (CryptTabEntry*) _tmp10_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp11_ = entry;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp12_ = crypt_tab_entry_get_device_uuid (_tmp11_);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp13_ = _tmp12_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp14_ = _tmp13_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp15_ = uuid;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_tmp16_ = g_strcmp0 (_tmp14_, _tmp15_) == 0;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_g_free0 (_tmp14_);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			if (_tmp16_) {
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				result = entry;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				_g_object_unref0 (_entry_list);
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
				return result;
#line 1324 "CryptTabEntry.c"
			}
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
			_g_object_unref0 (entry);
#line 1328 "CryptTabEntry.c"
		}
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_object_unref0 (_entry_list);
#line 1332 "CryptTabEntry.c"
	}
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	result = NULL;
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	return result;
#line 1338 "CryptTabEntry.c"
}


CryptTabEntry* crypt_tab_entry_construct (GType object_type) {
	CryptTabEntry * self = NULL;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self = (CryptTabEntry*) g_object_new (object_type, NULL);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	return self;
#line 1348 "CryptTabEntry.c"
}


CryptTabEntry* crypt_tab_entry_new (void) {
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	return crypt_tab_entry_construct (TYPE_CRYPT_TAB_ENTRY);
#line 1355 "CryptTabEntry.c"
}


gchar* crypt_tab_entry_get_device_uuid (CryptTabEntry* self) {
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = self->device_string;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "uuid=");
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp4_ = _tmp3_;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (_tmp2_);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	if (_tmp4_) {
#line 1382 "CryptTabEntry.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp5_ = self->device_string;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp6_ = string_replace (_tmp5_, "\"", "");
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp7_ = _tmp6_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp8_ = string_replace (_tmp7_, "'", "");
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp9_ = _tmp8_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, "=", 0);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp12_ = _tmp11_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp12__length1 = _vala_array_length (_tmp10_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp13_ = _tmp12_[1];
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp15_ = _tmp14_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (_tmp9_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_g_free0 (_tmp7_);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		result = _tmp15_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		return result;
#line 1427 "CryptTabEntry.c"
	} else {
		gchar* _tmp16_;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		_tmp16_ = g_strdup ("");
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		result = _tmp16_;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		return result;
#line 1436 "CryptTabEntry.c"
	}
}


void crypt_tab_entry_set_device_uuid (CryptTabEntry* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = value;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp1_ = g_strdup_printf ("UUID=%s", _tmp0_);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->device_string);
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->device_string = _tmp1_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, crypt_tab_entry_properties[CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY]);
#line 1456 "CryptTabEntry.c"
}


static void crypt_tab_entry_class_init (CryptTabEntryClass * klass) {
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	crypt_tab_entry_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_crypt_tab_entry_get_property;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_crypt_tab_entry_set_property;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = crypt_tab_entry_finalize;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY, crypt_tab_entry_properties[CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY] = g_param_spec_string ("device-uuid", "device-uuid", "device-uuid", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1471 "CryptTabEntry.c"
}


static void crypt_tab_entry_instance_init (CryptTabEntry * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 34 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->is_comment = FALSE;
#line 35 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->is_empty_line = FALSE;
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->mapped_name = _tmp0_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp1_ = g_strdup ("");
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->device_string = _tmp1_;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp2_ = g_strdup ("none");
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->keyfile = _tmp2_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp3_ = g_strdup ("luks,nofail");
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->options = _tmp3_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_tmp4_ = g_strdup ("");
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self->line = _tmp4_;
#line 1505 "CryptTabEntry.c"
}


static void crypt_tab_entry_finalize (GObject * obj) {
	CryptTabEntry * self;
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->mapped_name);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->device_string);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->keyfile);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	_g_free0 (self->line);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (crypt_tab_entry_parent_class)->finalize (obj);
#line 1525 "CryptTabEntry.c"
}


GType crypt_tab_entry_get_type (void) {
	static volatile gsize crypt_tab_entry_type_id__volatile = 0;
	if (g_once_init_enter (&crypt_tab_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CryptTabEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crypt_tab_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CryptTabEntry), 0, (GInstanceInitFunc) crypt_tab_entry_instance_init, NULL };
		GType crypt_tab_entry_type_id;
		crypt_tab_entry_type_id = g_type_register_static (G_TYPE_OBJECT, "CryptTabEntry", &g_define_type_info, 0);
		g_once_init_leave (&crypt_tab_entry_type_id__volatile, crypt_tab_entry_type_id);
	}
	return crypt_tab_entry_type_id__volatile;
}


static void _vala_crypt_tab_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CryptTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		case CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		g_value_take_string (value, crypt_tab_entry_get_device_uuid (self));
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		break;
#line 1552 "CryptTabEntry.c"
		default:
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		break;
#line 1558 "CryptTabEntry.c"
	}
}


static void _vala_crypt_tab_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CryptTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		case CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		crypt_tab_entry_set_device_uuid (self, g_value_get_string (value));
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		break;
#line 1574 "CryptTabEntry.c"
		default:
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/timeshift-18.4/src/Utility/CryptTabEntry.vala"
		break;
#line 1580 "CryptTabEntry.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



