/* Device.c generated by valac 0.38.10, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Device.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */
/* Functions and classes for handling disk partitions */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>


#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_MOUNT_ENTRY (mount_entry_get_type ())
#define MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ENTRY, MountEntry))
#define MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ENTRY, MountEntryClass))
#define IS_MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ENTRY))
#define IS_MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ENTRY))
#define MOUNT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ENTRY, MountEntryClass))

typedef struct _MountEntry MountEntry;
typedef struct _MountEntryClass MountEntryClass;
enum  {
	DEVICE_0_PROPERTY,
	DEVICE_FREE_BYTES_PROPERTY,
	DEVICE_SIZE_PROPERTY,
	DEVICE_USED_PROPERTY,
	DEVICE_FREE_PROPERTY,
	DEVICE_IS_MOUNTED_PROPERTY,
	DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_FULL_NAME_WITH_PARENT_PROPERTY,
	DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY,
	DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY,
	DEVICE_NUM_PROPERTIES
};
static GParamSpec* device_properties[DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MountEntryPrivate MountEntryPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
	gchar* device;
	gchar* name;
	gchar* kname;
	gchar* pkname;
	gchar* pkname_toplevel;
	gchar* mapped_name;
	gchar* uuid;
	gchar* label;
	gchar* partuuid;
	gchar* partlabel;
	gint major;
	gint minor;
	gchar* device_mapper;
	gchar* device_by_uuid;
	gchar* device_by_label;
	gchar* device_by_partuuid;
	gchar* device_by_partlabel;
	gchar* type;
	gchar* fstype;
	gint order;
	gchar* vendor;
	gchar* model;
	gchar* serial;
	gchar* revision;
	gboolean removable;
	gboolean read_only;
	guint64 size_bytes;
	guint64 used_bytes;
	guint64 available_bytes;
	gchar* used_percent;
	gchar* dist_info;
	GeeArrayList* mount_points;
	GeeArrayList* symlinks;
	Device* parent;
	GeeArrayList* children;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _MountEntry {
	GObject parent_instance;
	MountEntryPrivate * priv;
	Device* device;
	gchar* mount_point;
	gchar* mount_options;
};

struct _MountEntryClass {
	GObjectClass parent_class;
};


static gpointer device_parent_class = NULL;
extern gdouble device_KB;
gdouble device_KB = (gdouble) 1000;
extern gdouble device_MB;
gdouble device_MB = 0.0;
extern gdouble device_GB;
gdouble device_GB = 0.0;
extern gdouble device_KiB;
gdouble device_KiB = (gdouble) 1024;
extern gdouble device_MiB;
gdouble device_MiB = 0.0;
extern gdouble device_GiB;
gdouble device_GiB = 0.0;
static gchar* device_lsblk_version;
static gchar* device_lsblk_version = NULL;
static gboolean device_lsblk_is_ancient;
static gboolean device_lsblk_is_ancient = FALSE;
static GeeArrayList* device_device_list;
static GeeArrayList* device_device_list = NULL;
extern gboolean tee_jee_logging_LOG_DEBUG;

GType device_get_type (void) G_GNUC_CONST;
GType mount_entry_get_type (void) G_GNUC_CONST;
Device* device_new (void);
Device* device_construct (GType object_type);
void device_test_lsblk_version (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd, gchar* * std_out, gchar* * std_err);
gboolean device_is_mounted_at_path (Device* self, const gchar* subvolname, const gchar* mount_path);
gboolean device_has_linux_filesystem (Device* self);
gboolean device_is_encrypted_partition (Device* self);
gboolean device_is_on_encrypted_partition (Device* self);
gboolean device_is_lvm_partition (Device* self);
gboolean device_has_children (Device* self);
Device* device_first_linux_child (Device* self);
gboolean device_has_parent (Device* self);
GeeArrayList* device_get_filesystems (gboolean get_space, gboolean get_mounts);
GeeArrayList* device_get_block_devices_using_lsblk (const gchar* dev_name);
GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point);
Device* device_find_device_in_list (GeeArrayList* list, const gchar* _dev_alias);
GeeArrayList* device_get_mounted_filesystems_using_mtab (void);
void tee_jee_logging_log_debug (const gchar* message);
static void device_find_child_devices (GeeArrayList* list, Device* parent);
static void device_find_toplevel_parent (GeeArrayList* list, Device* dev);
static void device_find_child_devices_using_dmsetup (GeeArrayList* list);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
MountEntry* mount_entry_new (Device* device, const gchar* mount_point, const gchar* mount_options);
MountEntry* mount_entry_construct (GType object_type, Device* device, const gchar* mount_point, const gchar* mount_options);
gchar* tee_jee_file_system_path_combine (const gchar* path1, const gchar* path2);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GeeArrayList* device_get_block_devices_using_blkid (const gchar* dev_name);
gint tee_jee_process_helper_exec_script_sync (const gchar* script, gchar* * std_out, gchar* * std_err, gboolean supress_errors, gboolean run_as_admin, gboolean cleanup_tmp, gboolean print_to_terminal);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* device_resolve_device_name (const gchar* dev_alias);
gchar* device_get_device_uuid (const gchar* device);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
Device* device_get_device_by_uuid (const gchar* uuid);
Device* device_get_device_by_name (const gchar* file_name);
Device* device_get_device_by_path (const gchar* path_to_check);
GeeArrayList* device_get_device_mount_points (const gchar* dev_name_or_uuid);
gboolean device_device_is_mounted (const gchar* dev_name_or_uuid);
gboolean device_mount_point_in_use (const gchar* mount_point);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
void device_copy_fields_from (Device* self, Device* dev2);
Device* device_query_changes (Device* self);
void device_query_disk_space (Device* self);
gboolean device_automount_udisks (const gchar* dev_name_or_uuid, GtkWindow* parent_window);
void tee_jee_gtk_helper_gtk_messagebox (const gchar* title, const gchar* message, GtkWindow* parent_win, gboolean is_error);
gboolean device_automount_udisks_iso (const gchar* iso_file_path, gchar* * loop_device, GtkWindow* parent_window);
void tee_jee_logging_log_msg (const gchar* message, gboolean highlight);
gboolean device_unmount_udisks (const gchar* dev_name_or_uuid, GtkWindow* parent_window);
Device* device_luks_unlock (Device* luks_device, const gchar* mapped_name, const gchar* passphrase, GtkWindow* parent_window, gchar* * message, gchar* * details);
GType timeout_counter_get_type (void) G_GNUC_CONST;
TimeoutCounter* timeout_counter_new (void);
TimeoutCounter* timeout_counter_construct (GType object_type);
void timeout_counter_kill_process_on_timeout (TimeoutCounter* self, const gchar* process_to_kill, gint seconds_to_wait, gboolean exit_app);
void timeout_counter_stop (TimeoutCounter* self);
gchar* tee_jee_gtk_helper_gtk_inputbox (const gchar* title, const gchar* message, GtkWindow* parent_win, gboolean mask_password);
gboolean device_luks_lock (const gchar* kname, GtkWindow* parent_window);
gboolean device_mount (const gchar* dev_name_or_uuid, const gchar* mount_point, const gchar* mount_options, gboolean silent);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path, gboolean show_message);
gboolean device_unmount (const gchar* mount_point);
gchar* device_get_device_name_with_parent (Device* self);
gchar* device_automount (const gchar* dev_name_or_uuid, const gchar* mount_options, const gchar* mount_prefix);
gchar* device_description (Device* self);
gchar* device_description_formatted (Device* self);
gchar* tee_jee_file_system_format_file_size (guint64 size, gboolean binary_units, const gchar* unit, gboolean show_units, gint decimals);
gchar* device_get_short_name_with_parent (Device* self);
gchar* device_description_simple (Device* self);
gchar* device_description_simple_formatted (Device* self);
gchar* device_description_full_free (Device* self);
guint64 device_get_free_bytes (Device* self);
gchar* device_description_free (Device* self);
gchar* device_description_full (Device* self);
gchar* device_get_used (Device* self);
gchar* device_get_size (Device* self);
gchar* device_description_usage (Device* self);
gchar* device_tooltip_text (Device* self);
static gchar* device_display_name (Device* self, gboolean short_name, gboolean show_label, gboolean show_parent, gboolean show_alias);
void device_test_all (void);
void device_print_device_list (GeeArrayList* list);
void device_print_device_mounts (GeeArrayList* list);
void device_print_device_disk_space (GeeArrayList* list);
gchar* device_get_free (Device* self);
gboolean device_get_is_mounted (Device* self);
gchar* device_get_full_name_with_alias (Device* self);
gchar* device_get_full_name_with_parent (Device* self);
gchar* device_get_short_name_with_alias (Device* self);
static void device_finalize (GObject * obj);
static void _vala_device_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


Device* device_construct (GType object_type) {
	Device * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self = (Device*) g_object_new (object_type, NULL);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->mount_points = _tmp0_;
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 96 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->symlinks = _tmp1_;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->children = _tmp2_;
#line 99 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_test_lsblk_version ();
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return self;
#line 294 "Device.c"
}


Device* device_new (void) {
#line 94 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return device_construct (TYPE_DEVICE);
#line 301 "Device.c"
}


void device_test_lsblk_version (void) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
	gint _tmp8_;
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_lsblk_version;
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_ != NULL) {
#line 319 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = device_lsblk_version;
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp4_ > 0;
#line 331 "Device.c"
	} else {
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 335 "Device.c"
	}
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp0_) {
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return;
#line 341 "Device.c"
	}
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync ("lsblk --bytes --pairs --output HOTPLUG,PKNAME,VENDOR,SERIAL,REV", &_tmp5_, &_tmp6_);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp5_;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp6_;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	status = _tmp7_;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = status;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp8_ == 0) {
#line 359 "Device.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = std_out;
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device_lsblk_version = _tmp10_;
#line 112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device_lsblk_is_ancient = FALSE;
#line 372 "Device.c"
	} else {
		gchar* _tmp11_;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strdup ("ancient");
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device_lsblk_version = _tmp11_;
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device_lsblk_is_ancient = TRUE;
#line 383 "Device.c"
	}
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 389 "Device.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 396 "Device.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 416 "Device.c"
}


gboolean device_is_mounted_at_path (Device* self, const gchar* subvolname, const gchar* mount_path) {
	gboolean result = FALSE;
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (subvolname != NULL, FALSE);
#line 158 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_path != NULL, FALSE);
#line 428 "Device.c"
	{
		GeeArrayList* _mnt_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _mnt_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mnt_index = 0;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = self->mount_points;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mnt_list = _tmp1_;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = _mnt_list;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mnt_size = _tmp4_;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mnt_index = -1;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 456 "Device.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			MountEntry* mnt = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			MountEntry* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = _mnt_index;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_mnt_index = _tmp5_ + 1;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = _mnt_index;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = _mnt_size;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 479 "Device.c"
			}
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _mnt_list;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _mnt_index;
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mnt = (MountEntry*) _tmp10_;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = mnt;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = _tmp11_->mount_point;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = mount_path;
#line 161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
#line 497 "Device.c"
				const gchar* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp14_ = subvolname;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp15_ = strlen (_tmp14_);
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp16_ = _tmp15_;
#line 162 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp16_ == 0) {
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					result = TRUE;
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (mnt);
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (_mnt_list);
#line 163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					return result;
#line 517 "Device.c"
				} else {
					gboolean _tmp17_ = FALSE;
					MountEntry* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gboolean _tmp23_;
					gboolean _tmp24_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp18_ = mnt;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp19_ = _tmp18_->mount_options;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp20_ = subvolname;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp21_ = g_strdup_printf ("subvol=%s", _tmp20_);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_ = _tmp21_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp23_ = string_contains (_tmp19_, _tmp22_);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp24_ = _tmp23_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_tmp22_);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp24_) {
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp17_ = TRUE;
#line 547 "Device.c"
					} else {
						MountEntry* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						gboolean _tmp30_;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp25_ = mnt;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp26_ = _tmp25_->mount_options;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp27_ = subvolname;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp28_ = g_strdup_printf ("subvol=/%s", _tmp27_);
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp29_ = _tmp28_;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp30_ = string_contains (_tmp26_, _tmp29_);
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp17_ = _tmp30_;
#line 166 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp29_);
#line 571 "Device.c"
					}
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp17_) {
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						result = TRUE;
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (mnt);
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (_mnt_list);
#line 168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						return result;
#line 583 "Device.c"
					}
				}
			}
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (mnt);
#line 589 "Device.c"
		}
#line 160 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_mnt_list);
#line 593 "Device.c"
	}
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = FALSE;
#line 173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 599 "Device.c"
}


gboolean device_has_linux_filesystem (Device* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	static GQuark _tmp2_label13 = 0;
#line 176 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->fstype;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if ((((((((((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ext2")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ext3"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ext4"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("reiserfs"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("reiser4"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("xfs"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("jfs"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("btrfs"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("lvm"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("lvm2"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("lvm2_member"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("luks"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("crypt"))))) || (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("crypto_luks"))))) {
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		switch (0) {
#line 648 "Device.c"
			default:
			{
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = TRUE;
#line 192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 655 "Device.c"
			}
		}
	} else {
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		switch (0) {
#line 661 "Device.c"
			default:
			{
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = FALSE;
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 668 "Device.c"
			}
		}
	}
}


gboolean device_is_encrypted_partition (Device* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 685 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = string_contains (_tmp4_, "luks");
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp5_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 702 "Device.c"
	} else {
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 706 "Device.c"
	}
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp0_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 712 "Device.c"
}


gboolean device_is_on_encrypted_partition (Device* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 202 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->type;
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = g_strcmp0 (_tmp0_, "crypt") == 0;
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 727 "Device.c"
}


gboolean device_is_lvm_partition (Device* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 741 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = string_contains (_tmp4_, "lvm2_member");
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp5_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 758 "Device.c"
	} else {
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 762 "Device.c"
	}
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp0_;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 768 "Device.c"
}


gboolean device_has_children (Device* self) {
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->children;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp2_ > 0;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 789 "Device.c"
}


Device* device_first_linux_child (Device* self) {
	Device* result = NULL;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 797 "Device.c"
	{
		GeeArrayList* _child_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _child_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _child_index = 0;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = self->children;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_child_list = _tmp1_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = _child_list;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_child_size = _tmp4_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_child_index = -1;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 825 "Device.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			Device* child = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			gboolean _tmp12_;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = _child_index;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_child_index = _tmp5_ + 1;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = _child_index;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = _child_size;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 847 "Device.c"
			}
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _child_list;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _child_index;
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			child = (Device*) _tmp10_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = child;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = device_has_linux_filesystem (_tmp11_);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp12_) {
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = child;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_child_list);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 869 "Device.c"
			}
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (child);
#line 873 "Device.c"
		}
#line 216 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_child_list);
#line 877 "Device.c"
	}
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = NULL;
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 883 "Device.c"
}


gboolean device_has_parent (Device* self) {
	gboolean result = FALSE;
	Device* _tmp0_;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->parent;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp0_ != NULL;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 898 "Device.c"
}


GeeArrayList* device_get_filesystems (gboolean get_space, gboolean get_mounts) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp32_;
	GeeArrayList* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = get_space;
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_) {
#line 921 "Device.c"
		GeeArrayList* list_df = NULL;
		GeeArrayList* _tmp2_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = device_get_disk_space_using_df ("");
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		list_df = _tmp2_;
#line 928 "Device.c"
		{
			GeeArrayList* _dev_df_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _dev_df_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _dev_df_index = 0;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp3_ = list_df;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp4_ = _g_object_ref0 (_tmp3_);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_df_list = _tmp4_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = _dev_df_list;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = _tmp6_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_df_size = _tmp7_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_df_index = -1;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			while (TRUE) {
#line 956 "Device.c"
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				Device* dev_df = NULL;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gpointer _tmp13_;
				Device* dev = NULL;
				GeeArrayList* _tmp14_;
				Device* _tmp15_;
				const gchar* _tmp16_;
				Device* _tmp17_;
				Device* _tmp18_;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp8_ = _dev_df_index;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_dev_df_index = _tmp8_ + 1;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp9_ = _dev_df_index;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp10_ = _dev_df_size;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 982 "Device.c"
				}
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp11_ = _dev_df_list;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp12_ = _dev_df_index;
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				dev_df = (Device*) _tmp13_;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp14_ = list;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp15_ = dev_df;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp16_ = _tmp15_->uuid;
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp17_ = device_find_device_in_list (_tmp14_, _tmp16_);
#line 242 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				dev = _tmp17_;
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp18_ = dev;
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp18_ != NULL) {
#line 1006 "Device.c"
					Device* _tmp19_;
					Device* _tmp20_;
					guint64 _tmp21_;
					Device* _tmp22_;
					Device* _tmp23_;
					guint64 _tmp24_;
					Device* _tmp25_;
					Device* _tmp26_;
					guint64 _tmp27_;
					Device* _tmp28_;
					Device* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp19_ = dev;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp20_ = dev_df;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp21_ = _tmp20_->size_bytes;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp19_->size_bytes = _tmp21_;
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_ = dev;
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp23_ = dev_df;
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp24_ = _tmp23_->used_bytes;
#line 245 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_->used_bytes = _tmp24_;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp25_ = dev;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = dev_df;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp27_ = _tmp26_->available_bytes;
#line 246 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp25_->available_bytes = _tmp27_;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp28_ = dev;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp29_ = dev_df;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp30_ = _tmp29_->used_percent;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp31_ = g_strdup (_tmp30_);
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_tmp28_->used_percent);
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp28_->used_percent = _tmp31_;
#line 1056 "Device.c"
				}
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (dev_df);
#line 1062 "Device.c"
			}
#line 241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (_dev_df_list);
#line 1066 "Device.c"
		}
#line 238 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list_df);
#line 1070 "Device.c"
	}
#line 252 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp32_ = get_mounts;
#line 252 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp32_) {
#line 1076 "Device.c"
		GeeArrayList* list_mtab = NULL;
		GeeArrayList* _tmp33_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp33_ = device_get_mounted_filesystems_using_mtab ();
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		list_mtab = _tmp33_;
#line 1083 "Device.c"
		{
			GeeArrayList* _dev_mtab_list = NULL;
			GeeArrayList* _tmp34_;
			GeeArrayList* _tmp35_;
			gint _dev_mtab_size = 0;
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gint _dev_mtab_index = 0;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp34_ = list_mtab;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp35_ = _g_object_ref0 (_tmp34_);
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_mtab_list = _tmp35_;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp36_ = _dev_mtab_list;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp38_ = _tmp37_;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_mtab_size = _tmp38_;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_mtab_index = -1;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			while (TRUE) {
#line 1111 "Device.c"
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				Device* dev_mtab = NULL;
				GeeArrayList* _tmp42_;
				gint _tmp43_;
				gpointer _tmp44_;
				Device* dev = NULL;
				GeeArrayList* _tmp45_;
				Device* _tmp46_;
				const gchar* _tmp47_;
				Device* _tmp48_;
				Device* _tmp49_;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp39_ = _dev_mtab_index;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_dev_mtab_index = _tmp39_ + 1;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp40_ = _dev_mtab_index;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp41_ = _dev_mtab_size;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!(_tmp40_ < _tmp41_)) {
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 1137 "Device.c"
				}
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42_ = _dev_mtab_list;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp43_ = _dev_mtab_index;
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp42_, _tmp43_);
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				dev_mtab = (Device*) _tmp44_;
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp45_ = list;
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp46_ = dev_mtab;
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp47_ = _tmp46_->uuid;
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp48_ = device_find_device_in_list (_tmp45_, _tmp47_);
#line 256 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				dev = _tmp48_;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp49_ = dev;
#line 257 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp49_ != NULL) {
#line 1161 "Device.c"
					Device* _tmp50_;
					Device* _tmp51_;
					GeeArrayList* _tmp52_;
					GeeArrayList* _tmp53_;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp50_ = dev;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp51_ = dev_mtab;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp52_ = _tmp51_->mount_points;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp53_ = _g_object_ref0 (_tmp52_);
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (_tmp50_->mount_points);
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp50_->mount_points = _tmp53_;
#line 1178 "Device.c"
				}
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (dev_mtab);
#line 1184 "Device.c"
			}
#line 255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (_dev_mtab_list);
#line 1188 "Device.c"
		}
#line 252 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1192 "Device.c"
	}
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp54_ = list;
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp55_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp54_);
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp56_ = _tmp55_;
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp57_ = g_strdup_printf ("Device: get_filesystems(): %d", _tmp56_);
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp58_ = _tmp57_;
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp58_);
#line 267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp58_);
#line 269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = list;
#line 269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 1212 "Device.c"
}


static void device_find_child_devices (GeeArrayList* list, Device* parent) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (parent != NULL);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_lsblk_is_ancient;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_) {
#line 1227 "Device.c"
		Device* _tmp2_;
		const gchar* _tmp3_;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = parent;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = _tmp2_->type;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, "disk") == 0;
#line 1236 "Device.c"
	} else {
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = FALSE;
#line 1240 "Device.c"
	}
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp0_) {
#line 1244 "Device.c"
		{
			GeeArrayList* _part_list = NULL;
			GeeArrayList* _tmp4_;
			GeeArrayList* _tmp5_;
			gint _part_size = 0;
			GeeArrayList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _part_index = 0;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp4_ = list;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_list = _tmp5_;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = _part_list;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_size = _tmp8_;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_index = -1;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			while (TRUE) {
#line 1272 "Device.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				Device* part = NULL;
				GeeArrayList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				gboolean _tmp15_ = FALSE;
				Device* _tmp16_;
				const gchar* _tmp17_;
				Device* _tmp18_;
				const gchar* _tmp19_;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp9_ = _part_index;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_part_index = _tmp9_ + 1;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp10_ = _part_index;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp11_ = _part_size;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 1297 "Device.c"
				}
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp12_ = _part_list;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp13_ = _part_index;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				part = (Device*) _tmp14_;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp16_ = part;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp17_ = _tmp16_->kname;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp18_ = parent;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp19_ = _tmp18_->kname;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (g_strcmp0 (_tmp17_, _tmp19_) != 0) {
#line 1317 "Device.c"
					Device* _tmp20_;
					const gchar* _tmp21_;
					Device* _tmp22_;
					const gchar* _tmp23_;
					gboolean _tmp24_;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp20_ = part;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp21_ = _tmp20_->kname;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_ = parent;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp23_ = _tmp22_->kname;
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp24_ = g_str_has_prefix (_tmp21_, _tmp23_);
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp15_ = _tmp24_;
#line 1335 "Device.c"
				} else {
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp15_ = FALSE;
#line 1339 "Device.c"
				}
#line 275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp15_) {
#line 1343 "Device.c"
					Device* _tmp25_;
					GeeArrayList* _tmp26_;
					Device* _tmp27_;
					Device* _tmp28_;
					Device* _tmp29_;
					Device* _tmp30_;
					Device* _tmp31_;
					Device* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
					Device* _tmp35_;
					const gchar* _tmp36_;
					Device* _tmp37_;
					const gchar* _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp25_ = parent;
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = _tmp25_->children;
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp27_ = part;
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp28_ = part;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp29_ = parent;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp30_ = _g_object_ref0 (_tmp29_);
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (_tmp28_->parent);
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp28_->parent = _tmp30_;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp31_ = part;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp32_ = parent;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp33_ = _tmp32_->kname;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp34_ = g_strdup (_tmp33_);
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_tmp31_->pkname);
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp31_->pkname = _tmp34_;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp35_ = parent;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp36_ = _tmp35_->kname;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp37_ = part;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp38_ = _tmp37_->kname;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp39_ = g_strdup_printf ("%s -> %s", _tmp36_, _tmp38_);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp40_ = _tmp39_;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_debug (_tmp40_);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_tmp40_);
#line 1406 "Device.c"
				}
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (part);
#line 1410 "Device.c"
			}
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (_part_list);
#line 1414 "Device.c"
		}
	} else {
		{
			GeeArrayList* _part_list = NULL;
			GeeArrayList* _tmp41_;
			GeeArrayList* _tmp42_;
			gint _part_size = 0;
			GeeArrayList* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			gint _part_index = 0;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp41_ = list;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp42_ = _g_object_ref0 (_tmp41_);
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_list = _tmp42_;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp43_ = _part_list;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp44_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp43_);
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_size = _tmp45_;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_index = -1;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			while (TRUE) {
#line 1444 "Device.c"
				gint _tmp46_;
				gint _tmp47_;
				gint _tmp48_;
				Device* part = NULL;
				GeeArrayList* _tmp49_;
				gint _tmp50_;
				gpointer _tmp51_;
				Device* _tmp52_;
				const gchar* _tmp53_;
				Device* _tmp54_;
				const gchar* _tmp55_;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp46_ = _part_index;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_part_index = _tmp46_ + 1;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp47_ = _part_index;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp48_ = _part_size;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!(_tmp47_ < _tmp48_)) {
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 1468 "Device.c"
				}
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp49_ = _part_list;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp50_ = _part_index;
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp49_, _tmp50_);
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				part = (Device*) _tmp51_;
#line 285 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp52_ = part;
#line 285 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp53_ = _tmp52_->pkname;
#line 285 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp54_ = parent;
#line 285 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp55_ = _tmp54_->kname;
#line 285 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (g_strcmp0 (_tmp53_, _tmp55_) == 0) {
#line 1488 "Device.c"
					Device* _tmp56_;
					GeeArrayList* _tmp57_;
					Device* _tmp58_;
					Device* _tmp59_;
					Device* _tmp60_;
					Device* _tmp61_;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp56_ = parent;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp57_ = _tmp56_->children;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp58_ = part;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp58_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp59_ = part;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp60_ = parent;
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp61_ = _g_object_ref0 (_tmp60_);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (_tmp59_->parent);
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp59_->parent = _tmp61_;
#line 1513 "Device.c"
				}
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (part);
#line 1517 "Device.c"
			}
#line 284 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (_part_list);
#line 1521 "Device.c"
		}
	}
}


static void device_find_toplevel_parent (GeeArrayList* list, Device* dev) {
	Device* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* top_kname = NULL;
	Device* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	Device* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
#line 293 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 293 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (dev != NULL);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = dev;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_->pkname;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = strlen (_tmp1_);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp3_ == 0) {
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return;
#line 1555 "Device.c"
	}
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = dev;
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = _tmp4_->pkname;
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	top_kname = _tmp6_;
#line 1565 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp7_;
		GeeArrayList* _tmp8_;
		gint _part_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _part_index = 0;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = list;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_list = _tmp8_;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = _part_list;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_size = _tmp11_;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_index = -1;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 1593 "Device.c"
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			Device* part = NULL;
			GeeArrayList* _tmp15_;
			gint _tmp16_;
			gpointer _tmp17_;
			Device* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = _part_index;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_index = _tmp12_ + 1;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = _part_index;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = _part_size;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 1616 "Device.c"
			}
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = _part_list;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = _part_index;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			part = (Device*) _tmp17_;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp18_ = part;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = _tmp18_->kname;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = top_kname;
#line 300 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp19_, _tmp20_) == 0) {
#line 1634 "Device.c"
				Device* _tmp21_;
				const gchar* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp21_ = part;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp22_ = _tmp21_->pkname;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp23_ = strlen (_tmp22_);
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp24_ = _tmp23_;
#line 301 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp24_ > 0) {
#line 1649 "Device.c"
					Device* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp25_ = part;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = _tmp25_->pkname;
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp27_ = g_strdup (_tmp26_);
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (top_kname);
#line 302 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					top_kname = _tmp27_;
#line 1663 "Device.c"
				}
			}
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 1668 "Device.c"
		}
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 1672 "Device.c"
	}
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp28_ = dev;
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp29_ = top_kname;
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp30_ = g_strdup (_tmp29_);
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp28_->pkname_toplevel);
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp28_->pkname_toplevel = _tmp30_;
#line 293 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (top_kname);
#line 1686 "Device.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 1709 "Device.c"
}


static void device_find_child_devices_using_dmsetup (GeeArrayList* list) {
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	GError * _inner_error_ = NULL;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_process_helper_exec_sync ("dmsetup deps -o blkdevname", &_tmp0_, &_tmp1_);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp0_;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp1_;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = std_out;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 1740 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = _tmp4_;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp3_);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp3_); line_it = line_it + 1) {
#line 1752 "Device.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			line = _tmp5_;
#line 1759 "Device.c"
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gboolean _tmp11_;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp6_ = line;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp7_ = string_strip (_tmp6_);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp8_ = _tmp7_;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp9_ = strlen (_tmp8_);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp11_ = _tmp10_ == 0;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp8_);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp11_) {
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 1787 "Device.c"
				}
				{
					GRegex* _tmp12_ = NULL;
					GRegex* _tmp13_;
					GRegex* _tmp14_;
					GRegex* _tmp15_;
					const gchar* _tmp16_;
					GMatchInfo* _tmp17_ = NULL;
					gboolean _tmp18_;
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp13_ = g_regex_new ("([^:]*)\\:.*\\((.*)\\)", 0, 0, &_inner_error_);
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp12_ = _tmp13_;
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1803 "Device.c"
						goto __catch42_g_error;
					}
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp14_ = _tmp12_;
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp12_ = NULL;
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					rex = _tmp14_;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp15_ = rex;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp16_ = line;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp18_ = g_regex_match (_tmp15_, _tmp16_, 0, &_tmp17_);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					match = _tmp17_;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp18_) {
#line 1826 "Device.c"
						gchar* child_name = NULL;
						GMatchInfo* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* parent_kname = NULL;
						GMatchInfo* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						Device* parent = NULL;
						Device* child = NULL;
						gboolean _tmp61_ = FALSE;
						Device* _tmp62_;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp19_ = match;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp20_ = g_match_info_fetch (_tmp19_, 1);
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp22_ = string_strip (_tmp21_);
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp23_ = _tmp22_;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						child_name = _tmp23_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp24_ = match;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp25_ = g_match_info_fetch (_tmp24_, 2);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp26_ = _tmp25_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp27_ = string_strip (_tmp26_);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp28_ = _tmp27_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp26_);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						parent_kname = _tmp28_;
#line 338 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						parent = NULL;
#line 1873 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							GeeArrayList* _tmp29_;
							GeeArrayList* _tmp30_;
							gint _dev_size = 0;
							GeeArrayList* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							gint _dev_index = 0;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp29_ = list;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp30_ = _g_object_ref0 (_tmp29_);
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_dev_list = _tmp30_;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp31_ = _dev_list;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp31_);
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp33_ = _tmp32_;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_dev_size = _tmp33_;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_dev_index = -1;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							while (TRUE) {
#line 1901 "Device.c"
								gint _tmp34_;
								gint _tmp35_;
								gint _tmp36_;
								Device* dev = NULL;
								GeeArrayList* _tmp37_;
								gint _tmp38_;
								gpointer _tmp39_;
								Device* _tmp40_;
								const gchar* _tmp41_;
								const gchar* _tmp42_;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp34_ = _dev_index;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_dev_index = _tmp34_ + 1;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp35_ = _dev_index;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp36_ = _dev_size;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								if (!(_tmp35_ < _tmp36_)) {
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 1924 "Device.c"
								}
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp37_ = _dev_list;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp38_ = _dev_index;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp37_, _tmp38_);
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								dev = (Device*) _tmp39_;
#line 340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp40_ = dev;
#line 340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp41_ = _tmp40_->kname;
#line 340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp42_ = parent_kname;
#line 340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								if (g_strcmp0 (_tmp41_, _tmp42_) == 0) {
#line 1942 "Device.c"
									Device* _tmp43_;
									Device* _tmp44_;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp43_ = dev;
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp44_ = _g_object_ref0 (_tmp43_);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_object_unref0 (parent);
#line 341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									parent = _tmp44_;
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_object_unref0 (dev);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 1957 "Device.c"
								}
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1961 "Device.c"
							}
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1965 "Device.c"
						}
#line 346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						child = NULL;
#line 1969 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							GeeArrayList* _tmp45_;
							GeeArrayList* _tmp46_;
							gint _dev_size = 0;
							GeeArrayList* _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							gint _dev_index = 0;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp45_ = list;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp46_ = _g_object_ref0 (_tmp45_);
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_dev_list = _tmp46_;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp47_ = _dev_list;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp49_ = _tmp48_;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_dev_size = _tmp49_;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_dev_index = -1;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							while (TRUE) {
#line 1997 "Device.c"
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								Device* dev = NULL;
								GeeArrayList* _tmp53_;
								gint _tmp54_;
								gpointer _tmp55_;
								Device* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp50_ = _dev_index;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_dev_index = _tmp50_ + 1;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp51_ = _dev_index;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp52_ = _dev_size;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								if (!(_tmp51_ < _tmp52_)) {
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 2020 "Device.c"
								}
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp53_ = _dev_list;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp54_ = _dev_index;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _tmp54_);
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								dev = (Device*) _tmp55_;
#line 348 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp56_ = dev;
#line 348 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp57_ = _tmp56_->mapped_name;
#line 348 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp58_ = child_name;
#line 348 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								if (g_strcmp0 (_tmp57_, _tmp58_) == 0) {
#line 2038 "Device.c"
									Device* _tmp59_;
									Device* _tmp60_;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp59_ = dev;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp60_ = _g_object_ref0 (_tmp59_);
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_object_unref0 (child);
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									child = _tmp60_;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_object_unref0 (dev);
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 2053 "Device.c"
								}
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_object_unref0 (dev);
#line 2057 "Device.c"
							}
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 2061 "Device.c"
						}
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp62_ = parent;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp62_ != NULL) {
#line 2067 "Device.c"
							Device* _tmp63_;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp63_ = child;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp61_ = _tmp63_ != NULL;
#line 2073 "Device.c"
						} else {
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp61_ = FALSE;
#line 2077 "Device.c"
						}
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp61_) {
#line 2081 "Device.c"
							Device* _tmp64_;
							Device* _tmp65_;
							const gchar* _tmp66_;
							gchar* _tmp67_;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp64_ = child;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp65_ = parent;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp66_ = _tmp65_->kname;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp67_ = g_strdup (_tmp66_);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp64_->pkname);
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp64_->pkname = _tmp67_;
#line 2098 "Device.c"
						}
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (child);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (parent);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (parent_kname);
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (child_name);
#line 2108 "Device.c"
					} else {
						const gchar* _tmp68_;
						gchar* _tmp69_;
						gchar* _tmp70_;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp68_ = line;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp69_ = g_strdup_printf ("no-match: %s", _tmp68_);
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp70_ = _tmp69_;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp70_);
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp70_);
#line 2123 "Device.c"
					}
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (_tmp12_);
#line 2127 "Device.c"
				}
				goto __finally42;
				__catch42_g_error:
				{
					GError* e = NULL;
					GError* _tmp71_;
					const gchar* _tmp72_;
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					e = _inner_error_;
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_inner_error_ = NULL;
#line 365 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp71_ = e;
#line 365 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp72_ = _tmp71_->message;
#line 365 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp72_, FALSE, FALSE);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_error_free0 (e);
#line 2147 "Device.c"
				}
				__finally42:
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_err);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_out);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					g_clear_error (&_inner_error_);
#line 329 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					return;
#line 2170 "Device.c"
				}
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (line);
#line 2174 "Device.c"
			}
		}
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2179 "Device.c"
	}
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 2189 "Device.c"
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_;
	gint64 _tmp1_;
#line 687 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 2207 "Device.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2226 "Device.c"
	} else {
		const gchar* _tmp2_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 2233 "Device.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2239 "Device.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 2249 "Device.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 2253 "Device.c"
		gchar* _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2261 "Device.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2293 "Device.c"
				goto __catch45_g_regex_error;
			}
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2302 "Device.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2318 "Device.c"
				goto __catch45_g_regex_error;
			}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2329 "Device.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2343 "Device.c"
	}
	goto __finally45;
	__catch45_g_regex_error:
	{
		GError* e = NULL;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1423 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 2357 "Device.c"
	}
	__finally45:
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return NULL;
#line 2368 "Device.c"
	}
}


GeeArrayList* device_get_block_devices_using_lsblk (const gchar* dev_name) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gboolean _tmp1_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	const gchar* _tmp12_;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gint _tmp15_;
	gint index = 0;
	const gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	GeeArrayList* _tmp319_;
	GeeArrayList* _tmp320_;
	gboolean _tmp336_;
	GError * _inner_error_ = NULL;
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 378 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_test_lsblk_version ();
#line 380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 389 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_lsblk_is_ancient;
#line 389 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_) {
#line 2411 "Device.c"
		gchar* _tmp2_;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,RM,MAJ:MIN");
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp2_;
#line 2419 "Device.c"
	} else {
		gchar* _tmp3_;
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,HOTPLUG,MAJ:MIN,PARTLABEL,PARTUUID,PKNAME,VENDOR,S" \
"ERIAL,REV");
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp3_;
#line 2428 "Device.c"
	}
#line 396 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = dev_name;
#line 396 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = strlen (_tmp4_);
#line 396 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = _tmp5_;
#line 396 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp6_ > 0) {
#line 2438 "Device.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = cmd;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = dev_name;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup_printf (" %s", _tmp8_);
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp11_;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 2460 "Device.c"
	}
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp12_ = cmd;
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = tee_jee_process_helper_exec_sync (_tmp12_, &_tmp13_, &_tmp14_);
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp13_;
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp14_;
#line 400 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	ret_val = _tmp15_;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	index = -1;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = std_out;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, "\n", 0);
#line 2482 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = _tmp18_;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp17_);
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp17_); line_it = line_it + 1) {
#line 2494 "Device.c"
			gchar* _tmp19_;
			gchar* line = NULL;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = g_strdup (line_collection[line_it]);
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			line = _tmp19_;
#line 2501 "Device.c"
			{
				const gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gboolean _tmp25_;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp20_ = line;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp21_ = string_strip (_tmp20_);
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp22_ = _tmp21_;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp23_ = strlen (_tmp22_);
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp24_ = _tmp23_;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp25_ = _tmp24_ == 0;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp22_);
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp25_) {
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 2529 "Device.c"
				}
				{
					gboolean _tmp26_;
					GRegex* _tmp33_;
					const gchar* _tmp34_;
					GMatchInfo* _tmp35_ = NULL;
					gboolean _tmp36_;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = device_lsblk_is_ancient;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp26_) {
#line 2541 "Device.c"
						GRegex* _tmp27_ = NULL;
						GRegex* _tmp28_;
						GRegex* _tmp29_;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp28_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" RM=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\"", 0, 0, &_inner_error_);
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp27_ = _tmp28_;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2551 "Device.c"
							goto __catch43_g_error;
						}
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp29_ = _tmp27_;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp27_ = NULL;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						rex = _tmp29_;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (_tmp27_);
#line 2564 "Device.c"
					} else {
						GRegex* _tmp30_ = NULL;
						GRegex* _tmp31_;
						GRegex* _tmp32_;
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp31_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" HOTPLUG=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\" PARTLABEL=\"(.*)" \
"\" PARTUUID=\"(.*)\" PKNAME=\"(.*)\" VENDOR=\"(.*)\" SERIAL=\"(.*)\" R" \
"EV=\"(.*)\"", 0, 0, &_inner_error_);
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp30_ = _tmp31_;
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2575 "Device.c"
							goto __catch43_g_error;
						}
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp32_ = _tmp30_;
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp30_ = NULL;
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						rex = _tmp32_;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (_tmp30_);
#line 2588 "Device.c"
					}
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp33_ = rex;
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp34_ = line;
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp36_ = g_regex_match (_tmp33_, _tmp34_, 0, &_tmp35_);
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					match = _tmp35_;
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp36_) {
#line 2602 "Device.c"
						Device* pi = NULL;
						Device* _tmp37_;
						gint pos = 0;
						Device* _tmp38_;
						GMatchInfo* _tmp39_;
						gint _tmp40_;
						gint _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						gchar* _tmp44_;
						Device* _tmp45_;
						GMatchInfo* _tmp46_;
						gint _tmp47_;
						gint _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						Device* _tmp52_;
						GMatchInfo* _tmp53_;
						gint _tmp54_;
						gint _tmp55_;
						gchar* _tmp56_;
						Device* _tmp57_;
						GMatchInfo* _tmp58_;
						gint _tmp59_;
						gint _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						Device* _tmp64_;
						GMatchInfo* _tmp65_;
						gint _tmp66_;
						gint _tmp67_;
						gchar* _tmp68_;
						gchar* _tmp69_;
						gchar* _tmp70_;
						gchar* _tmp71_;
						gchar* _tmp72_;
						Device* _tmp73_;
						GMatchInfo* _tmp74_;
						gint _tmp75_;
						gint _tmp76_;
						gchar* _tmp77_;
						gchar* _tmp78_;
						gchar* _tmp79_;
						gchar* _tmp80_;
						gchar* _tmp81_;
						const gchar* _tmp82_ = NULL;
						Device* _tmp83_;
						const gchar* _tmp84_;
						Device* _tmp87_;
						gchar* _tmp88_;
						const gchar* _tmp89_ = NULL;
						Device* _tmp90_;
						const gchar* _tmp91_;
						Device* _tmp94_;
						gchar* _tmp95_;
						Device* _tmp96_;
						GMatchInfo* _tmp97_;
						gint _tmp98_;
						gint _tmp99_;
						gchar* _tmp100_;
						gchar* _tmp101_;
						gchar* _tmp102_;
						gchar* _tmp103_;
						gint64 _tmp104_;
						gchar* mp = NULL;
						GMatchInfo* _tmp105_;
						gint _tmp106_;
						gint _tmp107_;
						gchar* _tmp108_;
						gchar* _tmp109_;
						gchar* _tmp110_;
						gchar* _tmp111_;
						const gchar* _tmp112_;
						gint _tmp113_;
						gint _tmp114_;
						Device* _tmp121_;
						GMatchInfo* _tmp122_;
						gint _tmp123_;
						gint _tmp124_;
						gchar* _tmp125_;
						gchar* _tmp126_;
						gchar* _tmp127_;
						Device* _tmp128_;
						GMatchInfo* _tmp129_;
						gint _tmp130_;
						gint _tmp131_;
						gchar* _tmp132_;
						gchar* _tmp133_;
						gchar* _tmp134_;
						gchar* _tmp135_;
						Device* _tmp136_;
						GMatchInfo* _tmp137_;
						gint _tmp138_;
						gint _tmp139_;
						gchar* _tmp140_;
						gchar* _tmp141_;
						gchar* _tmp142_;
						gchar* _tmp143_;
						gchar* txt = NULL;
						GMatchInfo* _tmp144_;
						gint _tmp145_;
						gint _tmp146_;
						gchar* _tmp147_;
						gchar* _tmp148_;
						gchar* _tmp149_;
						gchar* _tmp150_;
						const gchar* _tmp151_;
						gboolean _tmp152_;
						gboolean _tmp167_;
						Device* _tmp208_;
						gint _tmp209_;
						gint _tmp210_;
						Device* _tmp211_;
						Device* _tmp212_;
						const gchar* _tmp213_;
						gchar* _tmp214_;
						Device* _tmp215_;
						const gchar* _tmp216_;
						gint _tmp217_;
						gint _tmp218_;
						Device* _tmp223_;
						const gchar* _tmp224_;
						gint _tmp225_;
						gint _tmp226_;
						Device* _tmp231_;
						const gchar* _tmp232_;
						gint _tmp233_;
						gint _tmp234_;
						Device* _tmp239_;
						const gchar* _tmp240_;
						gint _tmp241_;
						gint _tmp242_;
						GeeArrayList* _tmp247_;
						Device* _tmp248_;
#line 436 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp37_ = device_new ();
#line 436 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pi = _tmp37_;
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = 0;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp38_ = pi;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp39_ = match;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp40_ = pos;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp40_ + 1;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp41_ = pos;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp42_ = g_match_info_fetch (_tmp39_, _tmp41_);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp43_ = _tmp42_;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp44_ = string_strip (_tmp43_);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp38_->name);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp38_->name = _tmp44_;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp43_);
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp45_ = pi;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp46_ = match;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp47_ = pos;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp47_ + 1;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp48_ = pos;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp49_ = g_match_info_fetch (_tmp46_, _tmp48_);
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp50_ = _tmp49_;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp51_ = string_strip (_tmp50_);
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp45_->kname);
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp45_->kname = _tmp51_;
#line 441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp50_);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp52_ = pi;
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp53_ = match;
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp54_ = pos;
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp54_ + 1;
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp55_ = pos;
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp56_ = g_match_info_fetch (_tmp53_, _tmp55_);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp52_->label);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp52_->label = _tmp56_;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp57_ = pi;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp58_ = match;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp59_ = pos;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp59_ + 1;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp60_ = pos;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp61_ = g_match_info_fetch (_tmp58_, _tmp60_);
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp63_ = string_strip (_tmp62_);
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp57_->uuid);
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp57_->uuid = _tmp63_;
#line 444 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp64_ = pi;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp65_ = match;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp66_ = pos;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp66_ + 1;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp67_ = pos;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp68_ = g_match_info_fetch (_tmp65_, _tmp67_);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp69_ = _tmp68_;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp70_ = string_strip (_tmp69_);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp71_ = _tmp70_;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp72_ = g_utf8_strdown (_tmp71_, (gssize) -1);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp64_->type);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp64_->type = _tmp72_;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp71_);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp69_);
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp73_ = pi;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp74_ = match;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp75_ = pos;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp75_ + 1;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp76_ = pos;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp77_ = g_match_info_fetch (_tmp74_, _tmp76_);
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp78_ = _tmp77_;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp79_ = string_strip (_tmp78_);
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp80_ = _tmp79_;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp81_ = g_utf8_strdown (_tmp80_, (gssize) -1);
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp73_->fstype);
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp73_->fstype = _tmp81_;
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp80_);
#line 448 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp78_);
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp83_ = pi;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp84_ = _tmp83_->fstype;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (g_strcmp0 (_tmp84_, "crypto_luks") == 0) {
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp82_ = "luks";
#line 2891 "Device.c"
						} else {
							Device* _tmp85_;
							const gchar* _tmp86_;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp85_ = pi;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp86_ = _tmp85_->fstype;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp82_ = _tmp86_;
#line 2901 "Device.c"
						}
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp87_ = pi;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp88_ = g_strdup (_tmp82_);
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp87_->fstype);
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp87_->fstype = _tmp88_;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp90_ = pi;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp91_ = _tmp90_->fstype;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (g_strcmp0 (_tmp91_, "lvm2_member") == 0) {
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp89_ = "lvm2";
#line 2919 "Device.c"
						} else {
							Device* _tmp92_;
							const gchar* _tmp93_;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp92_ = pi;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp93_ = _tmp92_->fstype;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp89_ = _tmp93_;
#line 2929 "Device.c"
						}
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp94_ = pi;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp95_ = g_strdup (_tmp89_);
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp94_->fstype);
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp94_->fstype = _tmp95_;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp96_ = pi;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp97_ = match;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp98_ = pos;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp98_ + 1;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp99_ = pos;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp100_ = g_match_info_fetch (_tmp97_, _tmp99_);
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp101_ = _tmp100_;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp102_ = string_strip (_tmp101_);
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp103_ = _tmp102_;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp104_ = int64_parse (_tmp103_);
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp96_->size_bytes = (guint64) _tmp104_;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp103_);
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp101_);
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp105_ = match;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp106_ = pos;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp106_ + 1;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp107_ = pos;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp108_ = g_match_info_fetch (_tmp105_, _tmp107_);
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp109_ = _tmp108_;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp110_ = string_strip (_tmp109_);
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp111_ = _tmp110_;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp109_);
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						mp = _tmp111_;
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp112_ = mp;
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp113_ = strlen (_tmp112_);
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp114_ = _tmp113_;
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp114_ > 0) {
#line 2993 "Device.c"
							Device* _tmp115_;
							GeeArrayList* _tmp116_;
							Device* _tmp117_;
							const gchar* _tmp118_;
							MountEntry* _tmp119_;
							MountEntry* _tmp120_;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp115_ = pi;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp116_ = _tmp115_->mount_points;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp117_ = pi;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp118_ = mp;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp119_ = mount_entry_new (_tmp117_, _tmp118_, "");
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp120_ = _tmp119_;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp116_, _tmp120_);
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_object_unref0 (_tmp120_);
#line 3016 "Device.c"
						}
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp121_ = pi;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp122_ = match;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp123_ = pos;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp123_ + 1;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp124_ = pos;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp125_ = g_match_info_fetch (_tmp122_, _tmp124_);
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp126_ = _tmp125_;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp127_ = string_strip (_tmp126_);
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp121_->model);
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp121_->model = _tmp127_;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp126_);
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp128_ = pi;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp129_ = match;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp130_ = pos;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp130_ + 1;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp131_ = pos;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp132_ = g_match_info_fetch (_tmp129_, _tmp131_);
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp133_ = _tmp132_;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp134_ = string_strip (_tmp133_);
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp135_ = _tmp134_;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp128_->read_only = g_strcmp0 (_tmp135_, "1") == 0;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp135_);
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp133_);
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp136_ = pi;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp137_ = match;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp138_ = pos;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp138_ + 1;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp139_ = pos;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp140_ = g_match_info_fetch (_tmp137_, _tmp139_);
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp141_ = _tmp140_;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp142_ = string_strip (_tmp141_);
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp143_ = _tmp142_;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp136_->removable = g_strcmp0 (_tmp143_, "1") == 0;
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp143_);
#line 463 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp141_);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp144_ = match;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp145_ = pos;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						pos = _tmp145_ + 1;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp146_ = pos;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp147_ = g_match_info_fetch (_tmp144_, _tmp146_);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp148_ = _tmp147_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp149_ = string_strip (_tmp148_);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp150_ = _tmp149_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp148_);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						txt = _tmp150_;
#line 466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp151_ = txt;
#line 466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp152_ = string_contains (_tmp151_, ":");
#line 466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp152_) {
#line 3114 "Device.c"
							Device* _tmp153_;
							const gchar* _tmp154_;
							gchar** _tmp155_;
							gchar** _tmp156_;
							gchar** _tmp157_;
							gint _tmp157__length1;
							const gchar* _tmp158_;
							gint _tmp159_;
							Device* _tmp160_;
							const gchar* _tmp161_;
							gchar** _tmp162_;
							gchar** _tmp163_;
							gchar** _tmp164_;
							gint _tmp164__length1;
							const gchar* _tmp165_;
							gint _tmp166_;
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp153_ = pi;
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp154_ = txt;
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp156_ = _tmp155_ = g_strsplit (_tmp154_, ":", 0);
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp157_ = _tmp156_;
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp157__length1 = _vala_array_length (_tmp155_);
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp158_ = _tmp157_[0];
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp159_ = atoi (_tmp158_);
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp153_->major = _tmp159_;
#line 467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp157_ = (_vala_array_free (_tmp157_, _tmp157__length1, (GDestroyNotify) g_free), NULL);
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp160_ = pi;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp161_ = txt;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp163_ = _tmp162_ = g_strsplit (_tmp161_, ":", 0);
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp164_ = _tmp163_;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp164__length1 = _vala_array_length (_tmp162_);
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp165_ = _tmp164_[1];
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp166_ = atoi (_tmp165_);
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp160_->minor = _tmp166_;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp164_ = (_vala_array_free (_tmp164_, _tmp164__length1, (GDestroyNotify) g_free), NULL);
#line 3167 "Device.c"
						}
#line 471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp167_ = device_lsblk_is_ancient;
#line 471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (!_tmp167_) {
#line 3173 "Device.c"
							Device* _tmp168_;
							GMatchInfo* _tmp169_;
							gint _tmp170_;
							gint _tmp171_;
							gchar* _tmp172_;
							Device* _tmp173_;
							GMatchInfo* _tmp174_;
							gint _tmp175_;
							gint _tmp176_;
							gchar* _tmp177_;
							gchar* _tmp178_;
							gchar* _tmp179_;
							Device* _tmp180_;
							GMatchInfo* _tmp181_;
							gint _tmp182_;
							gint _tmp183_;
							gchar* _tmp184_;
							gchar* _tmp185_;
							gchar* _tmp186_;
							Device* _tmp187_;
							GMatchInfo* _tmp188_;
							gint _tmp189_;
							gint _tmp190_;
							gchar* _tmp191_;
							gchar* _tmp192_;
							gchar* _tmp193_;
							Device* _tmp194_;
							GMatchInfo* _tmp195_;
							gint _tmp196_;
							gint _tmp197_;
							gchar* _tmp198_;
							gchar* _tmp199_;
							gchar* _tmp200_;
							Device* _tmp201_;
							GMatchInfo* _tmp202_;
							gint _tmp203_;
							gint _tmp204_;
							gchar* _tmp205_;
							gchar* _tmp206_;
							gchar* _tmp207_;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp168_ = pi;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp169_ = match;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp170_ = pos;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							pos = _tmp170_ + 1;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp171_ = pos;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp172_ = g_match_info_fetch (_tmp169_, _tmp171_);
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp168_->partlabel);
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp168_->partlabel = _tmp172_;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp173_ = pi;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp174_ = match;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp175_ = pos;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							pos = _tmp175_ + 1;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp176_ = pos;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp177_ = g_match_info_fetch (_tmp174_, _tmp176_);
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp178_ = _tmp177_;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp179_ = string_strip (_tmp178_);
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp173_->partuuid);
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp173_->partuuid = _tmp179_;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp178_);
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp180_ = pi;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp181_ = match;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp182_ = pos;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							pos = _tmp182_ + 1;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp183_ = pos;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp184_ = g_match_info_fetch (_tmp181_, _tmp183_);
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp185_ = _tmp184_;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp186_ = string_strip (_tmp185_);
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp180_->pkname);
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp180_->pkname = _tmp186_;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp185_);
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp187_ = pi;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp188_ = match;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp189_ = pos;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							pos = _tmp189_ + 1;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp190_ = pos;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp191_ = g_match_info_fetch (_tmp188_, _tmp190_);
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp192_ = _tmp191_;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp193_ = string_strip (_tmp192_);
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp187_->vendor);
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp187_->vendor = _tmp193_;
#line 477 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp192_);
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp194_ = pi;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp195_ = match;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp196_ = pos;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							pos = _tmp196_ + 1;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp197_ = pos;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp198_ = g_match_info_fetch (_tmp195_, _tmp197_);
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp199_ = _tmp198_;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp200_ = string_strip (_tmp199_);
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp194_->serial);
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp194_->serial = _tmp200_;
#line 478 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp199_);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp201_ = pi;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp202_ = match;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp203_ = pos;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							pos = _tmp203_ + 1;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp204_ = pos;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp205_ = g_match_info_fetch (_tmp202_, _tmp204_);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp206_ = _tmp205_;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp207_ = string_strip (_tmp206_);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp201_->revision);
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp201_->revision = _tmp207_;
#line 479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp206_);
#line 3340 "Device.c"
						}
#line 482 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp208_ = pi;
#line 482 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp209_ = index;
#line 482 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						index = _tmp209_ + 1;
#line 482 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp210_ = index;
#line 482 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp208_->order = _tmp210_;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp211_ = pi;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp212_ = pi;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp213_ = _tmp212_->kname;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp214_ = g_strdup_printf ("/dev/%s", _tmp213_);
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp211_->device);
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp211_->device = _tmp214_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp215_ = pi;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp216_ = _tmp215_->uuid;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp217_ = strlen (_tmp216_);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp218_ = _tmp217_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp218_ > 0) {
#line 3374 "Device.c"
							Device* _tmp219_;
							Device* _tmp220_;
							const gchar* _tmp221_;
							gchar* _tmp222_;
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp219_ = pi;
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp220_ = pi;
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp221_ = _tmp220_->uuid;
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp222_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp221_);
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp219_->device_by_uuid);
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp219_->device_by_uuid = _tmp222_;
#line 3391 "Device.c"
						}
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp223_ = pi;
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp224_ = _tmp223_->label;
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp225_ = strlen (_tmp224_);
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp226_ = _tmp225_;
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp226_ > 0) {
#line 3403 "Device.c"
							Device* _tmp227_;
							Device* _tmp228_;
							const gchar* _tmp229_;
							gchar* _tmp230_;
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp227_ = pi;
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp228_ = pi;
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp229_ = _tmp228_->label;
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp230_ = g_strdup_printf ("/dev/disk/by-label/%s", _tmp229_);
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp227_->device_by_label);
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp227_->device_by_label = _tmp230_;
#line 3420 "Device.c"
						}
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp231_ = pi;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp232_ = _tmp231_->partuuid;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp233_ = strlen (_tmp232_);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp234_ = _tmp233_;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp234_ > 0) {
#line 3432 "Device.c"
							Device* _tmp235_;
							Device* _tmp236_;
							const gchar* _tmp237_;
							gchar* _tmp238_;
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp235_ = pi;
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp236_ = pi;
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp237_ = _tmp236_->partuuid;
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp238_ = g_strdup_printf ("/dev/disk/by-partuuid/%s", _tmp237_);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp235_->device_by_partuuid);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp235_->device_by_partuuid = _tmp238_;
#line 3449 "Device.c"
						}
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp239_ = pi;
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp240_ = _tmp239_->partlabel;
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp241_ = strlen (_tmp240_);
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp242_ = _tmp241_;
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (_tmp242_ > 0) {
#line 3461 "Device.c"
							Device* _tmp243_;
							Device* _tmp244_;
							const gchar* _tmp245_;
							gchar* _tmp246_;
#line 498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp243_ = pi;
#line 498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp244_ = pi;
#line 498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp245_ = _tmp244_->partlabel;
#line 498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp246_ = g_strdup_printf ("/dev/disk/by-partlabel/%s", _tmp245_);
#line 498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp243_->device_by_partlabel);
#line 498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp243_->device_by_partlabel = _tmp246_;
#line 3478 "Device.c"
						}
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp247_ = list;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp248_ = pi;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp247_, _tmp248_);
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (txt);
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (mp);
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (pi);
#line 3492 "Device.c"
					} else {
						const gchar* _tmp249_;
						gchar* _tmp250_;
						gchar* _tmp251_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp249_ = line;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp250_ = g_strdup_printf ("no-match: %s", _tmp249_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp251_ = _tmp250_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp251_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp251_);
#line 3507 "Device.c"
					}
				}
				goto __finally43;
				__catch43_g_error:
				{
					GError* e = NULL;
					GError* _tmp252_;
					const gchar* _tmp253_;
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					e = _inner_error_;
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_inner_error_ = NULL;
#line 514 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp252_ = e;
#line 514 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp253_ = _tmp252_->message;
#line 514 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp253_, FALSE, FALSE);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_error_free0 (e);
#line 3528 "Device.c"
				}
				__finally43:
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (cmd);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_err);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_out);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (list);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					g_clear_error (&_inner_error_);
#line 426 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					return NULL;
#line 3555 "Device.c"
				}
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (line);
#line 3559 "Device.c"
			}
		}
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3564 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp254_;
		GeeArrayList* _tmp255_;
		gint _dev_size = 0;
		GeeArrayList* _tmp256_;
		gint _tmp257_;
		gint _tmp258_;
		gint _dev_index = 0;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp254_ = list;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp255_ = _g_object_ref0 (_tmp254_);
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp255_;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp256_ = _dev_list;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp257_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp256_);
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp258_ = _tmp257_;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp258_;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 3593 "Device.c"
			gint _tmp259_;
			gint _tmp260_;
			gint _tmp261_;
			Device* dev = NULL;
			GeeArrayList* _tmp262_;
			gint _tmp263_;
			gpointer _tmp264_;
			gchar* dev_by_uuid = NULL;
			Device* _tmp265_;
			const gchar* _tmp266_;
			gchar* _tmp267_;
			const gchar* _tmp268_;
			gboolean _tmp269_;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp259_ = _dev_index;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp259_ + 1;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp260_ = _dev_index;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp261_ = _dev_size;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp260_ < _tmp261_)) {
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 3619 "Device.c"
			}
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp262_ = _dev_list;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp263_ = _dev_index;
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp264_ = gee_abstract_list_get ((GeeAbstractList*) _tmp262_, _tmp263_);
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp264_;
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp265_ = dev;
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp266_ = _tmp265_->uuid;
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp267_ = tee_jee_file_system_path_combine ("/dev/disk/by-uuid/", _tmp266_);
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev_by_uuid = _tmp267_;
#line 527 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp268_ = dev_by_uuid;
#line 527 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp269_ = tee_jee_file_system_file_exists (_tmp268_);
#line 527 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp269_) {
#line 3643 "Device.c"
				Device* _tmp270_;
				GeeArrayList* _tmp271_;
				const gchar* _tmp272_;
#line 528 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp270_ = dev;
#line 528 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp271_ = _tmp270_->symlinks;
#line 528 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp272_ = dev_by_uuid;
#line 528 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp271_, _tmp272_);
#line 3655 "Device.c"
			}
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (dev_by_uuid);
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 3661 "Device.c"
		}
#line 525 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 3665 "Device.c"
	}
	{
		GFile* f_dev_mapper = NULL;
		GFile* _tmp273_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp274_;
		gchar* _tmp275_;
		gchar* _tmp276_;
		GFileEnumerator* _tmp277_;
		GFileEnumerator* _tmp278_;
		GFileInfo* info = NULL;
#line 536 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp273_ = g_file_new_for_path ("/dev/mapper");
#line 536 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		f_dev_mapper = _tmp273_;
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp274_ = f_dev_mapper;
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp275_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp276_ = _tmp275_;
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp277_ = g_file_enumerate_children (_tmp274_, _tmp276_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp278_ = _tmp277_;
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp276_);
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		enumerator = _tmp278_;
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (f_dev_mapper);
#line 3699 "Device.c"
			goto __catch44_g_error;
		}
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 3704 "Device.c"
			GFileInfo* _tmp279_ = NULL;
			GFileEnumerator* _tmp280_;
			GFileInfo* _tmp281_;
			GFileInfo* _tmp282_;
			GFileInfo* _tmp283_;
			GFileInfo* _tmp284_;
			const gchar* _tmp285_;
			GFile* f_mapped = NULL;
			GFile* _tmp286_;
			GFileInfo* _tmp287_;
			const gchar* _tmp288_;
			GFile* _tmp289_;
			gchar* mapped_file = NULL;
			GFile* _tmp290_;
			gchar* _tmp291_;
			gchar* mapped_device = NULL;
			GFileInfo* _tmp292_;
			const gchar* _tmp293_;
			gchar* _tmp294_;
			const gchar* _tmp295_;
			gchar* _tmp296_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp280_ = enumerator;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp281_ = g_file_enumerator_next_file (_tmp280_, NULL, &_inner_error_);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp279_ = _tmp281_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (info);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (enumerator);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (f_dev_mapper);
#line 3740 "Device.c"
				goto __catch44_g_error;
			}
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp282_ = _tmp279_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp279_ = NULL;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (info);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			info = _tmp282_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp283_ = info;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp283_ != NULL)) {
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_tmp279_);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 3759 "Device.c"
			}
#line 546 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp284_ = info;
#line 546 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp285_ = g_file_info_get_name (_tmp284_);
#line 546 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp285_, "control") == 0) {
#line 546 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_tmp279_);
#line 546 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				continue;
#line 3771 "Device.c"
			}
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp286_ = f_dev_mapper;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp287_ = info;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp288_ = g_file_info_get_name (_tmp287_);
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp289_ = g_file_resolve_relative_path (_tmp286_, _tmp288_);
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			f_mapped = _tmp289_;
#line 550 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp290_ = f_mapped;
#line 550 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp291_ = g_file_get_path (_tmp290_);
#line 550 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mapped_file = _tmp291_;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp292_ = info;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp293_ = g_file_info_get_symlink_target (_tmp292_);
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp294_ = g_strdup (_tmp293_);
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mapped_device = _tmp294_;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp295_ = mapped_device;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp296_ = string_replace (_tmp295_, "..", "/dev");
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (mapped_device);
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mapped_device = _tmp296_;
#line 3805 "Device.c"
			{
				GeeArrayList* _dev_list = NULL;
				GeeArrayList* _tmp297_;
				GeeArrayList* _tmp298_;
				gint _dev_size = 0;
				GeeArrayList* _tmp299_;
				gint _tmp300_;
				gint _tmp301_;
				gint _dev_index = 0;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp297_ = list;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp298_ = _g_object_ref0 (_tmp297_);
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_dev_list = _tmp298_;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp299_ = _dev_list;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp300_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp299_);
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp301_ = _tmp300_;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_dev_size = _tmp301_;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_dev_index = -1;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				while (TRUE) {
#line 3833 "Device.c"
					gint _tmp302_;
					gint _tmp303_;
					gint _tmp304_;
					Device* dev = NULL;
					GeeArrayList* _tmp305_;
					gint _tmp306_;
					gpointer _tmp307_;
					Device* _tmp308_;
					const gchar* _tmp309_;
					const gchar* _tmp310_;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp302_ = _dev_index;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_dev_index = _tmp302_ + 1;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp303_ = _dev_index;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp304_ = _dev_size;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (!(_tmp303_ < _tmp304_)) {
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						break;
#line 3856 "Device.c"
					}
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp305_ = _dev_list;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp306_ = _dev_index;
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp307_ = gee_abstract_list_get ((GeeAbstractList*) _tmp305_, _tmp306_);
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					dev = (Device*) _tmp307_;
#line 559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp308_ = dev;
#line 559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp309_ = _tmp308_->device;
#line 559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp310_ = mapped_device;
#line 559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (g_strcmp0 (_tmp309_, _tmp310_) == 0) {
#line 3874 "Device.c"
						Device* _tmp311_;
						const gchar* _tmp312_;
						gchar* _tmp313_;
						Device* _tmp314_;
						GeeArrayList* _tmp315_;
						const gchar* _tmp316_;
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp311_ = dev;
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp312_ = mapped_file;
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp313_ = string_replace (_tmp312_, "/dev/mapper/", "");
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp311_->mapped_name);
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp311_->mapped_name = _tmp313_;
#line 561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp314_ = dev;
#line 561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp315_ = _tmp314_->symlinks;
#line 561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp316_ = mapped_file;
#line 561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp315_, _tmp316_);
#line 563 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (dev);
#line 563 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						break;
#line 3903 "Device.c"
					}
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 3907 "Device.c"
				}
#line 558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 3911 "Device.c"
			}
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (mapped_device);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (mapped_file);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (f_mapped);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (_tmp279_);
#line 3921 "Device.c"
		}
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (info);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (enumerator);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (f_dev_mapper);
#line 3929 "Device.c"
	}
	goto __finally44;
	__catch44_g_error:
	{
		GError* e = NULL;
		GError* _tmp317_;
		const gchar* _tmp318_;
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		e = _inner_error_;
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_inner_error_ = NULL;
#line 569 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp317_ = e;
#line 569 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp318_ = _tmp317_->message;
#line 569 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp318_, FALSE, FALSE);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_error_free0 (e);
#line 3949 "Device.c"
	}
	__finally44:
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_clear_error (&_inner_error_);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return NULL;
#line 3972 "Device.c"
	}
#line 572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp319_ = list;
#line 572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp320_ = _g_object_ref0 (_tmp319_);
#line 572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (device_device_list);
#line 572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_device_list = _tmp320_;
#line 3982 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp321_;
		GeeArrayList* _tmp322_;
		gint _part_size = 0;
		GeeArrayList* _tmp323_;
		gint _tmp324_;
		gint _tmp325_;
		gint _part_index = 0;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp321_ = list;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp322_ = _g_object_ref0 (_tmp321_);
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_list = _tmp322_;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp323_ = _part_list;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp324_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp323_);
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp325_ = _tmp324_;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_size = _tmp325_;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_index = -1;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 4010 "Device.c"
			gint _tmp326_;
			gint _tmp327_;
			gint _tmp328_;
			Device* part = NULL;
			GeeArrayList* _tmp329_;
			gint _tmp330_;
			gpointer _tmp331_;
			GeeArrayList* _tmp332_;
			Device* _tmp333_;
			GeeArrayList* _tmp334_;
			Device* _tmp335_;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp326_ = _part_index;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_index = _tmp326_ + 1;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp327_ = _part_index;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp328_ = _part_size;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp327_ < _tmp328_)) {
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 4034 "Device.c"
			}
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp329_ = _part_list;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp330_ = _part_index;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp331_ = gee_abstract_list_get ((GeeAbstractList*) _tmp329_, _tmp330_);
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			part = (Device*) _tmp331_;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp332_ = list;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp333_ = part;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			device_find_child_devices (_tmp332_, _tmp333_);
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp334_ = list;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp335_ = part;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			device_find_toplevel_parent (_tmp334_, _tmp335_);
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 4058 "Device.c"
		}
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 4062 "Device.c"
	}
#line 581 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp336_ = device_lsblk_is_ancient;
#line 581 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp336_) {
#line 4068 "Device.c"
		GeeArrayList* _tmp337_;
#line 582 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp337_ = list;
#line 582 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device_find_child_devices_using_dmsetup (_tmp337_);
#line 4074 "Device.c"
	}
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = list;
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 4090 "Device.c"
}


GeeArrayList* device_get_block_devices_using_blkid (const gchar* dev_name) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gint _tmp14_;
	gint _tmp15_;
	const gchar* _tmp27_;
	gchar** _tmp28_;
	gchar** _tmp29_;
	GeeArrayList* _tmp116_;
	gint _tmp117_;
	gint _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	GError * _inner_error_ = NULL;
#line 593 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 598 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 598 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = dev_name;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 4138 "Device.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = dev_name;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = g_strconcat (" ", _tmp5_, NULL);
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = _tmp6_;
#line 4149 "Device.c"
	} else {
		gchar* _tmp7_;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = g_strdup ("");
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = _tmp7_;
#line 4158 "Device.c"
	}
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = g_strconcat ("/sbin/blkid", _tmp1_, NULL);
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp8_;
#line 609 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp9_ = tee_jee_logging_LOG_DEBUG;
#line 609 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp9_) {
#line 4170 "Device.c"
		const gchar* _tmp10_;
#line 610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = cmd;
#line 610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp10_);
#line 4176 "Device.c"
	}
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp11_ = cmd;
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = tee_jee_process_helper_exec_script_sync (_tmp11_, &_tmp12_, &_tmp13_, FALSE, FALSE, TRUE, FALSE);
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp12_;
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp13_;
#line 613 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	ret_val = _tmp14_;
#line 614 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = ret_val;
#line 614 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp15_ != 0) {
#line 4196 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp16_;
		gchar* _tmp17_ = NULL;
		const gchar* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		const gchar* _tmp26_;
#line 615 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp16_ = g_strconcat ("blkid: ", _ ("Failed to get partition list"), NULL);
#line 615 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		msg = _tmp16_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = dev_name;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = strlen (_tmp18_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp20_ > 0) {
#line 4218 "Device.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = dev_name;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = g_strconcat (": ", _tmp21_, NULL);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp17_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = _tmp22_;
#line 4229 "Device.c"
		} else {
			gchar* _tmp23_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = g_strdup ("");
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp17_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = _tmp23_;
#line 4238 "Device.c"
		}
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = msg;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = g_strconcat (_tmp24_, _tmp17_, NULL);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (msg);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		msg = _tmp25_;
#line 617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp26_ = msg;
#line 617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp26_, FALSE, FALSE);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = list;
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp17_);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (msg);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 618 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 4272 "Device.c"
	}
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp27_ = std_out;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, "\n", 0);
#line 4278 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = _tmp29_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp28_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp28_); line_it = line_it + 1) {
#line 4290 "Device.c"
			gchar* _tmp30_;
			gchar* line = NULL;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = g_strdup (line_collection[line_it]);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			line = _tmp30_;
#line 4297 "Device.c"
			{
				const gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gboolean _tmp36_;
				Device* pi = NULL;
				Device* _tmp37_;
				Device* _tmp38_;
				const gchar* _tmp39_;
				gchar** _tmp40_;
				gchar** _tmp41_;
				gchar** _tmp42_;
				gint _tmp42__length1;
				const gchar* _tmp43_;
				gchar* _tmp44_;
				Device* _tmp45_;
				const gchar* _tmp46_;
				gint _tmp47_;
				gint _tmp48_;
				Device* _tmp49_;
				const gchar* _tmp50_;
				gboolean _tmp51_;
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				Device* _tmp55_;
				const gchar* _tmp56_;
				gboolean _tmp57_;
				Device* _tmp110_;
				const gchar* _tmp111_;
				gint _tmp112_;
				gint _tmp113_;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp31_ = line;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp32_ = string_strip (_tmp31_);
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp33_ = _tmp32_;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp34_ = strlen (_tmp33_);
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp35_ = _tmp34_;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp36_ = _tmp35_ == 0;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp33_);
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp36_) {
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 4352 "Device.c"
				}
#line 634 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp37_ = device_new ();
#line 634 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				pi = _tmp37_;
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp38_ = pi;
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp39_ = line;
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp41_ = _tmp40_ = g_strsplit (_tmp39_, ":", 0);
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42_ = _tmp41_;
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42__length1 = _vala_array_length (_tmp40_);
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp43_ = _tmp42_[0];
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp44_ = string_strip (_tmp43_);
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp38_->device);
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp38_->device = _tmp44_;
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42_ = (_vala_array_free (_tmp42_, _tmp42__length1, (GDestroyNotify) g_free), NULL);
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp45_ = pi;
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp46_ = _tmp45_->device;
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp47_ = strlen (_tmp46_);
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp48_ = _tmp47_;
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp48_ == 0) {
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 638 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 4394 "Device.c"
				}
#line 642 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp49_ = pi;
#line 642 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp50_ = _tmp49_->device;
#line 642 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp51_ = g_str_has_prefix (_tmp50_, "/dev/");
#line 642 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!_tmp51_) {
#line 643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 4410 "Device.c"
				}
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp55_ = pi;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp56_ = _tmp55_->device;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp57_ = g_str_has_prefix (_tmp56_, "/dev/sd");
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp57_) {
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp54_ = TRUE;
#line 4422 "Device.c"
				} else {
					Device* _tmp58_;
					const gchar* _tmp59_;
					gboolean _tmp60_;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp58_ = pi;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp59_ = _tmp58_->device;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp60_ = g_str_has_prefix (_tmp59_, "/dev/hd");
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp54_ = _tmp60_;
#line 4435 "Device.c"
				}
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp54_) {
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp53_ = TRUE;
#line 4441 "Device.c"
				} else {
					Device* _tmp61_;
					const gchar* _tmp62_;
					gboolean _tmp63_;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp61_ = pi;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp62_ = _tmp61_->device;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp63_ = g_str_has_prefix (_tmp62_, "/dev/mapper/");
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp53_ = _tmp63_;
#line 4454 "Device.c"
				}
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp53_) {
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp52_ = TRUE;
#line 4460 "Device.c"
				} else {
					Device* _tmp64_;
					const gchar* _tmp65_;
					gboolean _tmp66_;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp64_ = pi;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp65_ = _tmp64_->device;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp66_ = g_str_has_prefix (_tmp65_, "/dev/dm");
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp52_ = _tmp66_;
#line 4473 "Device.c"
				}
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp52_) {
#line 4477 "Device.c"
				} else {
					Device* _tmp67_;
					const gchar* _tmp68_;
					gboolean _tmp69_;
#line 649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp67_ = pi;
#line 649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp68_ = _tmp67_->device;
#line 649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp69_ = g_str_has_prefix (_tmp68_, "/dev/disk/by-uuid/");
#line 649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp69_) {
#line 4490 "Device.c"
						Device* _tmp70_;
						Device* _tmp71_;
						const gchar* _tmp72_;
						gchar* _tmp73_;
#line 651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp70_ = pi;
#line 651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp71_ = pi;
#line 651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp72_ = _tmp71_->device;
#line 651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp73_ = string_replace (_tmp72_, "/dev/disk/by-uuid/", "");
#line 651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp70_->uuid);
#line 651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp70_->uuid = _tmp73_;
#line 4507 "Device.c"
					} else {
#line 654 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (pi);
#line 654 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (line);
#line 654 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						continue;
#line 4515 "Device.c"
					}
				}
				{
					GRegex* _tmp74_ = NULL;
					GRegex* _tmp75_;
					GRegex* _tmp76_;
					GRegex* _tmp77_;
					const gchar* _tmp78_;
					GMatchInfo* _tmp79_ = NULL;
					gboolean _tmp80_;
					GRegex* _tmp84_ = NULL;
					GRegex* _tmp85_;
					GRegex* _tmp86_;
					GRegex* _tmp87_;
					const gchar* _tmp88_;
					GMatchInfo* _tmp89_ = NULL;
					gboolean _tmp90_;
					GRegex* _tmp96_ = NULL;
					GRegex* _tmp97_;
					GRegex* _tmp98_;
					GRegex* _tmp99_;
					const gchar* _tmp100_;
					GMatchInfo* _tmp101_ = NULL;
					gboolean _tmp102_;
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp75_ = g_regex_new ("LABEL=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error_);
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp74_ = _tmp75_;
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4546 "Device.c"
						goto __catch46_g_error;
					}
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp76_ = _tmp74_;
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp74_ = NULL;
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 660 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					rex = _tmp76_;
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp77_ = rex;
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp78_ = line;
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp80_ = g_regex_match (_tmp77_, _tmp78_, 0, &_tmp79_);
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					match = _tmp79_;
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp80_) {
#line 4569 "Device.c"
						Device* _tmp81_;
						GMatchInfo* _tmp82_;
						gchar* _tmp83_;
#line 662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp81_ = pi;
#line 662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp82_ = match;
#line 662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp83_ = g_match_info_fetch (_tmp82_, 1);
#line 662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp81_->label);
#line 662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp81_->label = _tmp83_;
#line 4583 "Device.c"
					}
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp85_ = g_regex_new ("UUID=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error_);
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp84_ = _tmp85_;
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (_tmp74_);
#line 4593 "Device.c"
						goto __catch46_g_error;
					}
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp86_ = _tmp84_;
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp84_ = NULL;
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					rex = _tmp86_;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp87_ = rex;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp88_ = line;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp90_ = g_regex_match (_tmp87_, _tmp88_, 0, &_tmp89_);
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					match = _tmp89_;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp90_) {
#line 4616 "Device.c"
						Device* _tmp91_;
						GMatchInfo* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp91_ = pi;
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp92_ = match;
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp93_ = g_match_info_fetch (_tmp92_, 1);
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp94_ = _tmp93_;
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp95_ = string_strip (_tmp94_);
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp91_->uuid);
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp91_->uuid = _tmp95_;
#line 667 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp94_);
#line 4638 "Device.c"
					}
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp97_ = g_regex_new ("TYPE=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error_);
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp96_ = _tmp97_;
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (_tmp84_);
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_regex_unref0 (_tmp74_);
#line 4650 "Device.c"
						goto __catch46_g_error;
					}
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp98_ = _tmp96_;
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp96_ = NULL;
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					rex = _tmp98_;
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp99_ = rex;
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp100_ = line;
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp102_ = g_regex_match (_tmp99_, _tmp100_, 0, &_tmp101_);
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					match = _tmp101_;
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp102_) {
#line 4673 "Device.c"
						Device* _tmp103_;
						GMatchInfo* _tmp104_;
						gchar* _tmp105_;
						gchar* _tmp106_;
						gchar* _tmp107_;
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp103_ = pi;
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp104_ = match;
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp105_ = g_match_info_fetch (_tmp104_, 1);
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp106_ = _tmp105_;
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp107_ = string_strip (_tmp106_);
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp103_->fstype);
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp103_->fstype = _tmp107_;
#line 672 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp106_);
#line 4695 "Device.c"
					}
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (_tmp96_);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (_tmp84_);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (_tmp74_);
#line 4703 "Device.c"
				}
				goto __finally46;
				__catch46_g_error:
				{
					GError* e = NULL;
					GError* _tmp108_;
					const gchar* _tmp109_;
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					e = _inner_error_;
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_inner_error_ = NULL;
#line 676 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp108_ = e;
#line 676 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp109_ = _tmp108_->message;
#line 676 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp109_, FALSE, FALSE);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_error_free0 (e);
#line 4723 "Device.c"
				}
				__finally46:
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (pi);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_tmp1_);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (cmd);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_err);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_out);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (list);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					g_clear_error (&_inner_error_);
#line 659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					return NULL;
#line 4754 "Device.c"
				}
#line 681 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp110_ = pi;
#line 681 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp111_ = _tmp110_->uuid;
#line 681 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp112_ = strlen (_tmp111_);
#line 681 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp113_ = _tmp112_;
#line 681 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp113_ > 0) {
#line 4766 "Device.c"
					GeeArrayList* _tmp114_;
					Device* _tmp115_;
#line 682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp114_ = list;
#line 682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp115_ = pi;
#line 682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp114_, _tmp115_);
#line 4775 "Device.c"
				}
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (pi);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (line);
#line 4781 "Device.c"
			}
		}
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 4786 "Device.c"
	}
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp116_ = list;
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp117_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp116_);
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp118_ = _tmp117_;
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp119_ = g_strdup_printf ("Device: get_block_devices_using_blkid(): %d", _tmp118_);
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp120_ = _tmp119_;
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp120_);
#line 686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp120_);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = list;
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 4818 "Device.c"
}


static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_;
	guint64 _tmp1_;
#line 745 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 4836 "Device.c"
}


GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp12_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gint _tmp17_;
	gchar** lines = NULL;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint lines_length1;
	gint _lines_size_;
	gint line_num = 0;
	gchar** _tmp21_;
	gint _tmp21__length1;
	GeeArrayList* _tmp81_;
	gint _tmp82_;
	gint _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
#line 691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_mount_point != NULL, NULL);
#line 698 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 698 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("df -T -B1");
#line 705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp1_;
#line 707 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = dev_name_or_mount_point;
#line 707 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 707 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 707 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 4891 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = cmd;
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = dev_name_or_mount_point;
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = tee_jee_file_system_escape_single_quote (_tmp6_);
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup_printf (" '%s'", _tmp8_);
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp5_, _tmp10_, NULL);
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp11_;
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 708 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 4921 "Device.c"
	}
#line 711 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp12_ = tee_jee_logging_LOG_DEBUG;
#line 711 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp12_) {
#line 4927 "Device.c"
		const gchar* _tmp13_;
#line 712 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = cmd;
#line 712 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp13_);
#line 4933 "Device.c"
	}
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = cmd;
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = tee_jee_process_helper_exec_sync (_tmp14_, &_tmp15_, &_tmp16_);
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp15_;
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp16_;
#line 715 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	ret_val = _tmp17_;
#line 730 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = std_out;
#line 730 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "\n", 0);
#line 730 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	lines = _tmp20_;
#line 730 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp19_);
#line 730 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	line_num = 0;
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp21_ = lines;
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp21__length1 = lines_length1;
#line 4965 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection = _tmp21_;
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		line_collection_length1 = _tmp21__length1;
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		for (line_it = 0; line_it < _tmp21__length1; line_it = line_it + 1) {
#line 4977 "Device.c"
			gchar* _tmp22_;
			gchar* line = NULL;
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = g_strdup (line_collection[line_it]);
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			line = _tmp22_;
#line 4984 "Device.c"
			{
				gint _tmp23_;
				gint _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gboolean _tmp30_;
				Device* pi = NULL;
				Device* _tmp31_;
				gint k = 0;
				const gchar* _tmp32_;
				gchar** _tmp33_;
				gchar** _tmp34_;
				Device* _tmp67_;
				Device* _tmp68_;
				const gchar* _tmp69_;
				gchar* _tmp70_;
				Device* _tmp71_;
				Device* _tmp72_;
				const gchar* _tmp73_;
				gchar* _tmp74_;
				Device* _tmp75_;
				const gchar* _tmp76_;
				gint _tmp77_;
				gint _tmp78_;
#line 735 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp23_ = line_num;
#line 735 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				line_num = _tmp23_ + 1;
#line 735 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp24_ = line_num;
#line 735 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp24_ == 1) {
#line 735 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 735 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 5024 "Device.c"
				}
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp25_ = line;
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp27_ = _tmp26_;
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp30_ = _tmp29_ == 0;
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp27_);
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp30_) {
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 736 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 5046 "Device.c"
				}
#line 738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp31_ = device_new ();
#line 738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				pi = _tmp31_;
#line 742 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				k = 1;
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp32_ = line;
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, " ", 0);
#line 5058 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					val_collection = _tmp34_;
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp33_);
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					for (val_it = 0; val_it < _vala_array_length (_tmp33_); val_it = val_it + 1) {
#line 5070 "Device.c"
						gchar* _tmp35_;
						gchar* val = NULL;
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp35_ = g_strdup (val_collection[val_it]);
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						val = _tmp35_;
#line 5077 "Device.c"
						{
							const gchar* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							gboolean _tmp41_;
							gint _tmp42_;
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp36_ = val;
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp37_ = string_strip (_tmp36_);
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp38_ = _tmp37_;
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp39_ = strlen (_tmp38_);
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp40_ = _tmp39_;
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp41_ = _tmp40_ == 0;
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp38_);
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							if (_tmp41_) {
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_free0 (val);
#line 745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								continue;
#line 5106 "Device.c"
							}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp42_ = k;
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							k = _tmp42_ + 1;
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							switch (_tmp42_) {
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 1:
#line 5116 "Device.c"
								{
									Device* _tmp43_;
									const gchar* _tmp44_;
									gchar* _tmp45_;
#line 749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp43_ = pi;
#line 749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp44_ = val;
#line 749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp45_ = string_strip (_tmp44_);
#line 749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp43_->device);
#line 749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp43_->device = _tmp45_;
#line 750 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5133 "Device.c"
								}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 2:
#line 5137 "Device.c"
								{
									Device* _tmp46_;
									const gchar* _tmp47_;
									gchar* _tmp48_;
#line 752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp46_ = pi;
#line 752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp47_ = val;
#line 752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp48_ = string_strip (_tmp47_);
#line 752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp46_->fstype);
#line 752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp46_->fstype = _tmp48_;
#line 753 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5154 "Device.c"
								}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 3:
#line 5158 "Device.c"
								{
									Device* _tmp49_;
									const gchar* _tmp50_;
									gchar* _tmp51_;
									gchar* _tmp52_;
									guint64 _tmp53_;
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp49_ = pi;
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp50_ = val;
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp51_ = string_strip (_tmp50_);
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp52_ = _tmp51_;
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp53_ = uint64_parse (_tmp52_);
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp49_->size_bytes = _tmp53_;
#line 755 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp52_);
#line 756 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5181 "Device.c"
								}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 4:
#line 5185 "Device.c"
								{
									Device* _tmp54_;
									const gchar* _tmp55_;
									gchar* _tmp56_;
									gchar* _tmp57_;
									guint64 _tmp58_;
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp54_ = pi;
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp55_ = val;
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp56_ = string_strip (_tmp55_);
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp57_ = _tmp56_;
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp58_ = uint64_parse (_tmp57_);
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp54_->used_bytes = _tmp58_;
#line 758 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp57_);
#line 759 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5208 "Device.c"
								}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 5:
#line 5212 "Device.c"
								{
									Device* _tmp59_;
									const gchar* _tmp60_;
									gchar* _tmp61_;
									gchar* _tmp62_;
									guint64 _tmp63_;
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp59_ = pi;
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp60_ = val;
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp61_ = string_strip (_tmp60_);
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp62_ = _tmp61_;
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp63_ = uint64_parse (_tmp62_);
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp59_->available_bytes = _tmp63_;
#line 761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp62_);
#line 762 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5235 "Device.c"
								}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 6:
#line 5239 "Device.c"
								{
									Device* _tmp64_;
									const gchar* _tmp65_;
									gchar* _tmp66_;
#line 764 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp64_ = pi;
#line 764 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp65_ = val;
#line 764 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp66_ = string_strip (_tmp65_);
#line 764 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp64_->used_percent);
#line 764 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp64_->used_percent = _tmp66_;
#line 765 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5256 "Device.c"
								}
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 7:
#line 5260 "Device.c"
								{
#line 771 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5264 "Device.c"
								}
								default:
#line 747 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								break;
#line 5269 "Device.c"
							}
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (val);
#line 5273 "Device.c"
						}
					}
#line 743 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5278 "Device.c"
				}
#line 784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp67_ = pi;
#line 784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp68_ = pi;
#line 784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp69_ = _tmp68_->device;
#line 784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp70_ = device_resolve_device_name (_tmp69_);
#line 784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp67_->device);
#line 784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp67_->device = _tmp70_;
#line 788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp71_ = pi;
#line 788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp72_ = pi;
#line 788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp73_ = _tmp72_->device;
#line 788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp74_ = device_get_device_uuid (_tmp73_);
#line 788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp71_->uuid);
#line 788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp71_->uuid = _tmp74_;
#line 792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp75_ = pi;
#line 792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp76_ = _tmp75_->uuid;
#line 792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp77_ = strlen (_tmp76_);
#line 792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp78_ = _tmp77_;
#line 792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp78_ > 0) {
#line 5314 "Device.c"
					GeeArrayList* _tmp79_;
					Device* _tmp80_;
#line 793 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp79_ = list;
#line 793 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp80_ = pi;
#line 793 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp79_, _tmp80_);
#line 5323 "Device.c"
				}
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (pi);
#line 733 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (line);
#line 5329 "Device.c"
			}
		}
	}
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp81_ = list;
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp82_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp81_);
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp83_ = _tmp82_;
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp84_ = g_strdup_printf ("Device: get_disk_space_using_df(): %d", _tmp83_);
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp85_ = _tmp84_;
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp85_);
#line 797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp85_);
#line 799 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = list;
#line 799 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 799 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 799 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 799 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 799 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 5359 "Device.c"
}


GeeArrayList* device_get_mounted_filesystems_using_mtab (void) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* mtab_path = NULL;
	gchar* _tmp1_;
	gchar* mtab_lines = NULL;
	gchar* _tmp2_;
	GFile* f = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gboolean _tmp7_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar** lines = NULL;
	const gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gint lines_length1;
	gint _lines_size_;
	GeeArrayList* mount_list = NULL;
	GeeArrayList* _tmp23_;
	GeeArrayList* _tmp107_;
	gint _tmp108_;
	gint _tmp109_;
	gchar* _tmp110_;
	gchar* _tmp111_;
#line 807 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 807 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("/etc/mtab");
#line 809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mtab_path = _tmp1_;
#line 810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mtab_lines = _tmp2_;
#line 816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = g_strdup ("/proc/mounts");
#line 816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (mtab_path);
#line 816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mtab_path = _tmp3_;
#line 817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = mtab_path;
#line 817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (f);
#line 817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	f = _tmp5_;
#line 818 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = f;
#line 818 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = g_file_query_exists (_tmp6_, NULL);
#line 818 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (!_tmp7_) {
#line 5424 "Device.c"
		gchar* _tmp8_;
		const gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
#line 819 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = g_strdup ("/proc/self/mounts");
#line 819 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (mtab_path);
#line 819 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		mtab_path = _tmp8_;
#line 820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = mtab_path;
#line 820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_file_new_for_path (_tmp9_);
#line 820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (f);
#line 820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		f = _tmp10_;
#line 821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = f;
#line 821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
#line 821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (!_tmp12_) {
#line 5450 "Device.c"
			gchar* _tmp13_;
			const gchar* _tmp14_;
			GFile* _tmp15_;
			GFile* _tmp16_;
			gboolean _tmp17_;
#line 822 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = g_strdup ("/etc/mtab");
#line 822 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (mtab_path);
#line 822 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mtab_path = _tmp13_;
#line 823 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = mtab_path;
#line 823 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = g_file_new_for_path (_tmp14_);
#line 823 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (f);
#line 823 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			f = _tmp15_;
#line 824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = f;
#line 824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = g_file_query_exists (_tmp16_, NULL);
#line 824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!_tmp17_) {
#line 825 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = list;
#line 825 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (f);
#line 825 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (mtab_lines);
#line 825 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (mtab_path);
#line 825 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 5486 "Device.c"
			}
		}
	}
#line 838 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = mtab_path;
#line 838 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp19_ = tee_jee_file_system_file_read (_tmp18_);
#line 838 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 838 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mtab_lines = _tmp19_;
#line 867 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp20_ = mtab_lines;
#line 867 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp22_ = _tmp21_ = g_strsplit (_tmp20_, "\n", 0);
#line 867 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	lines = _tmp22_;
#line 867 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp21_);
#line 867 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 868 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp23_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 868 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mount_list = _tmp23_;
#line 5512 "Device.c"
	{
		gint i = 0;
		gchar** _tmp24_;
		gint _tmp24__length1;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = lines;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24__length1 = lines_length1;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		i = _tmp24__length1 - 1;
#line 5523 "Device.c"
		{
			gboolean _tmp25_ = FALSE;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp25_ = TRUE;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			while (TRUE) {
#line 5530 "Device.c"
				gint _tmp27_;
				gchar* line = NULL;
				gchar** _tmp28_;
				gint _tmp28__length1;
				gint _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				Device* pi = NULL;
				Device* _tmp35_;
				MountEntry* mp = NULL;
				Device* _tmp36_;
				MountEntry* _tmp37_;
				gint k = 0;
				const gchar* _tmp38_;
				gchar** _tmp39_;
				gchar** _tmp40_;
				Device* _tmp73_;
				Device* _tmp74_;
				const gchar* _tmp75_;
				gchar* _tmp76_;
				Device* _tmp77_;
				Device* _tmp78_;
				const gchar* _tmp79_;
				gchar* _tmp80_;
				Device* _tmp81_;
				const gchar* _tmp82_;
				gint _tmp83_;
				gint _tmp84_;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!_tmp25_) {
#line 5564 "Device.c"
					gint _tmp26_;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = i;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					i = _tmp26_ - 1;
#line 5570 "Device.c"
				}
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp25_ = FALSE;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp27_ = i;
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!(_tmp27_ >= 0)) {
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 5580 "Device.c"
				}
#line 872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp28_ = lines;
#line 872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp28__length1 = lines_length1;
#line 872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp29_ = i;
#line 872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp30_ = _tmp28_[_tmp29_];
#line 872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp31_ = string_strip (_tmp30_);
#line 872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				line = _tmp31_;
#line 873 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp32_ = line;
#line 873 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp33_ = strlen (_tmp32_);
#line 873 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 873 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp34_ == 0) {
#line 873 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (line);
#line 873 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					continue;
#line 5606 "Device.c"
				}
#line 875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp35_ = device_new ();
#line 875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				pi = _tmp35_;
#line 877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp36_ = pi;
#line 877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp37_ = mount_entry_new (_tmp36_, "", "");
#line 877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				mp = _tmp37_;
#line 881 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				k = 1;
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp38_ = line;
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp40_ = _tmp39_ = g_strsplit (_tmp38_, " ", 0);
#line 5624 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					val_collection = _tmp40_;
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp39_);
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					for (val_it = 0; val_it < _vala_array_length (_tmp39_); val_it = val_it + 1) {
#line 5636 "Device.c"
						gchar* _tmp41_;
						gchar* val = NULL;
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp41_ = g_strdup (val_collection[val_it]);
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						val = _tmp41_;
#line 5643 "Device.c"
						{
							const gchar* _tmp42_;
							gchar* _tmp43_;
							gchar* _tmp44_;
							gint _tmp45_;
							gint _tmp46_;
							gboolean _tmp47_;
							gint _tmp48_;
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp42_ = val;
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp43_ = string_strip (_tmp42_);
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp44_ = _tmp43_;
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp45_ = strlen (_tmp44_);
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp46_ = _tmp45_;
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp47_ = _tmp46_ == 0;
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (_tmp44_);
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							if (_tmp47_) {
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_free0 (val);
#line 883 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								continue;
#line 5672 "Device.c"
							}
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp48_ = k;
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							k = _tmp48_ + 1;
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							switch (_tmp48_) {
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 1:
#line 5682 "Device.c"
								{
									Device* _tmp49_;
									const gchar* _tmp50_;
									gchar* _tmp51_;
#line 886 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp49_ = pi;
#line 886 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp50_ = val;
#line 886 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp51_ = string_strip (_tmp50_);
#line 886 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp49_->device);
#line 886 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp49_->device = _tmp51_;
#line 887 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5699 "Device.c"
								}
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 2:
#line 5703 "Device.c"
								{
									MountEntry* _tmp52_;
									const gchar* _tmp53_;
									gchar* _tmp54_;
									gchar* _tmp55_;
									gchar* _tmp56_;
									GeeArrayList* _tmp57_;
									MountEntry* _tmp58_;
									const gchar* _tmp59_;
									gboolean _tmp60_;
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp52_ = mp;
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp53_ = val;
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp54_ = string_strip (_tmp53_);
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp55_ = _tmp54_;
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp56_ = string_replace (_tmp55_, "\\040", " ");
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp52_->mount_point);
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp52_->mount_point = _tmp56_;
#line 889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp55_);
#line 890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp57_ = mount_list;
#line 890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp58_ = mp;
#line 890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp59_ = _tmp58_->mount_point;
#line 890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp60_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp57_, _tmp59_);
#line 890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									if (!_tmp60_) {
#line 5740 "Device.c"
										GeeArrayList* _tmp61_;
										MountEntry* _tmp62_;
										const gchar* _tmp63_;
										Device* _tmp64_;
										GeeArrayList* _tmp65_;
										MountEntry* _tmp66_;
#line 891 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp61_ = mount_list;
#line 891 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp62_ = mp;
#line 891 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp63_ = _tmp62_->mount_point;
#line 891 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp63_);
#line 892 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp64_ = pi;
#line 892 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp65_ = _tmp64_->mount_points;
#line 892 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp66_ = mp;
#line 892 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp65_, _tmp66_);
#line 5763 "Device.c"
									}
#line 894 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5767 "Device.c"
								}
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 3:
#line 5771 "Device.c"
								{
									Device* _tmp67_;
									const gchar* _tmp68_;
									gchar* _tmp69_;
#line 896 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp67_ = pi;
#line 896 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp68_ = val;
#line 896 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp69_ = string_strip (_tmp68_);
#line 896 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp67_->fstype);
#line 896 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp67_->fstype = _tmp69_;
#line 897 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5788 "Device.c"
								}
#line 884 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								case 4:
#line 5792 "Device.c"
								{
									MountEntry* _tmp70_;
									const gchar* _tmp71_;
									gchar* _tmp72_;
#line 899 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp70_ = mp;
#line 899 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp71_ = val;
#line 899 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp72_ = string_strip (_tmp71_);
#line 899 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (_tmp70_->mount_options);
#line 899 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp70_->mount_options = _tmp72_;
#line 900 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5809 "Device.c"
								}
								default:
								{
#line 903 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5815 "Device.c"
								}
							}
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (val);
#line 5820 "Device.c"
						}
					}
#line 882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5825 "Device.c"
				}
#line 909 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp73_ = pi;
#line 909 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp74_ = pi;
#line 909 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp75_ = _tmp74_->device;
#line 909 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp76_ = device_resolve_device_name (_tmp75_);
#line 909 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp73_->device);
#line 909 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp73_->device = _tmp76_;
#line 913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp77_ = pi;
#line 913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp78_ = pi;
#line 913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp79_ = _tmp78_->device;
#line 913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp80_ = device_get_device_uuid (_tmp79_);
#line 913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp77_->uuid);
#line 913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp77_->uuid = _tmp80_;
#line 917 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp81_ = pi;
#line 917 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp82_ = _tmp81_->uuid;
#line 917 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp83_ = strlen (_tmp82_);
#line 917 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp84_ = _tmp83_;
#line 917 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp84_ > 0) {
#line 5861 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp85_;
					Device* _tmp86_;
					const gchar* _tmp87_;
					Device* _tmp88_;
					Device* _tmp89_;
#line 918 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp85_ = list;
#line 918 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp86_ = pi;
#line 918 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp87_ = _tmp86_->uuid;
#line 918 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp88_ = device_find_device_in_list (_tmp85_, _tmp87_);
#line 918 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					dev = _tmp88_;
#line 919 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp89_ = dev;
#line 919 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp89_ == NULL) {
#line 5882 "Device.c"
						GeeArrayList* _tmp90_;
						Device* _tmp91_;
#line 920 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp90_ = list;
#line 920 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp91_ = pi;
#line 920 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp90_, _tmp91_);
#line 5891 "Device.c"
					} else {
						{
							GeeArrayList* _item_list = NULL;
							Device* _tmp92_;
							GeeArrayList* _tmp93_;
							GeeArrayList* _tmp94_;
							gint _item_size = 0;
							GeeArrayList* _tmp95_;
							gint _tmp96_;
							gint _tmp97_;
							gint _item_index = 0;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp92_ = pi;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp93_ = _tmp92_->mount_points;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp94_ = _g_object_ref0 (_tmp93_);
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_item_list = _tmp94_;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp95_ = _item_list;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp96_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp95_);
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp97_ = _tmp96_;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_item_size = _tmp97_;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_item_index = -1;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							while (TRUE) {
#line 5923 "Device.c"
								gint _tmp98_;
								gint _tmp99_;
								gint _tmp100_;
								MountEntry* item = NULL;
								GeeArrayList* _tmp101_;
								gint _tmp102_;
								gpointer _tmp103_;
								Device* _tmp104_;
								GeeArrayList* _tmp105_;
								MountEntry* _tmp106_;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp98_ = _item_index;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_item_index = _tmp98_ + 1;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp99_ = _item_index;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp100_ = _item_size;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								if (!(_tmp99_ < _tmp100_)) {
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									break;
#line 5946 "Device.c"
								}
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp101_ = _item_list;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp102_ = _item_index;
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp103_ = gee_abstract_list_get ((GeeAbstractList*) _tmp101_, _tmp102_);
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								item = (MountEntry*) _tmp103_;
#line 925 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp104_ = dev;
#line 925 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp105_ = _tmp104_->mount_points;
#line 925 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp106_ = item;
#line 925 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp105_, _tmp106_);
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_object_unref0 (item);
#line 5966 "Device.c"
							}
#line 924 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_object_unref0 (_item_list);
#line 5970 "Device.c"
						}
					}
#line 917 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 5975 "Device.c"
				}
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (mp);
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (pi);
#line 870 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (line);
#line 5983 "Device.c"
			}
		}
	}
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp107_ = list;
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp108_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp107_);
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp109_ = _tmp108_;
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp110_ = g_strdup_printf ("Device: get_mounted_filesystems_using_mtab(): %d", _tmp109_);
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp111_ = _tmp110_;
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp111_);
#line 931 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp111_);
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = list;
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (mount_list);
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (f);
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (mtab_path);
#line 933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6015 "Device.c"
}


Device* device_get_device_by_uuid (const gchar* uuid) {
	Device* result = NULL;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
	Device* _tmp2_;
#line 938 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 940 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 940 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = uuid;
#line 940 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = device_find_device_in_list (_tmp0_, _tmp1_);
#line 940 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp2_;
#line 940 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6036 "Device.c"
}


Device* device_get_device_by_name (const gchar* file_name) {
	Device* result = NULL;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
	Device* _tmp2_;
#line 943 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 945 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 945 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = file_name;
#line 945 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = device_find_device_in_list (_tmp0_, _tmp1_);
#line 945 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp2_;
#line 945 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6057 "Device.c"
}


Device* device_get_device_by_path (const gchar* path_to_check) {
	Device* result = NULL;
	GeeArrayList* list = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 948 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (path_to_check != NULL, NULL);
#line 950 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = path_to_check;
#line 950 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_get_disk_space_using_df (_tmp0_);
#line 950 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp1_;
#line 952 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = list;
#line 952 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 952 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 952 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 6085 "Device.c"
		GeeArrayList* _tmp5_;
		gpointer _tmp6_;
#line 953 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = list;
#line 953 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, 0);
#line 953 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = (Device*) _tmp6_;
#line 953 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 953 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 6098 "Device.c"
	}
#line 956 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = NULL;
#line 956 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 956 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6106 "Device.c"
}


gchar* device_get_device_uuid (const gchar* device) {
	gchar* result = NULL;
	GeeArrayList* _tmp0_;
	gchar* _tmp19_;
#line 959 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 961 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 961 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp0_ == NULL) {
#line 6120 "Device.c"
		GeeArrayList* _tmp1_;
#line 962 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = device_get_block_devices_using_lsblk ("");
#line 962 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (device_device_list);
#line 962 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device_device_list = _tmp1_;
#line 6128 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = device_device_list;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp3_;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp6_;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 6157 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			Device* dev = NULL;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			Device* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp7_ + 1;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _dev_index;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _dev_size;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 6180 "Device.c"
			}
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = _dev_list;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = _dev_index;
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp12_;
#line 965 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = dev;
#line 965 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = _tmp13_->device;
#line 965 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = device;
#line 965 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 6198 "Device.c"
				Device* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp16_ = dev;
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp17_ = _tmp16_->uuid;
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = _tmp18_;
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 966 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 6216 "Device.c"
			}
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 6220 "Device.c"
		}
#line 964 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 6224 "Device.c"
	}
#line 970 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp19_ = g_strdup ("");
#line 970 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp19_;
#line 970 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6232 "Device.c"
}


GeeArrayList* device_get_device_mount_points (const gchar* dev_name_or_uuid) {
	GeeArrayList* result = NULL;
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	GeeArrayList* list_mtab = NULL;
	GeeArrayList* _tmp14_;
	Device* dev = NULL;
	GeeArrayList* _tmp15_;
	const gchar* _tmp16_;
	Device* _tmp17_;
	Device* _tmp18_;
#line 973 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 974 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 974 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device = _tmp0_;
#line 975 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 975 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	uuid = _tmp1_;
#line 977 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = dev_name_or_uuid;
#line 977 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "/dev");
#line 977 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp3_) {
#line 6267 "Device.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 978 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = dev_name_or_uuid;
#line 978 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 978 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 978 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp5_;
#line 979 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = dev_name_or_uuid;
#line 979 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = device_get_device_uuid (_tmp6_);
#line 979 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 979 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		uuid = _tmp7_;
#line 6288 "Device.c"
	} else {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 982 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = dev_name_or_uuid;
#line 982 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 982 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 982 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		uuid = _tmp9_;
#line 983 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = uuid;
#line 983 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp10_);
#line 983 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 983 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp11_;
#line 984 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = device;
#line 984 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = device_resolve_device_name (_tmp12_);
#line 984 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 984 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp13_;
#line 6320 "Device.c"
	}
#line 987 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = device_get_mounted_filesystems_using_mtab ();
#line 987 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list_mtab = _tmp14_;
#line 989 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = list_mtab;
#line 989 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = uuid;
#line 989 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = device_find_device_in_list (_tmp15_, _tmp16_);
#line 989 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	dev = _tmp17_;
#line 991 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = dev;
#line 991 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp18_ != NULL) {
#line 6338 "Device.c"
		Device* _tmp19_;
		GeeArrayList* _tmp20_;
		GeeArrayList* _tmp21_;
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = dev;
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = _tmp19_->mount_points;
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp21_;
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 992 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 6360 "Device.c"
	} else {
		GeeArrayList* _tmp22_;
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp22_;
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 6377 "Device.c"
	}
#line 973 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (dev);
#line 973 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list_mtab);
#line 973 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (uuid);
#line 973 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (device);
#line 6387 "Device.c"
}


gboolean device_device_is_mounted (const gchar* dev_name_or_uuid) {
	gboolean result = FALSE;
	GeeArrayList* mps = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 999 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1001 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = dev_name_or_uuid;
#line 1001 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_get_device_mount_points (_tmp0_);
#line 1001 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mps = _tmp1_;
#line 1002 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = mps;
#line 1002 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1002 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1002 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 1003 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = TRUE;
#line 1003 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1003 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 6421 "Device.c"
	}
#line 1006 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = FALSE;
#line 1006 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1006 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6429 "Device.c"
}


gboolean device_mount_point_in_use (const gchar* mount_point) {
	gboolean result = FALSE;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
#line 1009 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_get_mounted_filesystems_using_mtab ();
#line 1010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 6443 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = list;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp2_;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = _dev_list;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp5_;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 6471 "Device.c"
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = _dev_index;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp6_ + 1;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 6491 "Device.c"
			}
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = _dev_index;
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp11_;
#line 6501 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp12_;
				GeeArrayList* _tmp13_;
				GeeArrayList* _tmp14_;
				gint _mp_size = 0;
				GeeArrayList* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _mp_index = 0;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp12_ = dev;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp13_ = _tmp12_->mount_points;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_mp_list = _tmp14_;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp15_ = _mp_list;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp17_ = _tmp16_;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_mp_size = _tmp17_;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_mp_index = -1;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				while (TRUE) {
#line 6532 "Device.c"
					gint _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					MountEntry* mp = NULL;
					GeeArrayList* _tmp21_;
					gint _tmp22_;
					gpointer _tmp23_;
					MountEntry* _tmp24_;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					gboolean _tmp27_;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp18_ = _mp_index;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_mp_index = _tmp18_ + 1;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp19_ = _mp_index;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp20_ = _mp_size;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (!(_tmp19_ < _tmp20_)) {
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						break;
#line 6556 "Device.c"
					}
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp21_ = _mp_list;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_ = _mp_index;
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _tmp22_);
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					mp = (MountEntry*) _tmp23_;
#line 1013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp24_ = mp;
#line 1013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp25_ = _tmp24_->mount_point;
#line 1013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = mount_point;
#line 1013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp27_ = g_str_has_prefix (_tmp25_, _tmp26_);
#line 1013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp27_) {
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						result = TRUE;
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (mp);
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (_mp_list);
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (dev);
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (_dev_list);
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (list);
#line 1015 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						return result;
#line 6590 "Device.c"
					}
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (mp);
#line 6594 "Device.c"
				}
#line 1012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 6598 "Device.c"
			}
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 6602 "Device.c"
		}
#line 1011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 6606 "Device.c"
	}
#line 1019 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = FALSE;
#line 1019 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1019 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 6614 "Device.c"
}


gchar* device_resolve_device_name (const gchar* dev_alias) {
	gchar* result = NULL;
	Device* dev = NULL;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
	Device* _tmp2_;
	Device* _tmp3_;
#line 1022 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_alias != NULL, NULL);
#line 1024 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1024 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = dev_alias;
#line 1024 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = device_find_device_in_list (_tmp0_, _tmp1_);
#line 1024 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	dev = _tmp2_;
#line 1026 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = dev;
#line 1026 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp3_ != NULL) {
#line 6639 "Device.c"
		Device* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 1027 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = dev;
#line 1027 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_->device;
#line 1027 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 1027 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp6_;
#line 1027 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1027 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 6655 "Device.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1030 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = dev_alias;
#line 1030 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 1030 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp8_;
#line 1030 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1030 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 6669 "Device.c"
	}
#line 1022 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (dev);
#line 6673 "Device.c"
}


Device* device_find_device_in_list (GeeArrayList* list, const gchar* _dev_alias) {
	Device* result = NULL;
	gchar* dev_alias = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 1034 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 1034 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (_dev_alias != NULL, NULL);
#line 1036 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = _dev_alias;
#line 1036 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1036 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	dev_alias = _tmp1_;
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = dev_alias;
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = g_str_has_prefix (_tmp4_, "uuid=");
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = _tmp5_;
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1038 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp6_) {
#line 6711 "Device.c"
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = dev_alias;
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "=", 2);
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10__length1 = _vala_array_length (_tmp8_);
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = _tmp10_[1];
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = string_strip (_tmp11_);
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (dev_alias);
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		dev_alias = _tmp14_;
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 6745 "Device.c"
	} else {
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		gboolean _tmp17_;
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp16_ = dev_alias;
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = tee_jee_file_system_file_exists (_tmp16_);
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp17_) {
#line 6756 "Device.c"
			const gchar* _tmp18_;
			gboolean _tmp19_;
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp18_ = dev_alias;
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = tee_jee_file_system_file_is_symlink (_tmp18_);
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = _tmp19_;
#line 6765 "Device.c"
		} else {
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = FALSE;
#line 6769 "Device.c"
		}
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp15_) {
#line 6773 "Device.c"
			gchar* link_path = NULL;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
#line 1044 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = dev_alias;
#line 1044 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = tee_jee_file_system_file_get_symlink_target (_tmp20_);
#line 1044 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			link_path = _tmp21_;
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = link_path;
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = string_replace (_tmp22_, "../../../", "/dev/");
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = _tmp23_;
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp25_ = string_replace (_tmp24_, "../../", "/dev/");
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = string_replace (_tmp26_, "../", "/dev/");
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (dev_alias);
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev_alias = _tmp27_;
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 1046 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp24_);
#line 1042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (link_path);
#line 6811 "Device.c"
		}
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp28_;
		GeeArrayList* _tmp29_;
		gint _dev_size = 0;
		GeeArrayList* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		gint _dev_index = 0;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp28_ = list;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp29_ = _g_object_ref0 (_tmp28_);
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp29_;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp30_ = _dev_list;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp32_ = _tmp31_;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp32_;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 6841 "Device.c"
			gint _tmp33_;
			gint _tmp34_;
			gint _tmp35_;
			Device* dev = NULL;
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gpointer _tmp38_;
			Device* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp33_ = _dev_index;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp33_ + 1;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp34_ = _dev_index;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp35_ = _dev_size;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp34_ < _tmp35_)) {
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 6864 "Device.c"
			}
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp36_ = _dev_list;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp37_ = _dev_index;
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp38_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _tmp37_);
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp38_;
#line 1051 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp39_ = dev;
#line 1051 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp40_ = _tmp39_->device;
#line 1051 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp41_ = dev_alias;
#line 1051 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp40_, _tmp41_) == 0) {
#line 1052 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = dev;
#line 1052 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 1052 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (dev_alias);
#line 1052 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 6890 "Device.c"
			} else {
				Device* _tmp42_;
				const gchar* _tmp43_;
				const gchar* _tmp44_;
#line 1054 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42_ = dev;
#line 1054 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp43_ = _tmp42_->uuid;
#line 1054 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp44_ = dev_alias;
#line 1054 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (g_strcmp0 (_tmp43_, _tmp44_) == 0) {
#line 1055 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					result = dev;
#line 1055 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (_dev_list);
#line 1055 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (dev_alias);
#line 1055 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					return result;
#line 6911 "Device.c"
				} else {
					Device* _tmp45_;
					const gchar* _tmp46_;
					const gchar* _tmp47_;
#line 1057 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp45_ = dev;
#line 1057 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp46_ = _tmp45_->label;
#line 1057 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp47_ = dev_alias;
#line 1057 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (g_strcmp0 (_tmp46_, _tmp47_) == 0) {
#line 1058 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						result = dev;
#line 1058 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_object_unref0 (_dev_list);
#line 1058 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (dev_alias);
#line 1058 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						return result;
#line 6932 "Device.c"
					} else {
						Device* _tmp48_;
						const gchar* _tmp49_;
						const gchar* _tmp50_;
#line 1060 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp48_ = dev;
#line 1060 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp49_ = _tmp48_->partuuid;
#line 1060 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp50_ = dev_alias;
#line 1060 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						if (g_strcmp0 (_tmp49_, _tmp50_) == 0) {
#line 1061 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							result = dev;
#line 1061 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1061 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_g_free0 (dev_alias);
#line 1061 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							return result;
#line 6953 "Device.c"
						} else {
							Device* _tmp51_;
							const gchar* _tmp52_;
							const gchar* _tmp53_;
#line 1063 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp51_ = dev;
#line 1063 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp52_ = _tmp51_->partlabel;
#line 1063 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							_tmp53_ = dev_alias;
#line 1063 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
							if (g_strcmp0 (_tmp52_, _tmp53_) == 0) {
#line 1064 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								result = dev;
#line 1064 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_object_unref0 (_dev_list);
#line 1064 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_g_free0 (dev_alias);
#line 1064 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								return result;
#line 6974 "Device.c"
							} else {
								Device* _tmp54_;
								const gchar* _tmp55_;
								const gchar* _tmp56_;
#line 1066 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp54_ = dev;
#line 1066 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp55_ = _tmp54_->device_by_uuid;
#line 1066 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								_tmp56_ = dev_alias;
#line 1066 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
								if (g_strcmp0 (_tmp55_, _tmp56_) == 0) {
#line 1067 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									result = dev;
#line 1067 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_object_unref0 (_dev_list);
#line 1067 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_g_free0 (dev_alias);
#line 1067 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									return result;
#line 6995 "Device.c"
								} else {
									Device* _tmp57_;
									const gchar* _tmp58_;
									const gchar* _tmp59_;
#line 1069 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp57_ = dev;
#line 1069 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp58_ = _tmp57_->device_by_label;
#line 1069 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									_tmp59_ = dev_alias;
#line 1069 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
									if (g_strcmp0 (_tmp58_, _tmp59_) == 0) {
#line 1070 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										result = dev;
#line 1070 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_g_object_unref0 (_dev_list);
#line 1070 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_g_free0 (dev_alias);
#line 1070 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										return result;
#line 7016 "Device.c"
									} else {
										Device* _tmp60_;
										const gchar* _tmp61_;
										const gchar* _tmp62_;
#line 1072 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp60_ = dev;
#line 1072 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp61_ = _tmp60_->device_by_partuuid;
#line 1072 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										_tmp62_ = dev_alias;
#line 1072 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
										if (g_strcmp0 (_tmp61_, _tmp62_) == 0) {
#line 1073 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											result = dev;
#line 1073 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											_g_object_unref0 (_dev_list);
#line 1073 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											_g_free0 (dev_alias);
#line 1073 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											return result;
#line 7037 "Device.c"
										} else {
											Device* _tmp63_;
											const gchar* _tmp64_;
											const gchar* _tmp65_;
#line 1075 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											_tmp63_ = dev;
#line 1075 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											_tmp64_ = _tmp63_->device_by_partlabel;
#line 1075 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											_tmp65_ = dev_alias;
#line 1075 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
											if (g_strcmp0 (_tmp64_, _tmp65_) == 0) {
#line 1076 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												result = dev;
#line 1076 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												_g_object_unref0 (_dev_list);
#line 1076 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												_g_free0 (dev_alias);
#line 1076 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												return result;
#line 7058 "Device.c"
											} else {
												Device* _tmp66_;
												const gchar* _tmp67_;
												const gchar* _tmp68_;
#line 1078 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												_tmp66_ = dev;
#line 1078 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												_tmp67_ = _tmp66_->device_mapper;
#line 1078 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												_tmp68_ = dev_alias;
#line 1078 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
												if (g_strcmp0 (_tmp67_, _tmp68_) == 0) {
#line 1079 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													result = dev;
#line 1079 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													_g_object_unref0 (_dev_list);
#line 1079 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													_g_free0 (dev_alias);
#line 1079 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													return result;
#line 7079 "Device.c"
												} else {
													Device* _tmp69_;
													const gchar* _tmp70_;
													const gchar* _tmp71_;
#line 1081 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													_tmp69_ = dev;
#line 1081 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													_tmp70_ = _tmp69_->mapped_name;
#line 1081 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													_tmp71_ = dev_alias;
#line 1081 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
													if (g_strcmp0 (_tmp70_, _tmp71_) == 0) {
#line 1082 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
														result = dev;
#line 1082 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
														_g_object_unref0 (_dev_list);
#line 1082 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
														_g_free0 (dev_alias);
#line 1082 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
														return result;
#line 7100 "Device.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7114 "Device.c"
		}
#line 1049 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 7118 "Device.c"
	}
#line 1086 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = NULL;
#line 1086 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (dev_alias);
#line 1086 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 7126 "Device.c"
}


void device_copy_fields_from (Device* self, Device* dev2) {
	Device* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	Device* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	Device* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	Device* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	Device* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	Device* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	Device* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	Device* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	Device* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	Device* _tmp27_;
	guint64 _tmp28_;
	Device* _tmp29_;
	guint64 _tmp30_;
	Device* _tmp31_;
	guint64 _tmp32_;
	Device* _tmp33_;
	GeeArrayList* _tmp34_;
	GeeArrayList* _tmp35_;
	Device* _tmp36_;
	GeeArrayList* _tmp37_;
	GeeArrayList* _tmp38_;
	Device* _tmp39_;
	Device* _tmp40_;
	Device* _tmp41_;
	Device* _tmp42_;
	GeeArrayList* _tmp43_;
	GeeArrayList* _tmp44_;
	Device* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	Device* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	Device* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	Device* _tmp54_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	Device* _tmp57_;
	gboolean _tmp58_;
	Device* _tmp59_;
	gboolean _tmp60_;
#line 1089 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1089 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (dev2 != NULL);
#line 1091 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = dev2;
#line 1091 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_->device;
#line 1091 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1091 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device);
#line 1091 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device = _tmp2_;
#line 1092 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = dev2;
#line 1092 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_->name;
#line 1092 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1092 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->name);
#line 1092 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->name = _tmp5_;
#line 1093 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = dev2;
#line 1093 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = _tmp6_->kname;
#line 1093 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 1093 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->kname);
#line 1093 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->kname = _tmp8_;
#line 1094 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp9_ = dev2;
#line 1094 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp10_ = _tmp9_->pkname;
#line 1094 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 1094 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->pkname);
#line 1094 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->pkname = _tmp11_;
#line 1095 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp12_ = dev2;
#line 1095 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp13_ = _tmp12_->label;
#line 1095 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 1095 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->label);
#line 1095 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->label = _tmp14_;
#line 1096 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = dev2;
#line 1096 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = _tmp15_->uuid;
#line 1096 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 1096 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->uuid);
#line 1096 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->uuid = _tmp17_;
#line 1097 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = dev2;
#line 1097 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp19_ = _tmp18_->mapped_name;
#line 1097 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 1097 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 1097 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->mapped_name = _tmp20_;
#line 1099 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp21_ = dev2;
#line 1099 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp22_ = _tmp21_->type;
#line 1099 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 1099 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->type);
#line 1099 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->type = _tmp23_;
#line 1100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp24_ = dev2;
#line 1100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp25_ = _tmp24_->fstype;
#line 1100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp26_ = g_strdup (_tmp25_);
#line 1100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->fstype);
#line 1100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->fstype = _tmp26_;
#line 1102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp27_ = dev2;
#line 1102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp28_ = _tmp27_->size_bytes;
#line 1102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->size_bytes = _tmp28_;
#line 1103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp29_ = dev2;
#line 1103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp30_ = _tmp29_->used_bytes;
#line 1103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->used_bytes = _tmp30_;
#line 1104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp31_ = dev2;
#line 1104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp32_ = _tmp31_->available_bytes;
#line 1104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->available_bytes = _tmp32_;
#line 1106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp33_ = dev2;
#line 1106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp34_ = _tmp33_->mount_points;
#line 1106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp35_ = _g_object_ref0 (_tmp34_);
#line 1106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 1106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->mount_points = _tmp35_;
#line 1107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp36_ = dev2;
#line 1107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp37_ = _tmp36_->symlinks;
#line 1107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp38_ = _g_object_ref0 (_tmp37_);
#line 1107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 1107 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->symlinks = _tmp38_;
#line 1108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp39_ = dev2;
#line 1108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp40_ = _tmp39_->parent;
#line 1108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp41_ = _g_object_ref0 (_tmp40_);
#line 1108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 1108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->parent = _tmp41_;
#line 1109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp42_ = dev2;
#line 1109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp43_ = _tmp42_->children;
#line 1109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp44_ = _g_object_ref0 (_tmp43_);
#line 1109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 1109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->children = _tmp44_;
#line 1111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp45_ = dev2;
#line 1111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp46_ = _tmp45_->vendor;
#line 1111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp47_ = g_strdup (_tmp46_);
#line 1111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->vendor);
#line 1111 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->vendor = _tmp47_;
#line 1112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp48_ = dev2;
#line 1112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp49_ = _tmp48_->model;
#line 1112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp50_ = g_strdup (_tmp49_);
#line 1112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->model);
#line 1112 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->model = _tmp50_;
#line 1113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp51_ = dev2;
#line 1113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp52_ = _tmp51_->serial;
#line 1113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp53_ = g_strdup (_tmp52_);
#line 1113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->serial);
#line 1113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->serial = _tmp53_;
#line 1114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp54_ = dev2;
#line 1114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp55_ = _tmp54_->revision;
#line 1114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp56_ = g_strdup (_tmp55_);
#line 1114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->revision);
#line 1114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->revision = _tmp56_;
#line 1116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp57_ = dev2;
#line 1116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp58_ = _tmp57_->removable;
#line 1116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->removable = _tmp58_;
#line 1117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp59_ = dev2;
#line 1117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp60_ = _tmp59_->read_only;
#line 1117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->read_only = _tmp60_;
#line 7396 "Device.c"
}


Device* device_query_changes (Device* self) {
	Device* result = NULL;
	Device* dev_new = NULL;
#line 1120 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	dev_new = NULL;
#line 7407 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp0_;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp1_ = _dev_list;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp3_;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 7432 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			Device* dev = NULL;
			GeeArrayList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp4_ = _dev_index;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp4_ + 1;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = _dev_index;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = _dev_size;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 7455 "Device.c"
			}
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = _dev_list;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _dev_index;
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 1125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = self->uuid;
#line 1125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = strlen (_tmp10_);
#line 1125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = _tmp11_;
#line 1125 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp12_ > 0) {
#line 7473 "Device.c"
				Device* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 1126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp13_ = dev;
#line 1126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp14_ = _tmp13_->uuid;
#line 1126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp15_ = self->uuid;
#line 1126 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 7485 "Device.c"
					Device* _tmp16_;
					Device* _tmp17_;
#line 1127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp16_ = dev;
#line 1127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					dev_new = _tmp17_;
#line 1128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 7500 "Device.c"
				}
			} else {
				Device* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
#line 1132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp18_ = dev;
#line 1132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp19_ = _tmp18_->device;
#line 1132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp20_ = self->device;
#line 1132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (g_strcmp0 (_tmp19_, _tmp20_) == 0) {
#line 7514 "Device.c"
					Device* _tmp21_;
					Device* _tmp22_;
#line 1133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp21_ = dev;
#line 1133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_ = _g_object_ref0 (_tmp21_);
#line 1133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1133 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					dev_new = _tmp22_;
#line 1134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1134 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 7529 "Device.c"
				}
			}
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7534 "Device.c"
		}
#line 1124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 7538 "Device.c"
	}
#line 1139 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = dev_new;
#line 1139 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 7544 "Device.c"
}


void device_query_disk_space (Device* self) {
	GeeArrayList* list_df = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	Device* dev_df = NULL;
	GeeArrayList* _tmp2_;
	const gchar* _tmp3_;
	Device* _tmp4_;
	Device* _tmp5_;
#line 1142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->device;
#line 1146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_get_disk_space_using_df (_tmp0_);
#line 1146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list_df = _tmp1_;
#line 1148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = list_df;
#line 1148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = self->uuid;
#line 1148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = device_find_device_in_list (_tmp2_, _tmp3_);
#line 1148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	dev_df = _tmp4_;
#line 1150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = dev_df;
#line 1150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp5_ != NULL) {
#line 7577 "Device.c"
		Device* _tmp6_;
		guint64 _tmp7_;
		Device* _tmp8_;
		guint64 _tmp9_;
		Device* _tmp10_;
		guint64 _tmp11_;
		Device* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 1152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = dev_df;
#line 1152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = _tmp6_->size_bytes;
#line 1152 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		self->size_bytes = _tmp7_;
#line 1153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = dev_df;
#line 1153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = _tmp8_->used_bytes;
#line 1153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		self->used_bytes = _tmp9_;
#line 1154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = dev_df;
#line 1154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = _tmp10_->available_bytes;
#line 1154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		self->available_bytes = _tmp11_;
#line 1155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = dev_df;
#line 1155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = _tmp12_->used_percent;
#line 1155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 1155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (self->used_percent);
#line 1155 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		self->used_percent = _tmp14_;
#line 7615 "Device.c"
	}
#line 1142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (dev_df);
#line 1142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list_df);
#line 7621 "Device.c"
}


gboolean device_automount_udisks (const gchar* dev_name_or_uuid, GtkWindow* parent_window) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* cmd = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint status = 0;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp14_;
#line 1161 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = dev_name_or_uuid;
#line 1163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = strlen (_tmp0_);
#line 1163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1163 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp2_ == 0) {
#line 1164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = FALSE;
#line 1165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 7655 "Device.c"
	}
#line 1168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = dev_name_or_uuid;
#line 1168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = g_strdup_printf ("udisksctl mount -b '%s'", _tmp3_);
#line 1168 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp4_;
#line 1169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = cmd;
#line 1169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp5_);
#line 1170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = cmd;
#line 1170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = system (_tmp6_);
#line 1170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	status = _tmp7_;
#line 1172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = status;
#line 1172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp8_ != 0) {
#line 7677 "Device.c"
		GtkWindow* _tmp9_;
#line 1173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = parent_window;
#line 1173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp9_ != NULL) {
#line 7683 "Device.c"
			gchar* msg = NULL;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			GtkWindow* _tmp13_;
#line 1174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = dev_name_or_uuid;
#line 1174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = g_strdup_printf ("Failed to mount: %s", _tmp10_);
#line 1174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			msg = _tmp11_;
#line 1175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = msg;
#line 1175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = parent_window;
#line 1175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp12_, _tmp13_, TRUE);
#line 1173 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (msg);
#line 7703 "Device.c"
		}
	}
#line 1179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = status;
#line 1179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp14_ == 0;
#line 1179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1179 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 7714 "Device.c"
}


gboolean device_automount_udisks_iso (const gchar* iso_file_path, gchar* * loop_device, GtkWindow* parent_window) {
	gchar* _vala_loop_device = NULL;
	gboolean result = FALSE;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	gchar* cmd = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint exit_code = 0;
	const gchar* _tmp12_;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gint _tmp15_;
	gint _tmp16_;
#line 1182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (iso_file_path != NULL, FALSE);
#line 1184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_vala_loop_device);
#line 1184 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_vala_loop_device = _tmp0_;
#line 1186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = iso_file_path;
#line 1186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = tee_jee_file_system_file_exists (_tmp1_);
#line 1186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (!_tmp2_) {
#line 7753 "Device.c"
		gchar* msg = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 1187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = iso_file_path;
#line 1187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%s: %s", _ ("Could not find file"), _tmp3_);
#line 1187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		msg = _tmp4_;
#line 1188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = msg;
#line 1188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp5_, FALSE, FALSE);
#line 1189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = FALSE;
#line 1189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (msg);
#line 1189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (loop_device) {
#line 1189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			*loop_device = _vala_loop_device;
#line 7776 "Device.c"
		} else {
#line 1189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_vala_loop_device);
#line 7780 "Device.c"
		}
#line 1189 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 7784 "Device.c"
	}
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = iso_file_path;
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = tee_jee_file_system_escape_single_quote (_tmp6_);
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = _tmp7_;
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp9_ = g_strdup_printf ("udisksctl loop-setup -r -f '%s'", _tmp8_);
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp10_ = _tmp9_;
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp8_);
#line 1192 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp10_;
#line 1195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp11_ = cmd;
#line 1195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp11_);
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp12_ = cmd;
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = tee_jee_process_helper_exec_sync (_tmp12_, &_tmp13_, &_tmp14_);
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp13_;
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp14_;
#line 1197 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	exit_code = _tmp15_;
#line 1199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = exit_code;
#line 1199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp16_ == 0) {
#line 7822 "Device.c"
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gboolean _tmp21_;
		const gchar* _tmp22_;
		gchar** _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
		gint _tmp25__length1;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp33_;
#line 1200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = std_out;
#line 1200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = g_strdup_printf ("%s", _tmp17_);
#line 1200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp19_, FALSE);
#line 1200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp19_);
#line 1203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = std_out;
#line 1203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = string_contains (_tmp20_, " as ");
#line 1203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (!_tmp21_) {
#line 1204 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_error ("Could not determine loop device", FALSE, FALSE);
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			result = FALSE;
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (std_err);
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (std_out);
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (cmd);
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (loop_device) {
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				*loop_device = _vala_loop_device;
#line 7872 "Device.c"
			} else {
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_vala_loop_device);
#line 7876 "Device.c"
			}
#line 1205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			return result;
#line 7880 "Device.c"
		}
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = std_out;
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = _tmp23_ = g_strsplit (_tmp22_, " as ", 0);
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25__length1 = _vala_array_length (_tmp23_);
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp26_ = _tmp25_[1];
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp27_ = string_replace (_tmp26_, ".", "");
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp28_ = _tmp27_;
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp29_ = string_strip (_tmp28_);
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_loop_device = _tmp29_;
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp28_);
#line 1208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = (_vala_array_free (_tmp25_, _tmp25__length1, (GDestroyNotify) g_free), NULL);
#line 1209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp30_ = _vala_loop_device;
#line 1209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp31_ = g_strdup_printf ("loop_device: %s", _tmp30_);
#line 1209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp32_ = _tmp31_;
#line 1209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp32_, FALSE);
#line 1209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp32_);
#line 1211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp33_ = device_get_block_devices_using_lsblk ("");
#line 1211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		list = _tmp33_;
#line 7920 "Device.c"
		{
			GeeArrayList* _dev_list = NULL;
			GeeArrayList* _tmp34_;
			GeeArrayList* _tmp35_;
			gint _dev_size = 0;
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gint _dev_index = 0;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp34_ = list;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp35_ = _g_object_ref0 (_tmp34_);
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_list = _tmp35_;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp36_ = _dev_list;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp38_ = _tmp37_;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_size = _tmp38_;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = -1;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			while (TRUE) {
#line 7948 "Device.c"
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				Device* dev = NULL;
				GeeArrayList* _tmp42_;
				gint _tmp43_;
				gpointer _tmp44_;
				gboolean _tmp45_ = FALSE;
				Device* _tmp46_;
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gboolean _tmp51_;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp39_ = _dev_index;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_dev_index = _tmp39_ + 1;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp40_ = _dev_index;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp41_ = _dev_size;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!(_tmp40_ < _tmp41_)) {
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 7975 "Device.c"
				}
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42_ = _dev_list;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp43_ = _dev_index;
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp42_, _tmp43_);
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				dev = (Device*) _tmp44_;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp46_ = dev;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp47_ = _tmp46_->pkname;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp48_ = _vala_loop_device;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp49_ = string_replace (_tmp48_, "/dev/", "");
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp50_ = _tmp49_;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp51_ = g_strcmp0 (_tmp47_, _tmp50_) == 0;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp50_);
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp51_) {
#line 8001 "Device.c"
					Device* _tmp52_;
					const gchar* _tmp53_;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp52_ = dev;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp53_ = _tmp52_->fstype;
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp45_ = g_strcmp0 (_tmp53_, "iso9660") == 0;
#line 8010 "Device.c"
				} else {
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp45_ = FALSE;
#line 8014 "Device.c"
				}
#line 1213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (_tmp45_) {
#line 8018 "Device.c"
					Device* _tmp54_;
					const gchar* _tmp55_;
					gchar* _tmp56_;
					Device* _tmp57_;
					const gchar* _tmp58_;
					GtkWindow* _tmp59_;
					gboolean _tmp60_;
#line 1214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp54_ = dev;
#line 1214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp55_ = _tmp54_->device;
#line 1214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp56_ = g_strdup (_tmp55_);
#line 1214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_loop_device);
#line 1214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_vala_loop_device = _tmp56_;
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp57_ = dev;
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp58_ = _tmp57_->device;
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp59_ = parent_window;
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp60_ = device_automount_udisks (_tmp58_, _tmp59_);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					result = _tmp60_;
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (_dev_list);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (list);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_err);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (std_out);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (cmd);
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (loop_device) {
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						*loop_device = _vala_loop_device;
#line 8062 "Device.c"
					} else {
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_vala_loop_device);
#line 8066 "Device.c"
					}
#line 1215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					return result;
#line 8070 "Device.c"
				}
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (dev);
#line 8074 "Device.c"
			}
#line 1212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (_dev_list);
#line 8078 "Device.c"
		}
#line 1199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 8082 "Device.c"
	}
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = FALSE;
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (loop_device) {
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		*loop_device = _vala_loop_device;
#line 8096 "Device.c"
	} else {
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 8100 "Device.c"
	}
#line 1220 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 8104 "Device.c"
}


gboolean device_unmount_udisks (const gchar* dev_name_or_uuid, GtkWindow* parent_window) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* cmd = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint status = 0;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp14_;
#line 1223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = dev_name_or_uuid;
#line 1225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = strlen (_tmp0_);
#line 1225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp2_ == 0) {
#line 1226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = FALSE;
#line 1227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 8138 "Device.c"
	}
#line 1230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = dev_name_or_uuid;
#line 1230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = g_strdup_printf ("udisksctl unmount -b '%s'", _tmp3_);
#line 1230 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp4_;
#line 1231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = cmd;
#line 1231 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp5_);
#line 1232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = cmd;
#line 1232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = system (_tmp6_);
#line 1232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	status = _tmp7_;
#line 1234 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = status;
#line 1234 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp8_ != 0) {
#line 8160 "Device.c"
		GtkWindow* _tmp9_;
#line 1235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = parent_window;
#line 1235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp9_ != NULL) {
#line 8166 "Device.c"
			gchar* msg = NULL;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			GtkWindow* _tmp13_;
#line 1236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = dev_name_or_uuid;
#line 1236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = g_strdup_printf ("Failed to unmount: %s", _tmp10_);
#line 1236 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			msg = _tmp11_;
#line 1237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = msg;
#line 1237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = parent_window;
#line 1237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp12_, _tmp13_, TRUE);
#line 1235 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (msg);
#line 8186 "Device.c"
		}
	}
#line 1241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = status;
#line 1241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp14_ == 0;
#line 1241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1241 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 8197 "Device.c"
}


Device* device_luks_unlock (Device* luks_device, const gchar* mapped_name, const gchar* passphrase, GtkWindow* parent_window, gchar* * message, gchar* * details) {
	gchar* _vala_message = NULL;
	gchar* _vala_details = NULL;
	Device* result = NULL;
	Device* unlocked_device = NULL;
	gchar* std_out = NULL;
	gchar* _tmp0_;
	gchar* std_err = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Device* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp11_;
	gchar* luks_pass = NULL;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* luks_name = NULL;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	gboolean _tmp37_ = FALSE;
	const gchar* _tmp38_;
	GtkWindow* _tmp45_;
	GeeArrayList* _tmp115_;
	gboolean is_error = FALSE;
	Device* _tmp133_;
	GtkWindow* _tmp145_;
#line 1244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (luks_device != NULL, NULL);
#line 1244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mapped_name != NULL, NULL);
#line 1244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (passphrase != NULL, NULL);
#line 1254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	unlocked_device = NULL;
#line 1255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp0_;
#line 1255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1255 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp1_;
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = luks_device;
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_->fstype;
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = string_contains (_tmp4_, "luks");
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (!_tmp5_) {
#line 8253 "Device.c"
		Device* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = luks_device;
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = _tmp6_->fstype;
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = string_contains (_tmp7_, "crypt");
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = !_tmp8_;
#line 8265 "Device.c"
	} else {
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = FALSE;
#line 8269 "Device.c"
	}
#line 1258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp2_) {
#line 8273 "Device.c"
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup (_ ("This device is not encrypted"));
#line 1259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1259 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_message = _tmp9_;
#line 1260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_strdup (_ ("Failed to unlock device"));
#line 1260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_details = _tmp10_;
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = NULL;
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (unlocked_device);
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (message) {
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			*message = _vala_message;
#line 8300 "Device.c"
		} else {
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_vala_message);
#line 8304 "Device.c"
		}
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (details) {
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			*details = _vala_details;
#line 8310 "Device.c"
		} else {
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_vala_details);
#line 8314 "Device.c"
		}
#line 1261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 8318 "Device.c"
	}
#line 1265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp11_ = device_get_block_devices_using_lsblk ("");
#line 1265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp11_;
#line 8324 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
		gint _part_size = 0;
		GeeArrayList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _part_index = 0;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = list;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_list = _tmp13_;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = _part_list;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp16_ = _tmp15_;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_size = _tmp16_;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_index = -1;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 8352 "Device.c"
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			Device* part = NULL;
			GeeArrayList* _tmp20_;
			gint _tmp21_;
			gpointer _tmp22_;
			Device* _tmp23_;
			const gchar* _tmp24_;
			Device* _tmp25_;
			const gchar* _tmp26_;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = _part_index;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_index = _tmp17_ + 1;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp18_ = _part_index;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = _part_size;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 8376 "Device.c"
			}
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = _part_list;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = _part_index;
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _tmp21_);
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			part = (Device*) _tmp22_;
#line 1267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = part;
#line 1267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = _tmp23_->pkname;
#line 1267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp25_ = luks_device;
#line 1267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = _tmp25_->kname;
#line 1267 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp24_, _tmp26_) == 0) {
#line 8396 "Device.c"
				Device* _tmp27_;
				Device* _tmp28_;
				gchar* _tmp29_;
				Device* _tmp30_;
				const gchar* _tmp31_;
				gchar* _tmp32_;
#line 1268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp27_ = part;
#line 1268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp28_ = _g_object_ref0 (_tmp27_);
#line 1268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1268 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				unlocked_device = _tmp28_;
#line 1269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp29_ = g_strdup (_ ("Device is unlocked"));
#line 1269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1269 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_vala_message = _tmp29_;
#line 1270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp30_ = part;
#line 1270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp31_ = _tmp30_->mapped_name;
#line 1270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp32_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp31_);
#line 1270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_vala_details = _tmp32_;
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = part;
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_part_list);
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (list);
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (std_err);
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (std_out);
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (message) {
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					*message = _vala_message;
#line 8443 "Device.c"
				} else {
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 8447 "Device.c"
				}
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (details) {
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					*details = _vala_details;
#line 8453 "Device.c"
				} else {
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 8457 "Device.c"
				}
#line 1271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 8461 "Device.c"
			}
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 8465 "Device.c"
		}
#line 1266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 8469 "Device.c"
	}
#line 1275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp33_ = passphrase;
#line 1275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 1275 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	luks_pass = _tmp34_;
#line 1276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp35_ = mapped_name;
#line 1276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 1276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	luks_name = _tmp36_;
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp38_ = luks_name;
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp38_ == NULL) {
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp37_ = TRUE;
#line 8489 "Device.c"
	} else {
		const gchar* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp39_ = luks_name;
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp40_ = strlen (_tmp39_);
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp37_ = _tmp41_ == 0;
#line 8502 "Device.c"
	}
#line 1278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp37_) {
#line 8506 "Device.c"
		Device* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
#line 1279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp42_ = luks_device;
#line 1279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp43_ = _tmp42_->kname;
#line 1279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp44_ = g_strdup_printf ("%s_crypt", _tmp43_);
#line 1279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (luks_name);
#line 1279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		luks_name = _tmp44_;
#line 8520 "Device.c"
	}
#line 1282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp45_ = parent_window;
#line 1282 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp45_ == NULL) {
#line 8526 "Device.c"
		gboolean _tmp46_ = FALSE;
		const gchar* _tmp47_;
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp47_ = luks_pass;
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp47_ == NULL) {
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = TRUE;
#line 8535 "Device.c"
		} else {
			const gchar* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = luks_pass;
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp49_ = strlen (_tmp48_);
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp50_ = _tmp49_;
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = _tmp50_ == 0;
#line 8548 "Device.c"
		}
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp46_) {
#line 8552 "Device.c"
			TimeoutCounter* counter = NULL;
			TimeoutCounter* _tmp51_;
			TimeoutCounter* _tmp52_;
			gchar* cmd = NULL;
			Device* _tmp53_;
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			gchar* _tmp56_;
			const gchar* _tmp57_;
			const gchar* _tmp58_;
			TimeoutCounter* _tmp59_;
#line 1290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp51_ = timeout_counter_new ();
#line 1290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			counter = _tmp51_;
#line 1291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp52_ = counter;
#line 1291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			timeout_counter_kill_process_on_timeout (_tmp52_, "cryptsetup", 20, TRUE);
#line 1292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp53_ = luks_device;
#line 1292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp54_ = _tmp53_->device;
#line 1292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp55_ = luks_name;
#line 1292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp56_ = g_strdup_printf ("cryptsetup luksOpen '%s' '%s'", _tmp54_, _tmp55_);
#line 1292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			cmd = _tmp56_;
#line 1294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp57_ = cmd;
#line 1294 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp57_);
#line 1295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp58_ = cmd;
#line 1295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			system (_tmp58_);
#line 1296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp59_ = counter;
#line 1296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			timeout_counter_stop (_tmp59_);
#line 1297 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_msg ("", FALSE);
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (cmd);
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (counter);
#line 8600 "Device.c"
		} else {
			gchar* cmd = NULL;
			const gchar* _tmp60_;
			Device* _tmp61_;
			const gchar* _tmp62_;
			const gchar* _tmp63_;
			gchar* _tmp64_;
			const gchar* _tmp65_;
			const gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gint status = 0;
			const gchar* _tmp69_;
			gchar* _tmp70_ = NULL;
			gchar* _tmp71_ = NULL;
			gint _tmp72_;
			gint _tmp73_;
#line 1304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp60_ = luks_pass;
#line 1304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp61_ = luks_device;
#line 1304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp62_ = _tmp61_->device;
#line 1304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp63_ = luks_name;
#line 1304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp64_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp60_, _tmp62_, _tmp63_);
#line 1304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			cmd = _tmp64_;
#line 1307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp65_ = cmd;
#line 1307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp66_ = luks_pass;
#line 1307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp67_ = string_replace (_tmp65_, _tmp66_, "**PASSWORD**");
#line 1307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp68_ = _tmp67_;
#line 1307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp68_);
#line 1307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp68_);
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp69_ = cmd;
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp72_ = tee_jee_process_helper_exec_script_sync (_tmp69_, &_tmp70_, &_tmp71_, FALSE, TRUE, TRUE, FALSE);
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (std_out);
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			std_out = _tmp70_;
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (std_err);
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			std_err = _tmp71_;
#line 1309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			status = _tmp72_;
#line 1311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp73_ = status;
#line 1311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			switch (_tmp73_) {
#line 1311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				case 512:
#line 8662 "Device.c"
				{
					gchar* _tmp74_;
					gchar* _tmp75_;
					const gchar* _tmp76_;
					const gchar* _tmp77_;
#line 1313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp74_ = g_strdup (_ ("Wrong password"));
#line 1313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_vala_message = _tmp74_;
#line 1314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp75_ = g_strdup (_ ("Failed to unlock device"));
#line 1314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_vala_details = _tmp75_;
#line 1315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp76_ = _vala_message;
#line 1315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp76_, FALSE, FALSE);
#line 1316 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp77_ = _vala_details;
#line 1316 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp77_, FALSE, FALSE);
#line 1317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 8690 "Device.c"
				}
				default:
#line 1311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 8695 "Device.c"
			}
#line 1286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (cmd);
#line 8699 "Device.c"
		}
	} else {
		gboolean _tmp78_ = FALSE;
		const gchar* _tmp79_;
		gboolean _tmp92_ = FALSE;
		const gchar* _tmp93_;
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp79_ = luks_pass;
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp79_ == NULL) {
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp78_ = TRUE;
#line 8712 "Device.c"
		} else {
			const gchar* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp80_ = luks_pass;
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp81_ = strlen (_tmp80_);
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp82_ = _tmp81_;
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp78_ = _tmp82_ == 0;
#line 8725 "Device.c"
		}
#line 1326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp78_) {
#line 8729 "Device.c"
			Device* _tmp83_;
			const gchar* _tmp84_;
			gchar* _tmp85_;
			gchar* _tmp86_;
			GtkWindow* _tmp87_;
			gchar* _tmp88_;
			const gchar* _tmp89_;
#line 1330 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug ("Prompting user for passphrase..");
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp83_ = luks_device;
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp84_ = _tmp83_->name;
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp85_ = g_strdup_printf (_ ("Enter passphrase to unlock '%s'"), _tmp84_);
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp86_ = _tmp85_;
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp87_ = parent_window;
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp88_ = tee_jee_gtk_helper_gtk_inputbox (_ ("Encrypted Device"), _tmp86_, _tmp87_, TRUE);
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (luks_pass);
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			luks_pass = _tmp88_;
#line 1332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp86_);
#line 1337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp89_ = luks_pass;
#line 1337 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp89_ == NULL) {
#line 8761 "Device.c"
				gchar* _tmp90_;
				gchar* _tmp91_;
#line 1339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp90_ = g_strdup (_ ("Failed to unlock device"));
#line 1339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_vala_message = _tmp90_;
#line 1340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp91_ = g_strdup (_ ("User cancelled the password prompt"));
#line 1340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_vala_details = _tmp91_;
#line 1341 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				tee_jee_logging_log_debug ("User cancelled the password prompt");
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = NULL;
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (luks_name);
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (luks_pass);
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (list);
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (std_err);
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (std_out);
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (message) {
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					*message = _vala_message;
#line 8796 "Device.c"
				} else {
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 8800 "Device.c"
				}
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (details) {
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					*details = _vala_details;
#line 8806 "Device.c"
				} else {
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 8810 "Device.c"
				}
#line 1342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 8814 "Device.c"
			}
		}
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp93_ = luks_pass;
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp93_ != NULL) {
#line 8821 "Device.c"
			const gchar* _tmp94_;
			gint _tmp95_;
			gint _tmp96_;
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp94_ = luks_pass;
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp95_ = strlen (_tmp94_);
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp96_ = _tmp95_;
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp92_ = _tmp96_ > 0;
#line 8833 "Device.c"
		} else {
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp92_ = FALSE;
#line 8837 "Device.c"
		}
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp92_) {
#line 8841 "Device.c"
			gchar* cmd = NULL;
			const gchar* _tmp97_;
			Device* _tmp98_;
			const gchar* _tmp99_;
			const gchar* _tmp100_;
			gchar* _tmp101_;
			const gchar* _tmp102_;
			const gchar* _tmp103_;
			gchar* _tmp104_;
			gchar* _tmp105_;
			gint status = 0;
			const gchar* _tmp106_;
			gchar* _tmp107_ = NULL;
			gchar* _tmp108_ = NULL;
			gint _tmp109_;
			gint _tmp110_;
#line 1350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp97_ = luks_pass;
#line 1350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp98_ = luks_device;
#line 1350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp99_ = _tmp98_->device;
#line 1350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp100_ = luks_name;
#line 1350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp101_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp97_, _tmp99_, _tmp100_);
#line 1350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			cmd = _tmp101_;
#line 1353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp102_ = cmd;
#line 1353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp103_ = luks_pass;
#line 1353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp104_ = string_replace (_tmp102_, _tmp103_, "**PASSWORD**");
#line 1353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp105_ = _tmp104_;
#line 1353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp105_);
#line 1353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp105_);
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp106_ = cmd;
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp109_ = tee_jee_process_helper_exec_script_sync (_tmp106_, &_tmp107_, &_tmp108_, FALSE, TRUE, TRUE, FALSE);
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (std_out);
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			std_out = _tmp107_;
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (std_err);
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			std_err = _tmp108_;
#line 1355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			status = _tmp109_;
#line 1357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp110_ = status;
#line 1357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			switch (_tmp110_) {
#line 1357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				case 512:
#line 8902 "Device.c"
				{
					gchar* _tmp111_;
					gchar* _tmp112_;
					const gchar* _tmp113_;
					const gchar* _tmp114_;
#line 1359 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp111_ = g_strdup (_ ("Wrong password"));
#line 1359 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1359 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_vala_message = _tmp111_;
#line 1360 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp112_ = g_strdup (_ ("Failed to unlock device"));
#line 1360 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1360 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_vala_details = _tmp112_;
#line 1361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp113_ = _vala_message;
#line 1361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp113_, FALSE, FALSE);
#line 1362 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp114_ = _vala_details;
#line 1362 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_error (_tmp114_, FALSE, FALSE);
#line 1363 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					break;
#line 8930 "Device.c"
				}
				default:
#line 1357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 8935 "Device.c"
			}
#line 1346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (cmd);
#line 8939 "Device.c"
		}
	}
#line 1370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp115_ = device_get_block_devices_using_lsblk ("");
#line 1370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1370 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp115_;
#line 8948 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp116_;
		GeeArrayList* _tmp117_;
		gint _part_size = 0;
		GeeArrayList* _tmp118_;
		gint _tmp119_;
		gint _tmp120_;
		gint _part_index = 0;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp116_ = list;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp117_ = _g_object_ref0 (_tmp116_);
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_list = _tmp117_;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp118_ = _part_list;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp119_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp118_);
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp120_ = _tmp119_;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_size = _tmp120_;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_part_index = -1;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 8976 "Device.c"
			gint _tmp121_;
			gint _tmp122_;
			gint _tmp123_;
			Device* part = NULL;
			GeeArrayList* _tmp124_;
			gint _tmp125_;
			gpointer _tmp126_;
			Device* _tmp127_;
			const gchar* _tmp128_;
			Device* _tmp129_;
			const gchar* _tmp130_;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp121_ = _part_index;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_part_index = _tmp121_ + 1;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp122_ = _part_index;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp123_ = _part_size;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp122_ < _tmp123_)) {
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 9000 "Device.c"
			}
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp124_ = _part_list;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp125_ = _part_index;
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp126_ = gee_abstract_list_get ((GeeAbstractList*) _tmp124_, _tmp125_);
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			part = (Device*) _tmp126_;
#line 1372 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp127_ = part;
#line 1372 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp128_ = _tmp127_->pkname;
#line 1372 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp129_ = luks_device;
#line 1372 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp130_ = _tmp129_->kname;
#line 1372 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp128_, _tmp130_) == 0) {
#line 9020 "Device.c"
				Device* _tmp131_;
				Device* _tmp132_;
#line 1373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp131_ = part;
#line 1373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp132_ = _g_object_ref0 (_tmp131_);
#line 1373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				unlocked_device = _tmp132_;
#line 1374 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (part);
#line 1374 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 9035 "Device.c"
			}
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (part);
#line 9039 "Device.c"
		}
#line 1371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 9043 "Device.c"
	}
#line 1378 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	is_error = FALSE;
#line 1379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp133_ = unlocked_device;
#line 1379 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp133_ == NULL) {
#line 9051 "Device.c"
		Device* _tmp134_;
		const gchar* _tmp135_;
		gchar* _tmp136_;
		gchar* _tmp137_;
		gchar* _tmp138_;
		const gchar* _tmp139_;
		gchar* _tmp140_;
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp134_ = luks_device;
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp135_ = _tmp134_->device;
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp136_ = g_strdup_printf (" '%s'", _tmp135_);
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp137_ = _tmp136_;
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp138_ = g_strconcat (_ ("Failed to unlock device"), _tmp137_, NULL);
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_message = _tmp138_;
#line 1380 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp137_);
#line 1381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp139_ = std_err;
#line 1381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp140_ = g_strdup (_tmp139_);
#line 1381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_details = _tmp140_;
#line 1382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		is_error = TRUE;
#line 9085 "Device.c"
	} else {
		gchar* _tmp141_;
		Device* _tmp142_;
		const gchar* _tmp143_;
		gchar* _tmp144_;
#line 1385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp141_ = g_strdup (_ ("Unlocked successfully"));
#line 1385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_message = _tmp141_;
#line 1386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp142_ = unlocked_device;
#line 1386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp143_ = _tmp142_->mapped_name;
#line 1386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp144_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp143_);
#line 1386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_vala_details = _tmp144_;
#line 9107 "Device.c"
	}
#line 1389 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp145_ = parent_window;
#line 1389 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp145_ != NULL) {
#line 9113 "Device.c"
		const gchar* _tmp146_;
		const gchar* _tmp147_;
		GtkWindow* _tmp148_;
		gboolean _tmp149_;
#line 1390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp146_ = _vala_message;
#line 1390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp147_ = _vala_details;
#line 1390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp148_ = parent_window;
#line 1390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp149_ = is_error;
#line 1390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_gtk_helper_gtk_messagebox (_tmp146_, _tmp147_, _tmp148_, _tmp149_);
#line 9128 "Device.c"
	}
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = unlocked_device;
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (luks_name);
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (luks_pass);
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (message) {
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		*message = _vala_message;
#line 9146 "Device.c"
	} else {
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_message);
#line 9150 "Device.c"
	}
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (details) {
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		*details = _vala_details;
#line 9156 "Device.c"
	} else {
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_vala_details);
#line 9160 "Device.c"
	}
#line 1393 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 9164 "Device.c"
}


gboolean device_luks_lock (const gchar* kname, GtkWindow* parent_window) {
	gboolean result = FALSE;
	gchar* cmd = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp15_;
#line 1396 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (kname != NULL, FALSE);
#line 1397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = kname;
#line 1397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup_printf ("cryptsetup luksClose %s", _tmp0_);
#line 1397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp1_;
#line 1399 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = cmd;
#line 1399 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp2_);
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = cmd;
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = tee_jee_process_helper_exec_script_sync (_tmp3_, &_tmp4_, &_tmp5_, FALSE, TRUE, TRUE, FALSE);
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp4_;
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp5_;
#line 1402 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	status = _tmp6_;
#line 1403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = std_out;
#line 1403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 1404 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = std_err;
#line 1404 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp8_, FALSE);
#line 1406 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp9_ = status;
#line 1406 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp9_ != 0) {
#line 9223 "Device.c"
		GtkWindow* _tmp10_;
#line 1407 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = parent_window;
#line 1407 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp10_ != NULL) {
#line 9229 "Device.c"
			gchar* msg = NULL;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			GtkWindow* _tmp14_;
#line 1408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = kname;
#line 1408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = g_strdup_printf ("Failed to lock device: %s", _tmp11_);
#line 1408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			msg = _tmp12_;
#line 1409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = msg;
#line 1409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = parent_window;
#line 1409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp13_, _tmp14_, TRUE);
#line 1407 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (msg);
#line 9249 "Device.c"
		}
	}
#line 1413 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = status;
#line 1413 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp15_ == 0;
#line 1413 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1413 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1413 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 1413 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 9264 "Device.c"
}


gboolean device_mount (const gchar* dev_name_or_uuid, const gchar* mount_point, const gchar* mount_options, gboolean silent) {
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* device = NULL;
	gchar* _tmp1_;
	gchar* uuid = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	GeeArrayList* mps = NULL;
	const gchar* _tmp15_;
	GeeArrayList* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	const gchar* _tmp80_;
	gchar* _tmp81_ = NULL;
	gchar* _tmp82_ = NULL;
	gint _tmp83_;
	gint _tmp84_;
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, FALSE);
#line 1435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp0_;
#line 1440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device = _tmp1_;
#line 1441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 1441 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	uuid = _tmp2_;
#line 1445 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = dev_name_or_uuid;
#line 1445 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = g_str_has_prefix (_tmp3_, "/dev");
#line 1445 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_) {
#line 9322 "Device.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = dev_name_or_uuid;
#line 1446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 1446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp6_;
#line 1447 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = dev_name_or_uuid;
#line 1447 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = device_get_device_uuid (_tmp7_);
#line 1447 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1447 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		uuid = _tmp8_;
#line 9343 "Device.c"
	} else {
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 1450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = dev_name_or_uuid;
#line 1450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 1450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		uuid = _tmp10_;
#line 1451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = uuid;
#line 1451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp11_);
#line 1451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp12_;
#line 1452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = device;
#line 1452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = device_resolve_device_name (_tmp13_);
#line 1452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp14_;
#line 9375 "Device.c"
	}
#line 1457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = dev_name_or_uuid;
#line 1457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = device_get_device_mount_points (_tmp15_);
#line 1457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mps = _tmp16_;
#line 1459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 1460 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = dev_name_or_uuid;
#line 1460 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = device;
#line 1460 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp19_ = g_strdup_printf ("arg=%s, device=%s", _tmp17_, _tmp18_);
#line 1460 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp20_ = _tmp19_;
#line 1460 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp20_);
#line 1460 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp20_);
#line 9397 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp21_;
		GeeArrayList* _tmp22_;
		gint _mp_size = 0;
		GeeArrayList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _mp_index = 0;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = mps;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mp_list = _tmp22_;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp23_ = _mp_list;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mp_size = _tmp25_;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mp_index = -1;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 9425 "Device.c"
			gint _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			MountEntry* mp = NULL;
			GeeArrayList* _tmp29_;
			gint _tmp30_;
			gpointer _tmp31_;
			MountEntry* _tmp32_;
			const gchar* _tmp33_;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = _mp_index;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_mp_index = _tmp26_ + 1;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = _mp_index;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp28_ = _mp_size;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp27_ < _tmp28_)) {
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 9447 "Device.c"
			}
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp29_ = _mp_list;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = _mp_index;
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, _tmp30_);
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mp = (MountEntry*) _tmp31_;
#line 1462 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp32_ = mp;
#line 1462 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp33_ = _tmp32_->mount_point;
#line 1462 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp33_);
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (mp);
#line 9465 "Device.c"
		}
#line 1461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_mp_list);
#line 9469 "Device.c"
	}
#line 1464 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 9473 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp34_;
		GeeArrayList* _tmp35_;
		gint _mp_size = 0;
		GeeArrayList* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _mp_index = 0;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp34_ = mps;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp35_ = _g_object_ref0 (_tmp34_);
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mp_list = _tmp35_;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp36_ = _mp_list;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mp_size = _tmp38_;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_mp_index = -1;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 9501 "Device.c"
			gint _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			MountEntry* mp = NULL;
			GeeArrayList* _tmp42_;
			gint _tmp43_;
			gpointer _tmp44_;
			gboolean _tmp45_ = FALSE;
			MountEntry* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp39_ = _mp_index;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_mp_index = _tmp39_ + 1;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp40_ = _mp_index;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp41_ = _mp_size;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp40_ < _tmp41_)) {
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 9525 "Device.c"
			}
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp42_ = _mp_list;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp43_ = _mp_index;
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp42_, _tmp43_);
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mp = (MountEntry*) _tmp44_;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = mp;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp47_ = _tmp46_->mount_point;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = mount_point;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (g_strcmp0 (_tmp47_, _tmp48_) == 0) {
#line 9543 "Device.c"
				MountEntry* _tmp49_;
				const gchar* _tmp50_;
				const gchar* _tmp51_;
				gboolean _tmp52_;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp49_ = mp;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp50_ = _tmp49_->mount_options;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp51_ = mount_options;
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp52_ = string_contains (_tmp50_, _tmp51_);
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp45_ = _tmp52_;
#line 9558 "Device.c"
			} else {
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp45_ = FALSE;
#line 9562 "Device.c"
			}
#line 1467 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp45_) {
#line 9566 "Device.c"
				gboolean _tmp53_;
#line 1468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp53_ = silent;
#line 1468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				if (!_tmp53_) {
#line 9572 "Device.c"
					gchar* msg = NULL;
					const gchar* _tmp54_;
					const gchar* _tmp55_;
					gchar* _tmp56_;
					MountEntry* _tmp57_;
					const gchar* _tmp58_;
					gint _tmp59_;
					gint _tmp60_;
					const gchar* _tmp67_;
#line 1469 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp54_ = device;
#line 1469 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp55_ = mount_point;
#line 1469 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp56_ = g_strdup_printf ("%s is mounted at: %s", _tmp54_, _tmp55_);
#line 1469 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					msg = _tmp56_;
#line 1470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp57_ = mp;
#line 1470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp58_ = _tmp57_->mount_options;
#line 1470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp59_ = strlen (_tmp58_);
#line 1470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp60_ = _tmp59_;
#line 1470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp60_ > 0) {
#line 9600 "Device.c"
						const gchar* _tmp61_;
						MountEntry* _tmp62_;
						const gchar* _tmp63_;
						gchar* _tmp64_;
						gchar* _tmp65_;
						gchar* _tmp66_;
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp61_ = msg;
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp62_ = mp;
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp63_ = _tmp62_->mount_options;
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp64_ = g_strdup_printf (", options: %s", _tmp63_);
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp65_ = _tmp64_;
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp66_ = g_strconcat (_tmp61_, _tmp65_, NULL);
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (msg);
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						msg = _tmp66_;
#line 1471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp65_);
#line 9625 "Device.c"
					}
#line 1473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp67_ = msg;
#line 1473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					tee_jee_logging_log_msg (_tmp67_, FALSE);
#line 1468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (msg);
#line 9633 "Device.c"
				}
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				result = TRUE;
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (mp);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (mps);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (uuid);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (device);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (std_err);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (std_out);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (cmd);
#line 1475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				return result;
#line 9655 "Device.c"
			}
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (mp);
#line 9659 "Device.c"
		}
#line 1466 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_mp_list);
#line 9663 "Device.c"
	}
#line 1479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp68_ = mount_point;
#line 1479 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_file_system_dir_create (_tmp68_, FALSE);
#line 1483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp69_ = mount_point;
#line 1483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_unmount (_tmp69_);
#line 1487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp70_ = mount_options;
#line 1487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp71_ = strlen (_tmp70_);
#line 1487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp72_ = _tmp71_;
#line 1487 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp72_ > 0) {
#line 9681 "Device.c"
		const gchar* _tmp73_;
		const gchar* _tmp74_;
		const gchar* _tmp75_;
		gchar* _tmp76_;
#line 1488 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp73_ = mount_options;
#line 1488 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp74_ = device;
#line 1488 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp75_ = mount_point;
#line 1488 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp76_ = g_strdup_printf ("mount -o %s \"%s\" \"%s\"", _tmp73_, _tmp74_, _tmp75_);
#line 1488 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1488 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp76_;
#line 9698 "Device.c"
	} else {
		const gchar* _tmp77_;
		const gchar* _tmp78_;
		gchar* _tmp79_;
#line 1491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp77_ = device;
#line 1491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp78_ = mount_point;
#line 1491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp79_ = g_strdup_printf ("mount \"%s\" \"%s\"", _tmp77_, _tmp78_);
#line 1491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp79_;
#line 9713 "Device.c"
	}
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp80_ = cmd;
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp83_ = tee_jee_process_helper_exec_sync (_tmp80_, &_tmp81_, &_tmp82_);
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_out = _tmp81_;
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	std_err = _tmp82_;
#line 1494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	ret_val = _tmp83_;
#line 1496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp84_ = ret_val;
#line 1496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp84_ != 0) {
#line 9733 "Device.c"
		const gchar* _tmp85_;
		const gchar* _tmp86_;
		gchar* _tmp87_;
		gchar* _tmp88_;
		const gchar* _tmp89_;
#line 1497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp85_ = device;
#line 1497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp86_ = mount_point;
#line 1497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp87_ = g_strdup_printf ("Failed to mount device '%s' at mount point '%s'", _tmp85_, _tmp86_);
#line 1497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp88_ = _tmp87_;
#line 1497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp88_, FALSE, FALSE);
#line 1497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp88_);
#line 1498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp89_ = std_err;
#line 1498 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp89_, FALSE, FALSE);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = FALSE;
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1499 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 9771 "Device.c"
	} else {
		gboolean _tmp90_;
#line 1502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp90_ = silent;
#line 1502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (!_tmp90_) {
#line 9778 "Device.c"
			Device* dev = NULL;
			const gchar* _tmp91_;
			Device* _tmp92_;
			gchar* _tmp93_ = NULL;
			Device* _tmp94_;
			gchar* _tmp100_ = NULL;
			const gchar* _tmp101_;
			gint _tmp102_;
			gint _tmp103_;
			const gchar* _tmp107_;
			gchar* _tmp108_;
			gchar* _tmp109_;
#line 1503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp91_ = device;
#line 1503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp92_ = device_get_device_by_name (_tmp91_);
#line 1503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = _tmp92_;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp94_ = dev;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp94_ == NULL) {
#line 9801 "Device.c"
				const gchar* _tmp95_;
				gchar* _tmp96_;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp95_ = device;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp96_ = g_strdup (_tmp95_);
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp93_);
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp93_ = _tmp96_;
#line 9812 "Device.c"
			} else {
				Device* _tmp97_;
				gchar* _tmp98_;
				gchar* _tmp99_;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp97_ = dev;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp98_ = device_get_device_name_with_parent (_tmp97_);
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp99_ = _tmp98_;
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp93_);
#line 1505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp93_ = _tmp99_;
#line 9827 "Device.c"
			}
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp101_ = mount_options;
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp102_ = strlen (_tmp101_);
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp103_ = _tmp102_;
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp103_ > 0) {
#line 9837 "Device.c"
				const gchar* _tmp104_;
				gchar* _tmp105_;
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp104_ = mount_options;
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp105_ = g_strdup_printf (" (%s)", _tmp104_);
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp100_);
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp100_ = _tmp105_;
#line 9848 "Device.c"
			} else {
				gchar* _tmp106_;
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp106_ = g_strdup ("");
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp100_);
#line 1506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp100_ = _tmp106_;
#line 9857 "Device.c"
			}
#line 1504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp107_ = mount_point;
#line 1504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp108_ = g_strdup_printf ("Mounted '%s'%s at '%s'", _tmp93_, _tmp100_, _tmp107_);
#line 1504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp109_ = _tmp108_;
#line 1504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_msg (_tmp109_, FALSE);
#line 1504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp109_);
#line 1502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp100_);
#line 1502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp93_);
#line 1502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 9875 "Device.c"
		}
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = TRUE;
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 9893 "Device.c"
	}
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (uuid);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (device);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 9907 "Device.c"
}


gchar* device_automount (const gchar* dev_name_or_uuid, const gchar* mount_options, const gchar* mount_prefix) {
	gchar* result = NULL;
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp14_;
	Device* dev = NULL;
	GeeArrayList* _tmp15_;
	const gchar* _tmp16_;
	Device* _tmp17_;
	Device* _tmp18_;
	gchar* mount_point = NULL;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	gboolean _tmp40_;
	GError * _inner_error_ = NULL;
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, NULL);
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_prefix != NULL, NULL);
#line 1531 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1531 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device = _tmp0_;
#line 1532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1532 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	uuid = _tmp1_;
#line 1536 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = dev_name_or_uuid;
#line 1536 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "/dev");
#line 1536 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp3_) {
#line 9955 "Device.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 1537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = dev_name_or_uuid;
#line 1537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 1537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp5_;
#line 1538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = dev_name_or_uuid;
#line 1538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = device_get_device_uuid (_tmp6_);
#line 1538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1538 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		uuid = _tmp7_;
#line 9976 "Device.c"
	} else {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 1541 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = dev_name_or_uuid;
#line 1541 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 1541 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1541 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		uuid = _tmp9_;
#line 1542 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = uuid;
#line 1542 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp10_);
#line 1542 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1542 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp11_;
#line 1543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = device;
#line 1543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = device_resolve_device_name (_tmp12_);
#line 1543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		device = _tmp13_;
#line 10008 "Device.c"
	}
#line 1548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = device_get_block_devices_using_lsblk ("");
#line 1548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp14_;
#line 1549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = list;
#line 1549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = uuid;
#line 1549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = device_find_device_in_list (_tmp15_, _tmp16_);
#line 1549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	dev = _tmp17_;
#line 1550 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = dev;
#line 1550 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp18_ != NULL) {
#line 10026 "Device.c"
		Device* _tmp19_;
		GeeArrayList* _tmp20_;
		gpointer _tmp21_;
		MountEntry* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = dev;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = _tmp19_->mount_points;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, 0);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = (MountEntry*) _tmp21_;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp23_ = _tmp22_->mount_point;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_tmp22_);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp25_;
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10062 "Device.c"
	}
#line 1556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp26_ = mount_prefix;
#line 1556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp27_ = uuid;
#line 1556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp28_ = g_strdup_printf ("%s/%s", _tmp26_, _tmp27_);
#line 1556 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	mount_point = _tmp28_;
#line 10072 "Device.c"
	{
		GFile* file = NULL;
		const gchar* _tmp29_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		gboolean _tmp32_;
#line 1559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp29_ = mount_point;
#line 1559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp30_ = g_file_new_for_path (_tmp29_);
#line 1559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		file = _tmp30_;
#line 1560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp31_ = file;
#line 1560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp32_ = g_file_query_exists (_tmp31_, NULL);
#line 1560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (!_tmp32_) {
#line 10091 "Device.c"
			GFile* _tmp33_;
#line 1561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp33_ = file;
#line 1561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			g_file_make_directory_with_parents (_tmp33_, NULL, &_inner_error_);
#line 1561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1561 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (file);
#line 10101 "Device.c"
				goto __catch47_g_error;
			}
		}
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (file);
#line 10107 "Device.c"
	}
	goto __finally47;
	__catch47_g_error:
	{
		GError* e = NULL;
		GError* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		e = _inner_error_;
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_inner_error_ = NULL;
#line 1565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp34_ = e;
#line 1565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp35_ = _tmp34_->message;
#line 1565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp35_, FALSE, FALSE);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp36_ = g_strdup ("");
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp36_;
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_error_free0 (e);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (mount_point);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10144 "Device.c"
	}
	__finally47:
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (mount_point);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_clear_error (&_inner_error_);
#line 1558 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return NULL;
#line 10165 "Device.c"
	}
#line 1571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp37_ = uuid;
#line 1571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp38_ = mount_point;
#line 1571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp39_ = mount_options;
#line 1571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp40_ = device_mount (_tmp37_, _tmp38_, _tmp39_, FALSE);
#line 1571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp40_) {
#line 1572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = mount_point;
#line 1572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1572 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10189 "Device.c"
	} else {
		gchar* _tmp41_;
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp41_ = g_strdup ("");
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp41_;
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (mount_point);
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (list);
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (uuid);
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (device);
#line 1575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10208 "Device.c"
	}
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (mount_point);
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (dev);
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (uuid);
#line 1524 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (device);
#line 10220 "Device.c"
}


gboolean device_unmount (const gchar* mount_point) {
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp24_;
	gboolean _tmp25_;
	GError * _inner_error_ = NULL;
#line 1579 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1584 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1584 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	cmd = _tmp0_;
#line 1590 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = mount_point;
#line 1590 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = device_mount_point_in_use (_tmp1_);
#line 1590 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (!_tmp2_) {
#line 1591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = TRUE;
#line 1591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10258 "Device.c"
	}
	{
		gchar* cmd_unmount = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		const gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gint _tmp18_;
		gint _tmp19_;
#line 1598 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = mount_point;
#line 1598 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("cat /proc/mounts | awk '{print $2}' | grep '%s' | sort -r | xargs umou" \
"nt", _tmp3_);
#line 1598 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd_unmount = _tmp4_;
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = mount_point;
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = g_strdup_printf (": '%s'", _tmp5_);
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = g_strconcat (_ ("Unmounting from"), _tmp7_, NULL);
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp9_);
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 1600 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 1603 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_strdup ("sync");
#line 1603 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1603 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		cmd = _tmp10_;
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = cmd;
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_spawn_command_line_sync (_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, &_inner_error_);
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		std_out = _tmp12_;
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		std_err = _tmp13_;
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		ret_val = _tmp14_;
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1604 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (cmd_unmount);
#line 10325 "Device.c"
			goto __catch48_g_error;
		}
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = cmd_unmount;
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = tee_jee_process_helper_exec_script_sync (_tmp15_, &_tmp16_, &_tmp17_, FALSE, FALSE, TRUE, FALSE);
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		std_out = _tmp16_;
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		std_err = _tmp17_;
#line 1608 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		ret_val = _tmp18_;
#line 1610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = ret_val;
#line 1610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp19_ != 0) {
#line 10346 "Device.c"
			const gchar* _tmp20_;
#line 1611 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_error (_ ("Failed to unmount"), FALSE, FALSE);
#line 1612 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = std_err;
#line 1612 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_error (_tmp20_, FALSE, FALSE);
#line 10354 "Device.c"
		}
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd_unmount);
#line 10358 "Device.c"
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		e = _inner_error_;
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_inner_error_ = NULL;
#line 1616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = e;
#line 1616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = _tmp21_->message;
#line 1616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 1617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = FALSE;
#line 1617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_error_free0 (e);
#line 1617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10388 "Device.c"
	}
	__finally48:
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10393 "Device.c"
		gboolean _tmp23_ = FALSE;
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_clear_error (&_inner_error_);
#line 1596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return _tmp23_;
#line 10407 "Device.c"
	}
#line 1621 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp24_ = mount_point;
#line 1621 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp25_ = device_mount_point_in_use (_tmp24_);
#line 1621 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (!_tmp25_) {
#line 1622 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = TRUE;
#line 1622 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1622 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1622 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1622 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10425 "Device.c"
	} else {
#line 1625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = FALSE;
#line 1625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_err);
#line 1625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (std_out);
#line 1625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (cmd);
#line 1625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 10437 "Device.c"
	}
#line 1579 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_err);
#line 1579 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (std_out);
#line 1579 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (cmd);
#line 10445 "Device.c"
}


gchar* device_description (Device* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1681 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_description_formatted (self);
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp5_;
#line 1682 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 10479 "Device.c"
}


gchar* device_description_formatted (Device* self) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp70_;
	gchar* _tmp71_;
#line 1685 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1686 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp0_;
#line 1688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 10500 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		guint64 _tmp25_;
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = s;
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = self->kname;
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = g_strconcat ("<b>", _tmp3_, NULL);
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp5_, "</b> ~", NULL);
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp2_, _tmp7_, NULL);
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp8_;
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 1689 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1690 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = self->vendor;
#line 1690 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = strlen (_tmp9_);
#line 1690 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1690 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp11_ > 0) {
#line 10545 "Device.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = s;
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = self->vendor;
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = g_strconcat (" ", _tmp13_, NULL);
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp16_;
#line 1691 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 10567 "Device.c"
		}
#line 1693 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = self->model;
#line 1693 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1693 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1693 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp19_ > 0) {
#line 10577 "Device.c"
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = s;
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = self->model;
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = g_strconcat (" ", _tmp21_, NULL);
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp24_;
#line 1694 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 10599 "Device.c"
		}
#line 1696 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = self->size_bytes;
#line 1696 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp25_ > ((guint64) 0)) {
#line 10605 "Device.c"
			const gchar* _tmp26_;
			guint64 _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = s;
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = self->size_bytes;
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp28_ = tee_jee_file_system_format_file_size (_tmp27_, FALSE, "", TRUE, 0);
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = g_strdup_printf (" (%s)", _tmp29_);
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp32_ = g_strconcat (_tmp26_, _tmp31_, NULL);
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp32_;
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp31_);
#line 1697 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp29_);
#line 10635 "Device.c"
		}
	} else {
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_ = NULL;
		const gchar* _tmp43_;
		gint _tmp44_;
		gint _tmp45_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_ = NULL;
		const gchar* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		guint64 _tmp62_;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp33_ = s;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp34_ = device_get_short_name_with_parent (self);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp35_ = _tmp34_;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp36_ = _tmp35_;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp37_ = g_strconcat ("<b>", _tmp36_, NULL);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp39_ = g_strconcat (_tmp38_, "</b>", NULL);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp40_ = _tmp39_;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp41_ = g_strconcat (_tmp33_, _tmp40_, NULL);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp41_;
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp40_);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp38_);
#line 1701 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp36_);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp43_ = self->label;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp44_ = strlen (_tmp43_);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp45_ = _tmp44_;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp45_ > 0) {
#line 10696 "Device.c"
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = self->label;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp47_ = g_strconcat (" (", _tmp46_, NULL);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = _tmp47_;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp49_ = g_strconcat (_tmp48_, ")", NULL);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp42_);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp42_ = _tmp49_;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp48_);
#line 10715 "Device.c"
		} else {
			gchar* _tmp50_;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp50_ = g_strdup ("");
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp42_);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp42_ = _tmp50_;
#line 10724 "Device.c"
		}
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp51_ = s;
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp52_ = g_strconcat (_tmp51_, _tmp42_, NULL);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1702 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp52_;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp54_ = self->fstype;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp55_ = strlen (_tmp54_);
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp56_ > 0) {
#line 10742 "Device.c"
			const gchar* _tmp57_;
			gchar* _tmp58_;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp57_ = self->fstype;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp58_ = g_strconcat (" ~ ", _tmp57_, NULL);
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp53_);
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp53_ = _tmp58_;
#line 10753 "Device.c"
		} else {
			gchar* _tmp59_;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp59_ = g_strdup ("");
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp53_);
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp53_ = _tmp59_;
#line 10762 "Device.c"
		}
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp60_ = s;
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp61_ = g_strconcat (_tmp60_, _tmp53_, NULL);
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1703 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp61_;
#line 1704 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp62_ = self->size_bytes;
#line 1704 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp62_ > ((guint64) 0)) {
#line 10776 "Device.c"
			const gchar* _tmp63_;
			guint64 _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp63_ = s;
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp64_ = self->size_bytes;
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp65_ = tee_jee_file_system_format_file_size (_tmp64_, FALSE, "", TRUE, 0);
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp66_ = _tmp65_;
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp67_ = g_strdup_printf (" (%s)", _tmp66_);
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp68_ = _tmp67_;
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp69_ = g_strconcat (_tmp63_, _tmp68_, NULL);
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp69_;
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp68_);
#line 1705 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp66_);
#line 10806 "Device.c"
		}
#line 1688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp53_);
#line 1688 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 10812 "Device.c"
	}
#line 1709 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp70_ = s;
#line 1709 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp71_ = string_strip (_tmp70_);
#line 1709 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp71_;
#line 1709 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1709 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 10824 "Device.c"
}


gchar* device_description_simple (Device* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1712 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_description_simple_formatted (self);
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp5_;
#line 1713 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 10858 "Device.c"
}


gchar* device_description_simple_formatted (Device* self) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
#line 1716 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1718 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1718 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp0_;
#line 1720 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1720 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 10879 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		guint64 _tmp18_;
#line 1721 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = self->vendor;
#line 1721 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 1721 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1721 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp4_ > 0) {
#line 10895 "Device.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp5_ = s;
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = self->vendor;
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = g_strconcat (" ", _tmp6_, NULL);
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp9_;
#line 1722 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp8_);
#line 10917 "Device.c"
		}
#line 1724 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = self->model;
#line 1724 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1724 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1724 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp12_ > 0) {
#line 10927 "Device.c"
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = s;
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = self->model;
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = g_strconcat (" ", _tmp14_, NULL);
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp17_;
#line 1725 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 10949 "Device.c"
		}
#line 1727 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = self->size_bytes;
#line 1727 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp18_ > ((guint64) 0)) {
#line 10955 "Device.c"
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gboolean _tmp24_;
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = s;
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = string_strip (_tmp19_);
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = _tmp20_;
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = strlen (_tmp21_);
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = _tmp23_ == 0;
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp21_);
#line 1728 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp24_) {
#line 10978 "Device.c"
				const gchar* _tmp25_;
				guint64 _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp25_ = s;
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp26_ = self->size_bytes;
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp27_ = tee_jee_file_system_format_file_size (_tmp26_, FALSE, "", TRUE, 0);
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp28_ = _tmp27_;
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp29_ = g_strdup_printf ("%s Device", _tmp28_);
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp30_ = _tmp29_;
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp31_ = g_strconcat (_tmp25_, _tmp30_, NULL);
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (s);
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				s = _tmp31_;
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp30_);
#line 1729 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp28_);
#line 11008 "Device.c"
			} else {
				const gchar* _tmp32_;
				guint64 _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp32_ = s;
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp33_ = self->size_bytes;
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp34_ = tee_jee_file_system_format_file_size (_tmp33_, FALSE, "", TRUE, 0);
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp35_ = _tmp34_;
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp36_ = g_strdup_printf (" (%s)", _tmp35_);
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp37_ = _tmp36_;
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp38_ = g_strconcat (_tmp32_, _tmp37_, NULL);
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (s);
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				s = _tmp38_;
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp37_);
#line 1732 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp35_);
#line 11039 "Device.c"
			}
		}
	} else {
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_ = NULL;
		const gchar* _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_ = NULL;
		const gchar* _tmp60_;
		gint _tmp61_;
		gint _tmp62_;
		const gchar* _tmp66_;
		gchar* _tmp67_;
		guint64 _tmp68_;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp39_ = s;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp40_ = device_get_short_name_with_parent (self);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp43_ = g_strconcat ("<b>", _tmp42_, NULL);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp45_ = g_strconcat (_tmp44_, "</b>", NULL);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp46_ = _tmp45_;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp47_ = g_strconcat (_tmp39_, _tmp46_, NULL);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp47_;
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp46_);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp44_);
#line 1737 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp49_ = self->label;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp50_ = strlen (_tmp49_);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp51_ = _tmp50_;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp51_ > 0) {
#line 11101 "Device.c"
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp52_ = self->label;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp53_ = g_strconcat (" (", _tmp52_, NULL);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp54_ = _tmp53_;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp55_ = g_strconcat (_tmp54_, ")", NULL);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp48_);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = _tmp55_;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp54_);
#line 11120 "Device.c"
		} else {
			gchar* _tmp56_;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp56_ = g_strdup ("");
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp48_);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = _tmp56_;
#line 11129 "Device.c"
		}
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp57_ = s;
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp58_ = g_strconcat (_tmp57_, _tmp48_, NULL);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1738 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp58_;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp60_ = self->fstype;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp61_ = strlen (_tmp60_);
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp62_ = _tmp61_;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp62_ > 0) {
#line 11147 "Device.c"
			const gchar* _tmp63_;
			gchar* _tmp64_;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp63_ = self->fstype;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp64_ = g_strconcat (" ~ ", _tmp63_, NULL);
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp59_);
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp59_ = _tmp64_;
#line 11158 "Device.c"
		} else {
			gchar* _tmp65_;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp65_ = g_strdup ("");
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp59_);
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp59_ = _tmp65_;
#line 11167 "Device.c"
		}
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp66_ = s;
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp67_ = g_strconcat (_tmp66_, _tmp59_, NULL);
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1739 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp67_;
#line 1740 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp68_ = self->size_bytes;
#line 1740 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp68_ > ((guint64) 0)) {
#line 11181 "Device.c"
			const gchar* _tmp69_;
			guint64 _tmp70_;
			gchar* _tmp71_;
			gchar* _tmp72_;
			gchar* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp69_ = s;
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp70_ = self->size_bytes;
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp71_ = tee_jee_file_system_format_file_size (_tmp70_, FALSE, "", TRUE, 0);
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp72_ = _tmp71_;
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp73_ = g_strdup_printf (" (%s)", _tmp72_);
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp74_ = _tmp73_;
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp75_ = g_strconcat (_tmp69_, _tmp74_, NULL);
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp75_;
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp74_);
#line 1741 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp72_);
#line 11211 "Device.c"
		}
#line 1720 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp59_);
#line 1720 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp48_);
#line 11217 "Device.c"
	}
#line 1745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp76_ = s;
#line 1745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp77_ = string_strip (_tmp76_);
#line 1745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp77_;
#line 1745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1745 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 11229 "Device.c"
}


gchar* device_description_full_free (Device* self) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1748 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1749 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp0_;
#line 1751 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1751 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11248 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = s;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = self->model;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = self->vendor;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = g_strdup_printf ("%s %s", _tmp3_, _tmp4_);
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = string_strip (_tmp6_);
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp2_, _tmp8_, NULL);
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp9_;
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1752 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 1753 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = s;
#line 1753 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1753 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1753 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp12_ == 0) {
#line 11292 "Device.c"
			guint64 _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = self->size_bytes;
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = tee_jee_file_system_format_file_size (_tmp13_, FALSE, "", TRUE, 1);
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = g_strdup_printf ("%s Disk", _tmp15_);
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp16_;
#line 1754 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 11311 "Device.c"
		} else {
			const gchar* _tmp17_;
			guint64 _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = s;
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp18_ = self->size_bytes;
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = tee_jee_file_system_format_file_size (_tmp18_, FALSE, "", TRUE, 1);
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = g_strdup_printf (" (%s Disk)", _tmp20_);
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = g_strconcat (_tmp17_, _tmp22_, NULL);
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp23_;
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 1757 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 11342 "Device.c"
		}
	} else {
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		guint64 _tmp43_;
		guint64 _tmp44_;
#line 1761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = s;
#line 1761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = self->kname;
#line 1761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 1761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (s);
#line 1761 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		s = _tmp26_;
#line 1762 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp27_ = self->label;
#line 1762 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp28_ = strlen (_tmp27_);
#line 1762 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp29_ = _tmp28_;
#line 1762 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp29_ > 0) {
#line 11374 "Device.c"
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = s;
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp31_ = self->label;
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp32_ = g_strdup_printf (" (%s)", _tmp31_);
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp33_ = _tmp32_;
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp34_ = g_strconcat (_tmp30_, _tmp33_, NULL);
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp34_;
#line 1763 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp33_);
#line 11396 "Device.c"
		}
#line 1765 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp35_ = self->fstype;
#line 1765 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp36_ = strlen (_tmp35_);
#line 1765 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp37_ = _tmp36_;
#line 1765 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp37_ > 0) {
#line 11406 "Device.c"
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp38_ = s;
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp39_ = self->fstype;
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp40_ = g_strdup_printf (" ~ %s", _tmp39_);
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp41_ = _tmp40_;
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp42_ = g_strconcat (_tmp38_, _tmp41_, NULL);
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp42_;
#line 1766 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp41_);
#line 11428 "Device.c"
		}
#line 1768 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp43_ = device_get_free_bytes (self);
#line 1768 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1768 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp44_ > ((guint64) 0)) {
#line 11436 "Device.c"
			const gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp45_ = s;
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = device_description_free (self);
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp47_ = _tmp46_;
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = g_strdup_printf (" ~ %s", _tmp47_);
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp49_ = _tmp48_;
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp50_ = g_strconcat (_tmp45_, _tmp49_, NULL);
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (s);
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			s = _tmp50_;
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp49_);
#line 1769 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp47_);
#line 11463 "Device.c"
		}
	}
#line 1773 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = s;
#line 1773 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 11470 "Device.c"
}


gchar* device_description_full (Device* self) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
#line 1776 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1777 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1777 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp0_;
#line 1778 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = s;
#line 1778 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = self->device;
#line 1778 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1778 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1778 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp3_;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = self->label;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = _tmp6_;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp7_ > 0) {
#line 11532 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = self->label;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp11_;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 11551 "Device.c"
	} else {
		gchar* _tmp12_;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = g_strdup ("");
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = _tmp12_;
#line 11560 "Device.c"
	}
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp13_ = s;
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = g_strconcat (_tmp13_, _tmp4_, NULL);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1779 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp14_;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = self->uuid;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = strlen (_tmp16_);
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = _tmp17_;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp18_ > 0) {
#line 11578 "Device.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = self->uuid;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = g_strconcat (" ~ ", _tmp19_, NULL);
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = _tmp20_;
#line 11589 "Device.c"
	} else {
		gchar* _tmp21_;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = g_strdup ("");
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = _tmp21_;
#line 11598 "Device.c"
	}
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp22_ = s;
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp23_ = g_strconcat (_tmp22_, _tmp15_, NULL);
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1780 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp23_;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp25_ = self->fstype;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp26_ = strlen (_tmp25_);
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp27_ = _tmp26_;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp27_ > 0) {
#line 11616 "Device.c"
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp28_ = self->fstype;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp29_ = g_strconcat (" ~ ", _tmp28_, NULL);
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = _tmp29_;
#line 11627 "Device.c"
	} else {
		gchar* _tmp30_;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp30_ = g_strdup ("");
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = _tmp30_;
#line 11636 "Device.c"
	}
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp31_ = s;
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp32_ = g_strconcat (_tmp31_, _tmp24_, NULL);
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1781 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp32_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp34_ = device_get_used (self);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp35_ = _tmp34_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp36_ = _tmp35_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp37_ = strlen (_tmp36_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp38_ = _tmp37_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp39_ = _tmp38_ > 0;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp36_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp39_) {
#line 11662 "Device.c"
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp40_ = device_get_used (self);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp43_ = g_strconcat (" ~ ", _tmp42_, NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp45_ = g_strconcat (_tmp44_, " / ", NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp46_ = _tmp45_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp47_ = device_get_size (self);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp49_ = _tmp48_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp51_ = _tmp50_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp52_ = g_strconcat (_tmp51_, " GB used (", NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp53_ = _tmp52_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp54_ = self->used_percent;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp53_, _tmp54_, NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp56_, ")", NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp33_ = _tmp57_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp53_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp49_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp46_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp44_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 11735 "Device.c"
	} else {
		gchar* _tmp58_;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp58_ = g_strdup ("");
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp33_ = _tmp58_;
#line 11744 "Device.c"
	}
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp59_ = s;
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp60_ = g_strconcat (_tmp59_, _tmp33_, NULL);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (s);
#line 1782 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	s = _tmp60_;
#line 1784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = s;
#line 1784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp33_);
#line 1784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp24_);
#line 1784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp15_);
#line 1784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1784 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 11766 "Device.c"
}


gchar* device_description_usage (Device* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 1787 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1788 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp5_) {
#line 11796 "Device.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = device_get_used (self);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp8_, " / ", NULL);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = device_get_size (self);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " used (", NULL);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = self->used_percent;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp17_);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp22_;
#line 1789 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 11864 "Device.c"
	} else {
		gchar* _tmp23_;
#line 1792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp23_ = g_strdup ("");
#line 1792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp23_;
#line 1792 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 11873 "Device.c"
	}
}


gchar* device_description_free (Device* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 1796 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1797 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp5_) {
#line 11904 "Device.c"
		guint64 _tmp6_;
		guint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		guint64 _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = device_get_free_bytes (self);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = tee_jee_file_system_format_file_size (_tmp7_, FALSE, "g", FALSE, 1);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp9_, " / ", NULL);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = self->size_bytes;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = tee_jee_file_system_format_file_size (_tmp12_, FALSE, "g", TRUE, 1);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = _tmp13_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp16_ = _tmp15_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = g_strconcat (_tmp16_, " free", NULL);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = _tmp17_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp16_);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp14_);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp18_;
#line 1798 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 11956 "Device.c"
	} else {
		gchar* _tmp19_;
#line 1802 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = g_strdup ("");
#line 1802 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp19_;
#line 1802 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 11965 "Device.c"
	}
}


gchar* device_tooltip_text (Device* self) {
	gchar* result = NULL;
	gchar* tt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp99_;
	gchar* _tmp100_;
#line 1806 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1807 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1807 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tt = _tmp0_;
#line 1809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->type;
#line 1809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11987 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		guint64 _tmp28_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = tt;
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = self->device;
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp3_);
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp6_;
#line 1810 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = tt;
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup_printf ("%-15s: %s\n", _ ("Vendor"), _tmp8_);
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp11_;
#line 1811 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp12_ = tt;
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp13_ = self->model;
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp14_ = g_strdup_printf ("%-15s: %s\n", _ ("Model"), _tmp13_);
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp16_;
#line 1812 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = tt;
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = self->serial;
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = g_strdup_printf ("%-15s: %s\n", _ ("Serial"), _tmp18_);
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp21_;
#line 1813 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp22_ = tt;
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp23_ = self->revision;
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp24_ = g_strdup_printf ("%-15s: %s\n", _ ("Revision"), _tmp23_);
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp26_;
#line 1814 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp25_);
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp28_ = self->size_bytes;
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp28_ > ((guint64) 0)) {
#line 12103 "Device.c"
			guint64 _tmp29_;
			gchar* _tmp30_;
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp29_ = self->size_bytes;
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = tee_jee_file_system_format_file_size (_tmp29_, FALSE, "", TRUE, 1);
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = _tmp30_;
#line 12114 "Device.c"
		} else {
			gchar* _tmp31_;
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp31_ = g_strdup ("N/A");
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1817 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = _tmp31_;
#line 12123 "Device.c"
		}
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp32_ = tt;
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp33_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp27_);
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp34_ = _tmp33_;
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp35_ = g_strconcat (_tmp32_, _tmp34_, NULL);
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp35_;
#line 1816 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 1809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp27_);
#line 12141 "Device.c"
	} else {
		gchar* _tmp36_ = NULL;
		const gchar* _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gboolean _tmp49_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		const gchar* _tmp71_;
		const gchar* _tmp72_;
		gchar* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_ = NULL;
		guint64 _tmp77_;
		const gchar* _tmp81_;
		gchar* _tmp82_;
		gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_ = NULL;
		guint64 _tmp86_;
		const gchar* _tmp90_;
		gchar* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
		const gchar* _tmp94_;
		const gchar* _tmp95_;
		gchar* _tmp96_;
		gchar* _tmp97_;
		gchar* _tmp98_;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp37_ = self->mapped_name;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp38_ = strlen (_tmp37_);
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp39_ = _tmp38_;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp39_ > 0) {
#line 12197 "Device.c"
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp40_ = self->device;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp41_ = self->mapped_name;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp42_ = g_strdup_printf ("%s → %s", _tmp40_, _tmp41_);
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp36_);
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp36_ = _tmp42_;
#line 12211 "Device.c"
		} else {
			const gchar* _tmp43_;
			gchar* _tmp44_;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp43_ = self->device;
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp44_ = g_strdup (_tmp43_);
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp36_);
#line 1821 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp36_ = _tmp44_;
#line 12223 "Device.c"
		}
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp45_ = tt;
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp46_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp36_);
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp47_ = _tmp46_;
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp48_ = g_strconcat (_tmp45_, _tmp47_, NULL);
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp48_;
#line 1820 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp47_);
#line 1823 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp49_ = device_has_parent (self);
#line 1823 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp49_) {
#line 12243 "Device.c"
			const gchar* _tmp50_;
			Device* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp50_ = tt;
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp51_ = self->parent;
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp52_ = _tmp51_->device;
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp53_ = g_strdup_printf ("%-15s: %s\n", _ ("Parent Device"), _tmp52_);
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp54_ = _tmp53_;
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp55_ = g_strconcat (_tmp50_, _tmp54_, NULL);
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (tt);
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tt = _tmp55_;
#line 1824 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp54_);
#line 12268 "Device.c"
		}
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp56_ = tt;
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp57_ = self->uuid;
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp58_ = g_strdup_printf ("%-15s: %s\n", _ ("UUID"), _tmp57_);
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp59_ = _tmp58_;
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp60_ = g_strconcat (_tmp56_, _tmp59_, NULL);
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp60_;
#line 1826 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp59_);
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp61_ = tt;
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp62_ = self->type;
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp63_ = g_strdup_printf ("%-15s: %s\n", _ ("Type"), _tmp62_);
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp64_ = _tmp63_;
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp65_ = g_strconcat (_tmp61_, _tmp64_, NULL);
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp65_;
#line 1827 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp64_);
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp66_ = tt;
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp67_ = self->fstype;
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp68_ = g_strdup_printf ("%-15s: %s\n", _ ("Filesystem"), _tmp67_);
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp69_ = _tmp68_;
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp70_ = g_strconcat (_tmp66_, _tmp69_, NULL);
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp70_;
#line 1828 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp69_);
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp71_ = tt;
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp72_ = self->label;
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp73_ = g_strdup_printf ("%-15s: %s\n", _ ("Label"), _tmp72_);
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp74_ = _tmp73_;
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp75_ = g_strconcat (_tmp71_, _tmp74_, NULL);
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp75_;
#line 1829 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp74_);
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp77_ = self->size_bytes;
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp77_ > ((guint64) 0)) {
#line 12338 "Device.c"
			guint64 _tmp78_;
			gchar* _tmp79_;
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp78_ = self->size_bytes;
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp79_ = tee_jee_file_system_format_file_size (_tmp78_, FALSE, "", TRUE, 1);
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp76_);
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp76_ = _tmp79_;
#line 12349 "Device.c"
		} else {
			gchar* _tmp80_;
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp80_ = g_strdup ("N/A");
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp76_);
#line 1832 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp76_ = _tmp80_;
#line 12358 "Device.c"
		}
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp81_ = tt;
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp82_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp76_);
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp83_ = _tmp82_;
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp84_ = g_strconcat (_tmp81_, _tmp83_, NULL);
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp84_;
#line 1831 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp83_);
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp86_ = self->used_bytes;
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp86_ > ((guint64) 0)) {
#line 12378 "Device.c"
			guint64 _tmp87_;
			gchar* _tmp88_;
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp87_ = self->used_bytes;
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp88_ = tee_jee_file_system_format_file_size (_tmp87_, FALSE, "", TRUE, 1);
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp85_);
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp85_ = _tmp88_;
#line 12389 "Device.c"
		} else {
			gchar* _tmp89_;
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp89_ = g_strdup ("N/A");
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp85_);
#line 1835 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp85_ = _tmp89_;
#line 12398 "Device.c"
		}
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp90_ = tt;
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp91_ = g_strdup_printf ("%-15s: %s\n", _ ("Used"), _tmp85_);
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp92_ = _tmp91_;
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp93_ = g_strconcat (_tmp90_, _tmp92_, NULL);
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp93_;
#line 1834 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp92_);
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp94_ = tt;
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp95_ = self->dist_info;
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp96_ = g_strdup_printf ("%-15s: %s\n", _ ("System"), _tmp95_);
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp97_ = _tmp96_;
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp98_ = g_strconcat (_tmp94_, _tmp97_, NULL);
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (tt);
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		tt = _tmp98_;
#line 1837 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp97_);
#line 1809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp85_);
#line 1809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp76_);
#line 1809 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp36_);
#line 12436 "Device.c"
	}
#line 1840 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp99_ = tt;
#line 1840 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp100_ = g_strdup_printf ("<tt>%s</tt>", _tmp99_);
#line 1840 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp100_;
#line 1840 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (tt);
#line 1840 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 12448 "Device.c"
}


static gchar* device_display_name (Device* self, gboolean short_name, gboolean show_label, gboolean show_parent, gboolean show_alias) {
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp8_;
#line 1843 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1845 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1845 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	txt = _tmp0_;
#line 1847 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = short_name;
#line 1847 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_) {
#line 12468 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 1848 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = txt;
#line 1848 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = self->kname;
#line 1848 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 1848 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (txt);
#line 1848 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		txt = _tmp4_;
#line 12482 "Device.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 1851 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = txt;
#line 1851 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = self->device;
#line 1851 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
#line 1851 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (txt);
#line 1851 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		txt = _tmp7_;
#line 12497 "Device.c"
	}
#line 1854 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = self->type;
#line 1854 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (g_strcmp0 (_tmp8_, "disk") == 0) {
#line 12503 "Device.c"
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		guint64 _tmp25_;
#line 1855 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = self->vendor;
#line 1855 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = strlen (_tmp9_);
#line 1855 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1855 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp11_ > 0) {
#line 12519 "Device.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = txt;
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = self->vendor;
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = g_strconcat (" ", _tmp13_, NULL);
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (txt);
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			txt = _tmp16_;
#line 1856 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 12541 "Device.c"
		}
#line 1858 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp17_ = self->model;
#line 1858 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1858 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1858 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp19_ > 0) {
#line 12551 "Device.c"
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = txt;
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = self->model;
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = g_strconcat (" ", _tmp21_, NULL);
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (txt);
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			txt = _tmp24_;
#line 1859 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 12573 "Device.c"
		}
#line 1861 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp25_ = self->size_bytes;
#line 1861 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp25_ > ((guint64) 0)) {
#line 12579 "Device.c"
			const gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gboolean _tmp31_;
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = txt;
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = string_strip (_tmp26_);
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp28_ = _tmp27_;
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp29_ = strlen (_tmp28_);
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = _tmp29_;
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp31_ = _tmp30_ == 0;
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp28_);
#line 1862 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (_tmp31_) {
#line 12602 "Device.c"
				const gchar* _tmp32_;
				guint64 _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp32_ = txt;
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp33_ = self->size_bytes;
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp34_ = tee_jee_file_system_format_file_size (_tmp33_, FALSE, "", TRUE, 0);
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp35_ = _tmp34_;
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp36_ = g_strdup_printf ("%s Device", _tmp35_);
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp37_ = _tmp36_;
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp38_ = g_strconcat (_tmp32_, _tmp37_, NULL);
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (txt);
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				txt = _tmp38_;
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp37_);
#line 1863 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp35_);
#line 12632 "Device.c"
			} else {
				const gchar* _tmp39_;
				guint64 _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp39_ = txt;
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp40_ = self->size_bytes;
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp41_ = tee_jee_file_system_format_file_size (_tmp40_, FALSE, "", TRUE, 0);
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp42_ = _tmp41_;
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp43_ = g_strdup_printf (" (%s)", _tmp42_);
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp44_ = _tmp43_;
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp45_ = g_strconcat (_tmp39_, _tmp44_, NULL);
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (txt);
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				txt = _tmp45_;
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp44_);
#line 1866 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_free0 (_tmp42_);
#line 12663 "Device.c"
			}
		}
	} else {
		gboolean _tmp46_ = FALSE;
		gboolean _tmp47_;
		gboolean _tmp56_ = FALSE;
		gboolean _tmp57_ = FALSE;
		gboolean _tmp58_;
		gboolean _tmp67_ = FALSE;
		gboolean _tmp68_;
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp47_ = show_label;
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp47_) {
#line 12678 "Device.c"
			const gchar* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = self->label;
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp49_ = strlen (_tmp48_);
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp50_ = _tmp49_;
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = _tmp50_ > 0;
#line 12690 "Device.c"
		} else {
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = FALSE;
#line 12694 "Device.c"
		}
#line 1871 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp46_) {
#line 12698 "Device.c"
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp51_ = txt;
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp52_ = self->label;
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp53_ = g_strdup_printf ("(%s)", _tmp52_);
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp54_ = _tmp53_;
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp55_ = g_strconcat (_tmp51_, _tmp54_, NULL);
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (txt);
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			txt = _tmp55_;
#line 1872 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp54_);
#line 12720 "Device.c"
		}
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp58_ = show_parent;
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp58_) {
#line 12726 "Device.c"
			gboolean _tmp59_;
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp59_ = device_has_parent (self);
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp57_ = _tmp59_;
#line 12732 "Device.c"
		} else {
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp57_ = FALSE;
#line 12736 "Device.c"
		}
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp57_) {
#line 12740 "Device.c"
			Device* _tmp60_;
			const gchar* _tmp61_;
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp60_ = self->parent;
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp61_ = _tmp60_->type;
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp56_ = g_strcmp0 (_tmp61_, "part") == 0;
#line 12749 "Device.c"
		} else {
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp56_ = FALSE;
#line 12753 "Device.c"
		}
#line 1874 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp56_) {
#line 12757 "Device.c"
			const gchar* _tmp62_;
			const gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp62_ = txt;
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp63_ = self->pkname;
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp64_ = g_strdup_printf ("(%s)", _tmp63_);
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp65_ = _tmp64_;
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp66_ = g_strconcat (_tmp62_, _tmp65_, NULL);
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (txt);
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			txt = _tmp66_;
#line 1875 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp65_);
#line 12779 "Device.c"
		}
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp68_ = show_alias;
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp68_) {
#line 12785 "Device.c"
			const gchar* _tmp69_;
			gint _tmp70_;
			gint _tmp71_;
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp69_ = self->mapped_name;
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp70_ = strlen (_tmp69_);
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp71_ = _tmp70_;
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp67_ = _tmp71_ > 0;
#line 12797 "Device.c"
		} else {
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp67_ = FALSE;
#line 12801 "Device.c"
		}
#line 1877 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp67_) {
#line 12805 "Device.c"
			const gchar* _tmp72_;
			const gchar* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp72_ = txt;
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp73_ = self->mapped_name;
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp74_ = g_strdup_printf ("(%s)", _tmp73_);
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp75_ = _tmp74_;
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp76_ = g_strconcat (_tmp72_, _tmp75_, NULL);
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (txt);
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			txt = _tmp76_;
#line 1878 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp75_);
#line 12827 "Device.c"
		}
	}
#line 1882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = txt;
#line 1882 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 12834 "Device.c"
}


void device_test_all (void) {
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
#line 1888 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1888 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp0_;
#line 1889 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_block_devices_using_lsblk()", FALSE);
#line 1890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = list;
#line 1890 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_print_device_list (_tmp1_);
#line 1892 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1898 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = device_get_mounted_filesystems_using_mtab ();
#line 1898 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1898 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp2_;
#line 1899 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_mounted_filesystems_using_mtab()", FALSE);
#line 1900 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = list;
#line 1900 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_print_device_mounts (_tmp3_);
#line 1902 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1904 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = device_get_disk_space_using_df ("");
#line 1904 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1904 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp4_;
#line 1905 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_disk_space_using_df()", FALSE);
#line 1906 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = list;
#line 1906 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_print_device_disk_space (_tmp5_);
#line 1908 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1910 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = device_get_filesystems (TRUE, TRUE);
#line 1910 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 1910 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	list = _tmp6_;
#line 1911 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_filesystems()", FALSE);
#line 1912 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = list;
#line 1912 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_print_device_list (_tmp7_);
#line 1913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = list;
#line 1913 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_print_device_mounts (_tmp8_);
#line 1914 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp9_ = list;
#line 1914 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_print_device_disk_space (_tmp9_);
#line 1916 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1887 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (list);
#line 12914 "Device.c"
}


void device_print_device_list (GeeArrayList* list) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1919 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 1921 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 1923 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", "device", "pkname", "kname", "uuid", "mapped_name");
#line 1923 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1923 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1923 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1930 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 1930 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1930 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1930 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 12943 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		gint _dev_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _dev_index = 0;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = list;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp5_;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = _dev_list;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp8_;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 12971 "Device.c"
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			Device* dev = NULL;
			GeeArrayList* _tmp12_;
			gint _tmp13_;
			gpointer _tmp14_;
			Device* _tmp15_;
			const gchar* _tmp16_;
			Device* _tmp17_;
			const gchar* _tmp18_;
			Device* _tmp19_;
			const gchar* _tmp20_;
			Device* _tmp21_;
			const gchar* _tmp22_;
			Device* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _dev_index;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp9_ + 1;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = _dev_index;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = _dev_size;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 13003 "Device.c"
			}
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = _dev_list;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = _dev_index;
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp14_;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = dev;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = _tmp15_->device;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = dev;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp18_ = _tmp17_->pkname;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = dev;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = _tmp19_->kname;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = dev;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = _tmp21_->uuid;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = dev;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = _tmp23_->mapped_name;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp25_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", _tmp16_, _tmp18_, _tmp20_, _tmp22_, _tmp24_);
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp26_);
#line 1933 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13043 "Device.c"
		}
#line 1932 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 13047 "Device.c"
	}
#line 1942 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13051 "Device.c"
}


void device_print_device_mounts (GeeArrayList* list) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1995 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 1997 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 1999 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %s", "device", "> mount_points (mount_options)");
#line 1999 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1999 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1999 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2005 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2005 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2005 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2005 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13080 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		gint _dev_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _dev_index = 0;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = list;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp5_;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = _dev_list;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp8_;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 13108 "Device.c"
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			Device* dev = NULL;
			GeeArrayList* _tmp12_;
			gint _tmp13_;
			gpointer _tmp14_;
			gchar* mps = NULL;
			gchar* _tmp15_;
			Device* _tmp44_;
			const gchar* _tmp45_;
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _dev_index;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp9_ + 1;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = _dev_index;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = _dev_size;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 13135 "Device.c"
			}
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = _dev_list;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = _dev_index;
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp14_;
#line 2009 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = g_strdup ("");
#line 2009 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			mps = _tmp15_;
#line 13149 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp16_;
				GeeArrayList* _tmp17_;
				GeeArrayList* _tmp18_;
				gint _mp_size = 0;
				GeeArrayList* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _mp_index = 0;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp16_ = dev;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp17_ = _tmp16_->mount_points;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_mp_list = _tmp18_;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp19_ = _mp_list;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_tmp21_ = _tmp20_;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_mp_size = _tmp21_;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_mp_index = -1;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				while (TRUE) {
#line 13180 "Device.c"
					gint _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					MountEntry* mp = NULL;
					GeeArrayList* _tmp25_;
					gint _tmp26_;
					gpointer _tmp27_;
					const gchar* _tmp28_;
					MountEntry* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					MountEntry* _tmp34_;
					const gchar* _tmp35_;
					gint _tmp36_;
					gint _tmp37_;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp22_ = _mp_index;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_mp_index = _tmp22_ + 1;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp23_ = _mp_index;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp24_ = _mp_size;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (!(_tmp23_ < _tmp24_)) {
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						break;
#line 13210 "Device.c"
					}
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp25_ = _mp_list;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp26_ = _mp_index;
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _tmp26_);
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					mp = (MountEntry*) _tmp27_;
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp28_ = mps;
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp29_ = mp;
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp30_ = _tmp29_->mount_point;
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp31_ = g_strdup_printf ("\n    %s -> ", _tmp30_);
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp32_ = _tmp31_;
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp33_ = g_strconcat (_tmp28_, _tmp32_, NULL);
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (mps);
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					mps = _tmp33_;
#line 2011 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_free0 (_tmp32_);
#line 2012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp34_ = mp;
#line 2012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp35_ = _tmp34_->mount_options;
#line 2012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp36_ = strlen (_tmp35_);
#line 2012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_tmp37_ = _tmp36_;
#line 2012 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					if (_tmp37_ > 0) {
#line 13248 "Device.c"
						const gchar* _tmp38_;
						MountEntry* _tmp39_;
						const gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp38_ = mps;
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp39_ = mp;
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp40_ = _tmp39_->mount_options;
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp41_ = g_strdup_printf (" %s", _tmp40_);
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp42_ = _tmp41_;
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_tmp43_ = g_strconcat (_tmp38_, _tmp42_, NULL);
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (mps);
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						mps = _tmp43_;
#line 2013 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
						_g_free0 (_tmp42_);
#line 13273 "Device.c"
					}
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
					_g_object_unref0 (mp);
#line 13277 "Device.c"
				}
#line 2010 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 13281 "Device.c"
			}
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp44_ = dev;
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp45_ = _tmp44_->device;
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp46_ = mps;
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp47_ = g_strdup_printf ("%-15s %s", _tmp45_, _tmp46_);
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp48_ = _tmp47_;
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp48_);
#line 2017 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp48_);
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (mps);
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13301 "Device.c"
		}
#line 2007 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 13305 "Device.c"
	}
#line 2025 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13309 "Device.c"
}


void device_print_device_disk_space (GeeArrayList* list) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2028 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2029 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2031 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", "device", "fstype", "size", "used", "available", "used_percent");
#line 2031 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2031 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2031 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2040 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13338 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		gint _dev_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _dev_index = 0;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = list;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_list = _tmp5_;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = _dev_list;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_size = _tmp8_;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_dev_index = -1;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		while (TRUE) {
#line 13366 "Device.c"
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			Device* dev = NULL;
			GeeArrayList* _tmp12_;
			gint _tmp13_;
			gpointer _tmp14_;
			Device* _tmp15_;
			const gchar* _tmp16_;
			Device* _tmp17_;
			const gchar* _tmp18_;
			Device* _tmp19_;
			guint64 _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			Device* _tmp23_;
			guint64 _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			Device* _tmp27_;
			guint64 _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			Device* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = _dev_index;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_dev_index = _tmp9_ + 1;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp10_ = _dev_index;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp11_ = _dev_size;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
				break;
#line 13406 "Device.c"
			}
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp12_ = _dev_list;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp13_ = _dev_index;
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			dev = (Device*) _tmp14_;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp15_ = dev;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp16_ = _tmp15_->device;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp17_ = dev;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp18_ = _tmp17_->fstype;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp19_ = dev;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp20_ = _tmp19_->size_bytes;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp21_ = tee_jee_file_system_format_file_size (_tmp20_, TRUE, "", TRUE, 1);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp23_ = dev;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp24_ = _tmp23_->used_bytes;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp25_ = tee_jee_file_system_format_file_size (_tmp24_, TRUE, "", TRUE, 1);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp27_ = dev;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp28_ = _tmp27_->available_bytes;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp29_ = tee_jee_file_system_format_file_size (_tmp28_, TRUE, "", TRUE, 1);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp30_ = _tmp29_;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp31_ = dev;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp32_ = _tmp31_->used_percent;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp33_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", _tmp16_, _tmp18_, _tmp22_, _tmp26_, _tmp30_, _tmp32_);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp34_ = _tmp33_;
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp34_);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp30_);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 2043 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13468 "Device.c"
		}
#line 2042 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 13472 "Device.c"
	}
#line 2053 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13476 "Device.c"
}


guint64 device_get_free_bytes (Device* self) {
	guint64 result;
	guint64 _tmp0_ = 0ULL;
	guint64 _tmp1_;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->used_bytes;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_ == ((guint64) 0)) {
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = (guint64) 0;
#line 13492 "Device.c"
	} else {
		guint64 _tmp2_;
		guint64 _tmp3_;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = self->size_bytes;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = self->used_bytes;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp2_ - _tmp3_;
#line 13502 "Device.c"
	}
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp0_;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13508 "Device.c"
}


gchar* device_get_size (Device* self) {
	gchar* result;
	guint64 _tmp0_;
	gdouble _tmp1_;
#line 127 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->size_bytes;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_GB;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (((gdouble) _tmp0_) < _tmp1_) {
#line 13524 "Device.c"
		guint64 _tmp2_;
		gdouble _tmp3_;
		gchar* _tmp4_;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = self->size_bytes;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = device_MB;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%.1f MB", _tmp2_ / _tmp3_);
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		result = _tmp4_;
#line 129 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		return result;
#line 13538 "Device.c"
	} else {
		guint64 _tmp5_;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = self->size_bytes;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		if (_tmp5_ > ((guint64) 0)) {
#line 13545 "Device.c"
			guint64 _tmp6_;
			gdouble _tmp7_;
			gchar* _tmp8_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp6_ = self->size_bytes;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp7_ = device_GB;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp8_ = g_strdup_printf ("%.1f GB", _tmp6_ / _tmp7_);
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			result = _tmp8_;
#line 132 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			return result;
#line 13559 "Device.c"
		} else {
			gchar* _tmp9_;
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			_tmp9_ = g_strdup ("");
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			result = _tmp9_;
#line 135 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
			return result;
#line 13568 "Device.c"
		}
	}
}


gchar* device_get_used (Device* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = self->used_bytes;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp1_ == ((guint64) 0)) {
#line 13584 "Device.c"
		gchar* _tmp2_;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = g_strdup ("");
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp2_;
#line 13592 "Device.c"
	} else {
		guint64 _tmp3_;
		gdouble _tmp4_;
		gchar* _tmp5_;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = self->used_bytes;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = device_GB;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = g_strdup_printf ("%.1f GB", _tmp3_ / _tmp4_);
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp5_;
#line 13607 "Device.c"
	}
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp0_;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13613 "Device.c"
}


gchar* device_get_free (Device* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	guint64 _tmp2_;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_get_free_bytes (self);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp2_ == ((guint64) 0)) {
#line 13630 "Device.c"
		gchar* _tmp3_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp3_ = g_strdup ("");
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp3_;
#line 13638 "Device.c"
	} else {
		guint64 _tmp4_;
		guint64 _tmp5_;
		gdouble _tmp6_;
		gchar* _tmp7_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = device_get_free_bytes (self);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = device_GB;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf ("%.1f GB", _tmp5_ / _tmp6_);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp0_ = _tmp7_;
#line 13656 "Device.c"
	}
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp0_;
#line 148 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13662 "Device.c"
}


gboolean device_get_is_mounted (Device* self) {
	gboolean result;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->mount_points;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp2_ > 0;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13683 "Device.c"
}


gchar* device_get_full_name_with_alias (Device* self) {
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1633 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->device;
#line 1633 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1633 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	text = _tmp1_;
#line 1634 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1634 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1634 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1634 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13711 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = text;
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (text);
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		text = _tmp9_;
#line 1635 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13733 "Device.c"
	}
#line 1637 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = text;
#line 1637 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13739 "Device.c"
}


gchar* device_get_full_name_with_parent (Device* self) {
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1642 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_get_device_name_with_parent (self);
#line 1643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = _tmp1_;
#line 1643 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13757 "Device.c"
}


gchar* device_get_short_name_with_alias (Device* self) {
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	text = _tmp1_;
#line 1650 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1650 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1650 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1650 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13785 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = text;
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (text);
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		text = _tmp9_;
#line 1651 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13807 "Device.c"
	}
#line 1653 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = text;
#line 1653 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13813 "Device.c"
}


gchar* device_get_short_name_with_parent (Device* self) {
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
#line 1658 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1659 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	text = _tmp1_;
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = device_has_parent (self);
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp3_) {
#line 13836 "Device.c"
		Device* _tmp4_;
		const gchar* _tmp5_;
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = self->parent;
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_->type;
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp5_, "part") == 0;
#line 13845 "Device.c"
	} else {
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13849 "Device.c"
	}
#line 1661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp2_) {
#line 13853 "Device.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = text;
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = self->pkname;
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = g_strdup_printf (" (%s)", _tmp7_);
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (text);
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		text = _tmp10_;
#line 1662 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 13875 "Device.c"
	}
#line 1665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = text;
#line 1665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13881 "Device.c"
}


gchar* device_get_device_name_with_parent (Device* self) {
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
#line 1670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = self->device;
#line 1671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	text = _tmp1_;
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = device_has_parent (self);
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp3_) {
#line 13904 "Device.c"
		Device* _tmp4_;
		const gchar* _tmp5_;
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp4_ = self->parent;
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp5_ = _tmp4_->type;
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp5_, "part") == 0;
#line 13913 "Device.c"
	} else {
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13917 "Device.c"
	}
#line 1673 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	if (_tmp2_) {
#line 13921 "Device.c"
		const gchar* _tmp6_;
		Device* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp6_ = text;
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp7_ = self->parent;
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp8_ = _tmp7_->kname;
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp9_ = g_strdup_printf (" (%s)", _tmp8_);
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp6_, _tmp10_, NULL);
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (text);
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		text = _tmp11_;
#line 1674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 13946 "Device.c"
	}
#line 1677 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	result = text;
#line 1677 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	return result;
#line 13952 "Device.c"
}


static void device_class_init (DeviceClass * klass) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_device_get_property;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_BYTES_PROPERTY, device_properties[DEVICE_FREE_BYTES_PROPERTY] = g_param_spec_uint64 ("free-bytes", "free-bytes", "free-bytes", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SIZE_PROPERTY, device_properties[DEVICE_SIZE_PROPERTY] = g_param_spec_string ("size", "size", "size", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_USED_PROPERTY, device_properties[DEVICE_USED_PROPERTY] = g_param_spec_string ("used", "used", "used", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_PROPERTY, device_properties[DEVICE_FREE_PROPERTY] = g_param_spec_string ("free", "free", "free", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_MOUNTED_PROPERTY, device_properties[DEVICE_IS_MOUNTED_PROPERTY] = g_param_spec_boolean ("is-mounted", "is-mounted", "is-mounted", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("full-name-with-alias", "full-name-with-alias", "full-name-with-alias", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("full-name-with-parent", "full-name-with-parent", "full-name-with-parent", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("short-name-with-alias", "short-name-with-alias", "short-name-with-alias", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("short-name-with-parent", "short-name-with-parent", "short-name-with-parent", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("device-name-with-parent", "device-name-with-parent", "device-name-with-parent", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = device_KB;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_MB = 1000 * _tmp0_;
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = device_MB;
#line 38 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_GB = 1000 * _tmp1_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = device_KiB;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_MiB = 1024 * _tmp2_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = device_MiB;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_GiB = 1024 * _tmp3_;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = g_strdup ("");
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	device_lsblk_version = _tmp4_;
#line 14008 "Device.c"
}


static void device_instance_init (Device * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device = _tmp0_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->name = _tmp1_;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->kname = _tmp2_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp3_ = g_strdup ("");
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->pkname = _tmp3_;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp4_ = g_strdup ("");
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->pkname_toplevel = _tmp4_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp5_ = g_strdup ("");
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->mapped_name = _tmp5_;
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp6_ = g_strdup ("");
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->uuid = _tmp6_;
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp7_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->label = _tmp7_;
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp8_ = g_strdup ("");
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->partuuid = _tmp8_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp9_ = g_strdup ("");
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->partlabel = _tmp9_;
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->major = -1;
#line 56 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->minor = -1;
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp10_ = g_strdup ("");
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device_mapper = _tmp10_;
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp11_ = g_strdup ("");
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device_by_uuid = _tmp11_;
#line 60 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp12_ = g_strdup ("");
#line 60 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device_by_label = _tmp12_;
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp13_ = g_strdup ("");
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device_by_partuuid = _tmp13_;
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->device_by_partlabel = _tmp14_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->type = _tmp15_;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp16_ = g_strdup ("");
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->fstype = _tmp16_;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->order = -1;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp17_ = g_strdup ("");
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->vendor = _tmp17_;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp18_ = g_strdup ("");
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->model = _tmp18_;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp19_ = g_strdup ("");
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->serial = _tmp19_;
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp20_ = g_strdup ("");
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->revision = _tmp20_;
#line 74 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->removable = FALSE;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->read_only = FALSE;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->size_bytes = (guint64) 0;
#line 78 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->used_bytes = (guint64) 0;
#line 79 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->available_bytes = (guint64) 0;
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp21_ = g_strdup ("");
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->used_percent = _tmp21_;
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_tmp22_ = g_strdup ("");
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->dist_info = _tmp22_;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->parent = NULL;
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self->children = NULL;
#line 14148 "Device.c"
}


static void device_finalize (GObject * obj) {
	Device * self;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE, Device);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->name);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->kname);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->pkname);
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->pkname_toplevel);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 50 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->uuid);
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->label);
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->partuuid);
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->partlabel);
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device_mapper);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device_by_uuid);
#line 60 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device_by_label);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device_by_partuuid);
#line 62 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->device_by_partlabel);
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->type);
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->fstype);
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->vendor);
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->model);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->serial);
#line 72 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->revision);
#line 81 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->used_percent);
#line 82 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_free0 (self->dist_info);
#line 83 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 84 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
#line 14212 "Device.c"
}


GType device_get_type (void) {
	static volatile gsize device_type_id__volatile = 0;
	if (g_once_init_enter (&device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
		GType device_type_id;
		device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
		g_once_init_leave (&device_type_id__volatile, device_type_id);
	}
	return device_type_id__volatile;
}


static void _vala_device_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
	switch (property_id) {
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_FREE_BYTES_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_set_uint64 (value, device_get_free_bytes (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_SIZE_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_size (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_USED_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_used (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_FREE_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_free (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_IS_MOUNTED_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_set_boolean (value, device_get_is_mounted (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_alias (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_PARENT_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_parent (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_alias (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_parent (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		case DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		g_value_take_string (value, device_get_device_name_with_parent (self));
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 14293 "Device.c"
		default:
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/builddir/build/BUILD/timeshift-18.4/src/Utility/Device.vala"
		break;
#line 14299 "Device.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



