/* TeeJee.Process.c generated by valac 0.38.10, the Vala compiler
 * generated from TeeJee.Process.vala, do not modify */

/*
 * TeeJee.ProcessHelper.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <signal.h>
#include <sys/types.h>
#include <glib/gi18n-lib.h>
#include <sys/time.h>
#include <sys/resource.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))


extern gchar* tee_jee_process_helper_TEMP_DIR;
gchar* tee_jee_process_helper_TEMP_DIR = NULL;

void tee_jee_process_helper_init_tmp (const gchar* subdir_name);
gchar* tee_jee_misc_random_string (gint length, const gchar* charset);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path, gboolean show_message);
gint tee_jee_process_helper_exec_script_sync (const gchar* script, gchar* * std_out, gchar* * std_err, gboolean supress_errors, gboolean run_as_admin, gboolean cleanup_tmp, gboolean print_to_terminal);
gint tee_jee_process_helper_exec_sync (const gchar* cmd, gchar* * std_out, gchar* * std_err);
gchar* tee_jee_process_helper_create_temp_subdir (void);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands, const gchar* script_path, gboolean force_locale, gboolean supress_errors);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gint tee_jee_process_helper_exec_script_async (const gchar* script);
gchar* tee_jee_process_helper_get_temp_file_path (void);
gint tee_jee_file_system_chmod (const gchar* file, const gchar* permission);
gchar* tee_jee_misc_timestamp_numeric (void);
void tee_jee_process_helper_exec_process_new_session (const gchar* command);
gchar* tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool);
gboolean tee_jee_process_helper_cmd_exists (const gchar* cmd_tool);
gint tee_jee_process_helper_get_pid_by_name (const gchar* name);
gint tee_jee_process_helper_get_pid_by_command (const gchar* cmdline);
void tee_jee_process_helper_get_proc_io_stats (gint pid, gint64* read_bytes, gint64* write_bytes);
gboolean tee_jee_process_helper_process_is_running (glong pid);
gboolean tee_jee_process_helper_process_is_running_by_name (const gchar* proc_name);
gint* tee_jee_process_helper_get_process_children (GPid parent_pid, int* result_length1);
static void _vala_array_add3 (gint* * array, int* length, int* size, gint value);
void tee_jee_process_helper_process_quit (GPid process_pid, gboolean killChildren);
void tee_jee_process_helper_process_kill (GPid process_pid, gboolean killChildren);
gint tee_jee_process_helper_process_pause (GPid procID);
gint tee_jee_process_helper_process_resume (GPid procID);
void tee_jee_process_helper_process_quit_by_name (const gchar* cmd_name, const gchar* cmd_to_match, gboolean exact_match);
void tee_jee_logging_log_debug (const gchar* message);
void tee_jee_process_helper_process_set_priority (GPid procID, gint prio);
gint tee_jee_process_helper_process_get_priority (GPid procID);
void tee_jee_process_helper_process_set_priority_normal (GPid procID);
void tee_jee_process_helper_process_set_priority_low (GPid procID);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 109 "TeeJee.Process.c"
}


void tee_jee_process_helper_init_tmp (const gchar* subdir_name) {
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_if_fail (subdir_name != NULL);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = g_get_tmp_dir ();
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = subdir_name;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp5_ = _tmp4_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp6_ = g_strconcat (_tmp5_, "/", NULL);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp7_ = _tmp6_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp8_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp9_ = _tmp8_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (tee_jee_process_helper_TEMP_DIR);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_TEMP_DIR = _tmp10_;
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp9_);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp7_);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp5_);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp11_ = tee_jee_process_helper_TEMP_DIR;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_file_system_dir_create (_tmp11_, FALSE);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_script_sync ("echo 'ok'", &_tmp12_, &_tmp13_, TRUE, FALSE, TRUE, FALSE);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_out = _tmp12_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_err = _tmp13_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp15_ = std_out;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp15_ == NULL) {
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp14_ = TRUE;
#line 188 "TeeJee.Process.c"
	} else {
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp16_ = std_out;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp17_ = string_strip (_tmp16_);
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp18_ = _tmp17_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp14_ = g_strcmp0 (_tmp18_, "ok") != 0;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp18_);
#line 203 "TeeJee.Process.c"
	}
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp14_) {
#line 207 "TeeJee.Process.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		const gchar* _tmp33_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp19_ = g_get_home_dir ();
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp20_ = g_strconcat (_tmp19_, "/.temp/", NULL);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp21_ = _tmp20_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp22_ = subdir_name;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp23_ = g_strconcat (_tmp21_, _tmp22_, NULL);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp24_ = _tmp23_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp25_ = g_strconcat (_tmp24_, "/", NULL);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp26_ = _tmp25_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp27_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp28_ = _tmp27_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp29_ = g_strconcat (_tmp26_, _tmp28_, NULL);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (tee_jee_process_helper_TEMP_DIR);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_process_helper_TEMP_DIR = _tmp29_;
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp28_);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp26_);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp24_);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp21_);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp30_ = tee_jee_process_helper_TEMP_DIR;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp31_ = g_strdup_printf ("rm -rf '%s'", _tmp30_);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp32_ = _tmp31_;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_process_helper_exec_sync (_tmp32_, NULL, NULL);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp32_);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp33_ = tee_jee_process_helper_TEMP_DIR;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_file_system_dir_create (_tmp33_, FALSE);
#line 271 "TeeJee.Process.c"
	}
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 36 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 277 "TeeJee.Process.c"
}


gchar* tee_jee_process_helper_create_temp_subdir (void) {
	gchar* result = NULL;
	gchar* temp = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp2_);
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	temp = _tmp4_;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_file_system_dir_create (temp, FALSE);
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = temp;
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 309 "TeeJee.Process.c"
}


gint tee_jee_process_helper_exec_sync (const gchar* cmd, gchar* * std_out, gchar* * std_err) {
	gchar* _vala_std_out = NULL;
	gchar* _vala_std_err = NULL;
	gint result = 0;
	gint _tmp6_ = 0;
	GError * _inner_error_ = NULL;
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd != NULL, 0);
#line 321 "TeeJee.Process.c"
	{
		gint status = 0;
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp0_ = cmd;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_inner_error_);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_vala_std_out);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_vala_std_out = _tmp1_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_vala_std_err);
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_vala_std_err = _tmp2_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		status = _tmp3_;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 344 "TeeJee.Process.c"
			goto __catch83_g_error;
		}
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = status;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_out) {
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 353 "TeeJee.Process.c"
		} else {
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 357 "TeeJee.Process.c"
		}
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_err) {
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 363 "TeeJee.Process.c"
		} else {
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 367 "TeeJee.Process.c"
		}
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 371 "TeeJee.Process.c"
	}
	goto __finally83;
	__catch83_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp4_ = e;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5_ = _tmp4_->message;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp5_, FALSE, FALSE);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = -1;
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_out) {
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 397 "TeeJee.Process.c"
		} else {
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 401 "TeeJee.Process.c"
		}
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_err) {
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 407 "TeeJee.Process.c"
		} else {
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 411 "TeeJee.Process.c"
		}
#line 71 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 415 "TeeJee.Process.c"
	}
	__finally83:
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error_);
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return _tmp6_;
#line 424 "TeeJee.Process.c"
}


gint tee_jee_process_helper_exec_script_sync (const gchar* script, gchar* * std_out, gchar* * std_err, gboolean supress_errors, gboolean run_as_admin, gboolean cleanup_tmp, gboolean print_to_terminal) {
	gchar* _vala_std_out = NULL;
	gchar* _vala_std_err = NULL;
	gint result = 0;
	gchar* sh_file = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* sh_file_admin = NULL;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gint _tmp54_ = 0;
	GError * _inner_error_ = NULL;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = script;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = supress_errors;
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_save_bash_script_temp (_tmp0_, NULL, TRUE, _tmp1_);
#line 86 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	sh_file = _tmp2_;
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = g_strdup ("");
#line 87 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	sh_file_admin = _tmp3_;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = run_as_admin;
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp4_) {
#line 459 "TeeJee.Process.c"
		gchar* script_admin = NULL;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gboolean _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5_ = g_strdup ("#!/bin/bash\n");
#line 91 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		script_admin = _tmp5_;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp6_ = script_admin;
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp7_ = g_strconcat (_tmp6_, "pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY", NULL);
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 92 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		script_admin = _tmp7_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp8_ = script_admin;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp9_ = sh_file;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp10_ = tee_jee_file_system_escape_single_quote (_tmp9_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp11_ = _tmp10_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp12_ = g_strdup_printf (" '%s'", _tmp11_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp13_ = _tmp12_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp14_ = g_strconcat (_tmp8_, _tmp13_, NULL);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		script_admin = _tmp14_;
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp13_);
#line 93 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp11_);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp15_ = sh_file;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp16_ = tee_jee_file_system_file_parent (_tmp15_);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp17_ = _tmp16_;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp18_ = g_build_filename (_tmp17_, "script-admin.sh", NULL);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		sh_file_admin = _tmp18_;
#line 95 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp17_);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp19_ = script_admin;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp20_ = sh_file_admin;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp21_ = supress_errors;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp22_ = tee_jee_process_helper_save_bash_script_temp (_tmp19_, _tmp20_, TRUE, _tmp21_);
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp23_ = _tmp22_;
#line 97 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp23_);
#line 89 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 542 "TeeJee.Process.c"
	}
	{
		gchar** argv = NULL;
		gchar** _tmp24_;
		gint argv_length1;
		gint _argv_size_;
		gboolean _tmp25_;
		gchar** env = NULL;
		gchar** _tmp34_;
		gchar** _tmp35_;
		gint env_length1;
		gint _env_size_;
		gint exit_code = 0;
		gboolean _tmp36_;
		gboolean _tmp47_;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp24_ = g_new0 (gchar*, 1 + 1);
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv = _tmp24_;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv_length1 = 1;
#line 101 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_argv_size_ = argv_length1;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp25_ = run_as_admin;
#line 102 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (_tmp25_) {
#line 570 "TeeJee.Process.c"
			gchar** _tmp26_;
			gint _tmp26__length1;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp26_ = argv;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp26__length1 = argv_length1;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp27_ = sh_file_admin;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp28_ = g_strdup (_tmp27_);
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_tmp26_[0]);
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp26_[0] = _tmp28_;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp29_ = _tmp26_[0];
#line 590 "TeeJee.Process.c"
		} else {
			gchar** _tmp30_;
			gint _tmp30__length1;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp30_ = argv;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp30__length1 = argv_length1;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp31_ = sh_file;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp32_ = g_strdup (_tmp31_);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_tmp30_[0]);
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp30_[0] = _tmp32_;
#line 106 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp33_ = _tmp30_[0];
#line 611 "TeeJee.Process.c"
		}
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp35_ = _tmp34_ = g_get_environ ();
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		env = _tmp35_;
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		env_length1 = _vala_array_length (_tmp34_);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_env_size_ = env_length1;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp36_ = print_to_terminal;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (_tmp36_) {
#line 625 "TeeJee.Process.c"
			const gchar* _tmp37_;
			gchar** _tmp38_;
			gint _tmp38__length1;
			gchar** _tmp39_;
			gint _tmp39__length1;
			gint _tmp40_ = 0;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp37_ = tee_jee_process_helper_TEMP_DIR;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp38_ = argv;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp38__length1 = argv_length1;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp39_ = env;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp39__length1 = env_length1;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			g_spawn_sync (_tmp37_, _tmp38_, _tmp39_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, &_tmp40_, &_inner_error_);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			exit_code = _tmp40_;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 652 "TeeJee.Process.c"
				goto __catch84_g_error;
			}
		} else {
			const gchar* _tmp41_;
			gchar** _tmp42_;
			gint _tmp42__length1;
			gchar** _tmp43_;
			gint _tmp43__length1;
			gchar* _tmp44_ = NULL;
			gchar* _tmp45_ = NULL;
			gint _tmp46_ = 0;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp41_ = tee_jee_process_helper_TEMP_DIR;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp42_ = argv;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp42__length1 = argv_length1;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp43_ = env;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp43__length1 = env_length1;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			g_spawn_sync (_tmp41_, _tmp42_, _tmp43_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp44_, &_tmp45_, &_tmp46_, &_inner_error_);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_vala_std_out = _tmp44_;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_vala_std_err = _tmp45_;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			exit_code = _tmp46_;
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 128 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 692 "TeeJee.Process.c"
				goto __catch84_g_error;
			}
		}
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp47_ = cleanup_tmp;
#line 140 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (_tmp47_) {
#line 700 "TeeJee.Process.c"
			const gchar* _tmp48_;
			gboolean _tmp49_;
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp48_ = sh_file;
#line 141 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			tee_jee_file_system_file_delete (_tmp48_);
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp49_ = run_as_admin;
#line 142 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (_tmp49_) {
#line 711 "TeeJee.Process.c"
				const gchar* _tmp50_;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp50_ = sh_file_admin;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				tee_jee_file_system_file_delete (_tmp50_);
#line 717 "TeeJee.Process.c"
			}
		}
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = exit_code;
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_file);
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_out) {
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 734 "TeeJee.Process.c"
		} else {
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 738 "TeeJee.Process.c"
		}
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_err) {
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 744 "TeeJee.Process.c"
		} else {
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 748 "TeeJee.Process.c"
		}
#line 147 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 752 "TeeJee.Process.c"
	}
	goto __finally84;
	__catch84_g_error:
	{
		GError* e = NULL;
		gboolean _tmp51_;
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp51_ = supress_errors;
#line 150 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (!_tmp51_) {
#line 767 "TeeJee.Process.c"
			GError* _tmp52_;
			const gchar* _tmp53_;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp52_ = e;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp53_ = _tmp52_->message;
#line 151 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			tee_jee_logging_log_error (_tmp53_, FALSE, FALSE);
#line 776 "TeeJee.Process.c"
		}
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = -1;
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_file);
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_out) {
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 790 "TeeJee.Process.c"
		} else {
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 794 "TeeJee.Process.c"
		}
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (std_err) {
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 800 "TeeJee.Process.c"
		} else {
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 804 "TeeJee.Process.c"
		}
#line 153 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 808 "TeeJee.Process.c"
	}
	__finally84:
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (sh_file_admin);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (sh_file);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error_);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return _tmp54_;
#line 821 "TeeJee.Process.c"
}


gint tee_jee_process_helper_exec_script_async (const gchar* script) {
	gint result = 0;
	gint _tmp11_ = 0;
	GError * _inner_error_ = NULL;
#line 157 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 831 "TeeJee.Process.c"
	{
		gchar* scriptfile = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar** argv = NULL;
		gchar** _tmp2_;
		gint argv_length1;
		gint _argv_size_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar** env = NULL;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gint env_length1;
		gint _env_size_;
		GPid child_pid = 0;
		const gchar* _tmp7_;
		GPid _tmp8_ = 0;
#line 167 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp0_ = script;
#line 167 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp1_ = tee_jee_process_helper_save_bash_script_temp (_tmp0_, NULL, TRUE, FALSE);
#line 167 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		scriptfile = _tmp1_;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv = _tmp2_;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv_length1 = 1;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_argv_size_ = argv_length1;
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp3_ = g_strdup (scriptfile);
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (argv[0]);
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv[0] = _tmp3_;
#line 170 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp4_ = argv[0];
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp6_ = _tmp5_ = g_get_environ ();
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		env = _tmp6_;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		env_length1 = _vala_array_length (_tmp5_);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_env_size_ = env_length1;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp7_ = tee_jee_process_helper_TEMP_DIR;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_spawn_async_with_pipes (_tmp7_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp8_, NULL, NULL, NULL, &_inner_error_);
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		child_pid = _tmp8_;
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 175 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (scriptfile);
#line 894 "TeeJee.Process.c"
			goto __catch85_g_error;
		}
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = 0;
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (scriptfile);
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 907 "TeeJee.Process.c"
	}
	goto __finally85;
	__catch85_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp9_ = e;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp10_ = _tmp9_->message;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = 1;
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 931 "TeeJee.Process.c"
	}
	__finally85:
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error_);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return _tmp11_;
#line 940 "TeeJee.Process.c"
}


gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands, const gchar* script_path, gboolean force_locale, gboolean supress_errors) {
	gchar* result = NULL;
	gchar* sh_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GString* script = NULL;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp4_;
	gboolean _tmp5_;
	GString* _tmp7_;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GString* _tmp12_;
	GString* _tmp13_;
	GString* _tmp14_;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GError * _inner_error_ = NULL;
#line 191 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (commands != NULL, NULL);
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = script_path;
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 194 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	sh_path = _tmp1_;
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = g_string_new ("");
#line 199 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	script = _tmp2_;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = script;
#line 200 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp3_, "#!/bin/bash\n");
#line 201 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = script;
#line 201 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp4_, "\n");
#line 202 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp5_ = force_locale;
#line 202 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp5_) {
#line 989 "TeeJee.Process.c"
		GString* _tmp6_;
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp6_ = script;
#line 203 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_string_append (_tmp6_, "LANG=C\n");
#line 995 "TeeJee.Process.c"
	}
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp7_ = script;
#line 205 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp7_, "\n");
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp8_ = script;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp9_ = commands;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp10_ = g_strdup_printf ("%s\n", _tmp9_);
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp11_ = _tmp10_;
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp8_, _tmp11_);
#line 206 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp11_);
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp12_ = script;
#line 207 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp12_, "\n\nexitCode=$?\n");
#line 208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp13_ = script;
#line 208 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp13_, "echo ${exitCode} > ${exitCode}\n");
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp14_ = script;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_string_append (_tmp14_, "echo ${exitCode} > status\n");
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp16_ = sh_path;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp16_ == NULL) {
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp15_ = TRUE;
#line 1031 "TeeJee.Process.c"
	} else {
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp17_ = sh_path;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp18_ = strlen (_tmp17_);
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp19_ = _tmp18_;
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp15_ = _tmp19_ == 0;
#line 1044 "TeeJee.Process.c"
	}
#line 211 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp15_) {
#line 1048 "TeeJee.Process.c"
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp20_ = tee_jee_process_helper_get_temp_file_path ();
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp21_ = _tmp20_;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp22_ = g_strconcat (_tmp21_, ".sh", NULL);
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_path);
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		sh_path = _tmp22_;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp21_);
#line 1064 "TeeJee.Process.c"
	}
	{
		GFile* file = NULL;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		gboolean _tmp26_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp28_;
		GFileOutputStream* _tmp29_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp30_;
		GDataOutputStream* _tmp31_;
		GDataOutputStream* _tmp32_;
		GString* _tmp33_;
		const gchar* _tmp34_;
		GDataOutputStream* _tmp35_;
		const gchar* _tmp36_;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp23_ = sh_path;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp24_ = g_file_new_for_path (_tmp23_);
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		file = _tmp24_;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp25_ = file;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp26_ = g_file_query_exists (_tmp25_, NULL);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (_tmp26_) {
#line 1095 "TeeJee.Process.c"
			GFile* _tmp27_;
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp27_ = file;
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			g_file_delete (_tmp27_, NULL, &_inner_error_);
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 219 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 1105 "TeeJee.Process.c"
				goto __catch86_g_error;
			}
		}
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp28_ = file;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp29_ = g_file_create (_tmp28_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		file_stream = _tmp29_;
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1119 "TeeJee.Process.c"
			goto __catch86_g_error;
		}
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp30_ = file_stream;
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp31_ = g_data_output_stream_new ((GOutputStream*) _tmp30_);
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		data_stream = _tmp31_;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp32_ = data_stream;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp33_ = script;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp34_ = _tmp33_->str;
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_data_output_stream_put_string (_tmp32_, _tmp34_, NULL, &_inner_error_);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (data_stream);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (file_stream);
#line 223 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1144 "TeeJee.Process.c"
			goto __catch86_g_error;
		}
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp35_ = data_stream;
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_output_stream_close ((GOutputStream*) _tmp35_, NULL, &_inner_error_);
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (data_stream);
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (file_stream);
#line 224 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1159 "TeeJee.Process.c"
			goto __catch86_g_error;
		}
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp36_ = sh_path;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_file_system_chmod (_tmp36_, "u+x");
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = sh_path;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (data_stream);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (file_stream);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_string_free0 (script);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 1178 "TeeJee.Process.c"
	}
	goto __finally86;
	__catch86_g_error:
	{
		GError* e = NULL;
		gboolean _tmp37_;
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp37_ = supress_errors;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (!_tmp37_) {
#line 1193 "TeeJee.Process.c"
			GError* _tmp38_;
			const gchar* _tmp39_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp38_ = e;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp39_ = _tmp38_->message;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			tee_jee_logging_log_error (_tmp39_, FALSE, FALSE);
#line 1202 "TeeJee.Process.c"
		}
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 1206 "TeeJee.Process.c"
	}
	__finally86:
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_string_free0 (script);
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (sh_path);
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error_);
#line 215 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return NULL;
#line 1221 "TeeJee.Process.c"
	}
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = NULL;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_string_free0 (script);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (sh_path);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 1231 "TeeJee.Process.c"
}


gchar* tee_jee_process_helper_get_temp_file_path (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GRand* _tmp7_;
	GRand* _tmp8_;
	guint32 _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = tee_jee_misc_timestamp_numeric ();
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp6_ = _tmp5_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp7_ = g_rand_new ();
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp9_ = g_rand_int (_tmp8_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp10_ = g_strdup_printf ("%u", _tmp9_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp11_ = _tmp10_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp12_ = g_strconcat (_tmp6_, _tmp11_, NULL);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp13_ = _tmp12_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp11_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_rand_free0 (_tmp8_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp6_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp4_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp13_;
#line 244 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 1293 "TeeJee.Process.c"
}


void tee_jee_process_helper_exec_process_new_session (const gchar* command) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_if_fail (command != NULL);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = command;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("setsid %s &", _tmp0_);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_script_async (_tmp2_);
#line 248 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 1313 "TeeJee.Process.c"
}


gchar* tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd_tool != NULL, NULL);
#line 1322 "TeeJee.Process.c"
	{
		gint exitCode = 0;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp0_ = cmd_tool;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp1_ = g_strconcat ("which ", _tmp0_, NULL);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = _tmp1_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (stdout);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		stdout = _tmp3_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (stderr);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		stderr = _tmp4_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		exitCode = _tmp5_;
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (_tmp2_);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (stderr);
#line 261 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (stdout);
#line 1359 "TeeJee.Process.c"
			goto __catch87_g_error;
		}
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = stdout;
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (stderr);
#line 262 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 1368 "TeeJee.Process.c"
	}
	goto __finally87;
	__catch87_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp6_ = e;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_->message;
#line 265 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp8_ = g_strdup ("");
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = _tmp8_;
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 266 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 1395 "TeeJee.Process.c"
	}
	__finally87:
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error_);
#line 258 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return NULL;
#line 1404 "TeeJee.Process.c"
}


gboolean tee_jee_process_helper_cmd_exists (const gchar* cmd_tool) {
	gboolean result = FALSE;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd_tool != NULL, FALSE);
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = cmd_tool;
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_process_helper_get_cmd_path (_tmp0_);
#line 271 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	path = _tmp1_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = path;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp3_ == NULL) {
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = TRUE;
#line 1429 "TeeJee.Process.c"
	} else {
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp4_ = path;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5_ = strlen (_tmp4_);
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp6_ = _tmp5_;
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = _tmp6_ == 0;
#line 1442 "TeeJee.Process.c"
	}
#line 272 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp2_) {
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = FALSE;
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (path);
#line 273 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 1452 "TeeJee.Process.c"
	} else {
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = TRUE;
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (path);
#line 276 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 1460 "TeeJee.Process.c"
	}
#line 270 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (path);
#line 1464 "TeeJee.Process.c"
}


gint tee_jee_process_helper_get_pid_by_name (const gchar* name) {
	gint result = 0;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = name;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("pidof \"%s\"", _tmp0_);
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp2_, &_tmp3_, &_tmp4_);
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_out = _tmp3_;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_err = _tmp4_;
#line 286 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp5_ = std_out;
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp5_ != NULL) {
#line 1502 "TeeJee.Process.c"
		gchar** arr = NULL;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint arr_length1;
		gint _arr_size_;
		gchar** _tmp9_;
		gint _tmp9__length1;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp6_ = std_out;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "\n", 0);
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		arr = _tmp8_;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		arr_length1 = _vala_array_length (_tmp7_);
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_arr_size_ = arr_length1;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp9_ = arr;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp9__length1 = arr_length1;
#line 290 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (_tmp9__length1 > 0) {
#line 1527 "TeeJee.Process.c"
			gchar** _tmp10_;
			gint _tmp10__length1;
			const gchar* _tmp11_;
			gint _tmp12_;
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp10_ = arr;
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp10__length1 = arr_length1;
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp11_ = _tmp10_[0];
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp12_ = atoi (_tmp11_);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			result = _tmp12_;
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (std_err);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (std_out);
#line 291 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			return result;
#line 1550 "TeeJee.Process.c"
		}
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 1554 "TeeJee.Process.c"
	}
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = -1;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 1564 "TeeJee.Process.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 1584 "TeeJee.Process.c"
}


gint tee_jee_process_helper_get_pid_by_command (const gchar* cmdline) {
	gint result = 0;
	GError * _inner_error_ = NULL;
#line 298 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmdline != NULL, 0);
#line 1593 "TeeJee.Process.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFileEnumerator* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileEnumerator* _tmp4_;
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp0_ = g_file_parse_name ("/proc");
#line 307 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		file = _tmp0_;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = file;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp3_ = g_file_enumerate_children (_tmp2_, "standard::name", 0, NULL, &_inner_error_);
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp3_;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (info);
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (enumerator);
#line 1621 "TeeJee.Process.c"
			goto __catch88_g_error;
		}
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp1_;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp1_ = NULL;
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (enumerator);
#line 309 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		enumerator = _tmp4_;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		while (TRUE) {
#line 1634 "TeeJee.Process.c"
			GFileInfo* _tmp5_ = NULL;
			GFileEnumerator* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp6_ = enumerator;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error_);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp5_ = _tmp7_;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp1_);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (info);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (enumerator);
#line 1656 "TeeJee.Process.c"
				goto __catch88_g_error;
			}
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp8_ = _tmp5_;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp5_ = NULL;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (info);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			info = _tmp8_;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp9_ = info;
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (!(_tmp9_ != NULL)) {
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp5_);
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				break;
#line 1675 "TeeJee.Process.c"
			}
			{
				gchar* io_stat_file_path = NULL;
				GFileInfo* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				GFile* io_stat_file = NULL;
				const gchar* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
				gboolean _tmp16_;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp10_ = info;
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp11_ = g_file_info_get_name (_tmp10_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp12_ = g_strdup_printf ("/proc/%s/cmdline", _tmp11_);
#line 312 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				io_stat_file_path = _tmp12_;
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp13_ = io_stat_file_path;
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp14_ = g_file_new_for_path (_tmp13_);
#line 313 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				io_stat_file = _tmp14_;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp15_ = file;
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp16_ = g_file_query_exists (_tmp15_, NULL);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp16_) {
#line 1707 "TeeJee.Process.c"
					GFileInputStream* _tmp17_ = NULL;
					GFile* _tmp18_;
					GFileInputStream* _tmp19_;
					GDataInputStream* dis = NULL;
					GDataInputStream* _tmp20_;
					gchar* line = NULL;
					gchar* text = NULL;
					gchar* _tmp21_;
					gsize length = 0UL;
					gboolean _tmp33_ = FALSE;
					const gchar* _tmp34_;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp18_ = io_stat_file;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp19_ = g_file_read (_tmp18_, NULL, &_inner_error_);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp17_ = _tmp19_;
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (io_stat_file);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (io_stat_file_path);
#line 1731 "TeeJee.Process.c"
						goto __catch89_g_error;
					}
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp20_ = g_data_input_stream_new ((GInputStream*) _tmp17_);
#line 315 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					dis = _tmp20_;
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp21_ = g_strdup ("");
#line 318 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					text = _tmp21_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					while (TRUE) {
#line 1744 "TeeJee.Process.c"
						gchar* _tmp22_ = NULL;
						GDataInputStream* _tmp23_;
						gsize _tmp24_ = 0UL;
						gchar* _tmp25_;
						gchar* _tmp26_;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp23_ = dis;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp25_ = g_data_input_stream_read_until (_tmp23_, "\0", &_tmp24_, NULL, &_inner_error_);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						length = _tmp24_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp22_ = _tmp25_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_free0 (text);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_free0 (line);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_object_unref0 (dis);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_object_unref0 (_tmp17_);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_object_unref0 (io_stat_file);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_free0 (io_stat_file_path);
#line 1778 "TeeJee.Process.c"
							goto __catch89_g_error;
						}
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp26_ = _tmp22_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp22_ = NULL;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (line);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						line = _tmp26_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp27_ = line;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						if (!(_tmp27_ != NULL)) {
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							_g_free0 (_tmp22_);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
							break;
#line 1797 "TeeJee.Process.c"
						}
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp28_ = text;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp29_ = line;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp30_ = g_strconcat (" ", _tmp29_, NULL);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp31_ = _tmp30_;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp32_ = g_strconcat (_tmp28_, _tmp31_, NULL);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (text);
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						text = _tmp32_;
#line 321 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (_tmp31_);
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (_tmp22_);
#line 1817 "TeeJee.Process.c"
					}
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp34_ = text;
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					if (_tmp34_ != NULL) {
#line 1823 "TeeJee.Process.c"
						const gchar* _tmp35_;
						const gchar* _tmp36_;
						gboolean _tmp37_;
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp35_ = text;
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp36_ = cmdline;
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp37_ = string_contains (_tmp35_, _tmp36_);
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp33_ = _tmp37_;
#line 1835 "TeeJee.Process.c"
					} else {
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp33_ = FALSE;
#line 1839 "TeeJee.Process.c"
					}
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					if (_tmp33_) {
#line 1843 "TeeJee.Process.c"
						GFileInfo* _tmp38_;
						const gchar* _tmp39_;
						gint _tmp40_;
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp38_ = info;
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp39_ = g_file_info_get_name (_tmp38_);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp40_ = atoi (_tmp39_);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						result = _tmp40_;
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (text);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (line);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (dis);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp17_);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (io_stat_file);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (io_stat_file_path);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp5_);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp1_);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (file);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (info);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_object_unref0 (enumerator);
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						return result;
#line 1879 "TeeJee.Process.c"
					}
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (text);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_object_unref0 (dis);
#line 314 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_object_unref0 (_tmp17_);
#line 1889 "TeeJee.Process.c"
				}
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (io_stat_file);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_free0 (io_stat_file_path);
#line 1895 "TeeJee.Process.c"
			}
			goto __finally89;
			__catch89_g_error:
			{
				GError* e = NULL;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				e = _inner_error_;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_inner_error_ = NULL;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_error_free0 (e);
#line 1907 "TeeJee.Process.c"
			}
			__finally89:
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp5_);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp1_);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (info);
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_object_unref0 (enumerator);
#line 1922 "TeeJee.Process.c"
				goto __catch88_g_error;
			}
#line 310 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (_tmp5_);
#line 1927 "TeeJee.Process.c"
		}
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (_tmp1_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (info);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (enumerator);
#line 1937 "TeeJee.Process.c"
	}
	goto __finally88;
	__catch88_g_error:
	{
		GError* e = NULL;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp41_ = e;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp42_ = _tmp41_->message;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp42_, FALSE, FALSE);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 1957 "TeeJee.Process.c"
	}
	__finally88:
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1962 "TeeJee.Process.c"
		gint _tmp43_ = 0;
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error_);
#line 304 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return _tmp43_;
#line 1970 "TeeJee.Process.c"
	}
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = -1;
#line 339 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 1976 "TeeJee.Process.c"
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_;
	gint64 _tmp1_;
#line 687 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 688 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 1994 "TeeJee.Process.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2013 "TeeJee.Process.c"
	} else {
		const gchar* _tmp2_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 2020 "TeeJee.Process.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2026 "TeeJee.Process.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 2036 "TeeJee.Process.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 2040 "TeeJee.Process.c"
		gchar* _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2048 "TeeJee.Process.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2080 "TeeJee.Process.c"
				goto __catch91_g_regex_error;
			}
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2089 "TeeJee.Process.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2105 "TeeJee.Process.c"
				goto __catch91_g_regex_error;
			}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 2116 "TeeJee.Process.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 2130 "TeeJee.Process.c"
	}
	goto __finally91;
	__catch91_g_regex_error:
	{
		GError* e = NULL;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1423 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 2144 "TeeJee.Process.c"
	}
	__finally91:
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return NULL;
#line 2155 "TeeJee.Process.c"
	}
}


void tee_jee_process_helper_get_proc_io_stats (gint pid, gint64* read_bytes, gint64* write_bytes) {
	gint64 _vala_read_bytes = 0LL;
	gint64 _vala_write_bytes = 0LL;
	gchar* io_stat_file_path = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GError * _inner_error_ = NULL;
#line 346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = pid;
#line 346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/io", _tmp0_);
#line 346 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	io_stat_file_path = _tmp1_;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = io_stat_file_path;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	file = _tmp3_;
#line 349 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_vala_read_bytes = (gint64) 0;
#line 350 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_vala_write_bytes = (gint64) 0;
#line 2186 "TeeJee.Process.c"
	{
		GFile* _tmp4_;
		gboolean _tmp5_;
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp4_ = file;
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (_tmp5_) {
#line 2196 "TeeJee.Process.c"
			GFileInputStream* _tmp6_ = NULL;
			GFile* _tmp7_;
			GFileInputStream* _tmp8_;
			GDataInputStream* dis = NULL;
			GDataInputStream* _tmp9_;
			gchar* line = NULL;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp7_ = file;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error_);
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp6_ = _tmp8_;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2211 "TeeJee.Process.c"
				goto __catch90_g_error;
			}
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp9_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			dis = _tmp9_;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			while (TRUE) {
#line 2220 "TeeJee.Process.c"
				gchar* _tmp10_ = NULL;
				GDataInputStream* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gboolean _tmp16_;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp11_ = dis;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp12_ = g_data_input_stream_read_line (_tmp11_, NULL, NULL, &_inner_error_);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp10_ = _tmp12_;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_object_unref0 (dis);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_object_unref0 (_tmp6_);
#line 2242 "TeeJee.Process.c"
					goto __catch90_g_error;
				}
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp13_ = _tmp10_;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp10_ = NULL;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				line = _tmp13_;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp14_ = line;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (!(_tmp14_ != NULL)) {
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp10_);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					break;
#line 2261 "TeeJee.Process.c"
				}
#line 357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp15_ = line;
#line 357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp16_ = g_str_has_prefix (_tmp15_, "rchar:");
#line 357 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp16_) {
#line 2269 "TeeJee.Process.c"
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gint64 _tmp22_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp17_ = line;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp18_ = string_replace (_tmp17_, "rchar:", "");
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp19_ = _tmp18_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp20_ = string_strip (_tmp19_);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp21_ = _tmp20_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp22_ = int64_parse (_tmp21_);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_vala_read_bytes = _tmp22_;
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp21_);
#line 358 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp19_);
#line 2294 "TeeJee.Process.c"
				} else {
					const gchar* _tmp23_;
					gboolean _tmp24_;
#line 360 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp23_ = line;
#line 360 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp24_ = g_str_has_prefix (_tmp23_, "wchar:");
#line 360 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					if (_tmp24_) {
#line 2304 "TeeJee.Process.c"
						const gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						gint64 _tmp30_;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp25_ = line;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp26_ = string_replace (_tmp25_, "wchar:", "");
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp27_ = _tmp26_;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp28_ = string_strip (_tmp27_);
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp29_ = _tmp28_;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp30_ = int64_parse (_tmp29_);
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_vala_write_bytes = _tmp30_;
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (_tmp29_);
#line 361 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_g_free0 (_tmp27_);
#line 2329 "TeeJee.Process.c"
					}
				}
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_free0 (_tmp10_);
#line 2334 "TeeJee.Process.c"
			}
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_free0 (line);
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (dis);
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_g_object_unref0 (_tmp6_);
#line 2342 "TeeJee.Process.c"
		}
	}
	goto __finally90;
	__catch90_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp31_ = e;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp32_ = _tmp31_->message;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp32_, FALSE, FALSE);
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 2363 "TeeJee.Process.c"
	}
	__finally90:
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (io_stat_file_path);
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error_);
#line 352 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return;
#line 2378 "TeeJee.Process.c"
	}
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_object_unref0 (file);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (io_stat_file_path);
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (read_bytes) {
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		*read_bytes = _vala_read_bytes;
#line 2388 "TeeJee.Process.c"
	}
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (write_bytes) {
#line 342 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		*write_bytes = _vala_write_bytes;
#line 2394 "TeeJee.Process.c"
	}
}


gboolean tee_jee_process_helper_process_is_running (glong pid) {
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gint _tmp10_;
	GError * _inner_error_ = NULL;
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup ("");
#line 376 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	cmd = _tmp0_;
#line 2412 "TeeJee.Process.c"
	{
		glong _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp1_ = pid;
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = g_strdup_printf ("ps --pid %ld", _tmp1_);
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 382 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		cmd = _tmp2_;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp3_ = cmd;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_inner_error_);
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		std_out = _tmp4_;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		std_err = _tmp5_;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		ret_val = _tmp6_;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2444 "TeeJee.Process.c"
			goto __catch92_g_error;
		}
	}
	goto __finally92;
	__catch92_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp7_ = e;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_->message;
#line 386 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = FALSE;
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 2476 "TeeJee.Process.c"
	}
	__finally92:
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2481 "TeeJee.Process.c"
		gboolean _tmp9_ = FALSE;
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error_);
#line 381 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return _tmp9_;
#line 2495 "TeeJee.Process.c"
	}
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp10_ = ret_val;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp10_ == 0;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (cmd);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 2509 "TeeJee.Process.c"
}


gboolean tee_jee_process_helper_process_is_running_by_name (const gchar* proc_name) {
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gint _tmp10_;
	GError * _inner_error_ = NULL;
#line 394 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_val_if_fail (proc_name != NULL, FALSE);
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup ("");
#line 398 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	cmd = _tmp0_;
#line 2528 "TeeJee.Process.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
#line 404 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp1_ = proc_name;
#line 404 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp2_ = g_strdup_printf ("pgrep -f '%s'", _tmp1_);
#line 404 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 404 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		cmd = _tmp2_;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp3_ = cmd;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_inner_error_);
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		std_out = _tmp4_;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		std_err = _tmp5_;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		ret_val = _tmp6_;
#line 405 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2560 "TeeJee.Process.c"
			goto __catch93_g_error;
		}
	}
	goto __finally93;
	__catch93_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		e = _inner_error_;
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_inner_error_ = NULL;
#line 408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp7_ = e;
#line 408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_->message;
#line 408 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		result = FALSE;
#line 409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 409 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return result;
#line 2592 "TeeJee.Process.c"
	}
	__finally93:
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2597 "TeeJee.Process.c"
		gboolean _tmp9_ = FALSE;
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error_);
#line 403 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		return _tmp9_;
#line 2611 "TeeJee.Process.c"
	}
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp10_ = ret_val;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp10_ == 0;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (cmd);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 2625 "TeeJee.Process.c"
}


static void _vala_array_add3 (gint* * array, int* length, int* size, gint value) {
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if ((*length) == (*size)) {
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		*array = g_renew (gint, *array, *size);
#line 2636 "TeeJee.Process.c"
	}
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	(*array)[(*length)++] = value;
#line 2640 "TeeJee.Process.c"
}


gint* tee_jee_process_helper_get_process_children (GPid parent_pid, int* result_length1) {
	gint* result = NULL;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	GPid _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint pid = 0;
	gint* procList = NULL;
	gint* _tmp5_;
	gint procList_length1;
	gint _procList_size_;
	gchar** arr = NULL;
	gint arr_length1 = 0;
	gint _arr_size_ = 0;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint* _tmp22_;
	gint _tmp22__length1;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = parent_pid;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("ps --ppid %d", (gint) _tmp0_);
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp2_, &_tmp3_, &_tmp4_);
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_out = _tmp3_;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_err = _tmp4_;
#line 421 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp5_ = g_new0 (gint, 0);
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	procList = _tmp5_;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	procList_length1 = 0;
#line 424 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_procList_size_ = procList_length1;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp6_ = std_out;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "\n", 0);
#line 2696 "TeeJee.Process.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		line_collection = _tmp8_;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		line_collection_length1 = _vala_array_length (_tmp7_);
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp7_); line_it = line_it + 1) {
#line 2708 "TeeJee.Process.c"
			gchar* _tmp9_;
			gchar* line = NULL;
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp9_ = g_strdup (line_collection[line_it]);
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			line = _tmp9_;
#line 2715 "TeeJee.Process.c"
			{
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar** _tmp13_;
				gchar** _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp10_ = line;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp11_ = string_strip (_tmp10_);
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp12_ = _tmp11_;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, " ", 0);
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				arr = _tmp14_;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				arr_length1 = _vala_array_length (_tmp13_);
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_arr_size_ = arr_length1;
#line 428 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_free0 (_tmp12_);
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp15_ = arr;
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp15__length1 = arr_length1;
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp15__length1 < 1) {
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					continue;
#line 2757 "TeeJee.Process.c"
				}
#line 431 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				pid = 0;
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp16_ = arr;
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp16__length1 = arr_length1;
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp17_ = _tmp16_[0];
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp18_ = atoi (_tmp17_);
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				pid = _tmp18_;
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp19_ = pid;
#line 434 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp19_ != 0) {
#line 2775 "TeeJee.Process.c"
					gint* _tmp20_;
					gint _tmp20__length1;
					gint _tmp21_;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp20_ = procList;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp20__length1 = procList_length1;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp21_ = pid;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_vala_array_add3 (&procList, &procList_length1, &_procList_size_, _tmp21_);
#line 2787 "TeeJee.Process.c"
				}
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 2791 "TeeJee.Process.c"
			}
		}
#line 427 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2796 "TeeJee.Process.c"
	}
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp22_ = procList;
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp22__length1 = procList_length1;
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (result_length1) {
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		*result_length1 = _tmp22__length1;
#line 2806 "TeeJee.Process.c"
	}
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp22_;
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 438 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 2818 "TeeJee.Process.c"
}


void tee_jee_process_helper_process_quit (GPid process_pid, gboolean killChildren) {
	gint* child_pids = NULL;
	GPid _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint child_pids_length1;
	gint _child_pids_size_;
	GPid _tmp3_;
	gboolean _tmp4_;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = process_pid;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_get_process_children (_tmp0_, &_tmp1_);
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	child_pids = _tmp2_;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	child_pids_length1 = _tmp1_;
#line 449 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_child_pids_size_ = child_pids_length1;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = process_pid;
#line 450 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	kill ((pid_t) _tmp3_, SIGTERM);
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = killChildren;
#line 452 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp4_) {
#line 2849 "TeeJee.Process.c"
		GPid childPid = 0;
		gint* _tmp5_;
		gint _tmp5__length1;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5_ = child_pids;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5__length1 = child_pids_length1;
#line 2857 "TeeJee.Process.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			pid_collection = _tmp5_;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			pid_collection_length1 = _tmp5__length1;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			for (pid_it = 0; pid_it < _tmp5__length1; pid_it = pid_it + 1) {
#line 2869 "TeeJee.Process.c"
				glong pid = 0L;
#line 454 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				pid = (glong) pid_collection[pid_it];
#line 2873 "TeeJee.Process.c"
				{
					glong _tmp6_;
					GPid _tmp7_;
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp6_ = pid;
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					childPid = (GPid) _tmp6_;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp7_ = childPid;
#line 456 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					kill ((pid_t) _tmp7_, SIGTERM);
#line 2885 "TeeJee.Process.c"
				}
			}
		}
	}
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	child_pids = (g_free (child_pids), NULL);
#line 2892 "TeeJee.Process.c"
}


void tee_jee_process_helper_process_kill (GPid process_pid, gboolean killChildren) {
	gint* child_pids = NULL;
	GPid _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint child_pids_length1;
	gint _child_pids_size_;
	GPid _tmp3_;
	gboolean _tmp4_;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = process_pid;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_get_process_children (_tmp0_, &_tmp1_);
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	child_pids = _tmp2_;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	child_pids_length1 = _tmp1_;
#line 468 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_child_pids_size_ = child_pids_length1;
#line 469 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = process_pid;
#line 469 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	kill ((pid_t) _tmp3_, SIGKILL);
#line 471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = killChildren;
#line 471 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp4_) {
#line 2923 "TeeJee.Process.c"
		GPid childPid = 0;
		gint* _tmp5_;
		gint _tmp5__length1;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5_ = child_pids;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp5__length1 = child_pids_length1;
#line 2931 "TeeJee.Process.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			pid_collection = _tmp5_;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			pid_collection_length1 = _tmp5__length1;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			for (pid_it = 0; pid_it < _tmp5__length1; pid_it = pid_it + 1) {
#line 2943 "TeeJee.Process.c"
				glong pid = 0L;
#line 473 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				pid = (glong) pid_collection[pid_it];
#line 2947 "TeeJee.Process.c"
				{
					glong _tmp6_;
					GPid _tmp7_;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp6_ = pid;
#line 474 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					childPid = (GPid) _tmp6_;
#line 475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp7_ = childPid;
#line 475 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					kill ((pid_t) _tmp7_, SIGKILL);
#line 2959 "TeeJee.Process.c"
				}
			}
		}
	}
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	child_pids = (g_free (child_pids), NULL);
#line 2966 "TeeJee.Process.c"
}


gint tee_jee_process_helper_process_pause (GPid procID) {
	gint result = 0;
	GPid _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = procID;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("kill -STOP %d", (gint) _tmp0_);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = tee_jee_process_helper_exec_sync (_tmp2_, NULL, NULL);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp4_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 2993 "TeeJee.Process.c"
}


gint tee_jee_process_helper_process_resume (GPid procID) {
	gint result = 0;
	GPid _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = procID;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("kill -CONT %d", (gint) _tmp0_);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp3_ = tee_jee_process_helper_exec_sync (_tmp2_, NULL, NULL);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp4_;
#line 493 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 3020 "TeeJee.Process.c"
}


static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1019 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1019 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = needle;
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = strstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1022 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1022 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 3047 "TeeJee.Process.c"
		gchar* _tmp4_;
#line 1023 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1023 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1023 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 3055 "TeeJee.Process.c"
	} else {
#line 1025 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = -1;
#line 1025 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 3061 "TeeJee.Process.c"
	}
}


void tee_jee_process_helper_process_quit_by_name (const gchar* cmd_name, const gchar* cmd_to_match, gboolean exact_match) {
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* pid = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_if_fail (cmd_name != NULL);
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	g_return_if_fail (cmd_to_match != NULL);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = cmd_name;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup_printf ("ps w -C '%s'", _tmp0_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp2_, &_tmp3_, &_tmp4_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_out = _tmp3_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	std_err = _tmp4_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp5_ = g_strdup ("");
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	pid = _tmp5_;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp6_ = std_out;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "\n", 0);
#line 3109 "TeeJee.Process.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		line_collection = _tmp8_;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		line_collection_length1 = _vala_array_length (_tmp7_);
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp7_); line_it = line_it + 1) {
#line 3121 "TeeJee.Process.c"
			gchar* _tmp9_;
			gchar* line = NULL;
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			_tmp9_ = g_strdup (line_collection[line_it]);
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
			line = _tmp9_;
#line 3128 "TeeJee.Process.c"
			{
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_tmp12_ = exact_match;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp12_) {
#line 3137 "TeeJee.Process.c"
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gboolean _tmp17_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp13_ = line;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp14_ = cmd_to_match;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp15_ = g_strconcat (" ", _tmp14_, NULL);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp16_ = _tmp15_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp17_ = g_str_has_suffix (_tmp13_, _tmp16_);
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp11_ = _tmp17_;
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp16_);
#line 3157 "TeeJee.Process.c"
				} else {
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp11_ = FALSE;
#line 3161 "TeeJee.Process.c"
				}
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp11_) {
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp10_ = TRUE;
#line 3167 "TeeJee.Process.c"
				} else {
					gboolean _tmp18_ = FALSE;
					gboolean _tmp19_;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp19_ = exact_match;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					if (!_tmp19_) {
#line 3175 "TeeJee.Process.c"
						const gchar* _tmp20_;
						const gchar* _tmp21_;
						gint _tmp22_;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp20_ = line;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp21_ = cmd_to_match;
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp22_ = string_index_of (_tmp20_, _tmp21_, 0);
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp18_ = _tmp22_ != -1;
#line 3187 "TeeJee.Process.c"
					} else {
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
						_tmp18_ = FALSE;
#line 3191 "TeeJee.Process.c"
					}
#line 508 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp10_ = _tmp18_;
#line 3195 "TeeJee.Process.c"
				}
#line 507 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				if (_tmp10_) {
#line 3199 "TeeJee.Process.c"
					const gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar** _tmp26_;
					gchar** _tmp27_;
					gchar** _tmp28_;
					gint _tmp28__length1;
					const gchar* _tmp29_;
					gchar* _tmp30_;
					const gchar* _tmp31_;
					gint _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					const gchar* _tmp35_;
					gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp23_ = line;
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp24_ = string_strip (_tmp23_);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp25_ = _tmp24_;
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, " ", 0);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp28_ = _tmp27_;
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp28__length1 = _vala_array_length (_tmp26_);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp29_ = _tmp28_[0];
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp30_ = g_strdup (_tmp29_);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (pid);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					pid = _tmp30_;
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp25_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp31_ = pid;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp32_ = atoi (_tmp31_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					kill ((pid_t) ((GPid) _tmp32_), 15);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp33_ = g_strconcat (_ ("Stopped"), ": [PID=", NULL);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp34_ = _tmp33_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp35_ = pid;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp36_ = g_strconcat (_tmp34_, _tmp35_, NULL);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp37_ = _tmp36_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp38_ = g_strconcat (_tmp37_, "] ", NULL);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_tmp39_ = _tmp38_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					tee_jee_logging_log_debug (_tmp39_);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp39_);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp37_);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
					_g_free0 (_tmp34_);
#line 3270 "TeeJee.Process.c"
				}
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 3274 "TeeJee.Process.c"
			}
		}
#line 506 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3279 "TeeJee.Process.c"
	}
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (pid);
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 3287 "TeeJee.Process.c"
}


void tee_jee_process_helper_process_set_priority (GPid procID, gint prio) {
	GPid _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = procID;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = getpriority (PRIO_PROCESS, (gint) _tmp0_);
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp2_ = prio;
#line 522 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	if (_tmp1_ != _tmp2_) {
#line 3303 "TeeJee.Process.c"
		GPid _tmp3_;
		gint _tmp4_;
#line 523 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp3_ = procID;
#line 523 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		_tmp4_ = prio;
#line 523 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
		setpriority (PRIO_PROCESS, (gint) _tmp3_, _tmp4_);
#line 3312 "TeeJee.Process.c"
	}
}


gint tee_jee_process_helper_process_get_priority (GPid procID) {
	gint result = 0;
	GPid _tmp0_;
	gint _tmp1_;
#line 530 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = procID;
#line 530 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp1_ = getpriority (PRIO_PROCESS, (gint) _tmp0_);
#line 530 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	result = _tmp1_;
#line 530 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	return result;
#line 3329 "TeeJee.Process.c"
}


void tee_jee_process_helper_process_set_priority_normal (GPid procID) {
	GPid _tmp0_;
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = procID;
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_process_set_priority (_tmp0_, 0);
#line 3339 "TeeJee.Process.c"
}


void tee_jee_process_helper_process_set_priority_low (GPid procID) {
	GPid _tmp0_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	_tmp0_ = procID;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/TeeJee.Process.vala"
	tee_jee_process_helper_process_set_priority (_tmp0_, 5);
#line 3349 "TeeJee.Process.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



