/* FileItem.c generated by valac 0.38.10, the Vala compiler
 * generated from FileItem.vala, do not modify */

/*
 * FileItem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_FILE_ITEM (file_item_get_type ())
#define FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ITEM, FileItem))
#define FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_ITEM, FileItemClass))
#define IS_FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ITEM))
#define IS_FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_ITEM))
#define FILE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_ITEM, FileItemClass))

typedef struct _FileItem FileItem;
typedef struct _FileItemClass FileItemClass;
typedef struct _FileItemPrivate FileItemPrivate;
enum  {
	FILE_ITEM_0_PROPERTY,
	FILE_ITEM_SIZE_PROPERTY,
	FILE_ITEM_SIZE_COMPRESSED_PROPERTY,
	FILE_ITEM_NUM_PROPERTIES
};
static GParamSpec* file_item_properties[FILE_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_ARCHIVE_FILE (archive_file_get_type ())
#define ARCHIVE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARCHIVE_FILE, ArchiveFile))
#define ARCHIVE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARCHIVE_FILE, ArchiveFileClass))
#define IS_ARCHIVE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARCHIVE_FILE))
#define IS_ARCHIVE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARCHIVE_FILE))
#define ARCHIVE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARCHIVE_FILE, ArchiveFileClass))

typedef struct _ArchiveFile ArchiveFile;
typedef struct _ArchiveFileClass ArchiveFileClass;

struct _FileItem {
	GObject parent_instance;
	FileItemPrivate * priv;
	gchar* file_name;
	gchar* file_location;
	gchar* file_path;
	gchar* file_path_prefix;
	GFileType file_type;
	GDateTime* modified;
	gchar* permissions;
	gchar* owner_user;
	gchar* owner_group;
	gchar* content_type;
	gchar* file_status;
	gboolean is_selected;
	gboolean is_symlink;
	gchar* symlink_target;
	gboolean is_archive;
	gboolean is_stale;
	FileItem* parent;
	GeeHashMap* children;
	FileItem* source_archive;
	GObject* tag;
	glong file_count;
	glong dir_count;
	glong file_count_total;
	glong dir_count_total;
	GIcon* icon;
	gboolean is_dummy;
};

struct _FileItemClass {
	GObjectClass parent_class;
};

struct _FileItemPrivate {
	gint64 _size;
	gint64 _size_compressed;
};


static gpointer file_item_parent_class = NULL;
extern gchar** file_item_archive_extensions;
extern gint file_item_archive_extensions_length1;
gchar** file_item_archive_extensions = NULL;
gint file_item_archive_extensions_length1 = 0;
static GeeComparableIface * file_item_gee_comparable_parent_iface = NULL;

GType file_item_get_type (void) G_GNUC_CONST;
#define FILE_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILE_ITEM, FileItemPrivate))
FileItem* file_item_new (const gchar* name);
FileItem* file_item_construct (GType object_type, const gchar* name);
FileItem* file_item_new_dummy (GFileType _file_type);
FileItem* file_item_construct_dummy (GType object_type, GFileType _file_type);
FileItem* file_item_new_dummy_root (void);
FileItem* file_item_construct_dummy_root (GType object_type);
FileItem* file_item_new_from_disk_path_with_basic_info (const gchar* _file_path);
FileItem* file_item_construct_from_disk_path_with_basic_info (GType object_type, const gchar* _file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
void file_item_query_file_info_basic (FileItem* self);
FileItem* file_item_new_from_path_and_type (const gchar* _file_path, GFileType _file_type);
FileItem* file_item_construct_from_path_and_type (GType object_type, const gchar* _file_path, GFileType _file_type);
static gint file_item_real_compare_to (GeeComparable* base, FileItem* b);
FileItem* file_item_add_child_from_disk (FileItem* self, const gchar* item_file_path, gint depth);
FileItem* file_item_add_child (FileItem* self, const gchar* item_file_path, GFileType item_file_type, gint64 item_size, gint64 item_size_compressed, gboolean item_query_file_info);
void tee_jee_logging_log_error (const gchar* message, gboolean highlight, gboolean is_warning);
FileItem* file_item_add_descendant (FileItem* self, const gchar* _file_path, GFileType* _file_type, gint64 item_size, gint64 item_size_compressed);
ArchiveFile* archive_file_new (const gchar* archive_file_path);
ArchiveFile* archive_file_construct (GType object_type, const gchar* archive_file_path);
GType archive_file_get_type (void) G_GNUC_CONST;
void file_item_query_file_info (FileItem* self);
void file_item_query_children (FileItem* self, gint depth);
void file_item_clear_children (FileItem* self);
FileItem* file_item_remove_child (FileItem* self, const gchar* child_name);
gint64 file_item_get_size (FileItem* self);
gint64 file_item_get_size_compressed (FileItem* self);
FileItem* file_item_find_descendant (FileItem* self, const gchar* path);
void file_item_set_file_path_prefix (FileItem* self, const gchar* prefix);
void file_item_print (FileItem* self, gint level);
GeeArrayList* file_item_get_children_sorted (FileItem* self);
static gint __lambda7_ (FileItem* self, FileItem* a, FileItem* b);
static gint ___lambda7__gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self);
GdkPixbuf* file_item_get_icon (FileItem* self, gint icon_size, gboolean add_transparency, gboolean add_emblems);
GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon, gint icon_size);
GdkPixbuf* icon_manager_lookup (const gchar* icon_name, gint icon_size, gboolean symbolic, gboolean use_hardcoded, gint scale);
static void file_item_finalize (GObject * obj);
static void _vala_file_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


FileItem* file_item_construct (GType object_type, const gchar* name) {
	FileItem * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 99 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 99 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = name;
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 100 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_name = _tmp1_;
#line 99 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return self;
#line 181 "FileItem.c"
}


FileItem* file_item_new (const gchar* name) {
#line 99 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return file_item_construct (TYPE_FILE_ITEM, name);
#line 188 "FileItem.c"
}


FileItem* file_item_construct_dummy (GType object_type, GFileType _file_type) {
	FileItem * self = NULL;
	GFileType _tmp0_;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 104 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->is_dummy = TRUE;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = _file_type;
#line 105 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_type = _tmp0_;
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return self;
#line 205 "FileItem.c"
}


FileItem* file_item_new_dummy (GFileType _file_type) {
#line 103 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return file_item_construct_dummy (TYPE_FILE_ITEM, _file_type);
#line 212 "FileItem.c"
}


FileItem* file_item_construct_dummy_root (GType object_type) {
	FileItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = g_strdup ("dummy");
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 109 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup ("");
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 110 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_location = _tmp1_;
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return self;
#line 236 "FileItem.c"
}


FileItem* file_item_new_dummy_root (void) {
#line 108 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return file_item_construct_dummy_root (TYPE_FILE_ITEM);
#line 243 "FileItem.c"
}


FileItem* file_item_construct_from_disk_path_with_basic_info (GType object_type, const gchar* _file_path) {
	FileItem * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = _file_path;
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 114 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_path = _tmp1_;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = _file_path;
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = tee_jee_file_system_file_basename (_tmp2_);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 115 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_name = _tmp3_;
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = _file_path;
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp5_ = tee_jee_file_system_file_parent (_tmp4_);
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 116 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_location = _tmp5_;
#line 117 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	file_item_query_file_info_basic (self);
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return self;
#line 287 "FileItem.c"
}


FileItem* file_item_new_from_disk_path_with_basic_info (const gchar* _file_path) {
#line 113 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return file_item_construct_from_disk_path_with_basic_info (TYPE_FILE_ITEM, _file_path);
#line 294 "FileItem.c"
}


FileItem* file_item_construct_from_path_and_type (GType object_type, const gchar* _file_path, GFileType _file_type) {
	FileItem * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GFileType _tmp6_;
#line 120 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 120 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = _file_path;
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 121 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_path = _tmp1_;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = _file_path;
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = tee_jee_file_system_file_basename (_tmp2_);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 122 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_name = _tmp3_;
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = _file_path;
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp5_ = tee_jee_file_system_file_parent (_tmp4_);
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 123 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_location = _tmp5_;
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp6_ = _file_type;
#line 124 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_type = _tmp6_;
#line 120 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return self;
#line 341 "FileItem.c"
}


FileItem* file_item_new_from_path_and_type (const gchar* _file_path, GFileType _file_type) {
#line 120 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return file_item_construct_from_path_and_type (TYPE_FILE_ITEM, _file_path, _file_type);
#line 348 "FileItem.c"
}


static gint file_item_real_compare_to (GeeComparable* base, FileItem* b) {
	FileItem * self;
	gint result = 0;
	GFileType _tmp0_;
	FileItem* _tmp1_;
	GFileType _tmp2_;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = (FileItem*) base;
#line 143 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->file_type;
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = b;
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = _tmp1_->file_type;
#line 144 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp0_ != _tmp2_) {
#line 370 "FileItem.c"
		GFileType _tmp3_;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = self->file_type;
#line 145 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp3_ == G_FILE_TYPE_DIRECTORY) {
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			result = -1;
#line 146 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			return result;
#line 380 "FileItem.c"
		} else {
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			result = 1;
#line 149 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			return result;
#line 386 "FileItem.c"
		}
	} else {
		GCompareFunc _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		FileItem* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp4_ = g_strcmp0;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp5_ = self->file_name;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) -1);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp7_ = _tmp6_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp8_ = b;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp9_ = _tmp8_->file_name;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp11_ = _tmp10_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp12_ = _tmp4_ (_tmp7_, _tmp11_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp13_ = _tmp12_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_free0 (_tmp11_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_free0 (_tmp7_);
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		result = _tmp13_;
#line 154 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return result;
#line 427 "FileItem.c"
	}
}


FileItem* file_item_add_child_from_disk (FileItem* self, const gchar* item_file_path, gint depth) {
	FileItem* result = NULL;
	FileItem* item = NULL;
	GError * _inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (item_file_path != NULL, NULL);
#line 165 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	item = NULL;
#line 442 "FileItem.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp0_ = item_file_path;
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 172 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		file = _tmp1_;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = file;
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 174 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp3_) {
#line 463 "FileItem.c"
			GFileType item_file_type = 0;
			GFile* _tmp4_;
			GFileType _tmp5_;
			const gchar* _tmp6_;
			GFileType _tmp7_;
			FileItem* _tmp8_;
			gboolean _tmp9_ = FALSE;
			FileItem* _tmp10_;
			GFileType _tmp11_;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = file;
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp5_ = g_file_query_file_type (_tmp4_, G_FILE_QUERY_INFO_NONE, NULL);
#line 177 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			item_file_type = _tmp5_;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp6_ = item_file_path;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp7_ = item_file_type;
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = file_item_add_child (self, _tmp6_, _tmp7_, (gint64) 0, (gint64) 0, TRUE);
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (item);
#line 180 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			item = _tmp8_;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = item;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = _tmp10_->file_type;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (_tmp11_ == G_FILE_TYPE_DIRECTORY) {
#line 495 "FileItem.c"
				FileItem* _tmp12_;
				gboolean _tmp13_;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp12_ = item;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp13_ = _tmp12_->is_symlink;
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp9_ = !_tmp13_;
#line 504 "FileItem.c"
			} else {
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp9_ = FALSE;
#line 508 "FileItem.c"
			}
#line 182 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (_tmp9_) {
#line 512 "FileItem.c"
				gint _tmp14_;
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp14_ = depth;
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (_tmp14_ != 0) {
#line 518 "FileItem.c"
					GFileEnumerator* _tmp15_ = NULL;
					GFile* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					GFileEnumerator* _tmp19_;
					GFileEnumerator* _tmp20_;
					GFileEnumerator* _tmp21_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp16_ = file;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp17_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp18_ = _tmp17_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp19_ = g_file_enumerate_children (_tmp16_, _tmp18_, 0, NULL, &_inner_error_);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp20_ = _tmp19_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_free0 (_tmp18_);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp15_ = _tmp20_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_object_unref0 (file);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_object_unref0 (info);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_object_unref0 (enumerator);
#line 548 "FileItem.c"
						goto __catch49_g_error;
					}
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp21_ = _tmp15_;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp15_ = NULL;
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (enumerator);
#line 185 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					enumerator = _tmp21_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					while (TRUE) {
#line 561 "FileItem.c"
						GFileInfo* _tmp22_ = NULL;
						GFileEnumerator* _tmp23_;
						GFileInfo* _tmp24_;
						GFileInfo* _tmp25_;
						GFileInfo* _tmp26_;
						gchar* child_path = NULL;
						const gchar* _tmp27_;
						GFileInfo* _tmp28_;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						FileItem* _tmp31_;
						const gchar* _tmp32_;
						gint _tmp33_;
						FileItem* _tmp34_;
						FileItem* _tmp35_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp23_ = enumerator;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp24_ = g_file_enumerator_next_file (_tmp23_, NULL, &_inner_error_);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp22_ = _tmp24_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
							_g_object_unref0 (_tmp15_);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
							_g_object_unref0 (file);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
							_g_object_unref0 (info);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
							_g_object_unref0 (enumerator);
#line 593 "FileItem.c"
							goto __catch49_g_error;
						}
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp25_ = _tmp22_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp22_ = NULL;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_object_unref0 (info);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						info = _tmp25_;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp26_ = info;
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						if (!(_tmp26_ != NULL)) {
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
							_g_object_unref0 (_tmp22_);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
							break;
#line 612 "FileItem.c"
						}
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp27_ = item_file_path;
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp28_ = info;
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp29_ = g_file_info_get_name (_tmp28_);
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp30_ = g_strdup_printf ("%s/%s", _tmp27_, _tmp29_);
#line 187 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						child_path = _tmp30_;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp31_ = item;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp32_ = child_path;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp33_ = depth;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp34_ = file_item_add_child_from_disk (_tmp31_, _tmp32_, _tmp33_ - 1);
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp35_ = _tmp34_;
#line 188 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_object_unref0 (_tmp35_);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_free0 (child_path);
#line 186 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_object_unref0 (_tmp22_);
#line 640 "FileItem.c"
					}
#line 183 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (_tmp15_);
#line 644 "FileItem.c"
				}
			}
		}
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (enumerator);
#line 654 "FileItem.c"
	}
	goto __finally49;
	__catch49_g_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		e = _inner_error_;
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_inner_error_ = NULL;
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp36_ = e;
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp37_ = _tmp36_->message;
#line 195 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp37_, FALSE, FALSE);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_error_free0 (e);
#line 674 "FileItem.c"
	}
	__finally49:
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (item);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_clear_error (&_inner_error_);
#line 169 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return NULL;
#line 687 "FileItem.c"
	}
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = item;
#line 198 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 693 "FileItem.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1242 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1243 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1244 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1245 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 716 "FileItem.c"
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_;
	glong _tmp16_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	gchar* _tmp21_;
#line 1363 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1364 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1365 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1365 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 749 "FileItem.c"
		glong _tmp3_;
		glong _tmp4_;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1366 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 758 "FileItem.c"
	}
#line 1368 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1368 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 764 "FileItem.c"
		glong _tmp6_;
		glong _tmp7_;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1369 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 773 "FileItem.c"
	}
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 779 "FileItem.c"
		glong _tmp10_;
		glong _tmp11_;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 788 "FileItem.c"
	} else {
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 792 "FileItem.c"
	}
#line 1371 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp8_, NULL);
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp13_ = end;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp13_ >= ((glong) 0)) {
#line 800 "FileItem.c"
		glong _tmp14_;
		glong _tmp15_;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = end;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = _tmp14_ <= _tmp15_;
#line 809 "FileItem.c"
	} else {
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = FALSE;
#line 813 "FileItem.c"
	}
#line 1372 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp16_ = start;
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp17_ = end;
#line 1373 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp21_;
#line 1374 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 835 "FileItem.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 842 "FileItem.c"
}


FileItem* file_item_add_descendant (FileItem* self, const gchar* _file_path, GFileType* _file_type, gint64 item_size, gint64 item_size_compressed) {
	FileItem* result = NULL;
	gchar* item_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFileType _tmp2_ = 0;
	GFileType* _tmp3_;
	GFileType item_type = 0;
	const gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp12_;
	gboolean _tmp13_;
	gchar* dir_name = NULL;
	gchar* _tmp19_;
	gchar* dir_path = NULL;
	gchar* _tmp20_;
	FileItem* current_dir = NULL;
	FileItem* _tmp21_;
	gchar** arr = NULL;
	const gchar* _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gint arr_length1;
	gint _arr_size_;
	gchar* item_name = NULL;
	gchar** _tmp60_;
	gint _tmp60__length1;
	gchar** _tmp61_;
	gint _tmp61__length1;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	FileItem* _tmp64_;
	GeeHashMap* _tmp65_;
	GeeSet* _tmp66_;
	GeeSet* _tmp67_;
	GeeSet* _tmp68_;
	const gchar* _tmp69_;
	gboolean _tmp70_;
	gboolean _tmp71_;
	FileItem* _tmp79_;
	GeeHashMap* _tmp80_;
	const gchar* _tmp81_;
	gpointer _tmp82_;
#line 201 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = _file_path;
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 209 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	item_path = _tmp1_;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = _file_type;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp3_ == NULL) {
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = G_FILE_TYPE_REGULAR;
#line 905 "FileItem.c"
	} else {
		GFileType* _tmp4_;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp4_ = _file_type;
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = *_tmp4_;
#line 912 "FileItem.c"
	}
#line 210 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	item_type = _tmp2_;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp5_ = item_path;
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp6_ = g_str_has_suffix (_tmp5_, "/");
#line 212 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp6_) {
#line 922 "FileItem.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp7_ = item_path;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp8_ = item_path;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp9_ = strlen (_tmp8_);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp10_ = _tmp9_;
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp11_ = string_slice (_tmp7_, (glong) 0, (glong) (_tmp10_ - 1));
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_free0 (item_path);
#line 213 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		item_path = _tmp11_;
#line 214 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		item_type = G_FILE_TYPE_DIRECTORY;
#line 944 "FileItem.c"
	}
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp12_ = item_path;
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp13_ = g_str_has_prefix (_tmp12_, "/");
#line 217 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp13_) {
#line 952 "FileItem.c"
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp14_ = item_path;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp15_ = item_path;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp16_ = strlen (_tmp15_);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp17_ = _tmp16_;
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp18_ = string_slice (_tmp14_, (glong) 1, (glong) _tmp17_);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_free0 (item_path);
#line 218 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		item_path = _tmp18_;
#line 972 "FileItem.c"
	}
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp19_ = g_strdup ("");
#line 221 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	dir_name = _tmp19_;
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp20_ = g_strdup ("");
#line 222 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	dir_path = _tmp20_;
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp21_ = _g_object_ref0 (self);
#line 225 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	current_dir = _tmp21_;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp22_ = item_path;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp24_ = _tmp23_ = g_strsplit (_tmp22_, "/", 0);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	arr = _tmp24_;
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	arr_length1 = _vala_array_length (_tmp23_);
#line 226 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_arr_size_ = arr_length1;
#line 996 "FileItem.c"
	{
		gint i = 0;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		i = 0;
#line 1001 "FileItem.c"
		{
			gboolean _tmp25_ = FALSE;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp25_ = TRUE;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			while (TRUE) {
#line 1008 "FileItem.c"
				gint _tmp27_;
				gchar** _tmp28_;
				gint _tmp28__length1;
				gchar** _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				const gchar* _tmp31_;
				gchar* _tmp32_;
				FileItem* _tmp33_;
				GeeHashMap* _tmp34_;
				GeeSet* _tmp35_;
				GeeSet* _tmp36_;
				GeeSet* _tmp37_;
				const gchar* _tmp38_;
				gboolean _tmp39_;
				gboolean _tmp40_;
				FileItem* _tmp56_;
				GeeHashMap* _tmp57_;
				const gchar* _tmp58_;
				gpointer _tmp59_;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (!_tmp25_) {
#line 1031 "FileItem.c"
					gint _tmp26_;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp26_ = i;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					i = _tmp26_ + 1;
#line 1037 "FileItem.c"
				}
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp25_ = FALSE;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp27_ = i;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp28_ = arr;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp28__length1 = arr_length1;
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (!(_tmp27_ < (_tmp28__length1 - 1))) {
#line 227 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					break;
#line 1051 "FileItem.c"
				}
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp29_ = arr;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp29__length1 = arr_length1;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp30_ = i;
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp31_ = _tmp29_[_tmp30_];
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp32_ = g_strdup (_tmp31_);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (dir_name);
#line 229 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				dir_name = _tmp32_;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp33_ = current_dir;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp34_ = _tmp33_->children;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp35_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp34_);
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp36_ = _tmp35_;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp37_ = _tmp36_;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp38_ = dir_name;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp39_ = gee_collection_contains ((GeeCollection*) _tmp37_, _tmp38_);
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp40_ = !_tmp39_;
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_tmp37_);
#line 232 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (_tmp40_) {
#line 1087 "FileItem.c"
					gboolean _tmp41_ = FALSE;
					FileItem* _tmp42_;
					const gchar* _tmp49_;
					const gchar* _tmp50_;
					gchar* _tmp51_;
					FileItem* _tmp52_;
					const gchar* _tmp53_;
					FileItem* _tmp54_;
					FileItem* _tmp55_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp42_ = current_dir;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (_tmp42_ == self) {
#line 1101 "FileItem.c"
						FileItem* _tmp43_;
						gboolean _tmp44_;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp43_ = current_dir;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp44_ = _tmp43_->is_archive;
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp41_ = _tmp44_;
#line 1110 "FileItem.c"
					} else {
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp41_ = FALSE;
#line 1114 "FileItem.c"
					}
#line 233 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (_tmp41_) {
#line 1118 "FileItem.c"
						gchar* _tmp45_;
#line 234 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp45_ = g_strdup ("");
#line 234 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_free0 (dir_path);
#line 234 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						dir_path = _tmp45_;
#line 1126 "FileItem.c"
					} else {
						FileItem* _tmp46_;
						const gchar* _tmp47_;
						gchar* _tmp48_;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp46_ = current_dir;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp47_ = _tmp46_->file_path;
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp48_ = g_strconcat (_tmp47_, "/", NULL);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_free0 (dir_path);
#line 237 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						dir_path = _tmp48_;
#line 1141 "FileItem.c"
					}
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp49_ = dir_path;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp50_ = dir_name;
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp51_ = g_strdup_printf ("%s%s", _tmp49_, _tmp50_);
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_free0 (dir_path);
#line 239 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					dir_path = _tmp51_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp52_ = current_dir;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp53_ = dir_path;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp54_ = file_item_add_child (_tmp52_, _tmp53_, G_FILE_TYPE_DIRECTORY, (gint64) 0, (gint64) 0, FALSE);
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp55_ = _tmp54_;
#line 240 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (_tmp55_);
#line 1163 "FileItem.c"
				}
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp56_ = current_dir;
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp57_ = _tmp56_->children;
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp58_ = dir_name;
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp59_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp57_, _tmp58_);
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (current_dir);
#line 243 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				current_dir = (FileItem*) _tmp59_;
#line 1177 "FileItem.c"
			}
		}
	}
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp60_ = arr;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp60__length1 = arr_length1;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp61_ = arr;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp61__length1 = arr_length1;
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp62_ = _tmp60_[_tmp61__length1 - 1];
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp63_ = g_strdup (_tmp62_);
#line 247 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	item_name = _tmp63_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp64_ = current_dir;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp65_ = _tmp64_->children;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp66_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp65_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp67_ = _tmp66_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp68_ = _tmp67_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp69_ = item_name;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp70_ = gee_collection_contains ((GeeCollection*) _tmp68_, _tmp69_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp71_ = !_tmp70_;
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (_tmp68_);
#line 250 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp71_) {
#line 1215 "FileItem.c"
		FileItem* _tmp72_;
		const gchar* _tmp73_;
		GFileType _tmp74_;
		gint64 _tmp75_;
		gint64 _tmp76_;
		FileItem* _tmp77_;
		FileItem* _tmp78_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp72_ = current_dir;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp73_ = item_path;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp74_ = item_type;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp75_ = item_size;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp76_ = item_size_compressed;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp77_ = file_item_add_child (_tmp72_, _tmp73_, _tmp74_, _tmp75_, _tmp76_, FALSE);
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp78_ = _tmp77_;
#line 254 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_tmp78_);
#line 1239 "FileItem.c"
	}
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp79_ = current_dir;
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp80_ = _tmp79_->children;
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp81_ = item_name;
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp82_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp80_, _tmp81_);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = (FileItem*) _tmp82_;
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (item_name);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (current_dir);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (dir_path);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (dir_name);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (item_path);
#line 260 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 1265 "FileItem.c"
}


FileItem* file_item_add_child (FileItem* self, const gchar* item_file_path, GFileType item_file_type, gint64 item_size, gint64 item_size_compressed, gboolean item_query_file_info) {
	FileItem* result = NULL;
	FileItem* item = NULL;
	const gchar* _tmp0_;
	GFileType _tmp1_;
	FileItem* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gboolean existing_file = FALSE;
	GeeHashMap* _tmp11_;
	FileItem* _tmp12_;
	const gchar* _tmp13_;
	gboolean _tmp14_;
	FileItem* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gboolean _tmp29_;
	GFileType _tmp31_;
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (item_file_path != NULL, NULL);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = item_file_path;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = item_file_type;
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = file_item_new_from_path_and_type (_tmp0_, _tmp1_);
#line 274 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	item = _tmp2_;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = file_item_archive_extensions;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3__length1 = file_item_archive_extensions_length1;
#line 1303 "FileItem.c"
	{
		gchar** ext_collection = NULL;
		gint ext_collection_length1 = 0;
		gint _ext_collection_size_ = 0;
		gint ext_it = 0;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		ext_collection = _tmp3_;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		ext_collection_length1 = _tmp3__length1;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		for (ext_it = 0; ext_it < _tmp3__length1; ext_it = ext_it + 1) {
#line 1315 "FileItem.c"
			gchar* _tmp4_;
			gchar* ext = NULL;
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = g_strdup (ext_collection[ext_it]);
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			ext = _tmp4_;
#line 1322 "FileItem.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gboolean _tmp7_;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp5_ = item_file_path;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp6_ = ext;
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp7_ = g_str_has_suffix (_tmp5_, _tmp6_);
#line 278 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (_tmp7_) {
#line 1335 "FileItem.c"
					const gchar* _tmp8_;
					ArchiveFile* _tmp9_;
					FileItem* _tmp10_;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp8_ = item_file_path;
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp9_ = archive_file_new (_tmp8_);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (item);
#line 279 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					item = (FileItem*) _tmp9_;
#line 280 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp10_ = item;
#line 280 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp10_->is_archive = TRUE;
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_free0 (ext);
#line 281 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					break;
#line 1355 "FileItem.c"
				}
#line 277 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (ext);
#line 1359 "FileItem.c"
			}
		}
	}
#line 287 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	existing_file = FALSE;
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp11_ = self->children;
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp12_ = item;
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp13_ = _tmp12_->file_name;
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp14_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp11_, _tmp13_);
#line 288 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (!_tmp14_) {
#line 1375 "FileItem.c"
		GeeHashMap* _tmp15_;
		FileItem* _tmp16_;
		const gchar* _tmp17_;
		FileItem* _tmp18_;
		FileItem* _tmp19_;
		FileItem* _tmp20_;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp15_ = self->children;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp16_ = item;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp17_ = _tmp16_->file_name;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp18_ = item;
#line 289 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp17_, _tmp18_);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp19_ = item;
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp20_ = _g_object_ref0 (self);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_tmp19_->parent);
#line 292 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp19_->parent = _tmp20_;
#line 1400 "FileItem.c"
	} else {
		GeeHashMap* _tmp21_;
		FileItem* _tmp22_;
		const gchar* _tmp23_;
		gpointer _tmp24_;
		FileItem* _tmp25_;
#line 295 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		existing_file = TRUE;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp21_ = self->children;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp22_ = item;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp23_ = _tmp22_->file_name;
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp21_, _tmp23_);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (item);
#line 296 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		item = (FileItem*) _tmp24_;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp25_ = item;
#line 299 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp25_->is_stale = FALSE;
#line 1425 "FileItem.c"
	}
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp26_ = item;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp27_ = self->file_path_prefix;
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (_tmp26_->file_path_prefix);
#line 303 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp26_->file_path_prefix = _tmp28_;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp29_ = item_query_file_info;
#line 306 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp29_) {
#line 1441 "FileItem.c"
		FileItem* _tmp30_;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp30_ = item;
#line 308 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		file_item_query_file_info (_tmp30_);
#line 1447 "FileItem.c"
	}
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp31_ = item_file_type;
#line 311 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp31_ == G_FILE_TYPE_REGULAR) {
#line 1453 "FileItem.c"
		gint64 _tmp32_;
		gint64 _tmp35_;
		gboolean _tmp38_;
#line 316 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp32_ = item_size;
#line 316 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp32_ > ((gint64) 0)) {
#line 1461 "FileItem.c"
			FileItem* _tmp33_;
			gint64 _tmp34_;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp33_ = item;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp34_ = item_size;
#line 317 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp33_->priv->_size = _tmp34_;
#line 1470 "FileItem.c"
		}
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp35_ = item_size_compressed;
#line 319 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp35_ > ((gint64) 0)) {
#line 1476 "FileItem.c"
			FileItem* _tmp36_;
			gint64 _tmp37_;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp36_ = item;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp37_ = item_size_compressed;
#line 320 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp36_->priv->_size_compressed = _tmp37_;
#line 1485 "FileItem.c"
		}
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp38_ = existing_file;
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (!_tmp38_) {
#line 1491 "FileItem.c"
			glong _tmp39_;
			glong _tmp40_;
			gint64 _tmp41_;
			gint64 _tmp42_;
			gint64 _tmp43_;
			gint64 _tmp44_;
			FileItem* temp = NULL;
			FileItem* _tmp45_;
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp39_ = self->file_count;
#line 325 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_count = _tmp39_ + 1;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp40_ = self->file_count_total;
#line 326 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_count_total = _tmp40_ + 1;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp41_ = self->priv->_size;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp42_ = item_size;
#line 327 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->priv->_size = _tmp41_ + _tmp42_;
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp43_ = self->priv->_size_compressed;
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp44_ = item_size_compressed;
#line 328 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->priv->_size_compressed = _tmp43_ + _tmp44_;
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp45_ = _g_object_ref0 (self);
#line 331 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			temp = _tmp45_;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			while (TRUE) {
#line 1526 "FileItem.c"
				FileItem* _tmp46_;
				FileItem* _tmp47_;
				FileItem* _tmp48_;
				FileItem* _tmp49_;
				glong _tmp50_;
				FileItem* _tmp51_;
				FileItem* _tmp52_;
				FileItem* _tmp53_;
				FileItem* _tmp54_;
				gint64 _tmp55_;
				gint64 _tmp56_;
				FileItem* _tmp57_;
				FileItem* _tmp58_;
				FileItem* _tmp59_;
				FileItem* _tmp60_;
				gint64 _tmp61_;
				gint64 _tmp62_;
				FileItem* _tmp63_;
				FileItem* _tmp64_;
				FileItem* _tmp65_;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp46_ = temp;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp47_ = _tmp46_->parent;
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (!(_tmp47_ != NULL)) {
#line 332 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					break;
#line 1555 "FileItem.c"
				}
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp48_ = temp;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp49_ = _tmp48_->parent;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp50_ = _tmp49_->file_count_total;
#line 333 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp49_->file_count_total = _tmp50_ + 1;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp51_ = temp;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp52_ = _tmp51_->parent;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp53_ = temp;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp54_ = _tmp53_->parent;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp55_ = _tmp54_->priv->_size;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp56_ = item_size;
#line 334 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp54_->priv->_size = _tmp55_ + _tmp56_;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp57_ = temp;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp58_ = _tmp57_->parent;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp59_ = temp;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp60_ = _tmp59_->parent;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp61_ = _tmp60_->priv->_size_compressed;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp62_ = item_size_compressed;
#line 335 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp60_->priv->_size_compressed = _tmp61_ + _tmp62_;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp63_ = temp;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp64_ = _tmp63_->parent;
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp65_ = _g_object_ref0 (_tmp64_);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 336 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				temp = _tmp65_;
#line 1603 "FileItem.c"
			}
#line 324 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (temp);
#line 1607 "FileItem.c"
		}
	} else {
		GFileType _tmp66_;
#line 340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp66_ = item_file_type;
#line 340 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp66_ == G_FILE_TYPE_DIRECTORY) {
#line 1615 "FileItem.c"
			gboolean _tmp67_;
#line 344 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp67_ = existing_file;
#line 344 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (!_tmp67_) {
#line 1621 "FileItem.c"
				glong _tmp68_;
				glong _tmp69_;
				FileItem* temp = NULL;
				FileItem* _tmp70_;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp68_ = self->dir_count;
#line 347 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->dir_count = _tmp68_ + 1;
#line 348 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp69_ = self->dir_count_total;
#line 348 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->dir_count_total = _tmp69_ + 1;
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp70_ = _g_object_ref0 (self);
#line 353 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				temp = _tmp70_;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				while (TRUE) {
#line 1640 "FileItem.c"
					FileItem* _tmp71_;
					FileItem* _tmp72_;
					FileItem* _tmp73_;
					FileItem* _tmp74_;
					glong _tmp75_;
					FileItem* _tmp76_;
					FileItem* _tmp77_;
					FileItem* _tmp78_;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp71_ = temp;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp72_ = _tmp71_->parent;
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (!(_tmp72_ != NULL)) {
#line 354 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						break;
#line 1657 "FileItem.c"
					}
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp73_ = temp;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp74_ = _tmp73_->parent;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp75_ = _tmp74_->dir_count_total;
#line 355 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp74_->dir_count_total = _tmp75_ + 1;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp76_ = temp;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp77_ = _tmp76_->parent;
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp78_ = _g_object_ref0 (_tmp77_);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (temp);
#line 356 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					temp = _tmp78_;
#line 1677 "FileItem.c"
				}
#line 344 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 1681 "FileItem.c"
			}
		}
	}
#line 364 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = item;
#line 364 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 1689 "FileItem.c"
}


void file_item_query_file_info (FileItem* self) {
	GError * _inner_error_ = NULL;
#line 367 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 1697 "FileItem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_;
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp0_ = self->file_path;
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 371 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		file = _tmp1_;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = file;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp3_) {
#line 1717 "FileItem.c"
			GFileInfo* _tmp4_ = NULL;
			GFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileType item_file_type = 0;
			GFileInfo* _tmp11_;
			GFileType _tmp12_;
			GFileInfo* _tmp13_;
			GIcon* _tmp14_;
			GIcon* _tmp15_;
			GFileType _tmp16_;
			GFileInfo* _tmp22_ = NULL;
			GFile* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			GFileInfo* _tmp26_;
			GFileInfo* _tmp27_;
			GFileInfo* _tmp28_;
			gboolean _tmp29_;
			GFileInfo* _tmp33_;
			GFileType _tmp34_;
			GFileInfo* _tmp35_;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			gboolean _tmp38_ = FALSE;
			gboolean _tmp39_;
			GFileInfo* _tmp43_;
			GTimeVal _tmp44_ = {0};
			GDateTime* _tmp45_;
			GDateTime* _tmp46_;
			GDateTime* _tmp47_;
			GFileInfo* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			GFileInfo* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp5_ = file;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp6_ = g_strdup_printf ("%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_ICON, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp7_ = _tmp6_;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = g_file_query_info (_tmp5_, _tmp7_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp9_ = _tmp8_;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (_tmp7_);
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = _tmp9_;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 1778 "FileItem.c"
				goto __catch50_g_error;
			}
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = _tmp4_;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = NULL;
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 377 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			info = _tmp10_;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = info;
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp12_ = g_file_info_get_file_type (_tmp11_);
#line 383 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			item_file_type = _tmp12_;
#line 385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp13_ = info;
#line 385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp14_ = g_file_info_get_icon (_tmp13_);
#line 385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (self->icon);
#line 385 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->icon = _tmp15_;
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp16_ = item_file_type;
#line 387 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (_tmp16_ == G_FILE_TYPE_SYMBOLIC_LINK) {
#line 1809 "FileItem.c"
				GFileInfo* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 389 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->is_symlink = TRUE;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp17_ = info;
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp18_ = g_file_info_get_symlink_target (_tmp17_);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (self->symlink_target);
#line 390 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->symlink_target = _tmp19_;
#line 1825 "FileItem.c"
			} else {
				gchar* _tmp20_;
				GFileType _tmp21_;
#line 394 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->is_symlink = FALSE;
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp20_ = g_strdup ("");
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (self->symlink_target);
#line 395 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->symlink_target = _tmp20_;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp21_ = item_file_type;
#line 397 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (_tmp21_ == G_FILE_TYPE_REGULAR) {
#line 1841 "FileItem.c"
				}
			}
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp23_ = file;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp24_ = g_strdup_printf ("%s,%s,%s,%s,%s,%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_ATTRIBUTE_STANDARD_ICON, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_ATTRIBUTE_OWNER_USER, G_FILE_ATTRIBUTE_OWNER_GROUP, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp25_ = _tmp24_;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp26_ = g_file_query_info (_tmp23_, _tmp25_, 0, NULL, &_inner_error_);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp27_ = _tmp26_;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (_tmp25_);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp22_ = _tmp27_;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_tmp4_);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 1866 "FileItem.c"
				goto __catch50_g_error;
			}
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp28_ = _tmp22_;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp22_ = NULL;
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 412 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			info = _tmp28_;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp29_ = self->is_symlink;
#line 423 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (_tmp29_) {
#line 1881 "FileItem.c"
				GFileInfo* _tmp30_;
				GIcon* _tmp31_;
				GIcon* _tmp32_;
#line 425 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp30_ = info;
#line 425 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp31_ = g_file_info_get_icon (_tmp30_);
#line 425 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp32_ = _g_object_ref0 (_tmp31_);
#line 425 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (self->icon);
#line 425 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->icon = _tmp32_;
#line 1895 "FileItem.c"
			}
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp33_ = info;
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp34_ = g_file_info_get_file_type (_tmp33_);
#line 429 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_type = _tmp34_;
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp35_ = info;
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp36_ = g_file_info_get_content_type (_tmp35_);
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp37_ = g_strdup (_tmp36_);
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (self->content_type);
#line 432 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->content_type = _tmp37_;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp39_ = self->is_symlink;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (!_tmp39_) {
#line 1917 "FileItem.c"
				GFileType _tmp40_;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp40_ = self->file_type;
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp38_ = _tmp40_ == G_FILE_TYPE_REGULAR;
#line 1923 "FileItem.c"
			} else {
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp38_ = FALSE;
#line 1927 "FileItem.c"
			}
#line 435 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (_tmp38_) {
#line 1931 "FileItem.c"
				GFileInfo* _tmp41_;
				gint64 _tmp42_;
#line 436 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp41_ = info;
#line 436 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp42_ = g_file_info_get_size (_tmp41_);
#line 436 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				self->priv->_size = _tmp42_;
#line 1940 "FileItem.c"
			}
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp43_ = info;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			g_file_info_get_modification_time (_tmp43_, &_tmp44_);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp45_ = g_date_time_new_from_timeval_utc (&_tmp44_);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp46_ = _tmp45_;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp47_ = g_date_time_to_local (_tmp46_);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_date_time_unref0 (self->modified);
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->modified = _tmp47_;
#line 440 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_date_time_unref0 (_tmp46_);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp48_ = info;
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp49_ = g_file_info_get_attribute_string (_tmp48_, G_FILE_ATTRIBUTE_OWNER_USER);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp50_ = g_strdup (_tmp49_);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (self->owner_user);
#line 443 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->owner_user = _tmp50_;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp51_ = info;
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp52_ = g_file_info_get_attribute_string (_tmp51_, G_FILE_ATTRIBUTE_OWNER_GROUP);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp53_ = g_strdup (_tmp52_);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (self->owner_group);
#line 446 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->owner_group = _tmp53_;
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (_tmp22_);
#line 373 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (_tmp4_);
#line 1982 "FileItem.c"
		}
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 1988 "FileItem.c"
	}
	goto __finally50;
	__catch50_g_error:
	{
		GError* e = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		e = _inner_error_;
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_inner_error_ = NULL;
#line 451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp54_ = e;
#line 451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp55_ = _tmp54_->message;
#line 451 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp55_, FALSE, FALSE);
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_error_free0 (e);
#line 2008 "FileItem.c"
	}
	__finally50:
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_clear_error (&_inner_error_);
#line 369 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return;
#line 2019 "FileItem.c"
	}
}


void file_item_query_file_info_basic (FileItem* self) {
	GError * _inner_error_ = NULL;
#line 455 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 2028 "FileItem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp0_ = self->file_path;
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 459 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		file = _tmp1_;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = file;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp3_) {
#line 2048 "FileItem.c"
			GFileInfo* _tmp4_ = NULL;
			GFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			GIcon* _tmp12_;
			GIcon* _tmp13_;
			GFileInfo* _tmp14_;
			GFileType _tmp15_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp5_ = file;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp6_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_ICON);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp7_ = _tmp6_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = g_file_query_info (_tmp5_, _tmp7_, 0, NULL, &_inner_error_);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp9_ = _tmp8_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (_tmp7_);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = _tmp9_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 2081 "FileItem.c"
				goto __catch51_g_error;
			}
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = _tmp4_;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = NULL;
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 465 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			info = _tmp10_;
#line 470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = info;
#line 470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp12_ = g_file_info_get_icon (_tmp11_);
#line 470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (self->icon);
#line 470 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->icon = _tmp13_;
#line 472 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp14_ = info;
#line 472 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp15_ = g_file_info_get_file_type (_tmp14_);
#line 472 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_type = _tmp15_;
#line 461 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (_tmp4_);
#line 2110 "FileItem.c"
		}
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 2116 "FileItem.c"
	}
	goto __finally51;
	__catch51_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		e = _inner_error_;
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_inner_error_ = NULL;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp16_ = e;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp17_ = _tmp16_->message;
#line 476 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_error_free0 (e);
#line 2136 "FileItem.c"
	}
	__finally51:
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_clear_error (&_inner_error_);
#line 457 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return;
#line 2147 "FileItem.c"
	}
}


void file_item_query_children (FileItem* self, gint depth) {
	GFileEnumerator* enumerator = NULL;
	GFileInfo* info = NULL;
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
	GFileType _tmp4_;
	GError * _inner_error_ = NULL;
#line 480 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->file_path;
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_file_parse_name (_tmp0_);
#line 483 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	file = _tmp1_;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = file;
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
#line 485 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (!_tmp3_) {
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (enumerator);
#line 486 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return;
#line 2184 "FileItem.c"
	}
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = self->file_type;
#line 489 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp4_ == G_FILE_TYPE_DIRECTORY) {
#line 2190 "FileItem.c"
		gint _tmp5_;
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp5_ = depth;
#line 490 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp5_ == 0) {
#line 491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (file);
#line 491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (enumerator);
#line 491 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			return;
#line 2204 "FileItem.c"
		}
		{
			GFileEnumerator* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GFileEnumerator* _tmp21_;
			GFileEnumerator* _tmp22_;
			GFileEnumerator* _tmp23_;
			GeeArrayList* list = NULL;
			GeeArrayList* _tmp39_;
			{
				GeeIterator* _child_it = NULL;
				GeeHashMap* _tmp6_;
				GeeCollection* _tmp7_;
				GeeCollection* _tmp8_;
				GeeCollection* _tmp9_;
				GeeIterator* _tmp10_;
				GeeIterator* _tmp11_;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp6_ = self->children;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp7_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp6_);
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp8_ = _tmp7_;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp9_ = _tmp8_;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp11_ = _tmp10_;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_tmp9_);
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_child_it = _tmp11_;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				while (TRUE) {
#line 2242 "FileItem.c"
					GeeIterator* _tmp12_;
					gboolean _tmp13_;
					FileItem* child = NULL;
					GeeIterator* _tmp14_;
					gpointer _tmp15_;
					FileItem* _tmp16_;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp12_ = _child_it;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp13_ = gee_iterator_next (_tmp12_);
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (!_tmp13_) {
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						break;
#line 2257 "FileItem.c"
					}
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp14_ = _child_it;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					child = (FileItem*) _tmp15_;
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp16_ = child;
#line 497 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp16_->is_stale = TRUE;
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (child);
#line 2271 "FileItem.c"
				}
#line 496 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_child_it);
#line 2275 "FileItem.c"
			}
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp18_ = file;
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp19_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp20_ = _tmp19_;
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp21_ = g_file_enumerate_children (_tmp18_, _tmp20_, 0, NULL, &_inner_error_);
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp22_ = _tmp21_;
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (_tmp20_);
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp17_ = _tmp22_;
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2293 "FileItem.c"
				goto __catch52_g_error;
			}
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp23_ = _tmp17_;
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp17_ = NULL;
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (enumerator);
#line 501 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			enumerator = _tmp23_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			while (TRUE) {
#line 2306 "FileItem.c"
				GFileInfo* _tmp24_ = NULL;
				GFileEnumerator* _tmp25_;
				GFileInfo* _tmp26_;
				GFileInfo* _tmp27_;
				GFileInfo* _tmp28_;
				gchar* child_name = NULL;
				GFileInfo* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* child_path = NULL;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
				gint _tmp36_;
				FileItem* _tmp37_;
				FileItem* _tmp38_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp25_ = enumerator;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp26_ = g_file_enumerator_next_file (_tmp25_, NULL, &_inner_error_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp24_ = _tmp26_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (_tmp17_);
#line 2334 "FileItem.c"
					goto __catch52_g_error;
				}
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp27_ = _tmp24_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp24_ = NULL;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				info = _tmp27_;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp28_ = info;
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (!(_tmp28_ != NULL)) {
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (_tmp24_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					break;
#line 2353 "FileItem.c"
				}
#line 503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp29_ = info;
#line 503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp30_ = g_file_info_get_name (_tmp29_);
#line 503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp31_ = g_strdup (_tmp30_);
#line 503 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				child_name = _tmp31_;
#line 504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp32_ = self->file_path;
#line 504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp33_ = child_name;
#line 504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp34_ = g_build_filename (_tmp32_, _tmp33_, NULL);
#line 504 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				child_path = _tmp34_;
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp35_ = child_path;
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp36_ = depth;
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp37_ = file_item_add_child_from_disk (self, _tmp35_, _tmp36_ - 1);
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp38_ = _tmp37_;
#line 505 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_tmp38_);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (child_path);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (child_name);
#line 502 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_tmp24_);
#line 2387 "FileItem.c"
			}
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp39_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 509 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			list = _tmp39_;
#line 2393 "FileItem.c"
			{
				GeeIterator* _key_it = NULL;
				GeeHashMap* _tmp40_;
				GeeSet* _tmp41_;
				GeeSet* _tmp42_;
				GeeSet* _tmp43_;
				GeeIterator* _tmp44_;
				GeeIterator* _tmp45_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp40_ = self->children;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp41_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp40_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp42_ = _tmp41_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp43_ = _tmp42_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp44_ = gee_iterable_iterator ((GeeIterable*) _tmp43_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp45_ = _tmp44_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_tmp43_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_key_it = _tmp45_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				while (TRUE) {
#line 2420 "FileItem.c"
					GeeIterator* _tmp46_;
					gboolean _tmp47_;
					gchar* key = NULL;
					GeeIterator* _tmp48_;
					gpointer _tmp49_;
					GeeHashMap* _tmp50_;
					const gchar* _tmp51_;
					gpointer _tmp52_;
					FileItem* _tmp53_;
					gboolean _tmp54_;
					gboolean _tmp55_;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp46_ = _key_it;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp47_ = gee_iterator_next (_tmp46_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (!_tmp47_) {
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						break;
#line 2440 "FileItem.c"
					}
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp48_ = _key_it;
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp49_ = gee_iterator_get (_tmp48_);
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					key = (gchar*) _tmp49_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp50_ = self->children;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp51_ = key;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp50_, _tmp51_);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp53_ = (FileItem*) _tmp52_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp54_ = _tmp53_->is_stale;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp55_ = _tmp54_;
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (_tmp53_);
#line 511 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (_tmp55_) {
#line 2464 "FileItem.c"
						GeeArrayList* _tmp56_;
						const gchar* _tmp57_;
#line 512 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp56_ = list;
#line 512 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_tmp57_ = key;
#line 512 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, _tmp57_);
#line 2473 "FileItem.c"
					}
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_free0 (key);
#line 2477 "FileItem.c"
				}
#line 510 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_key_it);
#line 2481 "FileItem.c"
			}
			{
				GeeArrayList* _key_list = NULL;
				GeeArrayList* _tmp58_;
				GeeArrayList* _tmp59_;
				gint _key_size = 0;
				GeeArrayList* _tmp60_;
				gint _tmp61_;
				gint _tmp62_;
				gint _key_index = 0;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp58_ = list;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp59_ = _g_object_ref0 (_tmp58_);
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_key_list = _tmp59_;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp60_ = _key_list;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp61_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp60_);
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp62_ = _tmp61_;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_key_size = _tmp62_;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_key_index = -1;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				while (TRUE) {
#line 2510 "FileItem.c"
					gint _tmp63_;
					gint _tmp64_;
					gint _tmp65_;
					gchar* key = NULL;
					GeeArrayList* _tmp66_;
					gint _tmp67_;
					gpointer _tmp68_;
					GeeHashMap* _tmp69_;
					const gchar* _tmp70_;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp63_ = _key_index;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_key_index = _tmp63_ + 1;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp64_ = _key_index;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp65_ = _key_size;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (!(_tmp64_ < _tmp65_)) {
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						break;
#line 2532 "FileItem.c"
					}
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp66_ = _key_list;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp67_ = _key_index;
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp68_ = gee_abstract_list_get ((GeeAbstractList*) _tmp66_, _tmp67_);
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					key = (gchar*) _tmp68_;
#line 517 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp69_ = self->children;
#line 517 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp70_ = key;
#line 517 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp69_, _tmp70_, NULL);
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_free0 (key);
#line 2550 "FileItem.c"
				}
#line 515 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (_key_list);
#line 2554 "FileItem.c"
			}
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (list);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (_tmp17_);
#line 2560 "FileItem.c"
		}
		goto __finally52;
		__catch52_g_error:
		{
			GError* e = NULL;
			GError* _tmp71_;
			const gchar* _tmp72_;
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			e = _inner_error_;
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_inner_error_ = NULL;
#line 521 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp71_ = e;
#line 521 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp72_ = _tmp71_->message;
#line 521 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			tee_jee_logging_log_error (_tmp72_, FALSE, FALSE);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_error_free0 (e);
#line 2580 "FileItem.c"
		}
		__finally52:
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (file);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (enumerator);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			g_clear_error (&_inner_error_);
#line 494 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			return;
#line 2597 "FileItem.c"
		}
	}
#line 480 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (file);
#line 480 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (info);
#line 480 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (enumerator);
#line 2606 "FileItem.c"
}


void file_item_clear_children (FileItem* self) {
	GeeHashMap* _tmp0_;
#line 526 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 527 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->children;
#line 527 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 2618 "FileItem.c"
}


FileItem* file_item_remove_child (FileItem* self, const gchar* child_name) {
	FileItem* result = NULL;
	FileItem* child = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
#line 530 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 530 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (child_name != NULL, NULL);
#line 531 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	child = NULL;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->children;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = child_name;
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 533 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp2_) {
#line 2642 "FileItem.c"
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		gpointer _tmp5_;
		GeeHashMap* _tmp6_;
		const gchar* _tmp7_;
		FileItem* _tmp8_;
		GFileType _tmp9_;
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = self->children;
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp4_ = child_name;
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (child);
#line 534 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		child = (FileItem*) _tmp5_;
#line 535 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp6_ = self->children;
#line 535 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp7_ = child_name;
#line 535 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp6_, _tmp7_, NULL);
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp8_ = child;
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp9_ = _tmp8_->file_type;
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp9_ == G_FILE_TYPE_REGULAR) {
#line 2672 "FileItem.c"
			glong _tmp10_;
			glong _tmp11_;
			gint64 _tmp12_;
			FileItem* _tmp13_;
			gint64 _tmp14_;
			gint64 _tmp15_;
			gint64 _tmp16_;
			FileItem* _tmp17_;
			gint64 _tmp18_;
			gint64 _tmp19_;
			FileItem* temp = NULL;
			FileItem* _tmp20_;
#line 539 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = self->file_count;
#line 539 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_count = _tmp10_ - 1;
#line 540 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = self->file_count_total;
#line 540 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_count_total = _tmp11_ - 1;
#line 543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp12_ = self->priv->_size;
#line 543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp13_ = child;
#line 543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp14_ = file_item_get_size (_tmp13_);
#line 543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp15_ = _tmp14_;
#line 543 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->priv->_size = _tmp12_ - _tmp15_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp16_ = self->priv->_size_compressed;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp17_ = child;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp18_ = file_item_get_size_compressed (_tmp17_);
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp19_ = _tmp18_;
#line 544 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->priv->_size_compressed = _tmp16_ - _tmp19_;
#line 547 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp20_ = _g_object_ref0 (self);
#line 547 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			temp = _tmp20_;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			while (TRUE) {
#line 2719 "FileItem.c"
				FileItem* _tmp21_;
				FileItem* _tmp22_;
				FileItem* _tmp23_;
				FileItem* _tmp24_;
				glong _tmp25_;
				FileItem* _tmp26_;
				FileItem* _tmp27_;
				FileItem* _tmp28_;
				FileItem* _tmp29_;
				gint64 _tmp30_;
				FileItem* _tmp31_;
				gint64 _tmp32_;
				gint64 _tmp33_;
				FileItem* _tmp34_;
				FileItem* _tmp35_;
				FileItem* _tmp36_;
				FileItem* _tmp37_;
				gint64 _tmp38_;
				FileItem* _tmp39_;
				gint64 _tmp40_;
				gint64 _tmp41_;
				FileItem* _tmp42_;
				FileItem* _tmp43_;
				FileItem* _tmp44_;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp21_ = temp;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp22_ = _tmp21_->parent;
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (!(_tmp22_ != NULL)) {
#line 548 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					break;
#line 2752 "FileItem.c"
				}
#line 549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp23_ = temp;
#line 549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp24_ = _tmp23_->parent;
#line 549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp25_ = _tmp24_->file_count_total;
#line 549 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp24_->file_count_total = _tmp25_ - 1;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp26_ = temp;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp27_ = _tmp26_->parent;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp28_ = temp;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp29_ = _tmp28_->parent;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp30_ = _tmp29_->priv->_size;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp31_ = child;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp32_ = file_item_get_size (_tmp31_);
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp33_ = _tmp32_;
#line 551 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp29_->priv->_size = _tmp30_ - _tmp33_;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp34_ = temp;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp35_ = _tmp34_->parent;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp36_ = temp;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp37_ = _tmp36_->parent;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp38_ = _tmp37_->priv->_size_compressed;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp39_ = child;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp40_ = file_item_get_size_compressed (_tmp39_);
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp41_ = _tmp40_;
#line 552 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp37_->priv->_size_compressed = _tmp38_ - _tmp41_;
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp42_ = temp;
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp43_ = _tmp42_->parent;
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp44_ = _g_object_ref0 (_tmp43_);
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 554 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				temp = _tmp44_;
#line 2808 "FileItem.c"
			}
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (temp);
#line 2812 "FileItem.c"
		} else {
			glong _tmp45_;
			glong _tmp46_;
			glong _tmp47_;
			FileItem* _tmp48_;
			glong _tmp49_;
			glong _tmp50_;
			FileItem* _tmp51_;
			glong _tmp52_;
			gint64 _tmp53_;
			FileItem* _tmp54_;
			gint64 _tmp55_;
			gint64 _tmp56_;
			gint64 _tmp57_;
			FileItem* _tmp58_;
			gint64 _tmp59_;
			gint64 _tmp60_;
			FileItem* temp = NULL;
			FileItem* _tmp61_;
#line 559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp45_ = self->dir_count;
#line 559 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->dir_count = _tmp45_ - 1;
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp46_ = self->dir_count_total;
#line 560 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->dir_count_total = _tmp46_ - 1;
#line 563 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp47_ = self->file_count_total;
#line 563 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp48_ = child;
#line 563 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp49_ = _tmp48_->file_count_total;
#line 563 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->file_count_total = _tmp47_ - _tmp49_;
#line 564 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp50_ = self->dir_count_total;
#line 564 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp51_ = child;
#line 564 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp52_ = _tmp51_->dir_count_total;
#line 564 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->dir_count_total = _tmp50_ - _tmp52_;
#line 565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp53_ = self->priv->_size;
#line 565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp54_ = child;
#line 565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp55_ = file_item_get_size (_tmp54_);
#line 565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp56_ = _tmp55_;
#line 565 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->priv->_size = _tmp53_ - _tmp56_;
#line 566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp57_ = self->priv->_size_compressed;
#line 566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp58_ = child;
#line 566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp59_ = file_item_get_size_compressed (_tmp58_);
#line 566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp60_ = _tmp59_;
#line 566 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			self->priv->_size_compressed = _tmp57_ - _tmp60_;
#line 569 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp61_ = _g_object_ref0 (self);
#line 569 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			temp = _tmp61_;
#line 570 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			while (TRUE) {
#line 2882 "FileItem.c"
				FileItem* _tmp62_;
				FileItem* _tmp63_;
				FileItem* _tmp64_;
				FileItem* _tmp65_;
				glong _tmp66_;
				FileItem* _tmp67_;
				FileItem* _tmp68_;
				FileItem* _tmp69_;
				FileItem* _tmp70_;
				glong _tmp71_;
				FileItem* _tmp72_;
				glong _tmp73_;
				FileItem* _tmp74_;
				FileItem* _tmp75_;
				FileItem* _tmp76_;
				FileItem* _tmp77_;
				glong _tmp78_;
				FileItem* _tmp79_;
				glong _tmp80_;
				FileItem* _tmp81_;
				FileItem* _tmp82_;
				FileItem* _tmp83_;
				FileItem* _tmp84_;
				gint64 _tmp85_;
				FileItem* _tmp86_;
				gint64 _tmp87_;
				gint64 _tmp88_;
				FileItem* _tmp89_;
				FileItem* _tmp90_;
				FileItem* _tmp91_;
				FileItem* _tmp92_;
				gint64 _tmp93_;
				FileItem* _tmp94_;
				gint64 _tmp95_;
				gint64 _tmp96_;
				FileItem* _tmp97_;
				FileItem* _tmp98_;
				FileItem* _tmp99_;
#line 570 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp62_ = temp;
#line 570 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp63_ = _tmp62_->parent;
#line 570 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (!(_tmp63_ != NULL)) {
#line 570 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					break;
#line 2929 "FileItem.c"
				}
#line 571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp64_ = temp;
#line 571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp65_ = _tmp64_->parent;
#line 571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp66_ = _tmp65_->dir_count_total;
#line 571 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp65_->dir_count_total = _tmp66_ - 1;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp67_ = temp;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp68_ = _tmp67_->parent;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp69_ = temp;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp70_ = _tmp69_->parent;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp71_ = _tmp70_->file_count_total;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp72_ = child;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp73_ = _tmp72_->file_count_total;
#line 573 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp70_->file_count_total = _tmp71_ - _tmp73_;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp74_ = temp;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp75_ = _tmp74_->parent;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp76_ = temp;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp77_ = _tmp76_->parent;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp78_ = _tmp77_->dir_count_total;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp79_ = child;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp80_ = _tmp79_->dir_count_total;
#line 574 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp77_->dir_count_total = _tmp78_ - _tmp80_;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp81_ = temp;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp82_ = _tmp81_->parent;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp83_ = temp;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp84_ = _tmp83_->parent;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp85_ = _tmp84_->priv->_size;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp86_ = child;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp87_ = file_item_get_size (_tmp86_);
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp88_ = _tmp87_;
#line 575 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp84_->priv->_size = _tmp85_ - _tmp88_;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp89_ = temp;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp90_ = _tmp89_->parent;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp91_ = temp;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp92_ = _tmp91_->parent;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp93_ = _tmp92_->priv->_size_compressed;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp94_ = child;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp95_ = file_item_get_size_compressed (_tmp94_);
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp96_ = _tmp95_;
#line 576 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp92_->priv->_size_compressed = _tmp93_ - _tmp96_;
#line 578 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp97_ = temp;
#line 578 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp98_ = _tmp97_->parent;
#line 578 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp99_ = _g_object_ref0 (_tmp98_);
#line 578 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_object_unref0 (temp);
#line 578 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				temp = _tmp99_;
#line 3017 "FileItem.c"
			}
#line 537 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (temp);
#line 3021 "FileItem.c"
		}
	}
#line 585 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = child;
#line 585 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 3028 "FileItem.c"
}


FileItem* file_item_find_descendant (FileItem* self, const gchar* path) {
	FileItem* result = NULL;
	FileItem* child = NULL;
	FileItem* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	FileItem* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
#line 588 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 588 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 589 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	child = _tmp0_;
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = path;
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "/", 0);
#line 3054 "FileItem.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		part_collection = _tmp3_;
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		part_collection_length1 = _vala_array_length (_tmp2_);
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		for (part_it = 0; part_it < _vala_array_length (_tmp2_); part_it = part_it + 1) {
#line 3066 "FileItem.c"
			gchar* _tmp4_;
			gchar* part = NULL;
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp4_ = g_strdup (part_collection[part_it]);
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			part = _tmp4_;
#line 3073 "FileItem.c"
			{
				FileItem* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				FileItem* _tmp14_;
				GeeHashMap* _tmp15_;
				const gchar* _tmp16_;
				gboolean _tmp17_;
#line 594 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp5_ = child;
#line 594 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp6_ = _tmp5_->children;
#line 594 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp7_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp6_);
#line 594 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp8_ = _tmp7_;
#line 594 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (_tmp8_ == 0) {
#line 3093 "FileItem.c"
					FileItem* _tmp9_;
					FileItem* _tmp10_;
					GeeHashMap* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
#line 595 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp9_ = child;
#line 595 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					file_item_query_children (_tmp9_, 1);
#line 596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp10_ = child;
#line 596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp11_ = _tmp10_->children;
#line 596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp12_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp11_);
#line 596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp13_ = _tmp12_;
#line 596 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					if (_tmp13_ == 0) {
#line 597 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						_g_free0 (part);
#line 597 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
						break;
#line 3117 "FileItem.c"
					}
				}
#line 601 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp14_ = child;
#line 601 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp15_ = _tmp14_->children;
#line 601 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp16_ = part;
#line 601 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_tmp17_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 601 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				if (_tmp17_) {
#line 3130 "FileItem.c"
					FileItem* _tmp18_;
					GeeHashMap* _tmp19_;
					const gchar* _tmp20_;
					gpointer _tmp21_;
#line 602 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp18_ = child;
#line 602 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp19_ = _tmp18_->children;
#line 602 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp20_ = part;
#line 602 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, _tmp20_);
#line 602 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					_g_object_unref0 (child);
#line 602 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
					child = (FileItem*) _tmp21_;
#line 3147 "FileItem.c"
				}
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				_g_free0 (part);
#line 3151 "FileItem.c"
			}
		}
#line 591 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3156 "FileItem.c"
	}
#line 606 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp22_ = child;
#line 606 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp23_ = _tmp22_->file_path;
#line 606 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp24_ = path;
#line 606 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (g_strcmp0 (_tmp23_, _tmp24_) == 0) {
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		result = child;
#line 607 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return result;
#line 3170 "FileItem.c"
	} else {
#line 610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		result = NULL;
#line 610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (child);
#line 610 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return result;
#line 3178 "FileItem.c"
	}
#line 588 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (child);
#line 3182 "FileItem.c"
}


void file_item_set_file_path_prefix (FileItem* self, const gchar* prefix) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 614 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 614 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (prefix != NULL);
#line 615 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = prefix;
#line 615 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 615 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_path_prefix);
#line 615 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_path_prefix = _tmp1_;
#line 3201 "FileItem.c"
	{
		GeeIterator* _child_it = NULL;
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = self->children;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp4_ = _tmp3_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp5_ = _tmp4_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp7_ = _tmp6_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_tmp5_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_child_it = _tmp7_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		while (TRUE) {
#line 3228 "FileItem.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_;
			FileItem* child = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			FileItem* _tmp12_;
			const gchar* _tmp13_;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = _child_it;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (!_tmp9_) {
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				break;
#line 3244 "FileItem.c"
			}
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = _child_it;
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			child = (FileItem*) _tmp11_;
#line 617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp12_ = child;
#line 617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp13_ = prefix;
#line 617 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			file_item_set_file_path_prefix (_tmp12_, _tmp13_);
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (child);
#line 3260 "FileItem.c"
		}
#line 616 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_child_it);
#line 3264 "FileItem.c"
	}
}


void file_item_print (FileItem* self, gint level) {
	gint _tmp0_;
	FILE* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	FILE* _tmp10_;
#line 621 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 623 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = level;
#line 623 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp0_ == 0) {
#line 3285 "FileItem.c"
		FILE* _tmp1_;
		FILE* _tmp2_;
#line 624 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp1_ = stdout;
#line 624 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		fprintf (_tmp1_, "\n");
#line 625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = stdout;
#line 625 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		fflush (_tmp2_);
#line 3296 "FileItem.c"
	}
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = stdout;
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = level;
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp5_ = g_strnfill ((gsize) (_tmp4_ * 2), ' ');
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp6_ = _tmp5_;
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp7_ = self->file_name;
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp8_ = g_strdup_printf ("%s%s\n", _tmp6_, _tmp7_);
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp9_ = _tmp8_;
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	fprintf (_tmp3_, "%s", _tmp9_);
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (_tmp9_);
#line 628 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (_tmp6_);
#line 629 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp10_ = stdout;
#line 629 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	fflush (_tmp10_);
#line 3322 "FileItem.c"
	{
		GeeIterator* _key_it = NULL;
		GeeHashMap* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		GeeSet* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp11_ = self->children;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp12_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp11_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp13_ = _tmp12_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp14_ = _tmp13_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp16_ = _tmp15_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_tmp14_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_key_it = _tmp16_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		while (TRUE) {
#line 3349 "FileItem.c"
			GeeIterator* _tmp17_;
			gboolean _tmp18_;
			gchar* key = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			GeeHashMap* _tmp21_;
			const gchar* _tmp22_;
			gpointer _tmp23_;
			FileItem* _tmp24_;
			gint _tmp25_;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp17_ = _key_it;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp18_ = gee_iterator_next (_tmp17_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (!_tmp18_) {
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				break;
#line 3368 "FileItem.c"
			}
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp19_ = _key_it;
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			key = (gchar*) _tmp20_;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp21_ = self->children;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp22_ = key;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp23_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp21_, _tmp22_);
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp24_ = (FileItem*) _tmp23_;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp25_ = level;
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			file_item_print (_tmp24_, _tmp25_ + 1);
#line 632 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (_tmp24_);
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (key);
#line 3392 "FileItem.c"
		}
#line 631 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_key_it);
#line 3396 "FileItem.c"
	}
}


static gint __lambda7_ (FileItem* self, FileItem* a, FileItem* b) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	FileItem* _tmp1_;
	GFileType _tmp2_;
#line 644 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 644 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = a;
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = _tmp1_->file_type;
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp2_ == G_FILE_TYPE_DIRECTORY) {
#line 3416 "FileItem.c"
		FileItem* _tmp3_;
		GFileType _tmp4_;
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = b;
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp4_ = _tmp3_->file_type;
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp0_ = _tmp4_ != G_FILE_TYPE_DIRECTORY;
#line 3425 "FileItem.c"
	} else {
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp0_ = FALSE;
#line 3429 "FileItem.c"
	}
#line 645 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp0_) {
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		result = -1;
#line 646 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		return result;
#line 3437 "FileItem.c"
	} else {
		gboolean _tmp5_ = FALSE;
		FileItem* _tmp6_;
		GFileType _tmp7_;
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp6_ = a;
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp7_ = _tmp6_->file_type;
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp7_ != G_FILE_TYPE_DIRECTORY) {
#line 3448 "FileItem.c"
			FileItem* _tmp8_;
			GFileType _tmp9_;
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = b;
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp9_ = _tmp8_->file_type;
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp5_ = _tmp9_ == G_FILE_TYPE_DIRECTORY;
#line 3457 "FileItem.c"
		} else {
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp5_ = FALSE;
#line 3461 "FileItem.c"
		}
#line 648 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp5_) {
#line 649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			result = 1;
#line 649 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			return result;
#line 3469 "FileItem.c"
		} else {
			GCompareFunc _tmp10_;
			FileItem* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			FileItem* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = g_strcmp0;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = a;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp12_ = _tmp11_->file_name;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp14_ = _tmp13_;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp15_ = b;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp16_ = _tmp15_->file_name;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp17_ = g_utf8_strdown (_tmp16_, (gssize) -1);
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp18_ = _tmp17_;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp19_ = _tmp10_ (_tmp14_, _tmp18_);
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp20_ = _tmp19_;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (_tmp18_);
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (_tmp14_);
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			result = _tmp20_;
#line 652 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			return result;
#line 3512 "FileItem.c"
		}
	}
}


static gint ___lambda7__gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gint result;
	result = __lambda7_ ((FileItem*) self, (FileItem*) a, (FileItem*) b);
#line 644 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 3523 "FileItem.c"
}


GeeArrayList* file_item_get_children_sorted (FileItem* self) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp16_;
#line 636 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 637 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = gee_array_list_new (TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 637 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	list = _tmp0_;
#line 3538 "FileItem.c"
	{
		GeeIterator* _key_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp1_ = self->children;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp1_);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = _tmp2_;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp4_ = _tmp3_;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp6_ = _tmp5_;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_tmp4_);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_key_it = _tmp6_;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		while (TRUE) {
#line 3565 "FileItem.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_;
			gchar* key = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			FileItem* item = NULL;
			GeeHashMap* _tmp11_;
			const gchar* _tmp12_;
			gpointer _tmp13_;
			GeeArrayList* _tmp14_;
			FileItem* _tmp15_;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp7_ = _key_it;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			if (!_tmp8_) {
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
				break;
#line 3585 "FileItem.c"
			}
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp9_ = _key_it;
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			key = (gchar*) _tmp10_;
#line 640 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp11_ = self->children;
#line 640 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp12_ = key;
#line 640 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
#line 640 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			item = (FileItem*) _tmp13_;
#line 641 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp14_ = list;
#line 641 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp15_ = item;
#line 641 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (item);
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_free0 (key);
#line 3611 "FileItem.c"
		}
#line 639 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (_key_it);
#line 3615 "FileItem.c"
	}
#line 644 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp16_ = list;
#line 644 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	gee_list_sort ((GeeList*) _tmp16_, ___lambda7__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 656 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = list;
#line 656 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 3625 "FileItem.c"
}


GdkPixbuf* file_item_get_icon (FileItem* self, gint icon_size, gboolean add_transparency, gboolean add_emblems) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GIcon* _tmp0_;
	GdkPixbuf* _tmp4_;
#line 661 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 663 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	pixbuf = NULL;
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->icon;
#line 665 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp0_ != NULL) {
#line 3642 "FileItem.c"
		GIcon* _tmp1_;
		gint _tmp2_;
		GdkPixbuf* _tmp3_;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp1_ = self->icon;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp2_ = icon_size;
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp3_ = icon_manager_lookup_gicon (_tmp1_, _tmp2_);
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_g_object_unref0 (pixbuf);
#line 666 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		pixbuf = _tmp3_;
#line 3656 "FileItem.c"
	}
#line 669 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = pixbuf;
#line 669 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	if (_tmp4_ == NULL) {
#line 3662 "FileItem.c"
		GFileType _tmp5_;
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		_tmp5_ = self->file_type;
#line 670 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		if (_tmp5_ == G_FILE_TYPE_DIRECTORY) {
#line 3668 "FileItem.c"
			gint _tmp6_;
			GdkPixbuf* _tmp7_;
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp6_ = icon_size;
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp7_ = icon_manager_lookup ("folder", _tmp6_, FALSE, FALSE, 1);
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (pixbuf);
#line 671 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			pixbuf = _tmp7_;
#line 3679 "FileItem.c"
		} else {
			gint _tmp8_;
			GdkPixbuf* _tmp9_;
#line 674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp8_ = icon_size;
#line 674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_tmp9_ = icon_manager_lookup ("text-x-preview", _tmp8_, FALSE, FALSE, 1);
#line 674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			_g_object_unref0 (pixbuf);
#line 674 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
			pixbuf = _tmp9_;
#line 3691 "FileItem.c"
		}
	}
#line 678 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = pixbuf;
#line 678 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 3698 "FileItem.c"
}


gint64 file_item_get_size (FileItem* self) {
	gint64 result;
	gint64 _tmp0_;
#line 130 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->priv->_size;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = _tmp0_;
#line 131 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 3713 "FileItem.c"
}


gint64 file_item_get_size_compressed (FileItem* self) {
	gint64 result;
	gint64 _tmp0_;
#line 136 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = self->priv->_size_compressed;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	result = _tmp0_;
#line 137 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	return result;
#line 3728 "FileItem.c"
}


static void file_item_class_init (FileItemClass * klass) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar** _tmp48_;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	file_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_type_class_add_private (klass, sizeof (FileItemPrivate));
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_file_item_get_property;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	G_OBJECT_CLASS (klass)->finalize = file_item_finalize;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_ITEM_SIZE_PROPERTY, file_item_properties[FILE_ITEM_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_ITEM_SIZE_COMPRESSED_PROPERTY, file_item_properties[FILE_ITEM_SIZE_COMPRESSED_PROPERTY] = g_param_spec_int64 ("size-compressed", "size-compressed", "size-compressed", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = g_strdup (".tar");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup (".tar.gz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = g_strdup (".tgz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = g_strdup (".tar.bzip2");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = g_strdup (".tar.bz2");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp5_ = g_strdup (".tbz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp6_ = g_strdup (".tbz2");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp7_ = g_strdup (".tb2");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp8_ = g_strdup (".tar.lzma");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp9_ = g_strdup (".tar.lz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp10_ = g_strdup (".tlz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp11_ = g_strdup (".tar.xz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp12_ = g_strdup (".txz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp13_ = g_strdup (".tar.7z");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp14_ = g_strdup (".tar.zip");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp15_ = g_strdup (".7z");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp16_ = g_strdup (".lzma");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp17_ = g_strdup (".bz2");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp18_ = g_strdup (".bzip2");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp19_ = g_strdup (".gz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp20_ = g_strdup (".gzip");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp21_ = g_strdup (".zip");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp22_ = g_strdup (".rar");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp23_ = g_strdup (".cab");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp24_ = g_strdup (".arj");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp25_ = g_strdup (".z");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp26_ = g_strdup (".taz");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp27_ = g_strdup (".cpio");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp28_ = g_strdup (".rpm");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp29_ = g_strdup (".deb");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp30_ = g_strdup (".lzh");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp31_ = g_strdup (".lha");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp32_ = g_strdup (".chm");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp33_ = g_strdup (".chw");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp34_ = g_strdup (".hxs");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp35_ = g_strdup (".iso");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp36_ = g_strdup (".dmg");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp37_ = g_strdup (".xar");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp38_ = g_strdup (".hfs");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp39_ = g_strdup (".ntfs");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp40_ = g_strdup (".fat");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp41_ = g_strdup (".vhd");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp42_ = g_strdup (".mbr");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp43_ = g_strdup (".wim");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp44_ = g_strdup (".swm");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp45_ = g_strdup (".squashfs");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp46_ = g_strdup (".cramfs");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp47_ = g_strdup (".scap");
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_ = g_new0 (gchar*, 48 + 1);
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[0] = _tmp0_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[1] = _tmp1_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[2] = _tmp2_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[3] = _tmp3_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[4] = _tmp4_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[5] = _tmp5_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[6] = _tmp6_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[7] = _tmp7_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[8] = _tmp8_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[9] = _tmp9_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[10] = _tmp10_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[11] = _tmp11_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[12] = _tmp12_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[13] = _tmp13_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[14] = _tmp14_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[15] = _tmp15_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[16] = _tmp16_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[17] = _tmp17_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[18] = _tmp18_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[19] = _tmp19_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[20] = _tmp20_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[21] = _tmp21_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[22] = _tmp22_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[23] = _tmp23_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[24] = _tmp24_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[25] = _tmp25_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[26] = _tmp26_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[27] = _tmp27_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[28] = _tmp28_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[29] = _tmp29_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[30] = _tmp30_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[31] = _tmp31_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[32] = _tmp32_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[33] = _tmp33_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[34] = _tmp34_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[35] = _tmp35_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[36] = _tmp36_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[37] = _tmp37_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[38] = _tmp38_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[39] = _tmp39_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[40] = _tmp40_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[41] = _tmp41_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[42] = _tmp42_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[43] = _tmp43_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[44] = _tmp44_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[45] = _tmp45_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[46] = _tmp46_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp48_[47] = _tmp47_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	file_item_archive_extensions = _tmp48_;
#line 77 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	file_item_archive_extensions_length1 = 48;
#line 3992 "FileItem.c"
}


static void file_item_gee_comparable_interface_init (GeeComparableIface * iface) {
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	file_item_gee_comparable_parent_iface = g_type_interface_peek_parent (iface);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	iface->compare_to = (gint (*) (GeeComparable *, gconstpointer)) file_item_real_compare_to;
#line 4001 "FileItem.c"
}


static void file_item_instance_init (FileItem * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GeeHashMap* _tmp10_;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->priv = FILE_ITEM_GET_PRIVATE (self);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp0_ = g_strdup ("");
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp1_ = g_strdup ("");
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_location = _tmp1_;
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp2_ = g_strdup ("");
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_path = _tmp2_;
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp3_ = g_strdup ("");
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_path_prefix = _tmp3_;
#line 43 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_type = G_FILE_TYPE_REGULAR;
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp4_ = g_strdup ("");
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->permissions = _tmp4_;
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp5_ = g_strdup ("");
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->owner_user = _tmp5_;
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp6_ = g_strdup ("");
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->owner_group = _tmp6_;
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp7_ = g_strdup ("");
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->content_type = _tmp7_;
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp8_ = g_strdup ("");
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_status = _tmp8_;
#line 51 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->is_selected = FALSE;
#line 52 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->is_symlink = FALSE;
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp9_ = g_strdup ("");
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->symlink_target = _tmp9_;
#line 54 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->is_archive = FALSE;
#line 55 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->is_stale = FALSE;
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_tmp10_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->children = _tmp10_;
#line 64 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_count = (glong) 0;
#line 65 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->dir_count = (glong) 0;
#line 66 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->priv->_size = (gint64) 0;
#line 67 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->priv->_size_compressed = (gint64) 0;
#line 69 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->file_count_total = (glong) 0;
#line 70 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->dir_count_total = (glong) 0;
#line 75 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self->is_dummy = FALSE;
#line 4087 "FileItem.c"
}


static void file_item_finalize (GObject * obj) {
	FileItem * self;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_ITEM, FileItem);
#line 39 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 40 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 41 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 42 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_path_prefix);
#line 44 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_date_time_unref0 (self->modified);
#line 45 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->permissions);
#line 46 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->owner_user);
#line 47 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->owner_group);
#line 48 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->content_type);
#line 49 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->file_status);
#line 53 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_free0 (self->symlink_target);
#line 57 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (self->parent);
#line 58 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (self->children);
#line 59 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (self->source_archive);
#line 61 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (self->tag);
#line 73 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	_g_object_unref0 (self->icon);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	G_OBJECT_CLASS (file_item_parent_class)->finalize (obj);
#line 4129 "FileItem.c"
}


GType file_item_get_type (void) {
	static volatile gsize file_item_type_id__volatile = 0;
	if (g_once_init_enter (&file_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FileItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileItem), 0, (GInstanceInitFunc) file_item_instance_init, NULL };
		static const GInterfaceInfo gee_comparable_info = { (GInterfaceInitFunc) file_item_gee_comparable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType file_item_type_id;
		file_item_type_id = g_type_register_static (G_TYPE_OBJECT, "FileItem", &g_define_type_info, 0);
		g_type_add_interface_static (file_item_type_id, GEE_TYPE_COMPARABLE, &gee_comparable_info);
		g_once_init_leave (&file_item_type_id__volatile, file_item_type_id);
	}
	return file_item_type_id__volatile;
}


static void _vala_file_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FileItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_ITEM, FileItem);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
	switch (property_id) {
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		case FILE_ITEM_SIZE_PROPERTY:
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_value_set_int64 (value, file_item_get_size (self));
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		break;
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		case FILE_ITEM_SIZE_COMPRESSED_PROPERTY:
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		g_value_set_int64 (value, file_item_get_size_compressed (self));
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		break;
#line 4164 "FileItem.c"
		default:
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "/builddir/build/BUILD/timeshift-18.4/src/Utility/FileItem.vala"
		break;
#line 4170 "FileItem.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



